﻿package org.alivepdf.japanese.pdf.linux {
/**
* JIS第一水準漢字・文字コード変換テーブル [Unicodeベース(UTF-16BE)].<br/>
* 参考 http://ash.jp/code/ <br/>
* 上記と違う箇所は以下のとおりです。<br/>
* <pre>
* (1) 実体(＼)のUnicode=005Cとなっているところは、Unicode=FF3Cに変更した。
* (2) 以下のコードを追加した。
*   a. Unicode=2011,2013 は対応するSJIS/EUC-JPが存在しないため、Unicode=2014に読み替えた。
*   b. Unicode=2012 は対応するSJIS/EUC-JPが存在しないため、Unicode=2010に読み替えた。
*   c. Unicode=2015 は対応するSJIS/EUC-JPが存在しないため、Unicode=2014に読み替えた。
* </pre>
*/
  public final class CharSetTable_Kanji01 {                //JIS 第一水準
    public static var charSet_MultiBytes:Object = {   // Utf-16 : [ Shift-Jis , Euc-JP , Utf-8 ]
//---------"005C":["815F","A1C0","5C"], // ＼
           "FF3C":["815F","A1C0","5C"], // ＼
           "00A2":["8191","A1F1","C2A2"], // ¢
           "00A3":["8192","A1F2","C2A3"], // £
           "00A7":["8198","A1F8","C2A7"], // §
           "00A8":["814E","A1AF","C2A8"], // ¨
           "00AC":["81CA","A2CC","C2AC"], // ¬
           "00B0":["818B","A1EB","C2B0"], // °
           "00B1":["817D","A1DE","C2B1"], // ±
           "00B4":["814C","A1AD","C2B4"], // ´
           "00B6":["81F7","A2F9","C2B6"], // ¶
           "00D7":["817E","A1DF","C397"], // ×
           "00F7":["8180","A1E0","C3B7"], // ÷
           "0391":["839F","A6A1","CE91"], // Α
           "0392":["83A0","A6A2","CE92"], // Β
           "0393":["83A1","A6A3","CE93"], // Γ
           "0394":["83A2","A6A4","CE94"], // Δ
           "0395":["83A3","A6A5","CE95"], // Ε
           "0396":["83A4","A6A6","CE96"], // Ζ
           "0397":["83A5","A6A7","CE97"], // Η
           "0398":["83A6","A6A8","CE98"], // Θ
           "0399":["83A7","A6A9","CE99"], // Ι
           "039A":["83A8","A6AA","CE9A"], // Κ
           "039B":["83A9","A6AB","CE9B"], // Λ
           "039C":["83AA","A6AC","CE9C"], // Μ
           "039D":["83AB","A6AD","CE9D"], // Ν
           "039E":["83AC","A6AE","CE9E"], // Ξ
           "039F":["83AD","A6AF","CE9F"], // Ο
           "03A0":["83AE","A6B0","CEA0"], // Π
           "03A1":["83AF","A6B1","CEA1"], // Ρ
           "03A3":["83B0","A6B2","CEA3"], // Σ
           "03A4":["83B1","A6B3","CEA4"], // Τ
           "03A5":["83B2","A6B4","CEA5"], // Υ
           "03A6":["83B3","A6B5","CEA6"], // Φ
           "03A7":["83B4","A6B6","CEA7"], // Χ
           "03A8":["83B5","A6B7","CEA8"], // Ψ
           "03A9":["83B6","A6B8","CEA9"], // Ω
           "03B1":["83BF","A6C1","CEB1"], // α
           "03B2":["83C0","A6C2","CEB2"], // β
           "03B3":["83C1","A6C3","CEB3"], // γ
           "03B4":["83C2","A6C4","CEB4"], // δ
           "03B5":["83C3","A6C5","CEB5"], // ε
           "03B6":["83C4","A6C6","CEB6"], // ζ
           "03B7":["83C5","A6C7","CEB7"], // η
           "03B8":["83C6","A6C8","CEB8"], // θ
           "03B9":["83C7","A6C9","CEB9"], // ι
           "03BA":["83C8","A6CA","CEBA"], // κ
           "03BB":["83C9","A6CB","CEBB"], // λ
           "03BC":["83CA","A6CC","CEBC"], // μ
           "03BD":["83CB","A6CD","CEBD"], // ν
           "03BE":["83CC","A6CE","CEBE"], // ξ
           "03BF":["83CD","A6CF","CEBF"], // ο
           "03C0":["83CE","A6D0","CF80"], // π
           "03C1":["83CF","A6D1","CF81"], // ρ
           "03C3":["83D0","A6D2","CF83"], // σ
           "03C4":["83D1","A6D3","CF84"], // τ
           "03C5":["83D2","A6D4","CF85"], // υ
           "03C6":["83D3","A6D5","CF86"], // φ
           "03C7":["83D4","A6D6","CF87"], // χ
           "03C8":["83D5","A6D7","CF88"], // ψ
           "03C9":["83D6","A6D8","CF89"], // ω
           "0401":["8446","A7A7","D081"], // Ё
           "0410":["8440","A7A1","D090"], // А
           "0411":["8441","A7A2","D091"], // Б
           "0412":["8442","A7A3","D092"], // В
           "0413":["8443","A7A4","D093"], // Г
           "0414":["8444","A7A5","D094"], // Д
           "0415":["8445","A7A6","D095"], // Е
           "0416":["8447","A7A8","D096"], // Ж
           "0417":["8448","A7A9","D097"], // З
           "0418":["8449","A7AA","D098"], // И
           "0419":["844A","A7AB","D099"], // Й
           "041A":["844B","A7AC","D09A"], // К
           "041B":["844C","A7AD","D09B"], // Л
           "041C":["844D","A7AE","D09C"], // М
           "041D":["844E","A7AF","D09D"], // Н
           "041E":["844F","A7B0","D09E"], // О
           "041F":["8450","A7B1","D09F"], // П
           "0420":["8451","A7B2","D0A0"], // Р
           "0421":["8452","A7B3","D0A1"], // С
           "0422":["8453","A7B4","D0A2"], // Т
           "0423":["8454","A7B5","D0A3"], // У
           "0424":["8455","A7B6","D0A4"], // Ф
           "0425":["8456","A7B7","D0A5"], // Х
           "0426":["8457","A7B8","D0A6"], // Ц
           "0427":["8458","A7B9","D0A7"], // Ч
           "0428":["8459","A7BA","D0A8"], // Ш
           "0429":["845A","A7BB","D0A9"], // Щ
           "042A":["845B","A7BC","D0AA"], // Ъ
           "042B":["845C","A7BD","D0AB"], // Ы
           "042C":["845D","A7BE","D0AC"], // Ь
           "042D":["845E","A7BF","D0AD"], // Э
           "042E":["845F","A7C0","D0AE"], // Ю
           "042F":["8460","A7C1","D0AF"], // Я
           "0430":["8470","A7D1","D0B0"], // а
           "0431":["8471","A7D2","D0B1"], // б
           "0432":["8472","A7D3","D0B2"], // в
           "0433":["8473","A7D4","D0B3"], // г
           "0434":["8474","A7D5","D0B4"], // д
           "0435":["8475","A7D6","D0B5"], // е
           "0436":["8477","A7D8","D0B6"], // ж
           "0437":["8478","A7D9","D0B7"], // з
           "0438":["8479","A7DA","D0B8"], // и
           "0439":["847A","A7DB","D0B9"], // й
           "043A":["847B","A7DC","D0BA"], // к
           "043B":["847C","A7DD","D0BB"], // л
           "043C":["847D","A7DE","D0BC"], // м
           "043D":["847E","A7DF","D0BD"], // н
           "043E":["8480","A7E0","D0BE"], // о
           "043F":["8481","A7E1","D0BF"], // п
           "0440":["8482","A7E2","D180"], // р
           "0441":["8483","A7E3","D181"], // с
           "0442":["8484","A7E4","D182"], // т
           "0443":["8485","A7E5","D183"], // у
           "0444":["8486","A7E6","D184"], // ф
           "0445":["8487","A7E7","D185"], // х
           "0446":["8488","A7E8","D186"], // ц
           "0447":["8489","A7E9","D187"], // ч
           "0448":["848A","A7EA","D188"], // ш
           "0449":["848B","A7EB","D189"], // щ
           "044A":["848C","A7EC","D18A"], // ъ
           "044B":["848D","A7ED","D18B"], // ы
           "044C":["848E","A7EE","D18C"], // ь
           "044D":["848F","A7EF","D18D"], // э
           "044E":["8490","A7F0","D18E"], // ю
           "044F":["8491","A7F1","D18F"], // я
           "0451":["8476","A7D7","D191"], // ё
           "2010":["815D","A1BE","E28090"], // ‐
           "2011":["815C","A1BD","E28095"], // —
           "2012":["815D","A1BE","E28090"], // ‐
           "2013":["815C","A1BD","E28095"], // —
           "2014":["815C","A1BD","E28095"], // —
           "2015":["815C","A1BD","E28095"], // —
           "2016":["8161","A1C2","E28096"], // ‖
           "2018":["8165","A1C6","E28098"], // ‘
           "2019":["8166","A1C7","E28099"], // ’
           "201C":["8167","A1C8","E2809C"], // “
           "201D":["8168","A1C9","E2809D"], // ”
           "2020":["81F5","A2F7","E280A0"], // †
           "2021":["81F6","A2F8","E280A1"], // ‡
           "2025":["8164","A1C5","E280A5"], // ‥
           "2026":["8163","A1C4","E280A6"], // …
           "2030":["81F1","A2F3","E280B0"], // ‰
           "2032":["818C","A1EC","E280B2"], // ′
           "2033":["818D","A1ED","E280B3"], // ″
           "203B":["81A6","A2A8","E280BB"], // ※
           "2103":["818E","A1EE","E28483"], // ℃
           "212B":["81F0","A2F2","E284AB"], // Å
           "2190":["81A9","A2AB","E28690"], // ←
           "2191":["81AA","A2AC","E28691"], // ↑
           "2192":["81A8","A2AA","E28692"], // →
           "2193":["81AB","A2AD","E28693"], // ↓
           "21D2":["81CB","A2CD","E28792"], // ⇒
           "21D4":["81CC","A2CE","E28794"], // ⇔
           "2200":["81CD","A2CF","E28880"], // ∀
           "2202":["81DD","A2DF","E28882"], // ∂
           "2203":["81CE","A2D0","E28883"], // ∃
           "2207":["81DE","A2E0","E28887"], // ∇
           "2208":["81B8","A2BA","E28888"], // ∈
           "220B":["81B9","A2BB","E2888B"], // ∋
           "2212":["817C","A1DD","E28892"], // −
           "221A":["81E3","A2E5","E2889A"], // √
           "221D":["81E5","A2E7","E2889D"], // ∝
           "221E":["8187","A1E7","E2889E"], // ∞
           "2220":["81DA","A2DC","E288A0"], // ∠
           "2227":["81C8","A2CA","E288A7"], // ∧
           "2228":["81C9","A2CB","E288A8"], // ∨
           "2229":["81BF","A2C1","E288A9"], // ∩
           "222A":["81BE","A2C0","E288AA"], // ∪
           "222B":["81E7","A2E9","E288AB"], // ∫
           "222C":["81E8","A2EA","E288AC"], // ∬
           "2234":["8188","A1E8","E288B4"], // ∴
           "2235":["81E6","A2E8","E288B5"], // ∵
           "223D":["81E4","A2E6","E288BD"], // ∽
           "2252":["81E0","A2E2","E28992"], // ≒
           "2260":["8182","A1E2","E289A0"], // ≠
           "2261":["81DF","A2E1","E289A1"], // ≡
           "2266":["8185","A1E5","E289A6"], // ≦
           "2267":["8186","A1E6","E289A7"], // ≧
           "226A":["81E1","A2E3","E289AA"], // ≪
           "226B":["81E2","A2E4","E289AB"], // ≫
           "2282":["81BC","A2BE","E28A82"], // ⊂
           "2283":["81BD","A2BF","E28A83"], // ⊃
           "2286":["81BA","A2BC","E28A86"], // ⊆
           "2287":["81BB","A2BD","E28A87"], // ⊇
           "22A5":["81DB","A2DD","E28AA5"], // ⊥
           "2312":["81DC","A2DE","E28C92"], // ⌒
           "2500":["849F","A8A1","E29480"], // ─
           "2501":["84AA","A8AC","E29481"], // ━
           "2502":["84A0","A8A2","E29482"], // │
           "2503":["84AB","A8AD","E29483"], // ┃
           "250C":["84A1","A8A3","E2948C"], // ┌
           "250F":["84AC","A8AE","E2948F"], // ┏
           "2510":["84A2","A8A4","E29490"], // ┐
           "2513":["84AD","A8AF","E29493"], // ┓
           "2514":["84A4","A8A6","E29494"], // └
           "2517":["84AF","A8B1","E29497"], // ┗
           "2518":["84A3","A8A5","E29498"], // ┘
           "251B":["84AE","A8B0","E2949B"], // ┛
           "251C":["84A5","A8A7","E2949C"], // ├
           "251D":["84BA","A8BC","E2949D"], // ┝
           "2520":["84B5","A8B7","E294A0"], // ┠
           "2523":["84B0","A8B2","E294A3"], // ┣
           "2524":["84A7","A8A9","E294A4"], // ┤
           "2525":["84BC","A8BE","E294A5"], // ┥
           "2528":["84B7","A8B9","E294A8"], // ┨
           "252B":["84B2","A8B4","E294AB"], // ┫
           "252C":["84A6","A8A8","E294AC"], // ┬
           "252F":["84B6","A8B8","E294AF"], // ┯
           "2530":["84BB","A8BD","E294B0"], // ┰
           "2533":["84B1","A8B3","E294B3"], // ┳
           "2534":["84A8","A8AA","E294B4"], // ┴
           "2537":["84B8","A8BA","E294B7"], // ┷
           "2538":["84BD","A8BF","E294B8"], // ┸
           "253B":["84B3","A8B5","E294BB"], // ┻
           "253C":["84A9","A8AB","E294BC"], // ┼
           "253F":["84B9","A8BB","E294BF"], // ┿
           "2542":["84BE","A8C0","E29582"], // ╂
           "254B":["84B4","A8B6","E2958B"], // ╋
           "25A0":["81A1","A2A3","E296A0"], // ■
           "25A1":["81A0","A2A2","E296A1"], // □
           "25B2":["81A3","A2A5","E296B2"], // ▲
           "25B3":["81A2","A2A4","E296B3"], // △
           "25BC":["81A5","A2A7","E296BC"], // ▼
           "25BD":["81A4","A2A6","E296BD"], // ▽
           "25C6":["819F","A2A1","E29786"], // ◆
           "25C7":["819E","A1FE","E29787"], // ◇
           "25CB":["819B","A1FB","E2978B"], // ○
           "25CE":["819D","A1FD","E2978E"], // ◎
           "25CF":["819C","A1FC","E2978F"], // ●
           "25EF":["81FC","A2FE","E297AF"], // ◯
           "2605":["819A","A1FA","E29885"], // ★
           "2606":["8199","A1F9","E29886"], // ☆
           "2640":["818A","A1EA","E29980"], // ♀
           "2642":["8189","A1E9","E29982"], // ♂
           "266A":["81F4","A2F6","E299AA"], // ♪
           "266D":["81F3","A2F5","E299AD"], // ♭
           "266F":["81F2","A2F4","E299AF"], // ♯
           "3000":["8140","A1A1","E38080"], // 　
           "3001":["8141","A1A2","E38081"], // 、
           "3002":["8142","A1A3","E38082"], // 。
           "3003":["8156","A1B7","E38083"], // 〃
           "3005":["8158","A1B9","E38085"], // 々
           "3006":["8159","A1BA","E38086"], // 〆
           "3007":["815A","A1BB","E38087"], // 〇
           "3008":["8171","A1D2","E38088"], // 〈
           "3009":["8172","A1D3","E38089"], // 〉
           "300A":["8173","A1D4","E3808A"], // 《
           "300B":["8174","A1D5","E3808B"], // 》
           "300C":["8175","A1D6","E3808C"], // 「
           "300D":["8176","A1D7","E3808D"], // 」
           "300E":["8177","A1D8","E3808E"], // 『
           "300F":["8178","A1D9","E3808F"], // 』
           "3010":["8179","A1DA","E38090"], // 【
           "3011":["817A","A1DB","E38091"], // 】
           "3012":["81A7","A2A9","E38092"], // 〒
           "3013":["81AC","A2AE","E38093"], // 〓
           "3014":["816B","A1CC","E38094"], // 〔
           "3015":["816C","A1CD","E38095"], // 〕
           "301C":["8160","A1C1","E3809C"], // 〜
           "3041":["829F","A4A1","E38181"], // ぁ
           "3042":["82A0","A4A2","E38182"], // あ
           "3043":["82A1","A4A3","E38183"], // ぃ
           "3044":["82A2","A4A4","E38184"], // い
           "3045":["82A3","A4A5","E38185"], // ぅ
           "3046":["82A4","A4A6","E38186"], // う
           "3047":["82A5","A4A7","E38187"], // ぇ
           "3048":["82A6","A4A8","E38188"], // え
           "3049":["82A7","A4A9","E38189"], // ぉ
           "304A":["82A8","A4AA","E3818A"], // お
           "304B":["82A9","A4AB","E3818B"], // か
           "304C":["82AA","A4AC","E3818C"], // が
           "304D":["82AB","A4AD","E3818D"], // き
           "304E":["82AC","A4AE","E3818E"], // ぎ
           "304F":["82AD","A4AF","E3818F"], // く
           "3050":["82AE","A4B0","E38190"], // ぐ
           "3051":["82AF","A4B1","E38191"], // け
           "3052":["82B0","A4B2","E38192"], // げ
           "3053":["82B1","A4B3","E38193"], // こ
           "3054":["82B2","A4B4","E38194"], // ご
           "3055":["82B3","A4B5","E38195"], // さ
           "3056":["82B4","A4B6","E38196"], // ざ
           "3057":["82B5","A4B7","E38197"], // し
           "3058":["82B6","A4B8","E38198"], // じ
           "3059":["82B7","A4B9","E38199"], // す
           "305A":["82B8","A4BA","E3819A"], // ず
           "305B":["82B9","A4BB","E3819B"], // せ
           "305C":["82BA","A4BC","E3819C"], // ぜ
           "305D":["82BB","A4BD","E3819D"], // そ
           "305E":["82BC","A4BE","E3819E"], // ぞ
           "305F":["82BD","A4BF","E3819F"], // た
           "3060":["82BE","A4C0","E381A0"], // だ
           "3061":["82BF","A4C1","E381A1"], // ち
           "3062":["82C0","A4C2","E381A2"], // ぢ
           "3063":["82C1","A4C3","E381A3"], // っ
           "3064":["82C2","A4C4","E381A4"], // つ
           "3065":["82C3","A4C5","E381A5"], // づ
           "3066":["82C4","A4C6","E381A6"], // て
           "3067":["82C5","A4C7","E381A7"], // で
           "3068":["82C6","A4C8","E381A8"], // と
           "3069":["82C7","A4C9","E381A9"], // ど
           "306A":["82C8","A4CA","E381AA"], // な
           "306B":["82C9","A4CB","E381AB"], // に
           "306C":["82CA","A4CC","E381AC"], // ぬ
           "306D":["82CB","A4CD","E381AD"], // ね
           "306E":["82CC","A4CE","E381AE"], // の
           "306F":["82CD","A4CF","E381AF"], // は
           "3070":["82CE","A4D0","E381B0"], // ば
           "3071":["82CF","A4D1","E381B1"], // ぱ
           "3072":["82D0","A4D2","E381B2"], // ひ
           "3073":["82D1","A4D3","E381B3"], // び
           "3074":["82D2","A4D4","E381B4"], // ぴ
           "3075":["82D3","A4D5","E381B5"], // ふ
           "3076":["82D4","A4D6","E381B6"], // ぶ
           "3077":["82D5","A4D7","E381B7"], // ぷ
           "3078":["82D6","A4D8","E381B8"], // へ
           "3079":["82D7","A4D9","E381B9"], // べ
           "307A":["82D8","A4DA","E381BA"], // ぺ
           "307B":["82D9","A4DB","E381BB"], // ほ
           "307C":["82DA","A4DC","E381BC"], // ぼ
           "307D":["82DB","A4DD","E381BD"], // ぽ
           "307E":["82DC","A4DE","E381BE"], // ま
           "307F":["82DD","A4DF","E381BF"], // み
           "3080":["82DE","A4E0","E38280"], // む
           "3081":["82DF","A4E1","E38281"], // め
           "3082":["82E0","A4E2","E38282"], // も
           "3083":["82E1","A4E3","E38283"], // ゃ
           "3084":["82E2","A4E4","E38284"], // や
           "3085":["82E3","A4E5","E38285"], // ゅ
           "3086":["82E4","A4E6","E38286"], // ゆ
           "3087":["82E5","A4E7","E38287"], // ょ
           "3088":["82E6","A4E8","E38288"], // よ
           "3089":["82E7","A4E9","E38289"], // ら
           "308A":["82E8","A4EA","E3828A"], // り
           "308B":["82E9","A4EB","E3828B"], // る
           "308C":["82EA","A4EC","E3828C"], // れ
           "308D":["82EB","A4ED","E3828D"], // ろ
           "308E":["82EC","A4EE","E3828E"], // ゎ
           "308F":["82ED","A4EF","E3828F"], // わ
           "3090":["82EE","A4F0","E38290"], // ゐ
           "3091":["82EF","A4F1","E38291"], // ゑ
           "3092":["82F0","A4F2","E38292"], // を
           "3093":["82F1","A4F3","E38293"], // ん
           "309B":["814A","A1AB","E3829B"], // ゛
           "309C":["814B","A1AC","E3829C"], // ゜
           "309D":["8154","A1B5","E3829D"], // ゝ
           "309E":["8155","A1B6","E3829E"], // ゞ
           "30A1":["8340","A5A1","E382A1"], // ァ
           "30A2":["8341","A5A2","E382A2"], // ア
           "30A3":["8342","A5A3","E382A3"], // ィ
           "30A4":["8343","A5A4","E382A4"], // イ
           "30A5":["8344","A5A5","E382A5"], // ゥ
           "30A6":["8345","A5A6","E382A6"], // ウ
           "30A7":["8346","A5A7","E382A7"], // ェ
           "30A8":["8347","A5A8","E382A8"], // エ
           "30A9":["8348","A5A9","E382A9"], // ォ
           "30AA":["8349","A5AA","E382AA"], // オ
           "30AB":["834A","A5AB","E382AB"], // カ
           "30AC":["834B","A5AC","E382AC"], // ガ
           "30AD":["834C","A5AD","E382AD"], // キ
           "30AE":["834D","A5AE","E382AE"], // ギ
           "30AF":["834E","A5AF","E382AF"], // ク
           "30B0":["834F","A5B0","E382B0"], // グ
           "30B1":["8350","A5B1","E382B1"], // ケ
           "30B2":["8351","A5B2","E382B2"], // ゲ
           "30B3":["8352","A5B3","E382B3"], // コ
           "30B4":["8353","A5B4","E382B4"], // ゴ
           "30B5":["8354","A5B5","E382B5"], // サ
           "30B6":["8355","A5B6","E382B6"], // ザ
           "30B7":["8356","A5B7","E382B7"], // シ
           "30B8":["8357","A5B8","E382B8"], // ジ
           "30B9":["8358","A5B9","E382B9"], // ス
           "30BA":["8359","A5BA","E382BA"], // ズ
           "30BB":["835A","A5BB","E382BB"], // セ
           "30BC":["835B","A5BC","E382BC"], // ゼ
           "30BD":["835C","A5BD","E382BD"], // ソ
           "30BE":["835D","A5BE","E382BE"], // ゾ
           "30BF":["835E","A5BF","E382BF"], // タ
           "30C0":["835F","A5C0","E38380"], // ダ
           "30C1":["8360","A5C1","E38381"], // チ
           "30C2":["8361","A5C2","E38382"], // ヂ
           "30C3":["8362","A5C3","E38383"], // ッ
           "30C4":["8363","A5C4","E38384"], // ツ
           "30C5":["8364","A5C5","E38385"], // ヅ
           "30C6":["8365","A5C6","E38386"], // テ
           "30C7":["8366","A5C7","E38387"], // デ
           "30C8":["8367","A5C8","E38388"], // ト
           "30C9":["8368","A5C9","E38389"], // ド
           "30CA":["8369","A5CA","E3838A"], // ナ
           "30CB":["836A","A5CB","E3838B"], // ニ
           "30CC":["836B","A5CC","E3838C"], // ヌ
           "30CD":["836C","A5CD","E3838D"], // ネ
           "30CE":["836D","A5CE","E3838E"], // ノ
           "30CF":["836E","A5CF","E3838F"], // ハ
           "30D0":["836F","A5D0","E38390"], // バ
           "30D1":["8370","A5D1","E38391"], // パ
           "30D2":["8371","A5D2","E38392"], // ヒ
           "30D3":["8372","A5D3","E38393"], // ビ
           "30D4":["8373","A5D4","E38394"], // ピ
           "30D5":["8374","A5D5","E38395"], // フ
           "30D6":["8375","A5D6","E38396"], // ブ
           "30D7":["8376","A5D7","E38397"], // プ
           "30D8":["8377","A5D8","E38398"], // ヘ
           "30D9":["8378","A5D9","E38399"], // ベ
           "30DA":["8379","A5DA","E3839A"], // ペ
           "30DB":["837A","A5DB","E3839B"], // ホ
           "30DC":["837B","A5DC","E3839C"], // ボ
           "30DD":["837C","A5DD","E3839D"], // ポ
           "30DE":["837D","A5DE","E3839E"], // マ
           "30DF":["837E","A5DF","E3839F"], // ミ
           "30E0":["8380","A5E0","E383A0"], // ム
           "30E1":["8381","A5E1","E383A1"], // メ
           "30E2":["8382","A5E2","E383A2"], // モ
           "30E3":["8383","A5E3","E383A3"], // ャ
           "30E4":["8384","A5E4","E383A4"], // ヤ
           "30E5":["8385","A5E5","E383A5"], // ュ
           "30E6":["8386","A5E6","E383A6"], // ユ
           "30E7":["8387","A5E7","E383A7"], // ョ
           "30E8":["8388","A5E8","E383A8"], // ヨ
           "30E9":["8389","A5E9","E383A9"], // ラ
           "30EA":["838A","A5EA","E383AA"], // リ
           "30EB":["838B","A5EB","E383AB"], // ル
           "30EC":["838C","A5EC","E383AC"], // レ
           "30ED":["838D","A5ED","E383AD"], // ロ
           "30EE":["838E","A5EE","E383AE"], // ヮ
           "30EF":["838F","A5EF","E383AF"], // ワ
           "30F0":["8390","A5F0","E383B0"], // ヰ
           "30F1":["8391","A5F1","E383B1"], // ヱ
           "30F2":["8392","A5F2","E383B2"], // ヲ
           "30F3":["8393","A5F3","E383B3"], // ン
           "30F4":["8394","A5F4","E383B4"], // ヴ
           "30F5":["8395","A5F5","E383B5"], // ヵ
           "30F6":["8396","A5F6","E383B6"], // ヶ
           "30FB":["8145","A1A6","E383BB"], // ・
           "30FC":["815B","A1BC","E383BC"], // ー
           "30FD":["8152","A1B3","E383BD"], // ヽ
           "30FE":["8153","A1B4","E383BE"], // ヾ
           "4E00":["88EA","B0EC","E4B880"], // 一
           "4E01":["929A","C3FA","E4B881"], // 丁
           "4E03":["8EB5","BCB7","E4B883"], // 七
           "4E07":["969C","CBFC","E4B887"], // 万
           "4E08":["8FE4","BEE6","E4B888"], // 丈
           "4E09":["8E4F","BBB0","E4B889"], // 三
           "4E0A":["8FE3","BEE5","E4B88A"], // 上
           "4E0B":["89BA","B2BC","E4B88B"], // 下
           "4E0D":["9573","C9D4","E4B88D"], // 不
           "4E0E":["975E","CDBF","E4B88E"], // 与
           "4E11":["894E","B1AF","E4B891"], // 丑
           "4E14":["8A8E","B3EE","E4B894"], // 且
           "4E16":["90A2","C0A4","E4B896"], // 世
           "4E18":["8B75","B5D6","E4B898"], // 丘
           "4E19":["95B8","CABA","E4B899"], // 丙
           "4E1E":["8FE5","BEE7","E4B89E"], // 丞
           "4E21":["97BC","CEBE","E4B8A1"], // 両
           "4E26":["95C0","CAC2","E4B8A6"], // 並
           "4E2D":["9286","C3E6","E4B8AD"], // 中
           "4E32":["8BF8","B6FA","E4B8B2"], // 串
           "4E38":["8ADB","B4DD","E4B8B8"], // 丸
           "4E39":["924F","C3B0","E4B8B9"], // 丹
           "4E3B":["8EE5","BCE7","E4B8BB"], // 主
           "4E43":["9454","C7B5","E4B983"], // 乃
           "4E45":["8B76","B5D7","E4B985"], // 久
           "4E4B":["9456","C7B7","E4B98B"], // 之
           "4E4D":["93E1","C6E3","E4B98D"], // 乍
           "4E4E":["8CC1","B8C3","E4B98E"], // 乎
           "4E4F":["9652","CBB3","E4B98F"], // 乏
           "4E57":["8FE6","BEE8","E4B997"], // 乗
           "4E59":["89B3","B2B5","E4B999"], // 乙
           "4E5D":["8BE3","B6E5","E4B99D"], // 九
           "4E5E":["8CEE","B8F0","E4B99E"], // 乞
           "4E5F":["96E7","CCE9","E4B99F"], // 也
           "4E71":["9790","CDF0","E4B9B1"], // 乱
           "4E73":["93FB","C6FD","E4B9B3"], // 乳
           "4E7E":["8AA3","B4A5","E4B9BE"], // 乾
           "4E80":["8B54","B5B5","E4BA80"], // 亀
           "4E86":["97B9","CEBB","E4BA86"], // 了
           "4E88":["975C","CDBD","E4BA88"], // 予
           "4E89":["9188","C1E8","E4BA89"], // 争
           "4E8B":["8E96","BBF6","E4BA8B"], // 事
           "4E8C":["93F1","C6F3","E4BA8C"], // 二
           "4E91":["895D","B1BE","E4BA91"], // 云
           "4E92":["8CDD","B8DF","E4BA92"], // 互
           "4E94":["8CDC","B8DE","E4BA94"], // 五
           "4E95":["88E4","B0E6","E4BA95"], // 井
           "4E98":["986A","CFCB","E4BA98"], // 亘
           "4E99":["9869","CFCA","E4BA99"], // 亙
           "4E9B":["8DB1","BAB3","E4BA9B"], // 些
           "4E9C":["889F","B0A1","E4BA9C"], // 亜
           "4EA1":["9653","CBB4","E4BAA1"], // 亡
           "4EA4":["8CF0","B8F2","E4BAA4"], // 交
           "4EA5":["88E5","B0E7","E4BAA5"], // 亥
           "4EA6":["9692","CBF2","E4BAA6"], // 亦
           "4EA8":["8B9C","B5FC","E4BAA8"], // 亨
           "4EAB":["8B9D","B5FD","E4BAAB"], // 享
           "4EAC":["8B9E","B5FE","E4BAAC"], // 京
           "4EAD":["92E0","C4E2","E4BAAD"], // 亭
           "4EAE":["97BA","CEBC","E4BAAE"], // 亮
           "4EBA":["906C","BFCD","E4BABA"], // 人
           "4EC0":["8F59","BDBA","E4BB80"], // 什
           "4EC1":["906D","BFCE","E4BB81"], // 仁
           "4EC7":["8B77","B5D8","E4BB87"], // 仇
           "4ECA":["8DA1","BAA3","E4BB8A"], // 今
           "4ECB":["89EE","B2F0","E4BB8B"], // 介
           "4ECF":["95A7","CAA9","E4BB8F"], // 仏
           "4ED4":["8E65","BBC6","E4BB94"], // 仔
           "4ED5":["8E64","BBC5","E4BB95"], // 仕
           "4ED6":["91BC","C2BE","E4BB96"], // 他
           "4ED8":["9574","C9D5","E4BB98"], // 付
           "4ED9":["90E5","C0E7","E4BB99"], // 仙
           "4EDD":["8157","A1B8","E4BB9D"], // 仝
           "4EE3":["91E3","C2E5","E4BBA3"], // 代
           "4EE4":["97DF","CEE1","E4BBA4"], // 令
           "4EE5":["88C8","B0CA","E4BBA5"], // 以
           "4EEE":["89BC","B2BE","E4BBAE"], // 仮
           "4EF0":["8BC2","B6C4","E4BBB0"], // 仰
           "4EF2":["9287","C3E7","E4BBB2"], // 仲
           "4EF6":["8C8F","B7EF","E4BBB6"], // 件
           "4EFB":["9443","C7A4","E4BBBB"], // 任
           "4F01":["8AE9","B4EB","E4BC81"], // 企
           "4F0A":["88C9","B0CB","E4BC8A"], // 伊
           "4F0D":["8CDE","B8E0","E4BC8D"], // 伍
           "4F0E":["8AEA","B4EC","E4BC8E"], // 伎
           "4F0F":["959A","C9FA","E4BC8F"], // 伏
           "4F10":["94B0","C8B2","E4BC90"], // 伐
           "4F11":["8B78","B5D9","E4BC91"], // 休
           "4F1A":["89EF","B2F1","E4BC9A"], // 会
           "4F1D":["9360","C5C1","E4BC9D"], // 伝
           "4F2F":["948C","C7EC","E4BCAF"], // 伯
           "4F34":["94BA","C8BC","E4BCB4"], // 伴
           "4F36":["97E0","CEE2","E4BCB6"], // 伶
           "4F38":["904C","BFAD","E4BCB8"], // 伸
           "4F3A":["8E66","BBC7","E4BCBA"], // 伺
           "4F3C":["8E97","BBF7","E4BCBC"], // 似
           "4F3D":["89BE","B2C0","E4BCBD"], // 伽
           "4F43":["92CF","C4D1","E4BD83"], // 佃
           "4F46":["9241","C3A2","E4BD86"], // 但
           "4F4D":["88CA","B0CC","E4BD8D"], // 位
           "4F4E":["92E1","C4E3","E4BD8E"], // 低
           "4F4F":["8F5A","BDBB","E4BD8F"], // 住
           "4F50":["8DB2","BAB4","E4BD90"], // 佐
           "4F51":["9743","CDA4","E4BD91"], // 佑
           "4F53":["91CC","C2CE","E4BD93"], // 体
           "4F55":["89BD","B2BF","E4BD95"], // 何
           "4F59":["975D","CDBE","E4BD99"], // 余
           "4F5C":["8DEC","BAEE","E4BD9C"], // 作
           "4F73":["89C0","B2C2","E4BDB3"], // 佳
           "4F75":["95B9","CABB","E4BDB5"], // 併
           "4F7C":["8CF1","B8F3","E4BDBC"], // 佼
           "4F7F":["8E67","BBC8","E4BDBF"], // 使
           "4F83":["8AA4","B4A6","E4BE83"], // 侃
           "4F8B":["97E1","CEE3","E4BE8B"], // 例
           "4F8D":["8E98","BBF8","E4BE8D"], // 侍
           "4F9B":["8B9F","B6A1","E4BE9B"], // 供
           "4F9D":["88CB","B0CD","E4BE9D"], // 依
           "4FA0":["8BA0","B6A2","E4BEA0"], // 侠
           "4FA1":["89BF","B2C1","E4BEA1"], // 価
           "4FAD":["9699","CBF9","E4BEAD"], // 侭
           "4FAE":["958E","C9EE","E4BEAE"], // 侮
           "4FAF":["8CF2","B8F4","E4BEAF"], // 侯
           "4FB5":["904E","BFAF","E4BEB5"], // 侵
           "4FB6":["97B5","CEB7","E4BEB6"], // 侶
           "4FBF":["95D6","CAD8","E4BEBF"], // 便
           "4FC2":["8C57","B7B8","E4BF82"], // 係
           "4FC3":["91A3","C2A5","E4BF83"], // 促
           "4FC4":["89E2","B2E4","E4BF84"], // 俄
           "4FCA":["8F72","BDD3","E4BF8A"], // 俊
           "4FD7":["91AD","C2AF","E4BF97"], // 俗
           "4FDD":["95DB","CADD","E4BF9D"], // 保
           "4FE1":["904D","BFAE","E4BFA1"], // 信
           "4FE3":["9693","CBF3","E4BFA3"], // 俣
           "4FEE":["8F43","BDA4","E4BFAE"], // 修
           "4FF3":["946F","C7D0","E4BFB3"], // 俳
           "4FF5":["9555","C9B6","E4BFB5"], // 俵
           "4FF8":["95EE","CAF0","E4BFB8"], // 俸
           "4FFA":["89B4","B2B6","E4BFBA"], // 俺
           "5009":["9171","C1D2","E58089"], // 倉
           "500B":["8CC2","B8C4","E5808B"], // 個
           "500D":["947B","C7DC","E5808D"], // 倍
           "5012":["937C","C5DD","E58092"], // 倒
           "5016":["8CF4","B8F6","E58096"], // 倖
           "5019":["8CF3","B8F5","E58099"], // 候
           "501F":["8ED8","BCDA","E5809F"], // 借
           "5023":["95ED","CAEF","E580A3"], // 倣
           "5024":["926C","C3CD","E580A4"], // 値
           "5026":["8C91","B7F1","E580A6"], // 倦
           "502B":["97CF","CED1","E580AB"], // 倫
           "502D":["9860","CFC1","E580AD"], // 倭
           "5036":["8BE4","B6E6","E580B6"], // 倶
           "5039":["8C90","B7F0","E580B9"], // 倹
           "5049":["88CC","B0CE","E58189"], // 偉
           "504F":["95CE","CAD0","E5818F"], // 偏
           "505C":["92E2","C4E4","E5819C"], // 停
           "5065":["8C92","B7F2","E581A5"], // 健
           "5072":["8EC3","BCC5","E581B2"], // 偲
           "5074":["91A4","C2A6","E581B4"], // 側
           "5075":["92E3","C4E5","E581B5"], // 偵
           "5076":["8BF4","B6F6","E581B6"], // 偶
           "507D":["8B55","B5B6","E581BD"], // 偽
           "508D":["9654","CBB5","E5828D"], // 傍
           "5091":["8C86","B7E6","E58291"], // 傑
           "5098":["8E50","BBB1","E58298"], // 傘
           "5099":["94F5","C8F7","E58299"], // 備
           "50AC":["8DC3","BAC5","E582AC"], // 催
           "50AD":["9762","CDC3","E582AD"], // 傭
           "50B5":["8DC2","BAC4","E582B5"], // 債
           "50B7":["8F9D","BDFD","E582B7"], // 傷
           "50BE":["8C58","B7B9","E582BE"], // 傾
           "50C5":["8BCD","B6CF","E58385"], // 僅
           "50CD":["93AD","C6AF","E5838D"], // 働
           "50CF":["919C","C1FC","E5838F"], // 像
           "50D1":["8BA1","B6A3","E58391"], // 僑
           "50D5":["966C","CBCD","E58395"], // 僕
           "50DA":["97BB","CEBD","E5839A"], // 僚
           "50E7":["916D","C1CE","E583A7"], // 僧
           "50FB":["95C6","CAC8","E583BB"], // 僻
           "5100":["8B56","B5B7","E58480"], // 儀
           "5104":["89AD","B2AF","E58484"], // 億
           "5112":["8EF2","BCF4","E58492"], // 儒
           "511F":["8F9E","BDFE","E5849F"], // 償
           "512A":["9744","CDA5","E584AA"], // 優
           "5132":["96D7","CCD9","E584B2"], // 儲
           "5141":["88F2","B0F4","E58581"], // 允
           "5143":["8CB3","B8B5","E58583"], // 元
           "5144":["8C5A","B7BB","E58584"], // 兄
           "5145":["8F5B","BDBC","E58585"], // 充
           "5146":["929B","C3FB","E58586"], // 兆
           "5147":["8BA2","B6A4","E58587"], // 兇
           "5148":["90E6","C0E8","E58588"], // 先
           "5149":["8CF5","B8F7","E58589"], // 光
           "514B":["8D8E","B9EE","E5858B"], // 克
           "514D":["96C6","CCC8","E5858D"], // 免
           "514E":["9365","C5C6","E5858E"], // 兎
           "5150":["8E99","BBF9","E58590"], // 児
           "515A":["937D","C5DE","E5859A"], // 党
           "515C":["8A95","B3F5","E5859C"], // 兜
           "5165":["93FC","C6FE","E585A5"], // 入
           "5168":["9153","C1B4","E585A8"], // 全
           "516B":["94AA","C8AC","E585AB"], // 八
           "516C":["8CF6","B8F8","E585AC"], // 公
           "516D":["985A","CFBB","E585AD"], // 六
           "5171":["8BA4","B6A6","E585B1"], // 共
           "5175":["95BA","CABC","E585B5"], // 兵
           "5176":["91B4","C2B6","E585B6"], // 其
           "5177":["8BEF","B6F1","E585B7"], // 具
           "5178":["9354","C5B5","E585B8"], // 典
           "517C":["8C93","B7F3","E585BC"], // 兼
           "5185":["93E0","C6E2","E58685"], // 内
           "5186":["897E","B1DF","E58686"], // 円
           "518A":["8DFB","BAFD","E5868A"], // 冊
           "518D":["8DC4","BAC6","E5868D"], // 再
           "5192":["9660","CBC1","E58692"], // 冒
           "5197":["8FE7","BEE9","E58697"], // 冗
           "5199":["8ECA","BCCC","E58699"], // 写
           "51A0":["8AA5","B4A7","E586A0"], // 冠
           "51A5":["96BB","CCBD","E586A5"], // 冥
           "51A8":["9579","C9DA","E586A8"], // 冨
           "51AC":["937E","C5DF","E586AC"], // 冬
           "51B4":["8DE1","BAE3","E586B4"], // 冴
           "51B6":["96E8","CCEA","E586B6"], // 冶
           "51B7":["97E2","CEE4","E586B7"], // 冷
           "51C4":["90A6","C0A8","E58784"], // 凄
           "51C6":["8F79","BDDA","E58786"], // 准
           "51CB":["929C","C3FC","E5878B"], // 凋
           "51CC":["97BD","CEBF","E5878C"], // 凌
           "51CD":["9380","C5E0","E5878D"], // 凍
           "51DD":["8BC3","B6C5","E5879D"], // 凝
           "51E1":["967D","CBDE","E587A1"], // 凡
           "51E6":["8F88","BDE8","E587A6"], // 処
           "51E7":["91FA","C2FC","E587A7"], // 凧
           "51EA":["93E2","C6E4","E587AA"], // 凪
           "51F1":["8A4D","B3AE","E587B1"], // 凱
           "51F6":["8BA5","B6A7","E587B6"], // 凶
           "51F8":["93CA","C6CC","E587B8"], // 凸
           "51F9":["899A","B1FA","E587B9"], // 凹
           "51FA":["8F6F","BDD0","E587BA"], // 出
           "51FD":["949F","C8A1","E587BD"], // 函
           "5200":["9381","C5E1","E58880"], // 刀
           "5203":["906E","BFCF","E58883"], // 刃
           "5206":["95AA","CAAC","E58886"], // 分
           "5207":["90D8","C0DA","E58887"], // 切
           "5208":["8AA0","B4A2","E58888"], // 刈
           "520A":["8AA7","B4A9","E5888A"], // 刊
           "5211":["8C59","B7BA","E58891"], // 刑
           "5217":["97F1","CEF3","E58897"], // 列
           "521D":["8F89","BDE9","E5889D"], // 初
           "5224":["94BB","C8BD","E588A4"], // 判
           "5225":["95CA","CACC","E588A5"], // 別
           "5229":["9798","CDF8","E588A9"], // 利
           "5230":["939E","C5FE","E588B0"], // 到
           "5236":["90A7","C0A9","E588B6"], // 制
           "5237":["8DFC","BAFE","E588B7"], // 刷
           "5238":["8C94","B7F4","E588B8"], // 券
           "523A":["8E68","BBC9","E588BA"], // 刺
           "523B":["8D8F","B9EF","E588BB"], // 刻
           "5243":["92E4","C4E6","E58983"], // 剃
           "5247":["91A5","C2A7","E58987"], // 則
           "524A":["8DED","BAEF","E5898A"], // 削
           "524D":["914F","C1B0","E5898D"], // 前
           "5256":["9655","CBB6","E58996"], // 剖
           "525B":["8D84","B9E4","E5899B"], // 剛
           "5263":["8C95","B7F5","E589A3"], // 剣
           "5264":["8DDC","BADE","E589A4"], // 剤
           "5265":["948D","C7ED","E589A5"], // 剥
           "526F":["959B","C9FB","E589AF"], // 副
           "5270":["8FE8","BEEA","E589B0"], // 剰
           "5272":["8A84","B3E4","E589B2"], // 割
           "5275":["916E","C1CF","E589B5"], // 創
           "5283":["8A63","B3C4","E58A83"], // 劃
           "5287":["8C80","B7E0","E58A87"], // 劇
           "5289":["97AB","CEAD","E58A89"], // 劉
           "529B":["97CD","CECF","E58A9B"], // 力
           "529F":["8CF7","B8F9","E58A9F"], // 功
           "52A0":["89C1","B2C3","E58AA0"], // 加
           "52A3":["97F2","CEF4","E58AA3"], // 劣
           "52A9":["8F95","BDF5","E58AA9"], // 助
           "52AA":["9377","C5D8","E58AAA"], // 努
           "52AB":["8D85","B9E5","E58AAB"], // 劫
           "52B1":["97E3","CEE5","E58AB1"], // 励
           "52B4":["984A","CFAB","E58AB4"], // 労
           "52B9":["8CF8","B8FA","E58AB9"], // 効
           "52BE":["8A4E","B3AF","E58ABE"], // 劾
           "52C3":["9675","CBD6","E58B83"], // 勃
           "52C5":["92BA","C4BC","E58B85"], // 勅
           "52C7":["9745","CDA6","E58B87"], // 勇
           "52C9":["95D7","CAD9","E58B89"], // 勉
           "52D5":["93AE","C6B0","E58B95"], // 動
           "52D8":["8AA8","B4AA","E58B98"], // 勘
           "52D9":["96B1","CCB3","E58B99"], // 務
           "52DD":["8F9F","BEA1","E58B9D"], // 勝
           "52DF":["95E5","CAE7","E58B9F"], // 募
           "52E2":["90A8","C0AA","E58BA2"], // 勢
           "52E4":["8BCE","B6D0","E58BA4"], // 勤
           "52E7":["8AA9","B4AB","E58BA7"], // 勧
           "52F2":["8C4D","B7AE","E58BB2"], // 勲
           "52FA":["8ED9","BCDB","E58BBA"], // 勺
           "52FE":["8CF9","B8FB","E58BBE"], // 勾
           "52FF":["96DC","CCDE","E58BBF"], // 勿
           "5301":["96E6","CCE8","E58C81"], // 匁
           "5302":["93F5","C6F7","E58C82"], // 匂
           "5305":["95EF","CAF1","E58C85"], // 包
           "5316":["89BB","B2BD","E58C96"], // 化
           "5317":["966B","CBCC","E58C97"], // 北
           "5319":["8DFA","BAFC","E58C99"], // 匙
           "531D":["9178","C1D9","E58C9D"], // 匝
           "5320":["8FA0","BEA2","E58CA0"], // 匠
           "5321":["8BA7","B6A9","E58CA1"], // 匡
           "532A":["94D9","C8DB","E58CAA"], // 匪
           "5339":["9543","C9A4","E58CB9"], // 匹
           "533A":["8BE6","B6E8","E58CBA"], // 区
           "533B":["88E3","B0E5","E58CBB"], // 医
           "533F":["93BD","C6BF","E58CBF"], // 匿
           "5341":["8F5C","BDBD","E58D81"], // 十
           "5343":["90E7","C0E9","E58D83"], // 千
           "5347":["8FA1","BEA3","E58D87"], // 升
           "5348":["8CDF","B8E1","E58D88"], // 午
           "534A":["94BC","C8BE","E58D8A"], // 半
           "5351":["94DA","C8DC","E58D91"], // 卑
           "5352":["91B2","C2B4","E58D92"], // 卒
           "5353":["91EC","C2EE","E58D93"], // 卓
           "5354":["8BA6","B6A8","E58D94"], // 協
           "5357":["93EC","C6EE","E58D97"], // 南
           "5358":["9250","C3B1","E58D98"], // 単
           "535A":["948E","C7EE","E58D9A"], // 博
           "535C":["966D","CBCE","E58D9C"], // 卜
           "5360":["90E8","C0EA","E58DA0"], // 占
           "5366":["8C54","B7B5","E58DA6"], // 卦
           "536F":["894B","B1AC","E58DAF"], // 卯
           "5370":["88F3","B0F5","E58DB0"], // 印
           "5371":["8AEB","B4ED","E58DB1"], // 危
           "5373":["91A6","C2A8","E58DB3"], // 即
           "5374":["8B70","B5D1","E58DB4"], // 却
           "5375":["9791","CDF1","E58DB5"], // 卵
           "5378":["89B5","B2B7","E58DB8"], // 卸
           "537F":["8BA8","B6AA","E58DBF"], // 卿
           "5384":["96EF","CCF1","E58E84"], // 厄
           "5398":["97D0","CED2","E58E98"], // 厘
           "539A":["8CFA","B8FC","E58E9A"], // 厚
           "539F":["8CB4","B8B6","E58E9F"], // 原
           "53A8":["907E","BFDF","E58EA8"], // 厨
           "53A9":["8958","B1B9","E58EA9"], // 厩
           "53AD":["897D","B1DE","E58EAD"], // 厭
           "53B3":["8CB5","B8B7","E58EB3"], // 厳
           "53BB":["8B8E","B5EE","E58EBB"], // 去
           "53C2":["8E51","BBB2","E58F82"], // 参
           "53C8":["9694","CBF4","E58F88"], // 又
           "53C9":["8DB3","BAB5","E58F89"], // 叉
           "53CA":["8B79","B5DA","E58F8A"], // 及
           "53CB":["9746","CDA7","E58F8B"], // 友
           "53CC":["916F","C1D0","E58F8C"], // 双
           "53CD":["94BD","C8BF","E58F8D"], // 反
           "53CE":["8EFB","BCFD","E58F8E"], // 収
           "53D4":["8F66","BDC7","E58F94"], // 叔
           "53D6":["8EE6","BCE8","E58F96"], // 取
           "53D7":["8EF3","BCF5","E58F97"], // 受
           "53D9":["8F96","BDF6","E58F99"], // 叙
           "53DB":["94BE","C8C0","E58F9B"], // 叛
           "53E1":["8962","B1C3","E58FA1"], // 叡
           "53E2":["9170","C1D1","E58FA2"], // 叢
           "53E3":["8CFB","B8FD","E58FA3"], // 口
           "53E4":["8CC3","B8C5","E58FA4"], // 古
           "53E5":["8BE5","B6E7","E58FA5"], // 句
           "53E9":["9240","C3A1","E58FA9"], // 叩
           "53EA":["91FC","C2FE","E58FAA"], // 只
           "53EB":["8BA9","B6AB","E58FAB"], // 叫
           "53EC":["8FA2","BEA4","E58FAC"], // 召
           "53EF":["89C2","B2C4","E58FAF"], // 可
           "53F0":["91E4","C2E6","E58FB0"], // 台
           "53F1":["8EB6","BCB8","E58FB1"], // 叱
           "53F2":["8E6A","BBCB","E58FB2"], // 史
           "53F3":["8945","B1A6","E58FB3"], // 右
           "53F6":["8A90","B3F0","E58FB6"], // 叶
           "53F7":["8D86","B9E6","E58FB7"], // 号
           "53F8":["8E69","BBCA","E58FB8"], // 司
           "5403":["8B68","B5C9","E59083"], // 吃
           "5404":["8A65","B3C6","E59084"], // 各
           "5408":["8D87","B9E7","E59088"], // 合
           "5409":["8B67","B5C8","E59089"], // 吉
           "540A":["92DD","C4DF","E5908A"], // 吊
           "540B":["8944","B1A5","E5908B"], // 吋
           "540C":["93AF","C6B1","E5908C"], // 同
           "540D":["96BC","CCBE","E5908D"], // 名
           "540E":["8D40","B9A1","E5908E"], // 后
           "540F":["9799","CDF9","E5908F"], // 吏
           "5410":["9366","C5C7","E59090"], // 吐
           "5411":["8CFC","B8FE","E59091"], // 向
           "541B":["8C4E","B7AF","E5909B"], // 君
           "541F":["8BE1","B6E3","E5909F"], // 吟
           "5420":["9669","CBCA","E590A0"], // 吠
           "5426":["94DB","C8DD","E590A6"], // 否
           "542B":["8ADC","B4DE","E590AB"], // 含
           "5438":["8B7A","B5DB","E590B8"], // 吸
           "5439":["9081","BFE1","E590B9"], // 吹
           "543B":["95AB","CAAD","E590BB"], // 吻
           "543E":["8CE1","B8E3","E590BE"], // 吾
           "5442":["9843","CFA4","E59182"], // 呂
           "5446":["95F0","CAF2","E59186"], // 呆
           "5448":["92E6","C4E8","E59188"], // 呈
           "5449":["8CE0","B8E2","E59189"], // 呉
           "544A":["8D90","B9F0","E5918A"], // 告
           "5451":["93DB","C6DD","E59191"], // 呑
           "5468":["8EFC","BCFE","E591A8"], // 周
           "546A":["8EF4","BCF6","E591AA"], // 呪
           "5473":["96A1","CCA3","E591B3"], // 味
           "547C":["8CC4","B8C6","E591BC"], // 呼
           "547D":["96BD","CCBF","E591BD"], // 命
           "548B":["8DEE","BAF0","E5928B"], // 咋
           "548C":["9861","CFC2","E5928C"], // 和
           "54B2":["8DE7","BAE9","E592B2"], // 咲
           "54B3":["8A50","B3B1","E592B3"], // 咳
           "54BD":["88F4","B0F6","E592BD"], // 咽
           "54C0":["88A3","B0A5","E59380"], // 哀
           "54C1":["9569","C9CA","E59381"], // 品
           "54C9":["8DC6","BAC8","E59389"], // 哉
           "54E1":["88F5","B0F7","E593A1"], // 員
           "54E8":["8FA3","BEA5","E593A8"], // 哨
           "54E9":["9689","CBE9","E593A9"], // 哩
           "54F2":["934E","C5AF","E593B2"], // 哲
           "5504":["8953","B1B4","E59484"], // 唄
           "5506":["8DB4","BAB6","E59486"], // 唆
           "5507":["904F","BFB0","E59487"], // 唇
           "5510":["9382","C5E2","E59490"], // 唐
           "5516":["88A0","B0A2","E59496"], // 唖
           "552F":["9742","CDA3","E594AF"], // 唯
           "5531":["8FA5","BEA7","E594B1"], // 唱
           "553E":["91C1","C2C3","E594BE"], // 唾
           "5544":["91ED","C2EF","E59584"], // 啄
           "5546":["8FA4","BEA6","E59586"], // 商
           "554F":["96E2","CCE4","E5958F"], // 問
           "5553":["8C5B","B7BC","E59593"], // 啓
           "5584":["9150","C1B1","E59684"], // 善
           "5589":["8D41","B9A2","E59689"], // 喉
           "558B":["929D","C3FD","E5968B"], // 喋
           "559A":["8AAB","B4AD","E5969A"], // 喚
           "559C":["8AEC","B4EE","E5969C"], // 喜
           "559D":["8A85","B3E5","E5969D"], // 喝
           "55A7":["8C96","B7F6","E596A7"], // 喧
           "55AA":["9172","C1D3","E596AA"], // 喪
           "55AB":["8B69","B5CA","E596AB"], // 喫
           "55AC":["8BAA","B6AC","E596AC"], // 喬
           "55B0":["8BF2","B6F4","E596B0"], // 喰
           "55B6":["8963","B1C4","E596B6"], // 営
           "55E3":["8E6B","BBCC","E597A3"], // 嗣
           "5606":["9251","C3B2","E59886"], // 嘆
           "5609":["89C3","B2C5","E59889"], // 嘉
           "5617":["8FA6","BEA8","E59897"], // 嘗
           "5618":["8952","B1B3","E59898"], // 嘘
           "5629":["89DC","B2DE","E598A9"], // 嘩
           "5631":["8FFA","BEFC","E598B1"], // 嘱
           "5642":["895C","B1BD","E59982"], // 噂
           "564C":["9158","C1B9","E5998C"], // 噌
           "565B":["8A9A","B3FA","E5999B"], // 噛
           "5668":["8AED","B4EF","E599A8"], // 器
           "5674":["95AC","CAAE","E599B4"], // 噴
           "5678":["93D3","C6D5","E599B8"], // 噸
           "567A":["94B6","C8B8","E599BA"], // 噺
           "5687":["8A64","B3C5","E59A87"], // 嚇
           "56A2":["9458","C7B9","E59AA2"], // 嚢
           "56DA":["8EFA","BCFC","E59B9A"], // 囚
           "56DB":["8E6C","BBCD","E59B9B"], // 四
           "56DE":["89F1","B2F3","E59B9E"], // 回
           "56E0":["88F6","B0F8","E59BA0"], // 因
           "56E3":["9263","C3C4","E59BA3"], // 団
           "56F0":["8DA2","BAA4","E59BB0"], // 困
           "56F2":["88CD","B0CF","E59BB2"], // 囲
           "56F3":["907D","BFDE","E59BB3"], // 図
           "56FA":["8CC5","B8C7","E59BBA"], // 固
           "56FD":["8D91","B9F1","E59BBD"], // 国
           "5703":["95DE","CAE0","E59C83"], // 圃
           "570F":["8C97","B7F7","E59C8F"], // 圏
           "5712":["8980","B1E0","E59C92"], // 園
           "571F":["9379","C5DA","E59C9F"], // 土
           "5727":["88B3","B0B5","E59CA7"], // 圧
           "5728":["8DDD","BADF","E59CA8"], // 在
           "572D":["8C5C","B7BD","E59CAD"], // 圭
           "5730":["926E","C3CF","E59CB0"], // 地
           "5742":["8DE2","BAE4","E59D82"], // 坂
           "5747":["8BCF","B6D1","E59D87"], // 均
           "574A":["9656","CBB7","E59D8A"], // 坊
           "5750":["8DBF","BAC1","E59D90"], // 坐
           "5751":["8D42","B9A3","E59D91"], // 坑
           "5764":["8DA3","BAA5","E59DA4"], // 坤
           "5766":["9252","C3B3","E59DA6"], // 坦
           "576A":["92D8","C4DA","E59DAA"], // 坪
           "5782":["9082","BFE2","E59E82"], // 垂
           "578B":["8C5E","B7BF","E59E8B"], // 型
           "57A2":["8D43","B9A4","E59EA2"], // 垢
           "57A3":["8A5F","B3C0","E59EA3"], // 垣
           "57CB":["9684","CBE4","E59F8B"], // 埋
           "57CE":["8FE9","BEEB","E59F8E"], // 城
           "57DC":["9457","C7B8","E59F9C"], // 埜
           "57DF":["88E6","B0E8","E59F9F"], // 域
           "57E0":["9575","C9D6","E59FA0"], // 埠
           "57F4":["8FFB","BEFD","E59FB4"], // 埴
           "57F7":["8EB7","BCB9","E59FB7"], // 執
           "57F9":["947C","C7DD","E59FB9"], // 培
           "57FA":["8AEE","B4F0","E59FBA"], // 基
           "57FC":["8DE9","BAEB","E59FBC"], // 埼
           "5800":["9678","CBD9","E5A080"], // 堀
           "5802":["93B0","C6B2","E5A082"], // 堂
           "5805":["8C98","B7F8","E5A085"], // 堅
           "5806":["91CD","C2CF","E5A086"], // 堆
           "5815":["91C2","C2C4","E5A095"], // 堕
           "5824":["92E7","C4E9","E5A0A4"], // 堤
           "582A":["8AAC","B4AE","E5A0AA"], // 堪
           "5830":["8981","B1E1","E5A0B0"], // 堰
           "5831":["95F1","CAF3","E5A0B1"], // 報
           "5834":["8FEA","BEEC","E5A0B4"], // 場
           "5835":["9367","C5C8","E5A0B5"], // 堵
           "583A":["8DE4","BAE6","E5A0BA"], // 堺
           "5840":["95BB","CABD","E5A180"], // 塀
           "5841":["97DB","CEDD","E5A181"], // 塁
           "584A":["89F2","B2F4","E5A18A"], // 塊
           "5851":["9159","C1BA","E5A191"], // 塑
           "5854":["9383","C5E3","E5A194"], // 塔
           "5857":["9368","C5C9","E5A197"], // 塗
           "5858":["9384","C5E4","E5A198"], // 塘
           "5859":["94B7","C8B9","E5A199"], // 塙
           "585A":["92CB","C4CD","E5A19A"], // 塚
           "585E":["8DC7","BAC9","E5A19E"], // 塞
           "5869":["8996","B1F6","E5A1A9"], // 塩
           "586B":["9355","C5B6","E5A1AB"], // 填
           "5875":["906F","BFD0","E5A1B5"], // 塵
           "587E":["8F6D","BDCE","E5A1BE"], // 塾
           "5883":["8BAB","B6AD","E5A283"], // 境
           "5893":["95E6","CAE8","E5A293"], // 墓
           "5897":["919D","C1FD","E5A297"], // 増
           "589C":["92C4","C4C6","E5A29C"], // 墜
           "58A8":["966E","CBCF","E5A2A8"], // 墨
           "58B3":["95AD","CAAF","E5A2B3"], // 墳
           "58BE":["8DA4","BAA6","E5A2BE"], // 墾
           "58C1":["95C7","CAC9","E5A381"], // 壁
           "58C7":["9264","C3C5","E5A387"], // 壇
           "58CA":["89F3","B2F5","E5A38A"], // 壊
           "58CC":["8FEB","BEED","E5A38C"], // 壌
           "58D5":["8D88","B9E8","E5A395"], // 壕
           "58EB":["8E6D","BBCE","E5A3AB"], // 士
           "58EC":["9070","BFD1","E5A3AC"], // 壬
           "58EE":["9173","C1D4","E5A3AE"], // 壮
           "58F0":["90BA","C0BC","E5A3B0"], // 声
           "58F1":["88EB","B0ED","E5A3B1"], // 壱
           "58F2":["9484","C7E4","E5A3B2"], // 売
           "58F7":["92D9","C4DB","E5A3B7"], // 壷
           "5909":["95CF","CAD1","E5A489"], // 変
           "590F":["89C4","B2C6","E5A48F"], // 夏
           "5915":["975B","CDBC","E5A495"], // 夕
           "5916":["8A4F","B3B0","E5A496"], // 外
           "5919":["8F67","BDC8","E5A499"], // 夙
           "591A":["91BD","C2BF","E5A49A"], // 多
           "591C":["96E9","CCEB","E5A49C"], // 夜
           "5922":["96B2","CCB4","E5A4A2"], // 夢
           "5927":["91E5","C2E7","E5A4A7"], // 大
           "5929":["9356","C5B7","E5A4A9"], // 天
           "592A":["91BE","C2C0","E5A4AA"], // 太
           "592B":["9576","C9D7","E5A4AB"], // 夫
           "592E":["899B","B1FB","E5A4AE"], // 央
           "5931":["8EB8","BCBA","E5A4B1"], // 失
           "5937":["88CE","B0D0","E5A4B7"], // 夷
           "5944":["8982","B1E2","E5A584"], // 奄
           "5947":["8AEF","B4F1","E5A587"], // 奇
           "5948":["93DE","C6E0","E5A588"], // 奈
           "5949":["95F2","CAF4","E5A589"], // 奉
           "594F":["9174","C1D5","E5A58F"], // 奏
           "5951":["8C5F","B7C0","E5A591"], // 契
           "5954":["967A","CBDB","E5A594"], // 奔
           "5957":["9385","C5E5","E5A597"], // 套
           "5965":["899C","B1FC","E5A5A5"], // 奥
           "5968":["8FA7","BEA9","E5A5A8"], // 奨
           "596A":["9244","C3A5","E5A5AA"], // 奪
           "596E":["95B1","CAB3","E5A5AE"], // 奮
           "5973":["8F97","BDF7","E5A5B3"], // 女
           "5974":["937A","C5DB","E5A5B4"], // 奴
           "597D":["8D44","B9A5","E5A5BD"], // 好
           "5982":["9440","C7A1","E5A682"], // 如
           "5983":["94DC","C8DE","E5A683"], // 妃
           "5984":["96CF","CCD1","E5A684"], // 妄
           "598A":["9444","C7A5","E5A68A"], // 妊
           "5993":["8B57","B5B8","E5A693"], // 妓
           "5996":["9764","CDC5","E5A696"], // 妖
           "5999":["96AD","CCAF","E5A699"], // 妙
           "59A5":["91C3","C2C5","E5A6A5"], // 妥
           "59A8":["9657","CBB8","E5A6A8"], // 妨
           "59AC":["9369","C5CA","E5A6AC"], // 妬
           "59B9":["9685","CBE5","E5A6B9"], // 妹
           "59BB":["8DC8","BACA","E5A6BB"], // 妻
           "59BE":["8FA8","BEAA","E5A6BE"], // 妾
           "59C9":["8E6F","BBD0","E5A789"], // 姉
           "59CB":["8E6E","BBCF","E5A78B"], // 始
           "59D0":["88B7","B0B9","E5A790"], // 姐
           "59D1":["8CC6","B8C8","E5A791"], // 姑
           "59D3":["90A9","C0AB","E5A793"], // 姓
           "59D4":["88CF","B0D1","E5A794"], // 委
           "59E5":["8957","B1B8","E5A7A5"], // 姥
           "59E6":["8AAD","B4AF","E5A7A6"], // 姦
           "59EA":["96C3","CCC5","E5A7AA"], // 姪
           "59EB":["9550","C9B1","E5A7AB"], // 姫
           "59F6":["88A6","B0A8","E5A7B6"], // 姶
           "59FB":["88F7","B0F9","E5A7BB"], // 姻
           "59FF":["8E70","BBD1","E5A7BF"], // 姿
           "5A01":["88D0","B0D2","E5A881"], // 威
           "5A03":["88A1","B0A3","E5A883"], // 娃
           "5A18":["96BA","CCBC","E5A898"], // 娘
           "5A20":["9050","BFB1","E5A8A0"], // 娠
           "5A29":["95D8","CADA","E5A8A9"], // 娩
           "5A2F":["8CE2","B8E4","E5A8AF"], // 娯
           "5A3C":["8FA9","BEAB","E5A8BC"], // 娼
           "5A41":["984B","CFAC","E5A981"], // 婁
           "5A46":["946B","C7CC","E5A986"], // 婆
           "5A5A":["8DA5","BAA7","E5A99A"], // 婚
           "5A66":["9577","C9D8","E5A9A6"], // 婦
           "5A7F":["96B9","CCBB","E5A9BF"], // 婿
           "5A92":["947D","C7DE","E5AA92"], // 媒
           "5A9B":["9551","C9B2","E5AA9B"], // 媛
           "5AC1":["89C5","B2C7","E5AB81"], // 嫁
           "5AC9":["8EB9","BCBB","E5AB89"], // 嫉
           "5ACC":["8C99","B7F9","E5AB8C"], // 嫌
           "5AE1":["9284","C3E4","E5ABA1"], // 嫡
           "5B09":["8AF0","B4F2","E5AC89"], // 嬉
           "5B22":["8FEC","BEEE","E5ACA2"], // 嬢
           "5B2C":["92DA","C4DC","E5ACAC"], // 嬬
           "5B30":["8964","B1C5","E5ACB0"], // 嬰
           "5B50":["8E71","BBD2","E5AD90"], // 子
           "5B54":["8D45","B9A6","E5AD94"], // 孔
           "5B57":["8E9A","BBFA","E5AD97"], // 字
           "5B58":["91B6","C2B8","E5AD98"], // 存
           "5B5C":["8E79","BBDA","E5AD9C"], // 孜
           "5B5D":["8D46","B9A7","E5AD9D"], // 孝
           "5B5F":["96D0","CCD2","E5AD9F"], // 孟
           "5B63":["8B47","B5A8","E5ADA3"], // 季
           "5B64":["8CC7","B8C9","E5ADA4"], // 孤
           "5B66":["8A77","B3D8","E5ADA6"], // 学
           "5B6B":["91B7","C2B9","E5ADAB"], // 孫
           "5B85":["91EE","C2F0","E5AE85"], // 宅
           "5B87":["8946","B1A7","E5AE87"], // 宇
           "5B88":["8EE7","BCE9","E5AE88"], // 守
           "5B89":["88C0","B0C2","E5AE89"], // 安
           "5B8B":["9176","C1D7","E5AE8B"], // 宋
           "5B8C":["8AAE","B4B0","E5AE8C"], // 完
           "5B8D":["8EB3","BCB5","E5AE8D"], // 宍
           "5B8F":["8D47","B9A8","E5AE8F"], // 宏
           "5B95":["9386","C5E6","E5AE95"], // 宕
           "5B97":["8F40","BDA1","E5AE97"], // 宗
           "5B98":["8AAF","B4B1","E5AE98"], // 官
           "5B99":["9288","C3E8","E5AE99"], // 宙
           "5B9A":["92E8","C4EA","E5AE9A"], // 定
           "5B9B":["88B6","B0B8","E5AE9B"], // 宛
           "5B9C":["8B58","B5B9","E5AE9C"], // 宜
           "5B9D":["95F3","CAF5","E5AE9D"], // 宝
           "5B9F":["8EC0","BCC2","E5AE9F"], // 実
           "5BA2":["8B71","B5D2","E5AEA2"], // 客
           "5BA3":["90E9","C0EB","E5AEA3"], // 宣
           "5BA4":["8EBA","BCBC","E5AEA4"], // 室
           "5BA5":["9747","CDA8","E5AEA5"], // 宥
           "5BAE":["8B7B","B5DC","E5AEAE"], // 宮
           "5BB0":["8DC9","BACB","E5AEB0"], // 宰
           "5BB3":["8A51","B3B2","E5AEB3"], // 害
           "5BB4":["8983","B1E3","E5AEB4"], // 宴
           "5BB5":["8FAA","BEAC","E5AEB5"], // 宵
           "5BB6":["89C6","B2C8","E5AEB6"], // 家
           "5BB9":["9765","CDC6","E5AEB9"], // 容
           "5BBF":["8F68","BDC9","E5AEBF"], // 宿
           "5BC2":["8EE2","BCE4","E5AF82"], // 寂
           "5BC4":["8AF1","B4F3","E5AF84"], // 寄
           "5BC5":["93D0","C6D2","E5AF85"], // 寅
           "5BC6":["96A7","CCA9","E5AF86"], // 密
           "5BCC":["9578","C9D9","E5AF8C"], // 富
           "5BD2":["8AA6","B4A8","E5AF92"], // 寒
           "5BD3":["8BF5","B6F7","E5AF93"], // 寓
           "5BDB":["8AB0","B4B2","E5AF9B"], // 寛
           "5BDD":["9051","BFB2","E5AF9D"], // 寝
           "5BDF":["8E40","BBA1","E5AF9F"], // 察
           "5BE1":["89C7","B2C9","E5AFA1"], // 寡
           "5BE7":["944A","C7AB","E5AFA7"], // 寧
           "5BE9":["9052","BFB3","E5AFA9"], // 審
           "5BEE":["97BE","CEC0","E5AFAE"], // 寮
           "5BF5":["929E","C3FE","E5AFB5"], // 寵
           "5BF8":["90A1","C0A3","E5AFB8"], // 寸
           "5BFA":["8E9B","BBFB","E5AFBA"], // 寺
           "5BFE":["91CE","C2D0","E5AFBE"], // 対
           "5BFF":["8EF5","BCF7","E5AFBF"], // 寿
           "5C01":["9595","C9F5","E5B081"], // 封
           "5C02":["90EA","C0EC","E5B082"], // 専
           "5C04":["8ECB","BCCD","E5B084"], // 射
           "5C06":["8FAB","BEAD","E5B086"], // 将
           "5C09":["88D1","B0D3","E5B089"], // 尉
           "5C0A":["91B8","C2BA","E5B08A"], // 尊
           "5C0B":["9071","BFD2","E5B08B"], // 尋
           "5C0E":["93B1","C6B3","E5B08E"], // 導
           "5C0F":["8FAC","BEAE","E5B08F"], // 小
           "5C11":["8FAD","BEAF","E5B091"], // 少
           "5C16":["90EB","C0ED","E5B096"], // 尖
           "5C1A":["8FAE","BEB0","E5B09A"], // 尚
           "5C24":["96DE","CCE0","E5B0A4"], // 尤
           "5C2D":["8BC4","B6C6","E5B0AD"], // 尭
           "5C31":["8F41","BDA2","E5B0B1"], // 就
           "5C3A":["8EDA","BCDC","E5B0BA"], // 尺
           "5C3B":["904B","BFAC","E5B0BB"], // 尻
           "5C3C":["93F2","C6F4","E5B0BC"], // 尼
           "5C3D":["9073","BFD4","E5B0BD"], // 尽
           "5C3E":["94F6","C8F8","E5B0BE"], // 尾
           "5C3F":["9441","C7A2","E5B0BF"], // 尿
           "5C40":["8BC7","B6C9","E5B180"], // 局
           "5C45":["8B8F","B5EF","E5B185"], // 居
           "5C48":["8BFC","B6FE","E5B188"], // 屈
           "5C4A":["93CD","C6CF","E5B18A"], // 届
           "5C4B":["89AE","B2B0","E5B18B"], // 屋
           "5C4D":["8E72","BBD3","E5B18D"], // 屍
           "5C51":["8BFB","B6FD","E5B191"], // 屑
           "5C55":["9357","C5B8","E5B195"], // 展
           "5C5E":["91AE","C2B0","E5B19E"], // 属
           "5C60":["936A","C5CB","E5B1A0"], // 屠
           "5C61":["8EC6","BCC8","E5B1A1"], // 屡
           "5C64":["9177","C1D8","E5B1A4"], // 層
           "5C65":["979A","CDFA","E5B1A5"], // 履
           "5C6F":["93D4","C6D6","E5B1AF"], // 屯
           "5C71":["8E52","BBB3","E5B1B1"], // 山
           "5C90":["8AF2","B4F4","E5B290"], // 岐
           "5CA1":["89AA","B2AC","E5B2A1"], // 岡
           "5CA8":["915A","C1BB","E5B2A8"], // 岨
           "5CA9":["8AE2","B4E4","E5B2A9"], // 岩
           "5CAC":["96A6","CCA8","E5B2AC"], // 岬
           "5CB1":["91D0","C2D2","E5B2B1"], // 岱
           "5CB3":["8A78","B3D9","E5B2B3"], // 岳
           "5CB8":["8ADD","B4DF","E5B2B8"], // 岸
           "5CE0":["93BB","C6BD","E5B3A0"], // 峠
           "5CE1":["8BAC","B6AE","E5B3A1"], // 峡
           "5CE8":["89E3","B2E5","E5B3A8"], // 峨
           "5CEF":["95F5","CAF7","E5B3AF"], // 峯
           "5CF0":["95F4","CAF6","E5B3B0"], // 峰
           "5CF6":["9387","C5E7","E5B3B6"], // 島
           "5CFB":["8F73","BDD4","E5B3BB"], // 峻
           "5D07":["9092","BFF2","E5B487"], // 崇
           "5D0E":["8DE8","BAEA","E5B48E"], // 崎
           "5D16":["8A52","B3B3","E5B496"], // 崖
           "5D29":["95F6","CAF8","E5B4A9"], // 崩
           "5D50":["9792","CDF2","E5B590"], // 嵐
           "5D69":["9093","BFF3","E5B5A9"], // 嵩
           "5D6F":["8DB5","BAB7","E5B5AF"], // 嵯
           "5D8B":["9388","C5E8","E5B68B"], // 嶋
           "5DBA":["97E4","CEE6","E5B6BA"], // 嶺
           "5DCC":["8ADE","B4E0","E5B78C"], // 巌
           "5DDD":["90EC","C0EE","E5B79D"], // 川
           "5DDE":["8F42","BDA3","E5B79E"], // 州
           "5DE1":["8F84","BDE4","E5B7A1"], // 巡
           "5DE3":["9183","C1E3","E5B7A3"], // 巣
           "5DE5":["8D48","B9A9","E5B7A5"], // 工
           "5DE6":["8DB6","BAB8","E5B7A6"], // 左
           "5DE7":["8D49","B9AA","E5B7A7"], // 巧
           "5DE8":["8B90","B5F0","E5B7A8"], // 巨
           "5DEE":["8DB7","BAB9","E5B7AE"], // 差
           "5DF1":["8CC8","B8CA","E5B7B1"], // 己
           "5DF3":["96A4","CCA6","E5B7B3"], // 巳
           "5DF4":["9462","C7C3","E5B7B4"], // 巴
           "5DF7":["8D4A","B9AB","E5B7B7"], // 巷
           "5DFB":["8AAA","B4AC","E5B7BB"], // 巻
           "5DFD":["9246","C3A7","E5B7BD"], // 巽
           "5DFE":["8BD0","B6D2","E5B7BE"], // 巾
           "5E02":["8E73","BBD4","E5B882"], // 市
           "5E03":["957A","C9DB","E5B883"], // 布
           "5E06":["94BF","C8C1","E5B886"], // 帆
           "5E0C":["8AF3","B4F5","E5B88C"], // 希
           "5E16":["929F","C4A1","E5B896"], // 帖
           "5E1D":["92E9","C4EB","E5B89D"], // 帝
           "5E25":["9083","BFE3","E5B8A5"], // 帥
           "5E2B":["8E74","BBD5","E5B8AB"], // 師
           "5E2D":["90C8","C0CA","E5B8AD"], // 席
           "5E2F":["91D1","C2D3","E5B8AF"], // 帯
           "5E30":["8B41","B5A2","E5B8B0"], // 帰
           "5E33":["92A0","C4A2","E5B8B3"], // 帳
           "5E38":["8FED","BEEF","E5B8B8"], // 常
           "5E3D":["9658","CBB9","E5B8BD"], // 帽
           "5E45":["959D","C9FD","E5B985"], // 幅
           "5E4C":["9679","CBDA","E5B98C"], // 幌
           "5E55":["968B","CBEB","E5B995"], // 幕
           "5E61":["94A6","C8A8","E5B9A1"], // 幡
           "5E63":["95BC","CABE","E5B9A3"], // 幣
           "5E72":["8AB1","B4B3","E5B9B2"], // 干
           "5E73":["95BD","CABF","E5B9B3"], // 平
           "5E74":["944E","C7AF","E5B9B4"], // 年
           "5E78":["8D4B","B9AC","E5B9B8"], // 幸
           "5E79":["8AB2","B4B4","E5B9B9"], // 幹
           "5E7B":["8CB6","B8B8","E5B9BB"], // 幻
           "5E7C":["9763","CDC4","E5B9BC"], // 幼
           "5E7D":["9748","CDA9","E5B9BD"], // 幽
           "5E7E":["8AF4","B4F6","E5B9BE"], // 幾
           "5E81":["92A1","C4A3","E5BA81"], // 庁
           "5E83":["8D4C","B9AD","E5BA83"], // 広
           "5E84":["8FAF","BEB1","E5BA84"], // 庄
           "5E87":["94DD","C8DF","E5BA87"], // 庇
           "5E8A":["8FB0","BEB2","E5BA8A"], // 床
           "5E8F":["8F98","BDF8","E5BA8F"], // 序
           "5E95":["92EA","C4EC","E5BA95"], // 底
           "5E96":["95F7","CAF9","E5BA96"], // 庖
           "5E97":["9358","C5B9","E5BA97"], // 店
           "5E9A":["8D4D","B9AE","E5BA9A"], // 庚
           "5E9C":["957B","C9DC","E5BA9C"], // 府
           "5EA6":["9378","C5D9","E5BAA6"], // 度
           "5EA7":["8DC0","BAC2","E5BAA7"], // 座
           "5EAB":["8CC9","B8CB","E5BAAB"], // 庫
           "5EAD":["92EB","C4ED","E5BAAD"], // 庭
           "5EB5":["88C1","B0C3","E5BAB5"], // 庵
           "5EB6":["8F8E","BDEE","E5BAB6"], // 庶
           "5EB7":["8D4E","B9AF","E5BAB7"], // 康
           "5EB8":["9766","CDC7","E5BAB8"], // 庸
           "5EC3":["9470","C7D1","E5BB83"], // 廃
           "5EC9":["97F5","CEF7","E5BB89"], // 廉
           "5ECA":["984C","CFAD","E5BB8A"], // 廊
           "5ED3":["8A66","B3C7","E5BB93"], // 廓
           "5EDF":["955F","C9C0","E5BB9F"], // 廟
           "5EE0":["8FB1","BEB3","E5BBA0"], // 廠
           "5EF6":["8984","B1E4","E5BBB6"], // 延
           "5EF7":["92EC","C4EE","E5BBB7"], // 廷
           "5EFA":["8C9A","B7FA","E5BBBA"], // 建
           "5EFB":["89F4","B2F6","E5BBBB"], // 廻
           "5EFC":["9455","C7B6","E5BBBC"], // 廼
           "5EFF":["93F9","C6FB","E5BBBF"], // 廿
           "5F01":["95D9","CADB","E5BC81"], // 弁
           "5F04":["984D","CFAE","E5BC84"], // 弄
           "5F0A":["95BE","CAC0","E5BC8A"], // 弊
           "5F0F":["8EAE","BCB0","E5BC8F"], // 式
           "5F10":["93F3","C6F5","E5BC90"], // 弐
           "5F13":["8B7C","B5DD","E5BC93"], // 弓
           "5F14":["92A2","C4A4","E5BC94"], // 弔
           "5F15":["88F8","B0FA","E5BC95"], // 引
           "5F17":["95A4","CAA6","E5BC97"], // 弗
           "5F18":["8D4F","B9B0","E5BC98"], // 弘
           "5F1B":["926F","C3D0","E5BC9B"], // 弛
           "5F1F":["92ED","C4EF","E5BC9F"], // 弟
           "5F25":["96ED","CCEF","E5BCA5"], // 弥
           "5F26":["8CB7","B8B9","E5BCA6"], // 弦
           "5F27":["8CCA","B8CC","E5BCA7"], // 弧
           "5F31":["8EE3","BCE5","E5BCB1"], // 弱
           "5F35":["92A3","C4A5","E5BCB5"], // 張
           "5F37":["8BAD","B6AF","E5BCB7"], // 強
           "5F3C":["954A","C9AB","E5BCBC"], // 弼
           "5F3E":["9265","C3C6","E5BCBE"], // 弾
           "5F4A":["8BAE","B6B0","E5BD8A"], // 彊
           "5F53":["9396","C5F6","E5BD93"], // 当
           "5F62":["8C60","B7C1","E5BDA2"], // 形
           "5F66":["9546","C9A7","E5BDA6"], // 彦
           "5F69":["8DCA","BACC","E5BDA9"], // 彩
           "5F6A":["9556","C9B7","E5BDAA"], // 彪
           "5F6B":["92A4","C4A6","E5BDAB"], // 彫
           "5F6C":["956A","C9CB","E5BDAC"], // 彬
           "5F70":["8FB2","BEB4","E5BDB0"], // 彰
           "5F71":["8965","B1C6","E5BDB1"], // 影
           "5F79":["96F0","CCF2","E5BDB9"], // 役
           "5F7C":["94DE","C8E0","E5BDBC"], // 彼
           "5F80":["899D","B1FD","E5BE80"], // 往
           "5F81":["90AA","C0AC","E5BE81"], // 征
           "5F84":["8C61","B7C2","E5BE84"], // 径
           "5F85":["91D2","C2D4","E5BE85"], // 待
           "5F8B":["97A5","CEA7","E5BE8B"], // 律
           "5F8C":["8CE3","B8E5","E5BE8C"], // 後
           "5F90":["8F99","BDF9","E5BE90"], // 徐
           "5F92":["936B","C5CC","E5BE92"], // 徒
           "5F93":["8F5D","BDBE","E5BE93"], // 従
           "5F97":["93BE","C6C0","E5BE97"], // 得
           "5FA1":["8CE4","B8E6","E5BEA1"], // 御
           "5FA9":["959C","C9FC","E5BEA9"], // 復
           "5FAA":["8F7A","BDDB","E5BEAA"], // 循
           "5FAE":["94F7","C8F9","E5BEAE"], // 微
           "5FB3":["93BF","C6C1","E5BEB3"], // 徳
           "5FB4":["92A5","C4A7","E5BEB4"], // 徴
           "5FB9":["934F","C5B0","E5BEB9"], // 徹
           "5FBD":["8B4A","B5AB","E5BEBD"], // 徽
           "5FC3":["9053","BFB4","E5BF83"], // 心
           "5FC5":["954B","C9AC","E5BF85"], // 必
           "5FCC":["8AF5","B4F7","E5BF8C"], // 忌
           "5FCD":["9445","C7A6","E5BF8D"], // 忍
           "5FD7":["8E75","BBD6","E5BF97"], // 志
           "5FD8":["9659","CBBA","E5BF98"], // 忘
           "5FD9":["965A","CBBB","E5BF99"], // 忙
           "5FDC":["899E","B1FE","E5BF9C"], // 応
           "5FE0":["9289","C3E9","E5BFA0"], // 忠
           "5FEB":["89F5","B2F7","E5BFAB"], // 快
           "5FF5":["944F","C7B0","E5BFB5"], // 念
           "5FFD":["8D9A","B9FA","E5BFBD"], // 忽
           "6012":["937B","C5DC","E68092"], // 怒
           "6016":["957C","C9DD","E68096"], // 怖
           "601C":["97E5","CEE7","E6809C"], // 怜
           "601D":["8E76","BBD7","E6809D"], // 思
           "6020":["91D3","C2D5","E680A0"], // 怠
           "6025":["8B7D","B5DE","E680A5"], // 急
           "6027":["90AB","C0AD","E680A7"], // 性
           "6028":["8985","B1E5","E680A8"], // 怨
           "602A":["89F6","B2F8","E680AA"], // 怪
           "602F":["8BAF","B6B1","E680AF"], // 怯
           "604B":["97F6","CEF8","E6818B"], // 恋
           "6050":["8BB0","B6B2","E68190"], // 恐
           "6052":["8D50","B9B1","E68192"], // 恒
           "6055":["8F9A","BDFA","E68195"], // 恕
           "6062":["89F8","B2FA","E681A2"], // 恢
           "6065":["9270","C3D1","E681A5"], // 恥
           "6068":["8DA6","BAA8","E681A8"], // 恨
           "6069":["89B6","B2B8","E681A9"], // 恩
           "606D":["8BB1","B6B3","E681AD"], // 恭
           "606F":["91A7","C2A9","E681AF"], // 息
           "6070":["8A86","B3E6","E681B0"], // 恰
           "6075":["8C62","B7C3","E681B5"], // 恵
           "6089":["8EBB","BCBD","E68289"], // 悉
           "608C":["92EE","C4F0","E6828C"], // 悌
           "6094":["89F7","B2F9","E68294"], // 悔
           "609F":["8CE5","B8E7","E6829F"], // 悟
           "60A0":["9749","CDAA","E682A0"], // 悠
           "60A3":["8AB3","B4B5","E682A3"], // 患
           "60A6":["8978","B1D9","E682A6"], // 悦
           "60A9":["9459","C7BA","E682A9"], // 悩
           "60AA":["88AB","B0AD","E682AA"], // 悪
           "60B2":["94DF","C8E1","E682B2"], // 悲
           "60B6":["96E3","CCE5","E682B6"], // 悶
           "60BC":["9389","C5E9","E682BC"], // 悼
           "60C5":["8FEE","BEF0","E68385"], // 情
           "60C7":["93D5","C6D7","E68387"], // 惇
           "60D1":["9866","CFC7","E68391"], // 惑
           "60DA":["8D9B","B9FB","E6839A"], // 惚
           "60DC":["90C9","C0CB","E6839C"], // 惜
           "60DF":["88D2","B0D4","E6839F"], // 惟
           "60E3":["9179","C1DA","E683A3"], // 惣
           "60E8":["8E53","BBB4","E683A8"], // 惨
           "60F0":["91C4","C2C6","E683B0"], // 惰
           "60F3":["917A","C1DB","E683B3"], // 想
           "60F9":["8EE4","BCE6","E683B9"], // 惹
           "6101":["8F44","BDA5","E68481"], // 愁
           "6108":["96FA","CCFC","E68488"], // 愈
           "6109":["96F9","CCFB","E68489"], // 愉
           "610F":["88D3","B0D5","E6848F"], // 意
           "611A":["8BF0","B6F2","E6849A"], // 愚
           "611B":["88A4","B0A6","E6849B"], // 愛
           "611F":["8AB4","B4B6","E6849F"], // 感
           "6148":["8E9C","BBFC","E68588"], // 慈
           "614B":["91D4","C2D6","E6858B"], // 態
           "614C":["8D51","B9B2","E6858C"], // 慌
           "614E":["9054","BFB5","E6858E"], // 慎
           "6155":["95E7","CAE9","E68595"], // 慕
           "6162":["969D","CBFD","E685A2"], // 慢
           "6163":["8AB5","B4B7","E685A3"], // 慣
           "6167":["8C64","B7C5","E685A7"], // 慧
           "6168":["8A53","B3B4","E685A8"], // 慨
           "616E":["97B6","CEB8","E685AE"], // 慮
           "6170":["88D4","B0D6","E685B0"], // 慰
           "6176":["8C63","B7C4","E685B6"], // 慶
           "617E":["977C","CDDD","E685BE"], // 慾
           "6182":["974A","CDAB","E68682"], // 憂
           "618E":["919E","C1FE","E6868E"], // 憎
           "6190":["97F7","CEF9","E68690"], // 憐
           "61A4":["95AE","CAB0","E686A4"], // 憤
           "61A7":["93B2","C6B4","E686A7"], // 憧
           "61A9":["8C65","B7C6","E686A9"], // 憩
           "61B2":["8C9B","B7FB","E686B2"], // 憲
           "61B6":["89AF","B2B1","E686B6"], // 憶
           "61BE":["8AB6","B4B8","E686BE"], // 憾
           "61C7":["8DA7","BAA9","E68787"], // 懇
           "61D0":["89F9","B2FB","E68790"], // 懐
           "61F2":["92A6","C4A8","E687B2"], // 懲
           "61F8":["8C9C","B7FC","E687B8"], // 懸
           "620A":["95E8","CAEA","E6888A"], // 戊
           "620E":["8F5E","BDBF","E6888E"], // 戎
           "6210":["90AC","C0AE","E68890"], // 成
           "6211":["89E4","B2E6","E68891"], // 我
           "6212":["89FA","B2FC","E68892"], // 戒
           "6216":["88BD","B0BF","E68896"], // 或
           "621A":["90CA","C0CC","E6889A"], // 戚
           "621F":["8C81","B7E1","E6889F"], // 戟
           "6226":["90ED","C0EF","E688A6"], // 戦
           "622F":["8B59","B5BA","E688AF"], // 戯
           "6234":["91D5","C2D7","E688B4"], // 戴
           "6238":["8CCB","B8CD","E688B8"], // 戸
           "623B":["96DF","CCE1","E688BB"], // 戻
           "623F":["965B","CBBC","E688BF"], // 房
           "6240":["8F8A","BDEA","E68980"], // 所
           "6247":["90EE","C0F0","E68987"], // 扇
           "6249":["94E0","C8E2","E68989"], // 扉
           "624B":["8EE8","BCEA","E6898B"], // 手
           "624D":["8DCB","BACD","E6898D"], // 才
           "6253":["91C5","C2C7","E68993"], // 打
           "6255":["95A5","CAA7","E68995"], // 払
           "6258":["91EF","C2F1","E68998"], // 托
           "626E":["95AF","CAB1","E689AE"], // 扮
           "6271":["88B5","B0B7","E689B1"], // 扱
           "6276":["957D","C9DE","E689B6"], // 扶
           "6279":["94E1","C8E3","E689B9"], // 批
           "627F":["8FB3","BEB5","E689BF"], // 承
           "6280":["8B5A","B5BB","E68A80"], // 技
           "6284":["8FB4","BEB6","E68A84"], // 抄
           "628A":["9463","C7C4","E68A8A"], // 把
           "6291":["977D","CDDE","E68A91"], // 抑
           "6295":["938A","C5EA","E68A95"], // 投
           "6297":["8D52","B9B3","E68A97"], // 抗
           "6298":["90DC","C0DE","E68A98"], // 折
           "629C":["94B2","C8B4","E68A9C"], // 抜
           "629E":["91F0","C2F2","E68A9E"], // 択
           "62AB":["94E2","C8E4","E68AAB"], // 披
           "62B1":["95F8","CAFA","E68AB1"], // 抱
           "62B5":["92EF","C4F1","E68AB5"], // 抵
           "62B9":["9695","CBF5","E68AB9"], // 抹
           "62BC":["899F","B2A1","E68ABC"], // 押
           "62BD":["928A","C3EA","E68ABD"], // 抽
           "62C5":["9253","C3B4","E68B85"], // 担
           "62CD":["948F","C7EF","E68B8D"], // 拍
           "62D0":["89FB","B2FD","E68B90"], // 拐
           "62D2":["8B91","B5F1","E68B92"], // 拒
           "62D3":["91F1","C2F3","E68B93"], // 拓
           "62D8":["8D53","B9B4","E68B98"], // 拘
           "62D9":["90D9","C0DB","E68B99"], // 拙
           "62DB":["8FB5","BEB7","E68B9B"], // 招
           "62DD":["9471","C7D2","E68B9D"], // 拝
           "62E0":["8B92","B5F2","E68BA0"], // 拠
           "62E1":["8A67","B3C8","E68BA1"], // 拡
           "62EC":["8A87","B3E7","E68BAC"], // 括
           "62ED":["9040","BFA1","E68BAD"], // 拭
           "62F3":["8C9D","B7FD","E68BB3"], // 拳
           "62F6":["8E41","BBA2","E68BB6"], // 拶
           "62F7":["8D89","B9E9","E68BB7"], // 拷
           "62FE":["8F45","BDA6","E68BBE"], // 拾
           "6301":["8E9D","BBFD","E68C81"], // 持
           "6307":["8E77","BBD8","E68C87"], // 指
           "6309":["88C2","B0C4","E68C89"], // 按
           "6311":["92A7","C4A9","E68C91"], // 挑
           "6319":["8B93","B5F3","E68C99"], // 挙
           "631F":["8BB2","B6B4","E68C9F"], // 挟
           "6328":["88A5","B0A7","E68CA8"], // 挨
           "632B":["8DC1","BAC3","E68CAB"], // 挫
           "632F":["9055","BFB6","E68CAF"], // 振
           "633A":["92F0","C4F2","E68CBA"], // 挺
           "633D":["94D2","C8D4","E68CBD"], // 挽
           "633F":["917D","C1DE","E68CBF"], // 挿
           "6349":["91A8","C2AA","E68D89"], // 捉
           "634C":["8E4A","BBAB","E68D8C"], // 捌
           "6355":["95DF","CAE1","E68D95"], // 捕
           "6357":["92BB","C4BD","E68D97"], // 捗
           "635C":["917B","C1DC","E68D9C"], // 捜
           "6367":["95F9","CAFB","E68DA7"], // 捧
           "6368":["8ECC","BCCE","E68DA8"], // 捨
           "636E":["9098","BFF8","E68DAE"], // 据
           "6372":["8C9E","B7FE","E68DB2"], // 捲
           "6377":["8FB7","BEB9","E68DB7"], // 捷
           "637A":["93E6","C6E8","E68DBA"], // 捺
           "637B":["9450","C7B1","E68DBB"], // 捻
           "6383":["917C","C1DD","E68E83"], // 掃
           "6388":["8EF6","BCF8","E68E88"], // 授
           "638C":["8FB6","BEB8","E68E8C"], // 掌
           "6392":["9472","C7D3","E68E92"], // 排
           "6398":["8C40","B7A1","E68E98"], // 掘
           "639B":["8A7C","B3DD","E68E9B"], // 掛
           "63A0":["97A9","CEAB","E68EA0"], // 掠
           "63A1":["8DCC","BACE","E68EA1"], // 採
           "63A2":["9254","C3B5","E68EA2"], // 探
           "63A5":["90DA","C0DC","E68EA5"], // 接
           "63A7":["8D54","B9B5","E68EA7"], // 控
           "63A8":["9084","BFE4","E68EA8"], // 推
           "63A9":["8986","B1E6","E68EA9"], // 掩
           "63AA":["915B","C1BC","E68EAA"], // 措
           "63AC":["8B64","B5C5","E68EAC"], // 掬
           "63B2":["8C66","B7C7","E68EB2"], // 掲
           "63B4":["92CD","C4CF","E68EB4"], // 掴
           "63BB":["917E","C1DF","E68EBB"], // 掻
           "63C3":["91B5","C2B7","E68F83"], // 揃
           "63CF":["9560","C9C1","E68F8F"], // 描
           "63D0":["92F1","C4F3","E68F90"], // 提
           "63D6":["974B","CDAC","E68F96"], // 揖
           "63DA":["9767","CDC8","E68F9A"], // 揚
           "63DB":["8AB7","B4B9","E68F9B"], // 換
           "63E1":["88AC","B0AE","E68FA1"], // 握
           "63EE":["8AF6","B4F8","E68FAE"], // 揮
           "63F4":["8987","B1E7","E68FB4"], // 援
           "63FA":["9768","CDC9","E68FBA"], // 揺
           "640D":["91B9","C2BB","E6908D"], // 損
           "642C":["94C0","C8C2","E690AC"], // 搬
           "642D":["938B","C5EB","E690AD"], // 搭
           "643A":["8C67","B7C8","E690BA"], // 携
           "643E":["8DEF","BAF1","E690BE"], // 搾
           "6442":["90DB","C0DD","E69182"], // 摂
           "6458":["9345","C5A6","E69198"], // 摘
           "6469":["9680","CBE0","E691A9"], // 摩
           "6478":["96CC","CCCE","E691B8"], // 摸
           "647A":["90A0","C0A2","E691BA"], // 摺
           "6483":["8C82","B7E2","E69283"], // 撃
           "6492":["8E54","BBB5","E69292"], // 撒
           "649A":["9451","C7B2","E6929A"], // 撚
           "649E":["93B3","C6B5","E6929E"], // 撞
           "64A4":["9350","C5B1","E692A4"], // 撤
           "64AB":["958F","C9EF","E692AB"], // 撫
           "64AD":["9464","C7C5","E692AD"], // 播
           "64AE":["8E42","BBA3","E692AE"], // 撮
           "64B0":["90EF","C0F1","E692B0"], // 撰
           "64B2":["966F","CBD0","E692B2"], // 撲
           "64B9":["8A68","B3C9","E692B9"], // 撹
           "64C1":["9769","CDCA","E69381"], // 擁
           "64CD":["9180","C1E0","E6938D"], // 操
           "64E2":["9346","C5A7","E693A2"], // 擢
           "64E6":["8E43","BBA4","E693A6"], // 擦
           "64EC":["8B5B","B5BC","E693AC"], // 擬
           "64FE":["8FEF","BEF1","E693BE"], // 擾
           "652F":["8E78","BBD9","E694AF"], // 支
           "6539":["89FC","B2FE","E694B9"], // 改
           "653B":["8D55","B9B6","E694BB"], // 攻
           "653E":["95FA","CAFC","E694BE"], // 放
           "653F":["90AD","C0AF","E694BF"], // 政
           "6545":["8CCC","B8CE","E69585"], // 故
           "654F":["9571","C9D2","E6958F"], // 敏
           "6551":["8B7E","B5DF","E69591"], // 救
           "6557":["9473","C7D4","E69597"], // 敗
           "6559":["8BB3","B6B5","E69599"], // 教
           "6562":["8AB8","B4BA","E695A2"], // 敢
           "6563":["8E55","BBB6","E695A3"], // 散
           "6566":["93D6","C6D8","E695A6"], // 敦
           "656C":["8C68","B7C9","E695AC"], // 敬
           "6570":["9094","BFF4","E695B0"], // 数
           "6574":["90AE","C0B0","E695B4"], // 整
           "6575":["9347","C5A8","E695B5"], // 敵
           "6577":["957E","C9DF","E695B7"], // 敷
           "6587":["95B6","CAB8","E69687"], // 文
           "6589":["90C4","C0C6","E69689"], // 斉
           "658C":["956B","C9CC","E6968C"], // 斌
           "658E":["8DD6","BAD8","E6968E"], // 斎
           "6590":["94E3","C8E5","E69690"], // 斐
           "6591":["94C1","C8C3","E69691"], // 斑
           "6597":["936C","C5CD","E69697"], // 斗
           "6599":["97BF","CEC1","E69699"], // 料
           "659C":["8ECE","BCD0","E6969C"], // 斜
           "65A1":["88B4","B0B6","E696A1"], // 斡
           "65A4":["8BD2","B6D4","E696A4"], // 斤
           "65A5":["90CB","C0CD","E696A5"], // 斥
           "65A7":["9580","C9E0","E696A7"], // 斧
           "65AC":["8E61","BBC2","E696AC"], // 斬
           "65AD":["9266","C3C7","E696AD"], // 断
           "65AF":["8E7A","BBDB","E696AF"], // 斯
           "65B0":["9056","BFB7","E696B0"], // 新
           "65B9":["95FB","CAFD","E696B9"], // 方
           "65BC":["8997","B1F7","E696BC"], // 於
           "65BD":["8E7B","BBDC","E696BD"], // 施
           "65C5":["97B7","CEB9","E69785"], // 旅
           "65CB":["90F9","C0FB","E6978B"], // 旋
           "65CF":["91B0","C2B2","E6978F"], // 族
           "65D7":["8AF8","B4FA","E69797"], // 旗
           "65E2":["8AF9","B4FB","E697A2"], // 既
           "65E5":["93FA","C6FC","E697A5"], // 日
           "65E6":["9255","C3B6","E697A6"], // 旦
           "65E7":["8B8C","B5EC","E697A7"], // 旧
           "65E8":["8E7C","BBDD","E697A8"], // 旨
           "65E9":["9181","C1E1","E697A9"], // 早
           "65EC":["8F7B","BDDC","E697AC"], // 旬
           "65ED":["88AE","B0B0","E697AD"], // 旭
           "65FA":["89A0","B2A2","E697BA"], // 旺
           "6602":["8D56","B9B7","E69882"], // 昂
           "6606":["8DA9","BAAB","E69886"], // 昆
           "6607":["8FB8","BEBA","E69887"], // 昇
           "660C":["8FB9","BEBB","E6988C"], // 昌
           "660E":["96BE","CCC0","E6988E"], // 明
           "660F":["8DA8","BAAA","E6988F"], // 昏
           "6613":["88D5","B0D7","E69893"], // 易
           "6614":["90CC","C0CE","E69894"], // 昔
           "661F":["90AF","C0B1","E6989F"], // 星
           "6620":["8966","B1C7","E698A0"], // 映
           "6625":["8F74","BDD5","E698A5"], // 春
           "6627":["9686","CBE6","E698A7"], // 昧
           "6628":["8DF0","BAF2","E698A8"], // 昨
           "662D":["8FBA","BEBC","E698AD"], // 昭
           "662F":["90A5","C0A7","E698AF"], // 是
           "663C":["928B","C3EB","E698BC"], // 昼
           "6642":["8E9E","BBFE","E69982"], // 時
           "6643":["8D57","B9B8","E69983"], // 晃
           "664B":["9057","BFB8","E6998B"], // 晋
           "6652":["8E4E","BBAF","E69992"], // 晒
           "6666":["8A41","B3A2","E699A6"], // 晦
           "6669":["94D3","C8D5","E699A9"], // 晩
           "666E":["9581","C9E1","E699AE"], // 普
           "666F":["8C69","B7CA","E699AF"], // 景
           "6674":["90B0","C0B2","E699B4"], // 晴
           "6676":["8FBB","BEBD","E699B6"], // 晶
           "667A":["9271","C3D2","E699BA"], // 智
           "6681":["8BC5","B6C7","E69A81"], // 暁
           "6687":["89C9","B2CB","E69A87"], // 暇
           "6691":["8F8B","BDEB","E69A91"], // 暑
           "6696":["9267","C3C8","E69A96"], // 暖
           "6697":["88C3","B0C5","E69A97"], // 暗
           "66A2":["92A8","C4AA","E69AA2"], // 暢
           "66A6":["97EF","CEF1","E69AA6"], // 暦
           "66AB":["8E62","BBC3","E69AAB"], // 暫
           "66AE":["95E9","CAEB","E69AAE"], // 暮
           "66B4":["965C","CBBD","E69AB4"], // 暴
           "66C7":["93DC","C6DE","E69B87"], // 曇
           "66D9":["8F8C","BDEC","E69B99"], // 曙
           "66DC":["976A","CDCB","E69B9C"], // 曜
           "66DD":["9498","C7F8","E69B9D"], // 曝
           "66F2":["8BC8","B6CA","E69BB2"], // 曲
           "66F3":["8967","B1C8","E69BB3"], // 曳
           "66F4":["8D58","B9B9","E69BB4"], // 更
           "66F8":["8F91","BDF1","E69BB8"], // 書
           "66F9":["9182","C1E2","E69BB9"], // 曹
           "66FD":["915D","C1BE","E69BBD"], // 曽
           "66FE":["915C","C1BD","E69BBE"], // 曾
           "66FF":["91D6","C2D8","E69BBF"], // 替
           "6700":["8DC5","BAC7","E69C80"], // 最
           "6708":["8C8E","B7EE","E69C88"], // 月
           "6709":["974C","CDAD","E69C89"], // 有
           "670B":["95FC","CAFE","E69C8B"], // 朋
           "670D":["959E","C9FE","E69C8D"], // 服
           "6714":["8DF1","BAF3","E69C94"], // 朔
           "6715":["92BD","C4BF","E69C95"], // 朕
           "6717":["984E","CFAF","E69C97"], // 朗
           "671B":["965D","CBBE","E69C9B"], // 望
           "671D":["92A9","C4AB","E69C9D"], // 朝
           "671F":["8AFA","B4FC","E69C9F"], // 期
           "6728":["96D8","CCDA","E69CA8"], // 木
           "672A":["96A2","CCA4","E69CAA"], // 未
           "672B":["9696","CBF6","E69CAB"], // 末
           "672C":["967B","CBDC","E69CAC"], // 本
           "672D":["8E44","BBA5","E69CAD"], // 札
           "6731":["8EE9","BCEB","E69CB1"], // 朱
           "6734":["9670","CBD1","E69CB4"], // 朴
           "673A":["8AF7","B4F9","E69CBA"], // 机
           "673D":["8B80","B5E0","E69CBD"], // 朽
           "6749":["9099","BFF9","E69D89"], // 杉
           "674E":["979B","CDFB","E69D8E"], // 李
           "674F":["88C7","B0C9","E69D8F"], // 杏
           "6750":["8DDE","BAE0","E69D90"], // 材
           "6751":["91BA","C2BC","E69D91"], // 村
           "6753":["8EDB","BCDD","E69D93"], // 杓
           "6756":["8FF1","BEF3","E69D96"], // 杖
           "675C":["936D","C5CE","E69D9C"], // 杜
           "675F":["91A9","C2AB","E69D9F"], // 束
           "6761":["8FF0","BEF2","E69DA1"], // 条
           "6762":["96DB","CCDD","E69DA2"], // 杢
           "6765":["9788","CDE8","E69DA5"], // 来
           "676D":["8D59","B9BA","E69DAD"], // 杭
           "676F":["9474","C7D5","E69DAF"], // 杯
           "6771":["938C","C5EC","E69DB1"], // 東
           "6775":["8B6E","B5CF","E69DB5"], // 杵
           "6777":["9466","C7C7","E69DB7"], // 杷
           "677E":["8FBC","BEBE","E69DBE"], // 松
           "677F":["94C2","C8C4","E69DBF"], // 板
           "6787":["94F8","C8FA","E69E87"], // 枇
           "6790":["90CD","C0CF","E69E90"], // 析
           "6795":["968D","CBED","E69E95"], // 枕
           "6797":["97D1","CED3","E69E97"], // 林
           "679A":["9687","CBE7","E69E9A"], // 枚
           "679C":["89CA","B2CC","E69E9C"], // 果
           "679D":["8E7D","BBDE","E69E9D"], // 枝
           "67A0":["9867","CFC8","E69EA0"], // 枠
           "67A2":["9095","BFF5","E69EA2"], // 枢
           "67AF":["8CCD","B8CF","E69EAF"], // 枯
           "67B6":["89CB","B2CD","E69EB6"], // 架
           "67C1":["91C6","C2C8","E69F81"], // 柁
           "67C4":["95BF","CAC1","E69F84"], // 柄
           "67CA":["9541","C9A2","E69F8A"], // 柊
           "67CF":["9490","C7F0","E69F8F"], // 柏
           "67D0":["965E","CBBF","E69F90"], // 某
           "67D1":["8AB9","B4BB","E69F91"], // 柑
           "67D3":["90F5","C0F7","E69F93"], // 染
           "67D4":["8F5F","BDC0","E69F94"], // 柔
           "67D8":["92D1","C4D3","E69F98"], // 柘
           "67DA":["974D","CDAE","E69F9A"], // 柚
           "67F1":["928C","C3EC","E69FB1"], // 柱
           "67F3":["96F6","CCF8","E69FB3"], // 柳
           "67F4":["8EC4","BCC6","E69FB4"], // 柴
           "67F5":["8DF2","BAF4","E69FB5"], // 柵
           "67FB":["8DB8","BABA","E69FBB"], // 査
           "67FE":["968F","CBEF","E69FBE"], // 柾
           "67FF":["8A60","B3C1","E69FBF"], // 柿
           "6802":["92CC","C4CE","E6A082"], // 栂
           "6803":["93C8","C6CA","E6A083"], // 栃
           "6804":["8968","B1C9","E6A084"], // 栄
           "6813":["90F0","C0F2","E6A093"], // 栓
           "6816":["90B2","C0B4","E6A096"], // 栖
           "6817":["8C49","B7AA","E6A097"], // 栗
           "6821":["8D5A","B9BB","E6A0A1"], // 校
           "6822":["8A9C","B3FC","E6A0A2"], // 栢
           "682A":["8A94","B3F4","E6A0AA"], // 株
           "6834":["90F1","C0F3","E6A0B4"], // 栴
           "6838":["8A6A","B3CB","E6A0B8"], // 核
           "6839":["8DAA","BAAC","E6A0B9"], // 根
           "683C":["8A69","B3CA","E6A0BC"], // 格
           "683D":["8DCD","BACF","E6A0BD"], // 栽
           "6841":["8C85","B7E5","E6A181"], // 桁
           "6842":["8C6A","B7CB","E6A182"], // 桂
           "6843":["938D","C5ED","E6A183"], // 桃
           "6848":["88C4","B0C6","E6A188"], // 案
           "6850":["8BCB","B6CD","E6A190"], // 桐
           "6851":["8C4B","B7AC","E6A191"], // 桑
           "6853":["8ABA","B4BC","E6A193"], // 桓
           "6854":["8B6A","B5CB","E6A194"], // 桔
           "685C":["8DF7","BAF9","E6A19C"], // 桜
           "685D":["9691","CBF1","E6A19D"], // 桝
           "685F":["8E56","BBB7","E6A19F"], // 桟
           "6867":["954F","C9B0","E6A1A7"], // 桧
           "6876":["89B1","B2B3","E6A1B6"], // 桶
           "6881":["97C0","CEC2","E6A281"], // 梁
           "6885":["947E","C7DF","E6A285"], // 梅
           "6893":["88B2","B0B4","E6A293"], // 梓
           "6897":["8D5B","B9BC","E6A297"], // 梗
           "68A2":["8FBD","BEBF","E6A2A2"], // 梢
           "68A7":["8CE6","B8E8","E6A2A7"], // 梧
           "68A8":["979C","CDFC","E6A2A8"], // 梨
           "68AF":["92F2","C4F4","E6A2AF"], // 梯
           "68B0":["8A42","B3A3","E6A2B0"], // 械
           "68B1":["8DAB","BAAD","E6A2B1"], // 梱
           "68B6":["8A81","B3E1","E6A2B6"], // 梶
           "68BC":["938E","C5EE","E6A2BC"], // 梼
           "68C4":["8AFC","B4FE","E6A384"], // 棄
           "68C9":["96C7","CCC9","E6A389"], // 棉
           "68CB":["8AFB","B4FD","E6A38B"], // 棋
           "68D2":["965F","CBC0","E6A392"], // 棒
           "68DA":["9249","C3AA","E6A39A"], // 棚
           "68DF":["938F","C5EF","E6A39F"], // 棟
           "68EE":["9058","BFB9","E6A3AE"], // 森
           "68F2":["90B1","C0B3","E6A3B2"], // 棲
           "68FA":["8ABB","B4BD","E6A3BA"], // 棺
           "6900":["986F","CFD0","E6A480"], // 椀
           "6905":["88D6","B0D8","E6A485"], // 椅
           "690B":["96B8","CCBA","E6A48B"], // 椋
           "690D":["9041","BFA2","E6A48D"], // 植
           "690E":["92C5","C4C7","E6A48E"], // 椎
           "6919":["909A","BFFA","E6A499"], // 椙
           "691B":["8A91","B3F1","E6A49B"], // 椛
           "691C":["8C9F","B8A1","E6A49C"], // 検
           "6934":["93CC","C6CE","E6A4B4"], // 椴
           "693F":["92D6","C4D8","E6A4BF"], // 椿
           "694A":["976B","CDCC","E6A58A"], // 楊
           "6953":["9596","C9F6","E6A593"], // 楓
           "6955":["91C8","C2CA","E6A595"], // 楕
           "695A":["915E","C1BF","E6A59A"], // 楚
           "6960":["93ED","C6EF","E6A5A0"], // 楠
           "6962":["93E8","C6EA","E6A5A2"], // 楢
           "696D":["8BC6","B6C8","E6A5AD"], // 業
           "696F":["8F7C","BDDD","E6A5AF"], // 楯
           "6973":["9480","C7E0","E6A5B3"], // 楳
           "6975":["8BC9","B6CB","E6A5B5"], // 極
           "697C":["984F","CFB0","E6A5BC"], // 楼
           "697D":["8A79","B3DA","E6A5BD"], // 楽
           "6982":["8A54","B3B5","E6A682"], // 概
           "698A":["8DE5","BAE7","E6A68A"], // 榊
           "698E":["897C","B1DD","E6A68E"], // 榎
           "6994":["9850","CFB1","E6A694"], // 榔
           "699B":["9059","BFBA","E6A69B"], // 榛
           "69CB":["8D5C","B9BD","E6A78B"], // 構
           "69CC":["92C6","C4C8","E6A78C"], // 槌
           "69CD":["9184","C1E4","E6A78D"], // 槍
           "69D8":["976C","CDCD","E6A798"], // 様
           "69D9":["968A","CBEA","E6A799"], // 槙
           "69FB":["92CE","C4D0","E6A7BB"], // 槻
           "69FD":["9185","C1E5","E6A7BD"], // 槽
           "6A0B":["94F3","C8F5","E6A88B"], // 樋
           "6A17":["9294","C3F4","E6A897"], // 樗
           "6A19":["9557","C9B8","E6A899"], // 標
           "6A1F":["8FBE","BEC0","E6A89F"], // 樟
           "6A21":["96CD","CCCF","E6A8A1"], // 模
           "6A29":["8CA0","B8A2","E6A8A9"], // 権
           "6A2A":["89A1","B2A3","E6A8AA"], // 横
           "6A2B":["8A7E","B3DF","E6A8AB"], // 樫
           "6A35":["8FBF","BEC1","E6A8B5"], // 樵
           "6A39":["8EF7","BCF9","E6A8B9"], // 樹
           "6A3A":["8A92","B3F2","E6A8BA"], // 樺
           "6A3D":["924D","C3AE","E6A8BD"], // 樽
           "6A4B":["8BB4","B6B6","E6A98B"], // 橋
           "6A58":["8B6B","B5CC","E6A998"], // 橘
           "6A5F":["8B40","B5A1","E6A99F"], // 機
           "6A61":["93C9","C6CB","E6A9A1"], // 橡
           "6A7F":["8A80","B3E0","E6A9BF"], // 橿
           "6A80":["9268","C3C9","E6AA80"], // 檀
           "6A8E":["8CE7","B8E9","E6AA8E"], // 檎
           "6AD3":["9845","CFA6","E6AB93"], // 櫓
           "6ADB":["8BF9","B6FB","E6AB9B"], // 櫛
           "6AE8":["94A5","C8A7","E6ABA8"], // 櫨
           "6B04":["9793","CDF3","E6AC84"], // 欄
           "6B1D":["8954","B1B5","E6AC9D"], // 欝
           "6B20":["8C87","B7E7","E6ACA0"], // 欠
           "6B21":["8E9F","BCA1","E6ACA1"], // 次
           "6B23":["8BD3","B6D5","E6ACA3"], // 欣
           "6B27":["89A2","B2A4","E6ACA7"], // 欧
           "6B32":["977E","CDDF","E6ACB2"], // 欲
           "6B3A":["8B5C","B5BD","E6ACBA"], // 欺
           "6B3D":["8BD4","B6D6","E6ACBD"], // 欽
           "6B3E":["8ABC","B4BE","E6ACBE"], // 款
           "6B4C":["89CC","B2CE","E6AD8C"], // 歌
           "6B4E":["9256","C3B7","E6AD8E"], // 歎
           "6B53":["8ABD","B4BF","E6AD93"], // 歓
           "6B62":["8E7E","BBDF","E6ADA2"], // 止
           "6B63":["90B3","C0B5","E6ADA3"], // 正
           "6B64":["8D9F","BAA1","E6ADA4"], // 此
           "6B66":["9590","C9F0","E6ADA6"], // 武
           "6B69":["95E0","CAE2","E6ADA9"], // 歩
           "6B6A":["9863","CFC4","E6ADAA"], // 歪
           "6B6F":["8E95","BBF5","E6ADAF"], // 歯
           "6B73":["8DCE","BAD0","E6ADB3"], // 歳
           "6B74":["97F0","CEF2","E6ADB4"], // 歴
           "6B7B":["8E80","BBE0","E6ADBB"], // 死
           "6B86":["9677","CBD8","E6AE86"], // 殆
           "6B89":["8F7D","BDDE","E6AE89"], // 殉
           "6B8A":["8EEA","BCEC","E6AE8A"], // 殊
           "6B8B":["8E63","BBC4","E6AE8B"], // 残
           "6B96":["9042","BFA3","E6AE96"], // 殖
           "6BB4":["89A3","B2A5","E6AEB4"], // 殴
           "6BB5":["9269","C3CA","E6AEB5"], // 段
           "6BBA":["8E45","BBA6","E6AEBA"], // 殺
           "6BBB":["8A6B","B3CC","E6AEBB"], // 殻
           "6BBF":["9361","C5C2","E6AEBF"], // 殿
           "6BC5":["8B42","B5A3","E6AF85"], // 毅
           "6BCD":["95EA","CAEC","E6AF8D"], // 母
           "6BCE":["9688","CBE8","E6AF8E"], // 毎
           "6BD2":["93C5","C6C7","E6AF92"], // 毒
           "6BD4":["94E4","C8E6","E6AF94"], // 比
           "6BD8":["94F9","C8FB","E6AF98"], // 毘
           "6BDB":["96D1","CCD3","E6AF9B"], // 毛
           "6C0F":["8E81","BBE1","E6B08F"], // 氏
           "6C11":["96AF","CCB1","E6B091"], // 民
           "6C17":["8B43","B5A4","E6B097"], // 気
           "6C34":["9085","BFE5","E6B0B4"], // 水
           "6C37":["9558","C9B9","E6B0B7"], // 氷
           "6C38":["8969","B1CA","E6B0B8"], // 永
           "6C3E":["94C3","C8C5","E6B0BE"], // 氾
           "6C40":["92F3","C4F5","E6B180"], // 汀
           "6C41":["8F60","BDC1","E6B181"], // 汁
           "6C42":["8B81","B5E1","E6B182"], // 求
           "6C4E":["94C4","C8C6","E6B18E"], // 汎
           "6C50":["8EAC","BCAE","E6B190"], // 汐
           "6C57":["8ABE","B4C0","E6B197"], // 汗
           "6C5A":["8998","B1F8","E6B19A"], // 汚
           "6C5D":["93F0","C6F2","E6B19D"], // 汝
           "6C5F":["8D5D","B9BE","E6B19F"], // 江
           "6C60":["9272","C3D3","E6B1A0"], // 池
           "6C70":["91BF","C2C1","E6B1B0"], // 汰
           "6C72":["8B82","B5E2","E6B1B2"], // 汲
           "6C7A":["8C88","B7E8","E6B1BA"], // 決
           "6C7D":["8B44","B5A5","E6B1BD"], // 汽
           "6C83":["9780","CDE0","E6B283"], // 沃
           "6C88":["92BE","C4C0","E6B288"], // 沈
           "6C8C":["93D7","C6D9","E6B28C"], // 沌
           "6C93":["8C42","B7A3","E6B293"], // 沓
           "6C96":["89AB","B2AD","E6B296"], // 沖
           "6C99":["8DB9","BABB","E6B299"], // 沙
           "6CA1":["9676","CBD7","E6B2A1"], // 没
           "6CA2":["91F2","C2F4","E6B2A2"], // 沢
           "6CAB":["9697","CBF7","E6B2AB"], // 沫
           "6CB3":["89CD","B2CF","E6B2B3"], // 河
           "6CB8":["95A6","CAA8","E6B2B8"], // 沸
           "6CB9":["96FB","CCFD","E6B2B9"], // 油
           "6CBB":["8EA1","BCA3","E6B2BB"], // 治
           "6CBC":["8FC0","BEC2","E6B2BC"], // 沼
           "6CBF":["8988","B1E8","E6B2BF"], // 沿
           "6CC1":["8BB5","B6B7","E6B381"], // 況
           "6CC9":["90F2","C0F4","E6B389"], // 泉
           "6CCA":["9491","C7F1","E6B38A"], // 泊
           "6CCC":["94E5","C8E7","E6B38C"], // 泌
           "6CD5":["9640","CBA1","E6B395"], // 法
           "6CE1":["9641","CBA2","E6B3A1"], // 泡
           "6CE2":["9467","C7C8","E6B3A2"], // 波
           "6CE3":["8B83","B5E3","E6B3A3"], // 泣
           "6CE5":["9344","C5A5","E6B3A5"], // 泥
           "6CE8":["928D","C3ED","E6B3A8"], // 注
           "6CF0":["91D7","C2D9","E6B3B0"], // 泰
           "6CF3":["896A","B1CB","E6B3B3"], // 泳
           "6D0B":["976D","CDCE","E6B48B"], // 洋
           "6D17":["90F4","C0F6","E6B497"], // 洗
           "6D1B":["978C","CDEC","E6B49B"], // 洛
           "6D1E":["93B4","C6B6","E6B49E"], // 洞
           "6D25":["92C3","C4C5","E6B4A5"], // 津
           "6D29":["896B","B1CC","E6B4A9"], // 洩
           "6D2A":["8D5E","B9BF","E6B4AA"], // 洪
           "6D32":["8F46","BDA7","E6B4B2"], // 洲
           "6D3B":["8A88","B3E8","E6B4BB"], // 活
           "6D3E":["9468","C7C9","E6B4BE"], // 派
           "6D41":["97AC","CEAE","E6B581"], // 流
           "6D44":["8FF2","BEF4","E6B584"], // 浄
           "6D45":["90F3","C0F5","E6B585"], // 浅
           "6D5C":["956C","C9CD","E6B59C"], // 浜
           "6D66":["8959","B1BA","E6B5A6"], // 浦
           "6D69":["8D5F","B9C0","E6B5A9"], // 浩
           "6D6A":["9851","CFB2","E6B5AA"], // 浪
           "6D6C":["8A5C","B3BD","E6B5AC"], // 浬
           "6D6E":["9582","C9E2","E6B5AE"], // 浮
           "6D74":["9781","CDE1","E6B5B4"], // 浴
           "6D77":["8A43","B3A4","E6B5B7"], // 海
           "6D78":["905A","BFBB","E6B5B8"], // 浸
           "6D88":["8FC1","BEC3","E6B688"], // 消
           "6D8C":["974F","CDB0","E6B68C"], // 涌
           "6D99":["97DC","CEDE","E6B699"], // 涙
           "6D9B":["9393","C5F3","E6B69B"], // 涛
           "6D9C":["93C0","C6C2","E6B69C"], // 涜
           "6DAF":["8A55","B3B6","E6B6AF"], // 涯
           "6DB2":["8974","B1D5","E6B6B2"], // 液
           "6DBC":["97C1","CEC3","E6B6BC"], // 涼
           "6DC0":["9784","CDE4","E6B780"], // 淀
           "6DCB":["97D2","CED4","E6B78B"], // 淋
           "6DD1":["8F69","BDCA","E6B791"], // 淑
           "6DD8":["9391","C5F1","E6B798"], // 淘
           "6DE1":["9257","C3B8","E6B7A1"], // 淡
           "6DEB":["88FA","B0FC","E6B7AB"], // 淫
           "6DF1":["905B","BFBC","E6B7B1"], // 深
           "6DF3":["8F7E","BDDF","E6B7B3"], // 淳
           "6DF5":["95A3","CAA5","E6B7B5"], // 淵
           "6DF7":["8DAC","BAAE","E6B7B7"], // 混
           "6DFB":["9359","C5BA","E6B7BB"], // 添
           "6E05":["90B4","C0B6","E6B885"], // 清
           "6E07":["8A89","B3E9","E6B887"], // 渇
           "6E08":["8DCF","BAD1","E6B888"], // 済
           "6E09":["8FC2","BEC4","E6B889"], // 渉
           "6E0B":["8F61","BDC2","E6B88B"], // 渋
           "6E13":["8C6B","B7CC","E6B893"], // 渓
           "6E1A":["8F8D","BDED","E6B89A"], // 渚
           "6E1B":["8CB8","B8BA","E6B89B"], // 減
           "6E20":["8B94","B5F4","E6B8A0"], // 渠
           "6E21":["936E","C5CF","E6B8A1"], // 渡
           "6E25":["88AD","B0AF","E6B8A5"], // 渥
           "6E26":["8951","B1B2","E6B8A6"], // 渦
           "6E29":["89B7","B2B9","E6B8A9"], // 温
           "6E2C":["91AA","C2AC","E6B8AC"], // 測
           "6E2F":["8D60","B9C1","E6B8AF"], // 港
           "6E4A":["96A9","CCAB","E6B98A"], // 湊
           "6E56":["8CCE","B8D0","E6B996"], // 湖
           "6E58":["8FC3","BEC5","E6B998"], // 湘
           "6E5B":["9258","C3B9","E6B99B"], // 湛
           "6E67":["974E","CDAF","E6B9A7"], // 湧
           "6E6F":["9392","C5F2","E6B9AF"], // 湯
           "6E7E":["9870","CFD1","E6B9BE"], // 湾
           "6E7F":["8EBC","BCBE","E6B9BF"], // 湿
           "6E80":["969E","CBFE","E6BA80"], // 満
           "6E8C":["94AC","C8AE","E6BA8C"], // 溌
           "6E90":["8CB9","B8BB","E6BA90"], // 源
           "6E96":["8F80","BDE0","E6BA96"], // 準
           "6E9C":["97AD","CEAF","E6BA9C"], // 溜
           "6E9D":["8D61","B9C2","E6BA9D"], // 溝
           "6EA2":["88EC","B0EE","E6BAA2"], // 溢
           "6EB6":["976E","CDCF","E6BAB6"], // 溶
           "6EBA":["934D","C5AE","E6BABA"], // 溺
           "6EC5":["96C5","CCC7","E6BB85"], // 滅
           "6ECB":["8EA0","BCA2","E6BB8B"], // 滋
           "6ED1":["8A8A","B3EA","E6BB91"], // 滑
           "6EDD":["91EA","C2EC","E6BB9D"], // 滝
           "6EDE":["91D8","C2DA","E6BB9E"], // 滞
           "6EF4":["9348","C5A9","E6BBB4"], // 滴
           "6F01":["8B99","B5F9","E6BC81"], // 漁
           "6F02":["9559","C9BA","E6BC82"], // 漂
           "6F06":["8EBD","BCBF","E6BC86"], // 漆
           "6F09":["8D97","B9F7","E6BC89"], // 漉
           "6F0F":["9852","CFB3","E6BC8F"], // 漏
           "6F14":["8989","B1E9","E6BC94"], // 演
           "6F15":["9186","C1E6","E6BC95"], // 漕
           "6F20":["9499","C7F9","E6BCA0"], // 漠
           "6F22":["8ABF","B4C1","E6BCA2"], // 漢
           "6F23":["97F8","CEFA","E6BCA3"], // 漣
           "6F2B":["969F","CCA1","E6BCAB"], // 漫
           "6F2C":["92D0","C4D2","E6BCAC"], // 漬
           "6F38":["9151","C1B2","E6BCB8"], // 漸
           "6F45":["8AC1","B4C3","E6BD85"], // 潅
           "6F54":["8C89","B7E9","E6BD94"], // 潔
           "6F5C":["90F6","C0F8","E6BD9C"], // 潜
           "6F5F":["8A83","B3E3","E6BD9F"], // 潟
           "6F64":["8F81","BDE1","E6BDA4"], // 潤
           "6F6E":["92AA","C4AC","E6BDAE"], // 潮
           "6F70":["92D7","C4D9","E6BDB0"], // 潰
           "6F84":["909F","C0A1","E6BE84"], // 澄
           "6F97":["8AC0","B4C2","E6BE97"], // 澗
           "6FB1":["9362","C5C3","E6BEB1"], // 澱
           "6FC0":["8C83","B7E3","E6BF80"], // 激
           "6FC1":["91F7","C2F9","E6BF81"], // 濁
           "6FC3":["945A","C7BB","E6BF83"], // 濃
           "6FE0":["8D8A","B9EA","E6BFA0"], // 濠
           "6FE1":["9447","C7A8","E6BFA1"], // 濡
           "6FEB":["9794","CDF4","E6BFAB"], // 濫
           "6FEF":["91F3","C2F5","E6BFAF"], // 濯
           "7015":["956D","C9CE","E78095"], // 瀕
           "701E":["93D2","C6D4","E7809E"], // 瀞
           "7026":["9295","C3F5","E780A6"], // 瀦
           "7027":["91EB","C2ED","E780A7"], // 瀧
           "702C":["90A3","C0A5","E780AC"], // 瀬
           "7058":["93E5","C6E7","E78198"], // 灘
           "706B":["89CE","B2D0","E781AB"], // 火
           "706F":["9394","C5F4","E781AF"], // 灯
           "7070":["8A44","B3A5","E781B0"], // 灰
           "7078":["8B84","B5E4","E781B8"], // 灸
           "707C":["8EDC","BCDE","E781BC"], // 灼
           "707D":["8DD0","BAD2","E781BD"], // 災
           "7089":["9846","CFA7","E78289"], // 炉
           "708A":["9086","BFE6","E7828A"], // 炊
           "708E":["898A","B1EA","E7828E"], // 炎
           "70AD":["9259","C3BA","E782AD"], // 炭
           "70B9":["935F","C5C0","E782B9"], // 点
           "70BA":["88D7","B0D9","E782BA"], // 為
           "70C8":["97F3","CEF5","E78388"], // 烈
           "70CF":["8947","B1A8","E7838F"], // 烏
           "70F9":["9642","CBA3","E783B9"], // 烹
           "7114":["898B","B1EB","E78494"], // 焔
           "711A":["95B0","CAB2","E7849A"], // 焚
           "7121":["96B3","CCB5","E784A1"], // 無
           "7126":["8FC5","BEC7","E784A6"], // 焦
           "7136":["9152","C1B3","E784B6"], // 然
           "713C":["8FC4","BEC6","E784BC"], // 焼
           "7149":["97F9","CEFB","E78589"], // 煉
           "714E":["90F7","C0F9","E7858E"], // 煎
           "7159":["898C","B1EC","E78599"], // 煙
           "7164":["9481","C7E1","E785A4"], // 煤
           "7167":["8FC6","BEC8","E785A7"], // 照
           "7169":["94CF","C8D1","E785A9"], // 煩
           "716E":["8ECF","BCD1","E785AE"], // 煮
           "717D":["90F8","C0FA","E785BD"], // 煽
           "718A":["8C46","B7A7","E7868A"], // 熊
           "7194":["976F","CDD0","E78694"], // 熔
           "719F":["8F6E","BDCF","E7869F"], // 熟
           "71B1":["944D","C7AE","E786B1"], // 熱
           "71C3":["9452","C7B3","E78783"], // 燃
           "71C8":["9395","C5F5","E78788"], // 燈
           "71D0":["97D3","CED5","E78790"], // 燐
           "71D5":["898D","B1ED","E78795"], // 燕
           "71E5":["9187","C1E7","E787A5"], // 燥
           "71E6":["8E57","BBB8","E787A6"], // 燦
           "71ED":["9043","BFA4","E787AD"], // 燭
           "7206":["949A","C7FA","E78886"], // 爆
           "722A":["92DC","C4DE","E788AA"], // 爪
           "7235":["8EDD","BCDF","E788B5"], // 爵
           "7236":["9583","C9E3","E788B6"], // 父
           "723A":["96EA","CCEC","E788BA"], // 爺
           "723D":["9175","C1D6","E788BD"], // 爽
           "723E":["8EA2","BCA4","E788BE"], // 爾
           "7247":["95D0","CAD2","E78987"], // 片
           "7248":["94C5","C8C7","E78988"], // 版
           "724C":["9476","C7D7","E7898C"], // 牌
           "7252":["92AB","C4AD","E78992"], // 牒
           "7259":["89E5","B2E7","E78999"], // 牙
           "725B":["8B8D","B5ED","E7899B"], // 牛
           "725D":["96C4","CCC6","E7899D"], // 牝
           "725F":["96B4","CCB6","E7899F"], // 牟
           "7261":["89B2","B2B4","E789A1"], // 牡
           "7262":["9853","CFB4","E789A2"], // 牢
           "7267":["9671","CBD2","E789A7"], // 牧
           "7269":["95A8","CAAA","E789A9"], // 物
           "7272":["90B5","C0B7","E789B2"], // 牲
           "7279":["93C1","C6C3","E789B9"], // 特
           "727D":["8CA1","B8A3","E789BD"], // 牽
           "7280":["8DD2","BAD4","E78A80"], // 犀
           "72A0":["8B5D","B5BE","E78AA0"], // 犠
           "72AC":["8CA2","B8A4","E78AAC"], // 犬
           "72AF":["94C6","C8C8","E78AAF"], // 犯
           "72B6":["8FF3","BEF5","E78AB6"], // 状
           "72C2":["8BB6","B6B8","E78B82"], // 狂
           "72D0":["8CCF","B8D1","E78B90"], // 狐
           "72D7":["8BE7","B6E9","E78B97"], // 狗
           "72D9":["915F","C1C0","E78B99"], // 狙
           "72DB":["8D9D","B9FD","E78B9B"], // 狛
           "72E9":["8EEB","BCED","E78BA9"], // 狩
           "72EC":["93C6","C6C8","E78BAC"], // 独
           "72ED":["8BB7","B6B9","E78BAD"], // 狭
           "72F8":["924B","C3AC","E78BB8"], // 狸
           "72FC":["9854","CFB5","E78BBC"], // 狼
           "72FD":["9482","C7E2","E78BBD"], // 狽
           "731B":["96D2","CCD4","E78C9B"], // 猛
           "731F":["97C2","CEC4","E78C9F"], // 猟
           "732A":["9296","C3F6","E78CAA"], // 猪
           "732B":["944C","C7AD","E78CAB"], // 猫
           "732E":["8CA3","B8A5","E78CAE"], // 献
           "7336":["9750","CDB1","E78CB6"], // 猶
           "7337":["9751","CDB2","E78CB7"], // 猷
           "733F":["898E","B1EE","E78CBF"], // 猿
           "7344":["8D96","B9F6","E78D84"], // 獄
           "7345":["8E82","BBE2","E78D85"], // 獅
           "7363":["8F62","BDC3","E78DA3"], // 獣
           "7372":["8A6C","B3CD","E78DB2"], // 獲
           "7384":["8CBA","B8BC","E78E84"], // 玄
           "7387":["97A6","CEA8","E78E87"], // 率
           "7389":["8BCA","B6CC","E78E89"], // 玉
           "738B":["89A4","B2A6","E78E8B"], // 王
           "7396":["8BE8","B6EA","E78E96"], // 玖
           "73A9":["8ADF","B4E1","E78EA9"], // 玩
           "73B2":["97E6","CEE8","E78EB2"], // 玲
           "73C2":["89CF","B2D1","E78F82"], // 珂
           "73CA":["8E58","BBB9","E78F8A"], // 珊
           "73CD":["92BF","C4C1","E78F8D"], // 珍
           "73E0":["8EEC","BCEE","E78FA0"], // 珠
           "73EA":["8C5D","B7BE","E78FAA"], // 珪
           "73ED":["94C7","C8C9","E78FAD"], // 班
           "73FE":["8CBB","B8BD","E78FBE"], // 現
           "7403":["8B85","B5E5","E79083"], // 球
           "7406":["979D","CDFD","E79086"], // 理
           "7409":["97AE","CEB0","E79089"], // 琉
           "7422":["91F4","C2F6","E790A2"], // 琢
           "7433":["97D4","CED6","E790B3"], // 琳
           "7434":["8BD5","B6D7","E790B4"], // 琴
           "7435":["94FA","C8FC","E790B5"], // 琵
           "7436":["9469","C7CA","E790B6"], // 琶
           "745A":["8CE8","B8EA","E7919A"], // 瑚
           "745B":["896C","B1CD","E7919B"], // 瑛
           "745E":["9090","BFF0","E7919E"], // 瑞
           "7460":["97DA","CEDC","E791A0"], // 瑠
           "7473":["8DBA","BABC","E791B3"], // 瑳
           "7483":["979E","CDFE","E79283"], // 璃
           "74B0":["8AC2","B4C4","E792B0"], // 環
           "74BD":["8EA3","BCA5","E792BD"], // 璽
           "74DC":["895A","B1BB","E7939C"], // 瓜
           "74E2":["955A","C9BB","E793A2"], // 瓢
           "74E6":["8AA2","B4A4","E793A6"], // 瓦
           "74F6":["9572","C9D3","E793B6"], // 瓶
           "7511":["8D99","B9F9","E79491"], // 甑
           "7518":["8AC3","B4C5","E79498"], // 甘
           "751A":["9072","BFD3","E7949A"], // 甚
           "751C":["935B","C5BC","E7949C"], // 甜
           "751F":["90B6","C0B8","E7949F"], // 生
           "7523":["8E59","BBBA","E794A3"], // 産
           "7525":["8999","B1F9","E794A5"], // 甥
           "7528":["9770","CDD1","E794A8"], // 用
           "752B":["95E1","CAE3","E794AB"], // 甫
           "7530":["9363","C5C4","E794B0"], // 田
           "7531":["9752","CDB3","E794B1"], // 由
           "7532":["8D62","B9C3","E794B2"], // 甲
           "7533":["905C","BFBD","E794B3"], // 申
           "7537":["926A","C3CB","E794B7"], // 男
           "753A":["92AC","C4AE","E794BA"], // 町
           "753B":["89E6","B2E8","E794BB"], // 画
           "754C":["8A45","B3A6","E7958C"], // 界
           "754F":["88D8","B0DA","E7958F"], // 畏
           "7551":["94A8","C8AA","E79591"], // 畑
           "7554":["94C8","C8CA","E79594"], // 畔
           "7559":["97AF","CEB1","E79599"], // 留
           "755C":["927B","C3DC","E7959C"], // 畜
           "755D":["90A4","C0A6","E7959D"], // 畝
           "7560":["94A9","C8AB","E795A0"], // 畠
           "7562":["954C","C9AD","E795A2"], // 畢
           "7565":["97AA","CEAC","E795A5"], // 略
           "7566":["8C6C","B7CD","E795A6"], // 畦
           "756A":["94D4","C8D6","E795AA"], // 番
           "7570":["88D9","B0DB","E795B0"], // 異
           "7573":["8FF4","BEF6","E795B3"], // 畳
           "7577":["93EB","C6ED","E795B7"], // 畷
           "757F":["8B45","B5A6","E795BF"], // 畿
           "758B":["9544","C9A5","E7968B"], // 疋
           "758E":["9161","C1C2","E7968E"], // 疎
           "758F":["9160","C1C1","E7968F"], // 疏
           "7591":["8B5E","B5BF","E79691"], // 疑
           "75AB":["8975","B1D6","E796AB"], // 疫
           "75B2":["94E6","C8E8","E796B2"], // 疲
           "75B9":["905D","BFBE","E796B9"], // 疹
           "75BE":["8EBE","BCC0","E796BE"], // 疾
           "75C5":["9561","C9C2","E79785"], // 病
           "75C7":["8FC7","BEC9","E79787"], // 症
           "75D4":["8EA4","BCA6","E79794"], // 痔
           "75D5":["8DAD","BAAF","E79795"], // 痕
           "75D8":["9397","C5F7","E79798"], // 痘
           "75DB":["92C9","C4CB","E7979B"], // 痛
           "75E2":["979F","CEA1","E797A2"], // 痢
           "75E9":["9189","C1E9","E797A9"], // 痩
           "75F4":["9273","C3D4","E797B4"], // 痴
           "7642":["97C3","CEC5","E79982"], // 療
           "764C":["8AE0","B4E2","E7998C"], // 癌
           "7652":["96FC","CCFE","E79992"], // 癒
           "7656":["95C8","CACA","E79996"], // 癖
           "767A":["94AD","C8AF","E799BA"], // 発
           "767B":["936F","C5D0","E799BB"], // 登
           "767D":["9492","C7F2","E799BD"], // 白
           "767E":["9553","C9B4","E799BE"], // 百
           "7684":["9349","C5AA","E79A84"], // 的
           "7686":["8A46","B3A7","E79A86"], // 皆
           "7687":["8D63","B9C4","E79A87"], // 皇
           "7690":["8E48","BBA9","E79A90"], // 皐
           "76AE":["94E7","C8E9","E79AAE"], // 皮
           "76BF":["8E4D","BBAE","E79ABF"], // 皿
           "76C3":["9475","C7D6","E79B83"], // 盃
           "76C6":["967E","CBDF","E79B86"], // 盆
           "76C8":["896D","B1CE","E79B88"], // 盈
           "76CA":["8976","B1D7","E79B8A"], // 益
           "76D7":["9390","C5F0","E79B97"], // 盗
           "76DB":["90B7","C0B9","E79B9B"], // 盛
           "76DF":["96BF","CCC1","E79B9F"], // 盟
           "76E3":["8AC4","B4C6","E79BA3"], // 監
           "76E4":["94D5","C8D7","E79BA4"], // 盤
           "76EE":["96DA","CCDC","E79BAE"], // 目
           "76F2":["96D3","CCD5","E79BB2"], // 盲
           "76F4":["92BC","C4BE","E79BB4"], // 直
           "76F8":["918A","C1EA","E79BB8"], // 相
           "76FE":["8F82","BDE2","E79BBE"], // 盾
           "7701":["8FC8","BECA","E79C81"], // 省
           "7709":["94FB","C8FD","E79C89"], // 眉
           "770B":["8AC5","B4C7","E79C8B"], // 看
           "770C":["8CA7","B8A9","E79C8C"], // 県
           "771F":["905E","BFBF","E79C9F"], // 真
           "7720":["96B0","CCB2","E79CA0"], // 眠
           "773A":["92AD","C4AF","E79CBA"], // 眺
           "773C":["8AE1","B4E3","E79CBC"], // 眼
           "7740":["9285","C3E5","E79D80"], // 着
           "7761":["9087","BFE7","E79DA1"], // 睡
           "7763":["93C2","C6C4","E79DA3"], // 督
           "7766":["9672","CBD3","E79DA6"], // 睦
           "77A5":["95CB","CACD","E79EA5"], // 瞥
           "77AC":["8F75","BDD6","E79EAC"], // 瞬
           "77AD":["97C4","CEC6","E79EAD"], // 瞭
           "77B3":["93B5","C6B7","E79EB3"], // 瞳
           "77DB":["96B5","CCB7","E79F9B"], // 矛
           "77E2":["96EE","CCF0","E79FA2"], // 矢
           "77E5":["926D","C3CE","E79FA5"], // 知
           "77E7":["948A","C7EA","E79FA7"], // 矧
           "77E9":["8BE9","B6EB","E79FA9"], // 矩
           "77ED":["925A","C3BB","E79FAD"], // 短
           "77EF":["8BB8","B6BA","E79FAF"], // 矯
           "77F3":["90CE","C0D0","E79FB3"], // 石
           "7802":["8DBB","BABD","E7A082"], // 砂
           "7814":["8CA4","B8A6","E7A094"], // 研
           "7815":["8DD3","BAD5","E7A095"], // 砕
           "7825":["9375","C5D6","E7A0A5"], // 砥
           "7826":["8DD4","BAD6","E7A0A6"], // 砦
           "7827":["8B6D","B5CE","E7A0A7"], // 砧
           "7832":["9643","CBA4","E7A0B2"], // 砲
           "7834":["946A","C7CB","E7A0B4"], // 破
           "783A":["9376","C5D7","E7A0BA"], // 砺
           "783F":["8D7B","B9DC","E7A0BF"], // 砿
           "785D":["8FC9","BECB","E7A19D"], // 硝
           "786B":["97B0","CEB2","E7A1AB"], // 硫
           "786C":["8D64","B9C5","E7A1AC"], // 硬
           "786F":["8CA5","B8A7","E7A1AF"], // 硯
           "7872":["94A1","C8A3","E7A1B2"], // 硲
           "7881":["8CE9","B8EB","E7A281"], // 碁
           "7887":["92F4","C4F6","E7A287"], // 碇
           "788D":["8A56","B3B7","E7A28D"], // 碍
           "7891":["94E8","C8EA","E7A291"], // 碑
           "7893":["894F","B1B0","E7A293"], // 碓
           "7895":["8DEA","BAEC","E7A295"], // 碕
           "7897":["9871","CFD2","E7A297"], // 碗
           "78A7":["95C9","CACB","E7A2A7"], // 碧
           "78A9":["90D7","C0D9","E7A2A9"], // 碩
           "78BA":["8A6D","B3CE","E7A2BA"], // 確
           "78C1":["8EA5","BCA7","E7A381"], // 磁
           "78D0":["94D6","C8D8","E7A390"], // 磐
           "78E8":["9681","CBE1","E7A3A8"], // 磨
           "78EF":["88E9","B0EB","E7A3AF"], // 磯
           "7901":["8FCA","BECC","E7A481"], // 礁
           "790E":["9162","C1C3","E7A48E"], // 礎
           "793A":["8EA6","BCA8","E7A4BA"], // 示
           "793C":["97E7","CEE9","E7A4BC"], // 礼
           "793E":["8ED0","BCD2","E7A4BE"], // 社
           "7941":["8C56","B7B7","E7A581"], // 祁
           "7947":["8B5F","B5C0","E7A587"], // 祇
           "7948":["8B46","B5A7","E7A588"], // 祈
           "7949":["8E83","BBE3","E7A589"], // 祉
           "7950":["9753","CDB4","E7A590"], // 祐
           "7956":["9163","C1C4","E7A596"], // 祖
           "795D":["8F6A","BDCB","E7A59D"], // 祝
           "795E":["905F","BFC0","E7A59E"], // 神
           "7962":["9449","C7AA","E7A5A2"], // 祢
           "7965":["8FCB","BECD","E7A5A5"], // 祥
           "7968":["955B","C9BC","E7A5A8"], // 票
           "796D":["8DD5","BAD7","E7A5AD"], // 祭
           "7977":["9398","C5F8","E7A5B7"], // 祷
           "7981":["8BD6","B6D8","E7A681"], // 禁
           "7984":["985C","CFBD","E7A684"], // 禄
           "7985":["9154","C1B5","E7A685"], // 禅
           "798D":["89D0","B2D2","E7A68D"], // 禍
           "798E":["92F5","C4F7","E7A68E"], // 禎
           "798F":["959F","CAA1","E7A68F"], // 福
           "79A6":["8B9A","B5FA","E7A6A6"], // 禦
           "79B0":["9448","C7A9","E7A6B0"], // 禰
           "79BD":["8BD7","B6D9","E7A6BD"], // 禽
           "79BE":["89D1","B2D3","E7A6BE"], // 禾
           "79BF":["93C3","C6C5","E7A6BF"], // 禿
           "79C0":["8F47","BDA8","E7A780"], // 秀
           "79C1":["8E84","BBE4","E7A781"], // 私
           "79CB":["8F48","BDA9","E7A78B"], // 秋
           "79D1":["89C8","B2CA","E7A791"], // 科
           "79D2":["9562","C9C3","E7A792"], // 秒
           "79D8":["94E9","C8EB","E7A798"], // 秘
           "79DF":["9164","C1C5","E7A79F"], // 租
           "79E4":["9489","C7E9","E7A7A4"], // 秤
           "79E6":["9060","BFC1","E7A7A6"], // 秦
           "79E9":["9281","C3E1","E7A7A9"], // 秩
           "79F0":["8FCC","BECE","E7A7B0"], // 称
           "79FB":["88DA","B0DC","E7A7BB"], // 移
           "7A00":["8B48","B5A9","E7A880"], // 稀
           "7A0B":["92F6","C4F8","E7A88B"], // 程
           "7A0E":["90C5","C0C7","E7A88E"], // 税
           "7A14":["96AB","CCAD","E7A894"], // 稔
           "7A17":["9542","C9A3","E7A897"], // 稗
           "7A1A":["9274","C3D5","E7A89A"], // 稚
           "7A1C":["97C5","CEC7","E7A89C"], // 稜
           "7A2E":["8EED","BCEF","E7A8AE"], // 種
           "7A32":["88EE","B0F0","E7A8B2"], // 稲
           "7A3C":["89D2","B2D4","E7A8BC"], // 稼
           "7A3D":["8C6D","B7CE","E7A8BD"], // 稽
           "7A3F":["8D65","B9C6","E7A8BF"], // 稿
           "7A40":["8D92","B9F2","E7A980"], // 穀
           "7A42":["95E4","CAE6","E7A982"], // 穂
           "7A46":["9673","CBD4","E7A986"], // 穆
           "7A4D":["90CF","C0D1","E7A98D"], // 積
           "7A4E":["896E","B1CF","E7A98E"], // 穎
           "7A4F":["89B8","B2BA","E7A98F"], // 穏
           "7A50":["88AA","B0AC","E7A990"], // 穐
           "7A63":["8FF5","BEF7","E7A9A3"], // 穣
           "7A6B":["8A6E","B3CF","E7A9AB"], // 穫
           "7A74":["8C8A","B7EA","E7A9B4"], // 穴
           "7A76":["8B86","B5E6","E7A9B6"], // 究
           "7A7A":["8BF3","B6F5","E7A9BA"], // 空
           "7A7F":["90FA","C0FC","E7A9BF"], // 穿
           "7A81":["93CB","C6CD","E7AA81"], // 突
           "7A83":["90DE","C0E0","E7AA83"], // 窃
           "7A84":["8DF3","BAF5","E7AA84"], // 窄
           "7A92":["9282","C3E2","E7AA92"], // 窒
           "7A93":["918B","C1EB","E7AA93"], // 窓
           "7A9F":["8C41","B7A2","E7AA9F"], // 窟
           "7AAA":["8C45","B7A6","E7AAAA"], // 窪
           "7AAE":["8B87","B5E7","E7AAAE"], // 窮
           "7AAF":["9771","CDD2","E7AAAF"], // 窯
           "7ABA":["894D","B1AE","E7AABA"], // 窺
           "7AC3":["8A96","B3F6","E7AB83"], // 竃
           "7ACB":["97A7","CEA9","E7AB8B"], // 立
           "7ADC":["97B3","CEB5","E7AB9C"], // 竜
           "7AE0":["8FCD","BECF","E7ABA0"], // 章
           "7AE3":["8F76","BDD7","E7ABA3"], // 竣
           "7AE5":["93B6","C6B8","E7ABA5"], // 童
           "7AEA":["9247","C3A8","E7ABAA"], // 竪
           "7AEF":["925B","C3BC","E7ABAF"], // 端
           "7AF6":["8BA3","B6A5","E7ABB6"], // 競
           "7AF9":["927C","C3DD","E7ABB9"], // 竹
           "7AFA":["8EB1","BCB3","E7ABBA"], // 竺
           "7AFF":["8AC6","B4C8","E7ABBF"], // 竿
           "7B08":["8B88","B5E8","E7AC88"], // 笈
           "7B11":["8FCE","BED0","E7AC91"], // 笑
           "7B1B":["934A","C5AB","E7AC9B"], // 笛
           "7B20":["8A7D","B3DE","E7ACA0"], // 笠
           "7B25":["9079","BFDA","E7ACA5"], // 笥
           "7B26":["9584","C9E4","E7ACA6"], // 符
           "7B2C":["91E6","C2E8","E7ACAC"], // 第
           "7B39":["8DF9","BAFB","E7ACB9"], // 笹
           "7B46":["954D","C9AE","E7AD86"], // 筆
           "7B48":["94A4","C8A6","E7AD88"], // 筈
           "7B49":["9399","C5F9","E7AD89"], // 等
           "7B4B":["8BD8","B6DA","E7AD8B"], // 筋
           "7B4F":["94B3","C8B5","E7AD8F"], // 筏
           "7B51":["927D","C3DE","E7AD91"], // 筑
           "7B52":["939B","C5FB","E7AD92"], // 筒
           "7B54":["939A","C5FA","E7AD94"], // 答
           "7B56":["8DF4","BAF6","E7AD96"], // 策
           "7B86":["95CD","CACF","E7AE86"], // 箆
           "7B87":["89D3","B2D5","E7AE87"], // 箇
           "7B94":["9493","C7F3","E7AE94"], // 箔
           "7B95":["96A5","CCA7","E7AE95"], // 箕
           "7B97":["8E5A","BBBB","E7AE97"], // 算
           "7BA1":["8AC7","B4C9","E7AEA1"], // 管
           "7BAA":["925C","C3BD","E7AEAA"], // 箪
           "7BAD":["90FB","C0FD","E7AEAD"], // 箭
           "7BB1":["94A0","C8A2","E7AEB1"], // 箱
           "7BB8":["94A2","C8A4","E7AEB8"], // 箸
           "7BC0":["90DF","C0E1","E7AF80"], // 節
           "7BC4":["94CD","C8CF","E7AF84"], // 範
           "7BC7":["95D1","CAD3","E7AF87"], // 篇
           "7BC9":["927A","C3DB","E7AF89"], // 築
           "7BE0":["8EC2","BCC4","E7AFA0"], // 篠
           "7BE4":["93C4","C6C6","E7AFA4"], // 篤
           "7BED":["9855","CFB6","E7AFAD"], // 篭
           "7C21":["8AC8","B4CA","E7B0A1"], // 簡
           "7C38":["94F4","C8F6","E7B0B8"], // 簸
           "7C3E":["97FA","CEFC","E7B0BE"], // 簾
           "7C3F":["95EB","CAED","E7B0BF"], // 簿
           "7C4D":["90D0","C0D2","E7B18D"], // 籍
           "7C73":["95C4","CAC6","E7B1B3"], // 米
           "7C7E":["96E0","CCE2","E7B1BE"], // 籾
           "7C81":["8BCC","B6CE","E7B281"], // 粁
           "7C82":["8C48","B7A9","E7B282"], // 粂
           "7C89":["95B2","CAB4","E7B289"], // 粉
           "7C8B":["9088","BFE8","E7B28B"], // 粋
           "7C8D":["96AE","CCB0","E7B28D"], // 粍
           "7C92":["97B1","CEB3","E7B292"], // 粒
           "7C95":["9494","C7F4","E7B295"], // 粕
           "7C97":["9165","C1C6","E7B297"], // 粗
           "7C98":["9453","C7B4","E7B298"], // 粘
           "7C9B":["8F6C","BDCD","E7B29B"], // 粛
           "7C9F":["88BE","B0C0","E7B29F"], // 粟
           "7CA5":["8A9F","B4A1","E7B2A5"], // 粥
           "7CA7":["8FCF","BED1","E7B2A7"], // 粧
           "7CBE":["90B8","C0BA","E7B2BE"], // 精
           "7CCA":["8CD0","B8D2","E7B38A"], // 糊
           "7CCE":["9157","C1B8","E7B38E"], // 糎
           "7CD6":["939C","C5FC","E7B396"], // 糖
           "7CDE":["95B3","CAB5","E7B39E"], // 糞
           "7CDF":["918C","C1EC","E7B39F"], // 糟
           "7CE0":["8D66","B9C7","E7B3A0"], // 糠
           "7CE7":["97C6","CEC8","E7B3A7"], // 糧
           "7CF8":["8E85","BBE5","E7B3B8"], // 糸
           "7CFB":["8C6E","B7CF","E7B3BB"], // 系
           "7CFE":["8B8A","B5EA","E7B3BE"], // 糾
           "7D00":["8B49","B5AA","E7B480"], // 紀
           "7D04":["96F1","CCF3","E7B484"], // 約
           "7D05":["8D67","B9C8","E7B485"], // 紅
           "7D0B":["96E4","CCE6","E7B48B"], // 紋
           "7D0D":["945B","C7BC","E7B48D"], // 納
           "7D10":["9552","C9B3","E7B490"], // 紐
           "7D14":["8F83","BDE3","E7B494"], // 純
           "7D17":["8ED1","BCD3","E7B497"], // 紗
           "7D18":["8D68","B9C9","E7B498"], // 紘
           "7D19":["8E86","BBE6","E7B499"], // 紙
           "7D1A":["8B89","B5E9","E7B49A"], // 級
           "7D1B":["95B4","CAB6","E7B49B"], // 紛
           "7D20":["9166","C1C7","E7B4A0"], // 素
           "7D21":["9661","CBC2","E7B4A1"], // 紡
           "7D22":["8DF5","BAF7","E7B4A2"], // 索
           "7D2B":["8E87","BBE7","E7B4AB"], // 紫
           "7D2C":["92DB","C4DD","E7B4AC"], // 紬
           "7D2F":["97DD","CEDF","E7B4AF"], // 累
           "7D30":["8DD7","BAD9","E7B4B0"], // 細
           "7D33":["9061","BFC2","E7B4B3"], // 紳
           "7D39":["8FD0","BED2","E7B4B9"], // 紹
           "7D3A":["8DAE","BAB0","E7B4BA"], // 紺
           "7D42":["8F49","BDAA","E7B582"], // 終
           "7D43":["8CBC","B8BE","E7B583"], // 絃
           "7D44":["9167","C1C8","E7B584"], // 組
           "7D4C":["8C6F","B7D0","E7B58C"], // 経
           "7D50":["8C8B","B7EB","E7B590"], // 結
           "7D5E":["8D69","B9CA","E7B59E"], // 絞
           "7D61":["978D","CDED","E7B5A1"], // 絡
           "7D62":["88BA","B0BC","E7B5A2"], // 絢
           "7D66":["8B8B","B5EB","E7B5A6"], // 給
           "7D71":["939D","C5FD","E7B5B1"], // 統
           "7D75":["8A47","B3A8","E7B5B5"], // 絵
           "7D76":["90E2","C0E4","E7B5B6"], // 絶
           "7D79":["8CA6","B8A8","E7B5B9"], // 絹
           "7D99":["8C70","B7D1","E7B699"], // 継
           "7D9A":["91B1","C2B3","E7B69A"], // 続
           "7D9C":["918E","C1EE","E7B69C"], // 綜
           "7DAC":["8EF8","BCFA","E7B6AC"], // 綬
           "7DAD":["88DB","B0DD","E7B6AD"], // 維
           "7DB1":["8D6A","B9CB","E7B6B1"], // 綱
           "7DB2":["96D4","CCD6","E7B6B2"], // 網
           "7DB4":["92D4","C4D6","E7B6B4"], // 綴
           "7DBB":["925D","C3BE","E7B6BB"], // 綻
           "7DBE":["88BB","B0BD","E7B6BE"], // 綾
           "7DBF":["96C8","CCCA","E7B6BF"], // 綿
           "7DCA":["8BD9","B6DB","E7B78A"], // 緊
           "7DCB":["94EA","C8EC","E7B78B"], // 緋
           "7DCF":["918D","C1ED","E7B78F"], // 総
           "7DD1":["97CE","CED0","E7B791"], // 緑
           "7DD2":["8F8F","BDEF","E7B792"], // 緒
           "7DDA":["90FC","C0FE","E7B79A"], // 線
           "7DE0":["92F7","C4F9","E7B7A0"], // 締
           "7DE8":["95D2","CAD4","E7B7A8"], // 編
           "7DE9":["8AC9","B4CB","E7B7A9"], // 緩
           "7DEC":["96C9","CCCB","E7B7AC"], // 緬
           "7DEF":["88DC","B0DE","E7B7AF"], // 緯
           "7DF4":["97FB","CEFD","E7B7B4"], // 練
           "7E01":["898F","B1EF","E7B881"], // 縁
           "7E04":["93EA","C6EC","E7B884"], // 縄
           "7E1B":["949B","C7FB","E7B89B"], // 縛
           "7E1E":["8EC8","BCCA","E7B89E"], // 縞
           "7E26":["8F63","BDC4","E7B8A6"], // 縦
           "7E2B":["9644","CBA5","E7B8AB"], // 縫
           "7E2E":["8F6B","BDCC","E7B8AE"], // 縮
           "7E3E":["90D1","C0D3","E7B8BE"], // 績
           "7E41":["94C9","C8CB","E7B981"], // 繁
           "7E4A":["9140","C1A1","E7B98A"], // 繊
           "7E4B":["8C71","B7D2","E7B98B"], // 繋
           "7E4D":["8F4A","BDAB","E7B98D"], // 繍
           "7E54":["9044","BFA5","E7B994"], // 織
           "7E55":["9155","C1B6","E7B995"], // 繕
           "7E6D":["969A","CBFA","E7B9AD"], // 繭
           "7E70":["8C4A","B7AB","E7B9B0"], // 繰
           "7E82":["8E5B","BBBC","E7BA82"], // 纂
           "7E8F":["935A","C5BB","E7BA8F"], // 纏
           "7F36":["8ACA","B4CC","E7BCB6"], // 缶
           "7F6A":["8DDF","BAE1","E7BDAA"], // 罪
           "7F6B":["8C72","B7D3","E7BDAB"], // 罫
           "7F6E":["9275","C3D6","E7BDAE"], // 置
           "7F70":["94B1","C8B3","E7BDB0"], // 罰
           "7F72":["8F90","BDF0","E7BDB2"], // 署
           "7F75":["946C","C7CD","E7BDB5"], // 罵
           "7F77":["94EB","C8ED","E7BDB7"], // 罷
           "7F85":["9785","CDE5","E7BE85"], // 羅
           "7F8A":["9772","CDD3","E7BE8A"], // 羊
           "7F8E":["94FC","C8FE","E7BE8E"], // 美
           "7FA4":["8C51","B7B2","E7BEA4"], // 群
           "7FA8":["9141","C1A2","E7BEA8"], // 羨
           "7FA9":["8B60","B5C1","E7BEA9"], // 義
           "7FBD":["8948","B1A9","E7BEBD"], // 羽
           "7FC1":["89A5","B2A7","E7BF81"], // 翁
           "7FCC":["9782","CDE2","E7BF8C"], // 翌
           "7FD2":["8F4B","BDAC","E7BF92"], // 習
           "7FE0":["9089","BFE9","E7BFA0"], // 翠
           "7FEB":["8AE3","B4E5","E7BFAB"], // 翫
           "7FF0":["8ACB","B4CD","E7BFB0"], // 翰
           "7FFB":["967C","CBDD","E7BFBB"], // 翻
           "7FFC":["9783","CDE3","E7BFBC"], // 翼
           "8000":["9773","CDD4","E88080"], // 耀
           "8001":["9856","CFB7","E88081"], // 老
           "8003":["8D6C","B9CD","E88083"], // 考
           "8005":["8ED2","BCD4","E88085"], // 者
           "800C":["8EA7","BCA9","E8808C"], // 而
           "8010":["91CF","C2D1","E88090"], // 耐
           "8015":["8D6B","B9CC","E88095"], // 耕
           "8017":["96D5","CCD7","E88097"], // 耗
           "8033":["8EA8","BCAA","E880B3"], // 耳
           "8036":["96EB","CCED","E880B6"], // 耶
           "803D":["925E","C3BF","E880BD"], // 耽
           "8056":["90B9","C0BB","E88196"], // 聖
           "805E":["95B7","CAB9","E8819E"], // 聞
           "8061":["918F","C1EF","E881A1"], // 聡
           "806F":["97FC","CEFE","E881AF"], // 聯
           "8074":["92AE","C4B0","E881B4"], // 聴
           "8077":["9045","BFA6","E881B7"], // 職
           "807E":["9857","CFB8","E881BE"], // 聾
           "8087":["94A3","C8A5","E88287"], // 肇
           "8089":["93F7","C6F9","E88289"], // 肉
           "808B":["985D","CFBE","E8828B"], // 肋
           "808C":["94A7","C8A9","E8828C"], // 肌
           "8096":["8FD1","BED3","E88296"], // 肖
           "8098":["9549","C9AA","E88298"], // 肘
           "809D":["8ACC","B4CE","E8829D"], // 肝
           "80A1":["8CD2","B8D4","E882A1"], // 股
           "80A2":["8E88","BBE8","E882A2"], // 肢
           "80A5":["94EC","C8EE","E882A5"], // 肥
           "80A9":["8CA8","B8AA","E882A9"], // 肩
           "80AA":["9662","CBC3","E882AA"], // 肪
           "80AF":["8D6D","B9CE","E882AF"], // 肯
           "80B1":["8D6E","B9CF","E882B1"], // 肱
           "80B2":["88E7","B0E9","E882B2"], // 育
           "80B4":["8DE6","BAE8","E882B4"], // 肴
           "80BA":["9478","C7D9","E882BA"], // 肺
           "80C3":["88DD","B0DF","E88383"], // 胃
           "80C6":["925F","C3C0","E88386"], // 胆
           "80CC":["9477","C7D8","E8838C"], // 背
           "80CE":["91D9","C2DB","E8838E"], // 胎
           "80DE":["9645","CBA6","E8839E"], // 胞
           "80E1":["8CD3","B8D5","E883A1"], // 胡
           "80E4":["88FB","B0FD","E883A4"], // 胤
           "80F4":["93B7","C6B9","E883B4"], // 胴
           "80F8":["8BB9","B6BB","E883B8"], // 胸
           "80FD":["945C","C7BD","E883BD"], // 能
           "8102":["8E89","BBE9","E88482"], // 脂
           "8105":["8BBA","B6BC","E88485"], // 脅
           "8106":["90C6","C0C8","E88486"], // 脆
           "8107":["9865","CFC6","E88487"], // 脇
           "8108":["96AC","CCAE","E88488"], // 脈
           "810A":["90D2","C0D4","E8848A"], // 脊
           "811A":["8B72","B5D3","E8849A"], // 脚
           "8131":["9245","C3A6","E884B1"], // 脱
           "8133":["945D","C7BE","E884B3"], // 脳
           "8139":["92AF","C4B1","E884B9"], // 脹
           "814E":["9074","BFD5","E8858E"], // 腎
           "8150":["9585","C9E5","E88590"], // 腐
           "8154":["8D6F","B9D0","E88594"], // 腔
           "8155":["9872","CFD3","E88595"], // 腕
           "816B":["8EEE","BCF0","E885AB"], // 腫
           "8170":["8D98","B9F8","E885B0"], // 腰
           "8178":["92B0","C4B2","E885B8"], // 腸
           "8179":["95A0","CAA2","E885B9"], // 腹
           "817A":["9142","C1A3","E885BA"], // 腺
           "817F":["91DA","C2DC","E885BF"], // 腿
           "818F":["8D70","B9D1","E8868F"], // 膏
           "819A":["9586","C9E6","E8869A"], // 膚
           "819C":["968C","CBEC","E8869C"], // 膜
           "819D":["9547","C9A8","E8869D"], // 膝
           "81A8":["9663","CBC4","E886A8"], // 膨
           "81B3":["9156","C1B7","E886B3"], // 膳
           "81BF":["945E","C7BF","E886BF"], // 膿
           "81C6":["89B0","B2B2","E88786"], // 臆
           "81D3":["919F","C2A1","E88793"], // 臓
           "81E3":["9062","BFC3","E887A3"], // 臣
           "81E5":["89E7","B2E9","E887A5"], // 臥
           "81E8":["97D5","CED7","E887A8"], // 臨
           "81EA":["8EA9","BCAB","E887AA"], // 自
           "81ED":["8F4C","BDAD","E887AD"], // 臭
           "81F3":["8E8A","BBEA","E887B3"], // 至
           "81F4":["9276","C3D7","E887B4"], // 致
           "81FC":["8950","B1B1","E887BC"], // 臼
           "8208":["8BBB","B6BD","E88888"], // 興
           "820C":["90E3","C0E5","E8888C"], // 舌
           "820E":["8EC9","BCCB","E8888E"], // 舎
           "8217":["95DC","CADE","E88897"], // 舗
           "8218":["8ADA","B4DC","E88898"], // 舘
           "821B":["9143","C1A4","E8889B"], // 舛
           "821C":["8F77","BDD8","E8889C"], // 舜
           "821E":["9591","C9F1","E8889E"], // 舞
           "821F":["8F4D","BDAE","E8889F"], // 舟
           "822A":["8D71","B9D2","E888AA"], // 航
           "822C":["94CA","C8CC","E888AC"], // 般
           "8235":["91C7","C2C9","E888B5"], // 舵
           "8236":["9495","C7F5","E888B6"], // 舶
           "8237":["8CBD","B8BF","E888B7"], // 舷
           "8239":["9144","C1A5","E888B9"], // 船
           "8247":["92F8","C4FA","E88987"], // 艇
           "8266":["8ACD","B4CF","E889A6"], // 艦
           "826E":["8DAF","BAB1","E889AE"], // 艮
           "826F":["97C7","CEC9","E889AF"], // 良
           "8272":["9046","BFA7","E889B2"], // 色
           "8276":["8990","B1F0","E889B6"], // 艶
           "828B":["88F0","B0F2","E88A8B"], // 芋
           "8299":["9587","C9E7","E88A99"], // 芙
           "829D":["8EC5","BCC7","E88A9D"], // 芝
           "82A5":["8A48","B3A9","E88AA5"], // 芥
           "82A6":["88B0","B0B2","E88AA6"], // 芦
           "82AD":["946D","C7CE","E88AAD"], // 芭
           "82AF":["9063","BFC4","E88AAF"], // 芯
           "82B1":["89D4","B2D6","E88AB1"], // 花
           "82B3":["9646","CBA7","E88AB3"], // 芳
           "82B8":["8C7C","B7DD","E88AB8"], // 芸
           "82B9":["8BDA","B6DC","E88AB9"], // 芹
           "82BD":["89E8","B2EA","E88ABD"], // 芽
           "82C5":["8AA1","B4A3","E88B85"], // 苅
           "82D1":["8991","B1F1","E88B91"], // 苑
           "82D3":["97E8","CEEA","E88B93"], // 苓
           "82D4":["91DB","C2DD","E88B94"], // 苔
           "82D7":["9563","C9C4","E88B97"], // 苗
           "82DB":["89D5","B2D7","E88B9B"], // 苛
           "82E5":["8EE1","BCE3","E88BA5"], // 若
           "82E6":["8BEA","B6EC","E88BA6"], // 苦
           "82E7":["9297","C3F7","E88BA7"], // 苧
           "82EB":["93CF","C6D1","E88BAB"], // 苫
           "82F1":["8970","B1D1","E88BB1"], // 英
           "8302":["96CE","CCD0","E88C82"], // 茂
           "8304":["89D6","B2D8","E88C84"], // 茄
           "8305":["8A9D","B3FD","E88C85"], // 茅
           "830E":["8C73","B7D4","E88C8E"], // 茎
           "831C":["88A9","B0AB","E88C9C"], // 茜
           "8328":["88EF","B0F1","E88CA8"], // 茨
           "8336":["9283","C3E3","E88CB6"], // 茶
           "8338":["91F9","C2FB","E88CB8"], // 茸
           "8349":["9190","C1F0","E88D89"], // 草
           "834A":["8C74","B7D5","E88D8A"], // 荊
           "834F":["8960","B1C1","E88D8F"], // 荏
           "8352":["8D72","B9D3","E88D92"], // 荒
           "8358":["9191","C1F1","E88D98"], // 荘
           "8377":["89D7","B2D9","E88DB7"], // 荷
           "837B":["89AC","B2AE","E88DBB"], // 荻
           "839E":["8ACE","B4D0","E88E9E"], // 莞
           "83AB":["949C","C7FC","E88EAB"], // 莫
           "83B1":["9789","CDE9","E88EB1"], // 莱
           "83C5":["909B","BFFB","E88F85"], // 菅
           "83CA":["8B65","B5C6","E88F8A"], // 菊
           "83CC":["8BDB","B6DD","E88F8C"], // 菌
           "83D3":["89D9","B2DB","E88F93"], // 菓
           "83D6":["8FD2","BED4","E88F96"], // 菖
           "83DC":["8DD8","BADA","E88F9C"], // 菜
           "83DF":["9370","C5D1","E88F9F"], // 菟
           "83E9":["95EC","CAEE","E88FA9"], // 菩
           "83EF":["89D8","B2DA","E88FAF"], // 華
           "83F0":["8CD4","B8D6","E88FB0"], // 菰
           "83F1":["9548","C9A9","E88FB1"], // 菱
           "8404":["93B8","C6BA","E89084"], // 萄
           "840C":["9647","CBA8","E8908C"], // 萌
           "840E":["88DE","B0E0","E8908E"], // 萎
           "8429":["948B","C7EB","E890A9"], // 萩
           "8431":["8A9E","B3FE","E890B1"], // 萱
           "843D":["978E","CDEE","E890BD"], // 落
           "8449":["9774","CDD5","E89189"], // 葉
           "844E":["97A8","CEAA","E8918E"], // 葎
           "8457":["9298","C3F8","E89197"], // 著
           "845B":["8A8B","B3EB","E8919B"], // 葛
           "8461":["9592","C9F2","E891A1"], // 葡
           "8463":["939F","C6A1","E891A3"], // 董
           "8466":["88AF","B0B1","E891A6"], // 葦
           "846C":["9192","C1F2","E891AC"], // 葬
           "8471":["944B","C7AC","E891B1"], // 葱
           "8475":["88A8","B0AA","E891B5"], // 葵
           "847A":["9598","C9F8","E891BA"], // 葺
           "848B":["8FD3","BED5","E8928B"], // 蒋
           "8490":["8F4E","BDAF","E89290"], // 蒐
           "8494":["8EAA","BCAC","E89294"], // 蒔
           "8499":["96D6","CCD8","E89299"], // 蒙
           "849C":["9566","C9C7","E8929C"], // 蒜
           "84B2":["8A97","B3F7","E892B2"], // 蒲
           "84B8":["8FF6","BEF8","E892B8"], // 蒸
           "84BC":["9193","C1F3","E892BC"], // 蒼
           "84C4":["927E","C3DF","E89384"], // 蓄
           "84C9":["9775","CDD6","E89389"], // 蓉
           "84CB":["8A57","B3B8","E8938B"], // 蓋
           "84D1":["96AA","CCAC","E89391"], // 蓑
           "84EC":["9648","CBA9","E893AC"], // 蓬
           "84EE":["9840","CFA1","E893AE"], // 蓮
           "8500":["8EC1","BCC3","E89480"], // 蔀
           "8511":["95CC","CACE","E89491"], // 蔑
           "8513":["96A0","CCA2","E89493"], // 蔓
           "851A":["8955","B1B6","E8949A"], // 蔚
           "8526":["92D3","C4D5","E894A6"], // 蔦
           "852D":["88FC","B0FE","E894AD"], // 蔭
           "8535":["91A0","C2A2","E894B5"], // 蔵
           "853D":["95C1","CAC3","E894BD"], // 蔽
           "8543":["94D7","C8D9","E89583"], // 蕃
           "8549":["8FD4","BED6","E89589"], // 蕉
           "854A":["8EC7","BCC9","E8958A"], // 蕊
           "854E":["8BBC","B6BE","E8958E"], // 蕎
           "8557":["9599","C9F9","E89597"], // 蕗
           "8568":["986E","CFCF","E895A8"], // 蕨
           "8569":["93A0","C6A2","E895A9"], // 蕩
           "856A":["9593","C9F3","E895AA"], // 蕪
           "8584":["9496","C7F6","E89684"], // 薄
           "8597":["8992","B1F2","E89697"], // 薗
           "8599":["93E3","C6E5","E89699"], // 薙
           "85A6":["9145","C1A6","E896A6"], // 薦
           "85A9":["8E46","BBA7","E896A9"], // 薩
           "85AA":["9064","BFC5","E896AA"], // 薪
           "85AB":["8C4F","B7B0","E896AB"], // 薫
           "85AC":["96F2","CCF4","E896AC"], // 薬
           "85AE":["96F7","CCF9","E896AE"], // 薮
           "85AF":["8F92","BDF2","E896AF"], // 薯
           "85C1":["986D","CFCE","E89781"], // 藁
           "85CD":["9795","CDF5","E8978D"], // 藍
           "85E4":["93A1","C6A3","E897A4"], // 藤
           "85E9":["94CB","C8CD","E897A9"], // 藩
           "85F7":["8F93","BDF3","E897B7"], // 藷
           "85FB":["9194","C1F4","E897BB"], // 藻
           "8607":["9168","C1C9","E89887"], // 蘇
           "862D":["9796","CDF6","E898AD"], // 蘭
           "864E":["8CD5","B8D7","E8998E"], // 虎
           "8650":["8B73","B5D4","E89990"], // 虐
           "865A":["8B95","B5F5","E8999A"], // 虚
           "865C":["97B8","CEBA","E8999C"], // 虜
           "865E":["8BF1","B6F3","E8999E"], // 虞
           "866B":["928E","C3EE","E899AB"], // 虫
           "8679":["93F8","C6FA","E899B9"], // 虹
           "867B":["88B8","B0BA","E899BB"], // 虻
           "868A":["89E1","B2E3","E89A8A"], // 蚊
           "8695":["8E5C","BBBD","E89A95"], // 蚕
           "86A4":["9461","C7C2","E89AA4"], // 蚤
           "86C7":["8ED6","BCD8","E89B87"], // 蛇
           "86CB":["9260","C3C1","E89B8B"], // 蛋
           "86CD":["8C75","B7D6","E89B8D"], // 蛍
           "86CE":["8A61","B3C2","E89B8E"], // 蛎
           "86D9":["8A5E","B3BF","E89B99"], // 蛙
           "86E4":["94B8","C8BA","E89BA4"], // 蛤
           "86ED":["9567","C9C8","E89BAD"], // 蛭
           "86EE":["94D8","C8DA","E89BAE"], // 蛮
           "86F8":["91FB","C2FD","E89BB8"], // 蛸
           "86FE":["89E9","B2EB","E89BBE"], // 蛾
           "8702":["9649","CBAA","E89C82"], // 蜂
           "8718":["9277","C3D8","E89C98"], // 蜘
           "871C":["96A8","CCAA","E89C9C"], // 蜜
           "8749":["90E4","C0E6","E89D89"], // 蝉
           "874B":["9858","CFB9","E89D8B"], // 蝋
           "8755":["9049","BFAA","E89D95"], // 蝕
           "8766":["89DA","B2DC","E89DA6"], // 蝦
           "8776":["92B1","C4B3","E89DB6"], // 蝶
           "877F":["9488","C7E8","E89DBF"], // 蝿
           "878D":["975A","CDBB","E89E8D"], // 融
           "87BA":["9786","CDE6","E89EBA"], // 螺
           "87F9":["8A49","B3AA","E89FB9"], // 蟹
           "87FB":["8B61","B5C2","E89FBB"], // 蟻
           "8840":["8C8C","B7EC","E8A180"], // 血
           "8846":["8F4F","BDB0","E8A186"], // 衆
           "884C":["8D73","B9D4","E8A18C"], // 行
           "8853":["8F70","BDD1","E8A193"], // 術
           "8857":["8A58","B3B9","E8A197"], // 街
           "885B":["8971","B1D2","E8A19B"], // 衛
           "885D":["8FD5","BED7","E8A19D"], // 衝
           "8861":["8D74","B9D5","E8A1A1"], // 衡
           "8863":["88DF","B0E1","E8A1A3"], // 衣
           "8868":["955C","C9BD","E8A1A8"], // 表
           "8870":["908A","BFEA","E8A1B0"], // 衰
           "8877":["928F","C3EF","E8A1B7"], // 衷
           "887F":["8BDC","B6DE","E8A1BF"], // 衿
           "8888":["8C55","B7B6","E8A288"], // 袈
           "888B":["91DC","C2DE","E8A28B"], // 袋
           "8896":["91B3","C2B5","E8A296"], // 袖
           "88AB":["94ED","C8EF","E8A2AB"], // 被
           "88B4":["8CD1","B8D3","E8A2B4"], // 袴
           "88B7":["88BF","B0C1","E8A2B7"], // 袷
           "88C1":["8DD9","BADB","E8A381"], // 裁
           "88C2":["97F4","CEF6","E8A382"], // 裂
           "88C5":["9195","C1F5","E8A385"], // 装
           "88CF":["97A0","CEA2","E8A38F"], // 裏
           "88D5":["9754","CDB5","E8A395"], // 裕
           "88DC":["95E2","CAE4","E8A39C"], // 補
           "88DF":["8DBE","BAC0","E8A39F"], // 裟
           "88E1":["97A1","CEA3","E8A3A1"], // 裡
           "88F3":["8FD6","BED8","E8A3B3"], // 裳
           "88F8":["9787","CDE7","E8A3B8"], // 裸
           "88FD":["90BB","C0BD","E8A3BD"], // 製
           "88FE":["909E","BFFE","E8A3BE"], // 裾
           "8907":["95A1","CAA3","E8A487"], // 複
           "8910":["8A8C","B3EC","E8A490"], // 褐
           "8912":["964A","CBAB","E8A492"], // 褒
           "8956":["89A6","B2A8","E8A596"], // 襖
           "895F":["8BDD","B6DF","E8A59F"], // 襟
           "8972":["8F50","BDB1","E8A5B2"], // 襲
           "897F":["90BC","C0BE","E8A5BF"], // 西
           "8981":["9776","CDD7","E8A681"], // 要
           "8986":["95A2","CAA4","E8A686"], // 覆
           "8987":["9465","C7C6","E8A687"], // 覇
           "898B":["8CA9","B8AB","E8A68B"], // 見
           "898F":["8B4B","B5AC","E8A68F"], // 規
           "8996":["8E8B","BBEB","E8A696"], // 視
           "8997":["9460","C7C1","E8A697"], // 覗
           "899A":["8A6F","B3D0","E8A69A"], // 覚
           "89A7":["9797","CDF7","E8A6A7"], // 覧
           "89AA":["9065","BFC6","E8A6AA"], // 親
           "89B3":["8ACF","B4D1","E8A6B3"], // 観
           "89D2":["8A70","B3D1","E8A792"], // 角
           "89E3":["89F0","B2F2","E8A7A3"], // 解
           "89E6":["9047","BFA8","E8A7A6"], // 触
           "8A00":["8CBE","B8C0","E8A880"], // 言
           "8A02":["92F9","C4FB","E8A882"], // 訂
           "8A08":["8C76","B7D7","E8A888"], // 計
           "8A0A":["9075","BFD6","E8A88A"], // 訊
           "8A0E":["93A2","C6A4","E8A88E"], // 討
           "8A13":["8C50","B7B1","E8A893"], // 訓
           "8A17":["91F5","C2F7","E8A897"], // 託
           "8A18":["8B4C","B5AD","E8A898"], // 記
           "8A1F":["8FD7","BED9","E8A89F"], // 訟
           "8A23":["8C8D","B7ED","E8A8A3"], // 訣
           "8A2A":["964B","CBAC","E8A8AA"], // 訪
           "8A2D":["90DD","C0DF","E8A8AD"], // 設
           "8A31":["8B96","B5F6","E8A8B1"], // 許
           "8A33":["96F3","CCF5","E8A8B3"], // 訳
           "8A34":["9169","C1CA","E8A8B4"], // 訴
           "8A3A":["9066","BFC7","E8A8BA"], // 診
           "8A3B":["9290","C3F0","E8A8BB"], // 註
           "8A3C":["8FD8","BEDA","E8A8BC"], // 証
           "8A50":["8DBC","BABE","E8A990"], // 詐
           "8A51":["91C0","C2C2","E8A991"], // 詑
           "8A54":["8FD9","BEDB","E8A994"], // 詔
           "8A55":["955D","C9BE","E8A995"], // 評
           "8A5E":["8E8C","BBEC","E8A99E"], // 詞
           "8A60":["8972","B1D3","E8A9A0"], // 詠
           "8A63":["8C77","B7D8","E8A9A3"], // 詣
           "8A66":["8E8E","BBEE","E8A9A6"], // 試
           "8A69":["8E8D","BBED","E8A9A9"], // 詩
           "8A6B":["986C","CFCD","E8A9AB"], // 詫
           "8A6E":["9146","C1A7","E8A9AE"], // 詮
           "8A70":["8B6C","B5CD","E8A9B0"], // 詰
           "8A71":["9862","CFC3","E8A9B1"], // 話
           "8A72":["8A59","B3BA","E8A9B2"], // 該
           "8A73":["8FDA","BEDC","E8A9B3"], // 詳
           "8A87":["8CD6","B8D8","E8AA87"], // 誇
           "8A89":["975F","CDC0","E8AA89"], // 誉
           "8A8C":["8E8F","BBEF","E8AA8C"], // 誌
           "8A8D":["9446","C7A7","E8AA8D"], // 認
           "8A93":["90BE","C0C0","E8AA93"], // 誓
           "8A95":["9261","C3C2","E8AA95"], // 誕
           "8A98":["9755","CDB6","E8AA98"], // 誘
           "8A9E":["8CEA","B8EC","E8AA9E"], // 語
           "8AA0":["90BD","C0BF","E8AAA0"], // 誠
           "8AA4":["8CEB","B8ED","E8AAA4"], // 誤
           "8AAC":["90E0","C0E2","E8AAAC"], // 説
           "8AAD":["93C7","C6C9","E8AAAD"], // 読
           "8AB0":["924E","C3AF","E8AAB0"], // 誰
           "8AB2":["89DB","B2DD","E8AAB2"], // 課
           "8AB9":["94EE","C8F0","E8AAB9"], // 誹
           "8ABC":["8B62","B5C3","E8AABC"], // 誼
           "8ABF":["92B2","C4B4","E8AABF"], // 調
           "8AC7":["926B","C3CC","E8AB87"], // 談
           "8ACB":["90BF","C0C1","E8AB8B"], // 請
           "8ACC":["8AD0","B4D2","E8AB8C"], // 諌
           "8ACF":["907A","BFDB","E8AB8F"], // 諏
           "8AD2":["97C8","CECA","E8AB92"], // 諒
           "8AD6":["985F","CFC0","E8AB96"], // 論
           "8ADC":["92B3","C4B5","E8AB9C"], // 諜
           "8AE6":["92FA","C4FC","E8ABA6"], // 諦
           "8AED":["9740","CDA1","E8ABAD"], // 諭
           "8AEE":["8E90","BBF0","E8ABAE"], // 諮
           "8AF8":["8F94","BDF4","E8ABB8"], // 諸
           "8AFA":["8CBF","B8C1","E8ABBA"], // 諺
           "8AFE":["91F8","C2FA","E8ABBE"], // 諾
           "8B00":["9664","CBC5","E8AC80"], // 謀
           "8B01":["8979","B1DA","E8AC81"], // 謁
           "8B02":["88E0","B0E2","E8AC82"], // 謂
           "8B04":["93A3","C6A5","E8AC84"], // 謄
           "8B0E":["93E4","C6E6","E8AC8E"], // 謎
           "8B19":["8CAA","B8AC","E8AC99"], // 謙
           "8B1B":["8D75","B9D6","E8AC9B"], // 講
           "8B1D":["8ED3","BCD5","E8AC9D"], // 謝
           "8B21":["9777","CDD8","E8ACA1"], // 謡
           "8B2C":["9554","C9B5","E8ACAC"], // 謬
           "8B39":["8BDE","B6E0","E8ACB9"], // 謹
           "8B58":["8EAF","BCB1","E8AD98"], // 識
           "8B5C":["9588","C9E8","E8AD9C"], // 譜
           "8B66":["8C78","B7D9","E8ADA6"], // 警
           "8B70":["8B63","B5C4","E8ADB0"], // 議
           "8B72":["8FF7","BEF9","E8ADB2"], // 譲
           "8B77":["8CEC","B8EE","E8ADB7"], // 護
           "8B83":["8E5D","BBBE","E8AE83"], // 讃
           "8B90":["8F51","BDB2","E8AE90"], // 讐
           "8C37":["924A","C3AB","E8B0B7"], // 谷
           "8C46":["93A4","C6A6","E8B186"], // 豆
           "8C4A":["964C","CBAD","E8B18A"], // 豊
           "8C5A":["93D8","C6DA","E8B19A"], // 豚
           "8C61":["8FDB","BEDD","E8B1A1"], // 象
           "8C6A":["8D8B","B9EB","E8B1AA"], // 豪
           "8C79":["955E","C9BF","E8B1B9"], // 豹
           "8C8C":["9665","CBC6","E8B28C"], // 貌
           "8C9D":["8A4C","B3AD","E8B29D"], // 貝
           "8C9E":["92E5","C4E7","E8B29E"], // 貞
           "8CA0":["9589","C9E9","E8B2A0"], // 負
           "8CA1":["8DE0","BAE2","E8B2A1"], // 財
           "8CA2":["8D76","B9D7","E8B2A2"], // 貢
           "8CA7":["956E","C9CF","E8B2A7"], // 貧
           "8CA8":["89DD","B2DF","E8B2A8"], // 貨
           "8CA9":["94CC","C8CE","E8B2A9"], // 販
           "8CAB":["8AD1","B4D3","E8B2AB"], // 貫
           "8CAC":["90D3","C0D5","E8B2AC"], // 責
           "8CAF":["9299","C3F9","E8B2AF"], // 貯
           "8CB0":["96E1","CCE3","E8B2B0"], // 貰
           "8CB4":["8B4D","B5AE","E8B2B4"], // 貴
           "8CB7":["9483","C7E3","E8B2B7"], // 買
           "8CB8":["91DD","C2DF","E8B2B8"], // 貸
           "8CBB":["94EF","C8F1","E8B2BB"], // 費
           "8CBC":["935C","C5BD","E8B2BC"], // 貼
           "8CBF":["9666","CBC7","E8B2BF"], // 貿
           "8CC0":["89EA","B2EC","E8B380"], // 賀
           "8CC2":["9847","CFA8","E8B382"], // 賂
           "8CC3":["92C0","C4C2","E8B383"], // 賃
           "8CC4":["9864","CFC5","E8B384"], // 賄
           "8CC7":["8E91","BBF1","E8B387"], // 資
           "8CCA":["91AF","C2B1","E8B38A"], // 賊
           "8CCE":["9147","C1A8","E8B38E"], // 賎
           "8CD1":["93F6","C6F8","E8B391"], // 賑
           "8CD3":["956F","C9D0","E8B393"], // 賓
           "8CDB":["8E5E","BBBF","E8B39B"], // 賛
           "8CDC":["8E92","BBF2","E8B39C"], // 賜
           "8CDE":["8FDC","BEDE","E8B39E"], // 賞
           "8CE0":["9485","C7E5","E8B3A0"], // 賠
           "8CE2":["8CAB","B8AD","E8B3A2"], // 賢
           "8CE6":["958A","C9EA","E8B3A6"], // 賦
           "8CEA":["8EBF","BCC1","E8B3AA"], // 質
           "8CED":["9371","C5D2","E8B3AD"], // 賭
           "8CFC":["8D77","B9D8","E8B3BC"], // 購
           "8D08":["91A1","C2A3","E8B488"], // 贈
           "8D0B":["8AE4","B4E6","E8B48B"], // 贋
           "8D64":["90D4","C0D6","E8B5A4"], // 赤
           "8D66":["8ECD","BCCF","E8B5A6"], // 赦
           "8D6B":["8A71","B3D2","E8B5AB"], // 赫
           "8D70":["9196","C1F6","E8B5B0"], // 走
           "8D74":["958B","C9EB","E8B5B4"], // 赴
           "8D77":["8B4E","B5AF","E8B5B7"], // 起
           "8D85":["92B4","C4B6","E8B685"], // 超
           "8D8A":["897A","B1DB","E8B68A"], // 越
           "8DA3":["8EEF","BCF1","E8B6A3"], // 趣
           "8DA8":["9096","BFF6","E8B6A8"], // 趨
           "8DB3":["91AB","C2AD","E8B6B3"], // 足
           "8DDD":["8B97","B5F7","E8B79D"], // 距
           "8DE1":["90D5","C0D7","E8B7A1"], // 跡
           "8DE8":["8CD7","B8D9","E8B7A8"], // 跨
           "8DEF":["9848","CFA9","E8B7AF"], // 路
           "8DF3":["92B5","C4B7","E8B7B3"], // 跳
           "8DF5":["9148","C1A9","E8B7B5"], // 践
           "8E0A":["9778","CDD9","E8B88A"], // 踊
           "8E0F":["93A5","C6A7","E8B88F"], // 踏
           "8E44":["92FB","C4FD","E8B984"], // 蹄
           "8E5F":["90D6","C0D8","E8B99F"], // 蹟
           "8E74":["8F52","BDB3","E8B9B4"], // 蹴
           "8E8D":["96F4","CCF6","E8BA8D"], // 躍
           "8EAB":["9067","BFC8","E8BAAB"], // 身
           "8EAF":["8BEB","B6ED","E8BAAF"], // 躯
           "8ECA":["8ED4","BCD6","E8BB8A"], // 車
           "8ECC":["8B4F","B5B0","E8BB8C"], // 軌
           "8ECD":["8C52","B7B3","E8BB8D"], // 軍
           "8ED2":["8CAC","B8AE","E8BB92"], // 軒
           "8EDF":["93EE","C6F0","E8BB9F"], // 軟
           "8EE2":["935D","C5BE","E8BBA2"], // 転
           "8EF8":["8EB2","BCB4","E8BBB8"], // 軸
           "8EFD":["8C79","B7DA","E8BBBD"], // 軽
           "8F03":["8A72","B3D3","E8BC83"], // 較
           "8F09":["8DDA","BADC","E8BC89"], // 載
           "8F14":["95E3","CAE5","E8BC94"], // 輔
           "8F1D":["8B50","B5B1","E8BC9D"], // 輝
           "8F29":["9479","C7DA","E8BCA9"], // 輩
           "8F2A":["97D6","CED8","E8BCAA"], // 輪
           "8F2F":["8F53","BDB4","E8BCAF"], // 輯
           "8F38":["9741","CDA2","E8BCB8"], // 輸
           "8F3F":["9760","CDC1","E8BCBF"], // 輿
           "8F44":["8A8D","B3ED","E8BD84"], // 轄
           "8F4D":["9351","C5B2","E8BD8D"], // 轍
           "8F5F":["8D8C","B9EC","E8BD9F"], // 轟
           "8F61":["8C44","B7A5","E8BDA1"], // 轡
           "8F9B":["9068","BFC9","E8BE9B"], // 辛
           "8F9E":["8EAB","BCAD","E8BE9E"], // 辞
           "8FB0":["9243","C3A4","E8BEB0"], // 辰
           "8FB1":["904A","BFAB","E8BEB1"], // 辱
           "8FB2":["945F","C7C0","E8BEB2"], // 農
           "8FBA":["95D3","CAD5","E8BEBA"], // 辺
           "8FBB":["92D2","C4D4","E8BEBB"], // 辻
           "8FBC":["8D9E","B9FE","E8BEBC"], // 込
           "8FBF":["9248","C3A9","E8BEBF"], // 辿
           "8FC2":["8949","B1AA","E8BF82"], // 迂
           "8FC4":["9698","CBF8","E8BF84"], // 迄
           "8FC5":["9076","BFD7","E8BF85"], // 迅
           "8FCE":["8C7D","B7DE","E8BF8E"], // 迎
           "8FD1":["8BDF","B6E1","E8BF91"], // 近
           "8FD4":["95D4","CAD6","E8BF94"], // 返
           "8FE6":["89DE","B2E0","E8BFA6"], // 迦
           "8FE9":["93F4","C6F6","E8BFA9"], // 迩
           "8FEB":["9497","C7F7","E8BFAB"], // 迫
           "8FED":["9352","C5B3","E8BFAD"], // 迭
           "8FF0":["8F71","BDD2","E8BFB0"], // 述
           "8FF7":["96C0","CCC2","E8BFB7"], // 迷
           "8FFD":["92C7","C4C9","E8BFBD"], // 追
           "9000":["91DE","C2E0","E98080"], // 退
           "9001":["9197","C1F7","E98081"], // 送
           "9003":["93A6","C6A8","E98083"], // 逃
           "9006":["8B74","B5D5","E98086"], // 逆
           "900F":["93A7","C6A9","E9808F"], // 透
           "9010":["9280","C3E0","E98090"], // 逐
           "9013":["92FC","C4FE","E98093"], // 逓
           "9014":["9372","C5D3","E98094"], // 途
           "9017":["9080","BFE0","E98097"], // 逗
           "9019":["9487","C7E7","E98099"], // 這
           "901A":["92CA","C4CC","E9809A"], // 通
           "901D":["90C0","C0C2","E9809D"], // 逝
           "901F":["91AC","C2AE","E9809F"], // 速
           "9020":["91A2","C2A4","E980A0"], // 造
           "9022":["88A7","B0A9","E980A2"], // 逢
           "9023":["9841","CFA2","E980A3"], // 連
           "902E":["91DF","C2E1","E980AE"], // 逮
           "9031":["8F54","BDB5","E980B1"], // 週
           "9032":["9069","BFCA","E980B2"], // 進
           "9038":["88ED","B0EF","E980B8"], // 逸
           "903C":["954E","C9AF","E980BC"], // 逼
           "9041":["93D9","C6DB","E98181"], // 遁
           "9042":["908B","BFEB","E98182"], // 遂
           "9045":["9278","C3D9","E98185"], // 遅
           "9047":["8BF6","B6F8","E98187"], // 遇
           "904A":["9756","CDB7","E9818A"], // 遊
           "904B":["895E","B1BF","E9818B"], // 運
           "904D":["95D5","CAD7","E9818D"], // 遍
           "904E":["89DF","B2E1","E9818E"], // 過
           "9053":["93B9","C6BB","E98193"], // 道
           "9054":["9242","C3A3","E98194"], // 達
           "9055":["88E1","B0E3","E98195"], // 違
           "905C":["91BB","C2BD","E9819C"], // 遜
           "9060":["8993","B1F3","E981A0"], // 遠
           "9061":["916B","C1CC","E981A1"], // 遡
           "9063":["8CAD","B8AF","E981A3"], // 遣
           "9065":["9779","CDDA","E981A5"], // 遥
           "9069":["934B","C5AC","E981A9"], // 適
           "906D":["9198","C1F8","E981AD"], // 遭
           "906E":["8ED5","BCD7","E981AE"], // 遮
           "9075":["8F85","BDE5","E981B5"], // 遵
           "9077":["914A","C1AB","E981B7"], // 遷
           "9078":["9149","C1AA","E981B8"], // 選
           "907A":["88E2","B0E4","E981BA"], // 遺
           "907C":["97C9","CECB","E981BC"], // 遼
           "907F":["94F0","C8F2","E981BF"], // 避
           "9084":["8AD2","B4D4","E98284"], // 還
           "9091":["9757","CDB8","E98291"], // 邑
           "90A3":["93DF","C6E1","E982A3"], // 那
           "90A6":["964D","CBAE","E982A6"], // 邦
           "90AA":["8ED7","BCD9","E982AA"], // 邪
           "90B8":["9340","C5A1","E982B8"], // 邸
           "90C1":["88E8","B0EA","E98381"], // 郁
           "90CA":["8D78","B9D9","E9838A"], // 郊
           "90CE":["9859","CFBA","E9838E"], // 郎
           "90E1":["8C53","B7B4","E983A1"], // 郡
           "90E8":["9594","C9F4","E983A8"], // 部
           "90ED":["8A73","B3D4","E983AD"], // 郭
           "90F5":["9758","CDB9","E983B5"], // 郵
           "90F7":["8BBD","B6BF","E983B7"], // 郷
           "90FD":["9373","C5D4","E983BD"], // 都
           "912D":["9341","C5A2","E984AD"], // 鄭
           "9149":["93D1","C6D3","E98589"], // 酉
           "914B":["8F55","BDB6","E9858B"], // 酋
           "914C":["8EDE","BCE0","E9858C"], // 酌
           "914D":["947A","C7DB","E9858D"], // 配
           "914E":["9291","C3F1","E9858E"], // 酎
           "9152":["8EF0","BCF2","E98592"], // 酒
           "9154":["908C","BFEC","E98594"], // 酔
           "9162":["907C","BFDD","E985A2"], // 酢
           "916A":["978F","CDEF","E985AA"], // 酪
           "916C":["8F56","BDB7","E985AC"], // 酬
           "9175":["8D79","B9DA","E985B5"], // 酵
           "9177":["8D93","B9F3","E985B7"], // 酷
           "9178":["8E5F","BBC0","E985B8"], // 酸
           "9187":["8F86","BDE6","E98687"], // 醇
           "918D":["91E7","C2E9","E9868D"], // 醍
           "9190":["8CED","B8EF","E98690"], // 醐
           "9192":["90C1","C0C3","E98692"], // 醒
           "9197":["94AE","C8B0","E98697"], // 醗
           "919C":["8F58","BDB9","E9869C"], // 醜
           "91A4":["8FDD","BEDF","E986A4"], // 醤
           "91B8":["8FF8","BEFA","E986B8"], // 醸
           "91C6":["94CE","C8D0","E98786"], // 釆
           "91C7":["8DD1","BAD3","E98787"], // 采
           "91C8":["8EDF","BCE1","E98788"], // 釈
           "91CC":["97A2","CEA4","E9878C"], // 里
           "91CD":["8F64","BDC5","E9878D"], // 重
           "91CE":["96EC","CCEE","E9878E"], // 野
           "91CF":["97CA","CECC","E9878F"], // 量
           "91D1":["8BE0","B6E2","E98791"], // 金
           "91D8":["9342","C5A3","E98798"], // 釘
           "91DC":["8A98","B3F8","E9879C"], // 釜
           "91DD":["906A","BFCB","E9879D"], // 針
           "91E3":["92DE","C4E0","E987A3"], // 釣
           "91E6":["9674","CBD5","E987A6"], // 釦
           "91E7":["8BFA","B6FC","E987A7"], // 釧
           "920D":["93DD","C6DF","E9888D"], // 鈍
           "920E":["8A62","B3C3","E9888E"], // 鈎
           "9234":["97E9","CEEB","E988B4"], // 鈴
           "9237":["8CD8","B8DA","E988B7"], // 鈷
           "9244":["9353","C5B4","E98984"], // 鉄
           "925B":["8994","B1F4","E9899B"], // 鉛
           "9262":["94AB","C8AD","E989A2"], // 鉢
           "9266":["8FDE","BEE0","E989A6"], // 鉦
           "9271":["8D7A","B9DB","E989B1"], // 鉱
           "927E":["9667","CBC8","E989BE"], // 鉾
           "9280":["8BE2","B6E4","E98A80"], // 銀
           "9283":["8F65","BDC6","E98A83"], // 銃
           "9285":["93BA","C6BC","E98A85"], // 銅
           "9291":["914C","C1AD","E98A91"], // 銑
           "9298":["96C1","CCC3","E98A98"], // 銘
           "929A":["92B6","C4B8","E98A9A"], // 銚
           "92AD":["914B","C1AC","E98AAD"], // 銭
           "92D2":["964E","CBAF","E98B92"], // 鋒
           "92E4":["8F9B","BDFB","E98BA4"], // 鋤
           "92EA":["95DD","CADF","E98BAA"], // 鋪
           "92ED":["8973","B1D4","E98BAD"], // 鋭
           "92F2":["9565","C9C6","E98BB2"], // 鋲
           "92F3":["9292","C3F2","E98BB3"], // 鋳
           "92F8":["8B98","B5F8","E98BB8"], // 鋸
           "92FC":["8D7C","B9DD","E98BBC"], // 鋼
           "9306":["8E4B","BBAC","E98C86"], // 錆
           "9310":["908D","BFED","E98C90"], // 錐
           "9318":["908E","BFEE","E98C98"], // 錘
           "9320":["8FF9","BEFB","E98CA0"], // 錠
           "9326":["8BD1","B6D3","E98CA6"], // 錦
           "9328":["9564","C9C5","E98CA8"], // 錨
           "932B":["8EE0","BCE2","E98CAB"], // 錫
           "932C":["9842","CFA3","E98CAC"], // 錬
           "932F":["8DF6","BAF8","E98CAF"], // 錯
           "9332":["985E","CFBF","E98CB2"], // 録
           "934B":["93E7","C6E9","E98D8B"], // 鍋
           "934D":["9374","C5D5","E98D8D"], // 鍍
           "9354":["92D5","C4D7","E98D94"], // 鍔
           "935B":["9262","C3C3","E98D9B"], // 鍛
           "936C":["8C4C","B7AD","E98DAC"], // 鍬
           "9375":["8CAE","B8B0","E98DB5"], // 鍵
           "937E":["8FDF","BEE1","E98DBE"], // 鍾
           "938C":["8A99","B3F9","E98E8C"], // 鎌
           "9396":["8DBD","BABF","E98E96"], // 鎖
           "9397":["9199","C1F9","E98E97"], // 鎗
           "939A":["92C8","C4CA","E98E9A"], // 鎚
           "93A7":["8A5A","B3BB","E98EA7"], // 鎧
           "93AE":["92C1","C4C3","E98EAE"], // 鎮
           "93D1":["934C","C5AD","E98F91"], // 鏑
           "93E1":["8BBE","B6C0","E98FA1"], // 鏡
           "9418":["8FE0","BEE2","E99098"], // 鐘
           "9419":["93A8","C6AA","E99099"], // 鐙
           "9438":["91F6","C2F8","E990B8"], // 鐸
           "9451":["8AD3","B4D5","E99191"], // 鑑
           "9453":["96F8","CCFA","E99193"], // 鑓
           "9577":["92B7","C4B9","E995B7"], // 長
           "9580":["96E5","CCE7","E99680"], // 門
           "9583":["914D","C1AE","E99683"], // 閃
           "9589":["95C2","CAC4","E99689"], // 閉
           "958B":["8A4A","B3AB","E9968B"], // 開
           "958F":["895B","B1BC","E9968F"], // 閏
           "9591":["8AD5","B4D7","E99691"], // 閑
           "9593":["8AD4","B4D6","E99693"], // 間
           "95A2":["8AD6","B4D8","E996A2"], // 関
           "95A3":["8A74","B3D5","E996A3"], // 閣
           "95A4":["8D7D","B9DE","E996A4"], // 閤
           "95A5":["94B4","C8B6","E996A5"], // 閥
           "95B2":["897B","B1DC","E996B2"], // 閲
           "95C7":["88C5","B0C7","E99787"], // 闇
           "95D8":["93AC","C6AE","E99798"], // 闘
           "961C":["958C","C9EC","E9989C"], // 阜
           "962A":["8DE3","BAE5","E998AA"], // 阪
           "9632":["9668","CBC9","E998B2"], // 防
           "963B":["916A","C1CB","E998BB"], // 阻
           "963F":["88A2","B0A4","E998BF"], // 阿
           "9640":["91C9","C2CB","E99980"], // 陀
           "9644":["958D","C9ED","E99984"], // 附
           "964D":["8D7E","B9DF","E9998D"], // 降
           "9650":["8CC0","B8C2","E99990"], // 限
           "965B":["95C3","CAC5","E9999B"], // 陛
           "9662":["8940","B1A1","E999A2"], // 院
           "9663":["9077","BFD8","E999A3"], // 陣
           "9664":["8F9C","BDFC","E999A4"], // 除
           "9665":["8AD7","B4D9","E999A5"], // 陥
           "966A":["9486","C7E6","E999AA"], // 陪
           "9670":["8941","B1A2","E999B0"], // 陰
           "9673":["92C2","C4C4","E999B3"], // 陳
           "9675":["97CB","CECD","E999B5"], // 陵
           "9676":["93A9","C6AB","E999B6"], // 陶
           "9678":["97A4","CEA6","E999B8"], // 陸
           "967A":["8CAF","B8B1","E999BA"], // 険
           "967D":["977A","CDDB","E999BD"], // 陽
           "9685":["8BF7","B6F9","E99A85"], // 隅
           "9686":["97B2","CEB4","E99A86"], // 隆
           "9688":["8C47","B7A8","E99A88"], // 隈
           "968A":["91E0","C2E2","E99A8A"], // 隊
           "968E":["8A4B","B3AC","E99A8E"], // 階
           "968F":["908F","BFEF","E99A8F"], // 随
           "9694":["8A75","B3D6","E99A94"], // 隔
           "9699":["8C84","B7E4","E99A99"], // 隙
           "969B":["8DDB","BADD","E99A9B"], // 際
           "969C":["8FE1","BEE3","E99A9C"], // 障
           "96A0":["8942","B1A3","E99AA0"], // 隠
           "96A3":["97D7","CED9","E99AA3"], // 隣
           "96B7":["97EA","CEEC","E99AB7"], // 隷
           "96BB":["90C7","C0C9","E99ABB"], // 隻
           "96BC":["94B9","C8BB","E99ABC"], // 隼
           "96C0":["909D","BFFD","E99B80"], // 雀
           "96C1":["8AE5","B4E7","E99B81"], // 雁
           "96C4":["9759","CDBA","E99B84"], // 雄
           "96C5":["89EB","B2ED","E99B85"], // 雅
           "96C6":["8F57","BDB8","E99B86"], // 集
           "96C7":["8CD9","B8DB","E99B87"], // 雇
           "96CC":["8E93","BBF3","E99B8C"], // 雌
           "96D1":["8E47","BBA8","E99B91"], // 雑
           "96DB":["9097","BFF7","E99B9B"], // 雛
           "96E2":["97A3","CEA5","E99BA2"], // 離
           "96E3":["93EF","C6F1","E99BA3"], // 難
           "96E8":["894A","B1AB","E99BA8"], // 雨
           "96EA":["90E1","C0E3","E99BAA"], // 雪
           "96EB":["8EB4","BCB6","E99BAB"], // 雫
           "96F0":["95B5","CAB7","E99BB0"], // 雰
           "96F2":["895F","B1C0","E99BB2"], // 雲
           "96F6":["97EB","CEED","E99BB6"], // 零
           "96F7":["978B","CDEB","E99BB7"], // 雷
           "96FB":["9364","C5C5","E99BBB"], // 電
           "9700":["8EF9","BCFB","E99C80"], // 需
           "9707":["906B","BFCC","E99C87"], // 震
           "970A":["97EC","CEEE","E99C8A"], // 霊
           "971C":["919A","C1FA","E99C9C"], // 霜
           "971E":["89E0","B2E2","E99C9E"], // 霞
           "9727":["96B6","CCB8","E99CA7"], // 霧
           "9732":["9849","CFAA","E99CB2"], // 露
           "9752":["90C2","C0C4","E99D92"], // 青
           "9756":["96F5","CCF7","E99D96"], // 靖
           "9759":["90C3","C0C5","E99D99"], // 静
           "975E":["94F1","C8F3","E99D9E"], // 非
           "9762":["96CA","CCCC","E99DA2"], // 面
           "9769":["8A76","B3D7","E99DA9"], // 革
           "976D":["9078","BFD9","E99DAD"], // 靭
           "9774":["8C43","B7A4","E99DB4"], // 靴
           "9784":["8A93","B3F3","E99E84"], // 鞄
           "978D":["88C6","B0C8","E99E8D"], // 鞍
           "9798":["8FE2","BEE4","E99E98"], // 鞘
           "97A0":["8B66","B5C7","E99EA0"], // 鞠
           "97AD":["95DA","CADC","E99EAD"], // 鞭
           "97D3":["8AD8","B4DA","E99F93"], // 韓
           "97EE":["9442","C7A3","E99FAE"], // 韮
           "97F3":["89B9","B2BB","E99FB3"], // 音
           "97FB":["8943","B1A4","E99FBB"], // 韻
           "97FF":["8BBF","B6C1","E99FBF"], // 響
           "9801":["95C5","CAC7","E9A081"], // 頁
           "9802":["92B8","C4BA","E9A082"], // 頂
           "9803":["8DA0","BAA2","E9A083"], // 頃
           "9805":["8D80","B9E0","E9A085"], // 項
           "9806":["8F87","BDE7","E9A086"], // 順
           "9808":["907B","BFDC","E9A088"], // 須
           "9810":["9761","CDC2","E9A090"], // 預
           "9811":["8AE6","B4E8","E9A091"], // 頑
           "9812":["94D0","C8D2","E9A092"], // 頒
           "9813":["93DA","C6DC","E9A093"], // 頓
           "9817":["909C","BFFC","E9A097"], // 頗
           "9818":["97CC","CECE","E9A098"], // 領
           "981A":["8C7A","B7DB","E9A09A"], // 頚
           "982C":["966A","CBCB","E9A0AC"], // 頬
           "982D":["93AA","C6AC","E9A0AD"], // 頭
           "9834":["896F","B1D0","E9A0B4"], // 頴
           "983B":["9570","C9D1","E9A0BB"], // 頻
           "983C":["978A","CDEA","E9A0BC"], // 頼
           "984C":["91E8","C2EA","E9A18C"], // 題
           "984D":["8A7A","B3DB","E9A18D"], // 額
           "984E":["8A7B","B3DC","E9A18E"], // 顎
           "9854":["8AE7","B4E9","E9A194"], // 顔
           "9855":["8CB0","B8B2","E9A195"], // 顕
           "9858":["8AE8","B4EA","E9A198"], // 願
           "985B":["935E","C5BF","E9A19B"], // 顛
           "985E":["97DE","CEE0","E9A19E"], // 類
           "9867":["8CDA","B8DC","E9A1A7"], // 顧
           "98A8":["9597","C9F7","E9A2A8"], // 風
           "98DB":["94F2","C8F4","E9A39B"], // 飛
           "98DF":["9048","BFA9","E9A39F"], // 食
           "98E2":["8B51","B5B2","E9A3A2"], // 飢
           "98EF":["94D1","C8D3","E9A3AF"], // 飯
           "98F2":["88F9","B0FB","E9A3B2"], // 飲
           "98F4":["88B9","B0BB","E9A3B4"], // 飴
           "98FC":["8E94","BBF4","E9A3BC"], // 飼
           "98FD":["964F","CBB0","E9A3BD"], // 飽
           "98FE":["8FFC","BEFE","E9A3BE"], // 飾
           "9905":["96DD","CCDF","E9A485"], // 餅
           "990A":["977B","CDDC","E9A48A"], // 養
           "990C":["8961","B1C2","E9A48C"], // 餌
           "9910":["8E60","BBC1","E9A490"], // 餐
           "9913":["89EC","B2EE","E9A493"], // 餓
           "9928":["8AD9","B4DB","E9A4A8"], // 館
           "9957":["8BC0","B6C2","E9A597"], // 饗
           "9996":["8EF1","BCF3","E9A696"], // 首
           "9999":["8D81","B9E1","E9A699"], // 香
           "99A8":["8A5D","B3BE","E9A6A8"], // 馨
           "99AC":["946E","C7CF","E9A6AC"], // 馬
           "99B3":["9279","C3DA","E9A6B3"], // 馳
           "99B4":["93E9","C6EB","E9A6B4"], // 馴
           "99C1":["949D","C7FD","E9A781"], // 駁
           "99C4":["91CA","C2CC","E9A784"], // 駄
           "99C5":["8977","B1D8","E9A785"], // 駅
           "99C6":["8BEC","B6EE","E9A786"], // 駆
           "99C8":["8BED","B6EF","E9A788"], // 駈
           "99D0":["9293","C3F3","E9A790"], // 駐
           "99D2":["8BEE","B6F0","E9A792"], // 駒
           "99D5":["89ED","B2EF","E9A795"], // 駕
           "99FF":["8F78","BDD9","E9A7BF"], // 駿
           "9A0E":["8B52","B5B3","E9A88E"], // 騎
           "9A12":["919B","C1FB","E9A892"], // 騒
           "9A13":["8CB1","B8B3","E9A893"], // 験
           "9A28":["91CB","C2CD","E9A8A8"], // 騨
           "9A30":["93AB","C6AD","E9A8B0"], // 騰
           "9A5A":["8BC1","B6C3","E9A99A"], // 驚
           "9AA8":["8D9C","B9FC","E9AAA8"], // 骨
           "9AB8":["8A5B","B3BC","E9AAB8"], // 骸
           "9AC4":["9091","BFF1","E9AB84"], // 髄
           "9AD8":["8D82","B9E2","E9AB98"], // 高
           "9AEA":["94AF","C8B1","E9ABAA"], // 髪
           "9AED":["9545","C9A6","E9ABAD"], // 髭
           "9B3C":["8B53","B5B4","E9ACBC"], // 鬼
           "9B41":["8A40","B3A1","E9AD81"], // 魁
           "9B42":["8DB0","BAB2","E9AD82"], // 魂
           "9B45":["96A3","CCA5","E9AD85"], // 魅
           "9B54":["9682","CBE2","E9AD94"], // 魔
           "9B5A":["8B9B","B5FB","E9AD9A"], // 魚
           "9B6F":["9844","CFA5","E9ADAF"], // 魯
           "9B8E":["88BC","B0BE","E9AE8E"], // 鮎
           "9B92":["95A9","CAAB","E9AE92"], // 鮒
           "9BAA":["968E","CBEE","E9AEAA"], // 鮪
           "9BAB":["8E4C","BBAD","E9AEAB"], // 鮫
           "9BAD":["8DF8","BAFA","E9AEAD"], // 鮭
           "9BAE":["914E","C1AF","E9AEAE"], // 鮮
           "9BC9":["8CEF","B8F1","E9AF89"], // 鯉
           "9BD6":["8E49","BBAA","E9AF96"], // 鯖
           "9BDB":["91E2","C2E4","E9AF9B"], // 鯛
           "9BE8":["8C7E","B7DF","E9AFA8"], // 鯨
           "9BF5":["88B1","B0B3","E9AFB5"], // 鯵
           "9C0D":["8A82","B3E2","E9B08D"], // 鰍
           "9C10":["986B","CFCC","E9B090"], // 鰐
           "9C2D":["9568","C9C9","E9B0AD"], // 鰭
           "9C2F":["88F1","B0F3","E9B0AF"], // 鰯
           "9C39":["8A8F","B3EF","E9B0B9"], // 鰹
           "9C3B":["8956","B1B7","E9B0BB"], // 鰻
           "9C48":["924C","C3AD","E9B188"], // 鱈
           "9C52":["9690","CBF0","E9B192"], // 鱒
           "9C57":["97D8","CEDA","E9B197"], // 鱗
           "9CE5":["92B9","C4BB","E9B3A5"], // 鳥
           "9CE9":["94B5","C8B7","E9B3A9"], // 鳩
           "9CF3":["9650","CBB1","E9B3B3"], // 鳳
           "9CF4":["96C2","CCC4","E9B3B4"], // 鳴
           "9CF6":["93CE","C6D0","E9B3B6"], // 鳶
           "9D07":["93BC","C6BE","E9B487"], // 鴇
           "9D0E":["89A8","B2AA","E9B48E"], // 鴎
           "9D1B":["8995","B1F5","E9B49B"], // 鴛
           "9D28":["8A9B","B3FB","E9B4A8"], // 鴨
           "9D2B":["8EB0","BCB2","E9B4AB"], // 鴫
           "9D2C":["89A7","B2A9","E9B4AC"], // 鴬
           "9D3B":["8D83","B9E3","E9B4BB"], // 鴻
           "9D5C":["894C","B1AD","E9B59C"], // 鵜
           "9D60":["8D94","B9F4","E9B5A0"], // 鵠
           "9D61":["96B7","CCB9","E9B5A1"], // 鵡
           "9D6C":["9651","CBB2","E9B5AC"], // 鵬
           "9D8F":["8C7B","B7DC","E9B68F"], // 鶏
           "9DB4":["92DF","C4E1","E9B6B4"], // 鶴
           "9DF2":["9868","CFC9","E9B7B2"], // 鷲
           "9DF9":["91E9","C2EB","E9B7B9"], // 鷹
           "9DFA":["8DEB","BAED","E9B7BA"], // 鷺
           "9E78":["8CB2","B8B4","E9B9B8"], // 鹸
           "9E7F":["8EAD","BCAF","E9B9BF"], // 鹿
           "9E93":["985B","CFBC","E9BA93"], // 麓
           "9E97":["97ED","CEEF","E9BA97"], // 麗
           "9E9F":["97D9","CEDB","E9BA9F"], // 麟
           "9EA6":["949E","C7FE","E9BAA6"], // 麦
           "9EB9":["8D8D","B9ED","E9BAB9"], // 麹
           "9EBA":["96CB","CCCD","E9BABA"], // 麺
           "9EBB":["9683","CBE3","E9BABB"], // 麻
           "9EBF":["969B","CBFB","E9BABF"], // 麿
           "9EC4":["89A9","B2AB","E9BB84"], // 黄
           "9ECD":["8B6F","B5D0","E9BB8D"], // 黍
           "9ED2":["8D95","B9F5","E9BB92"], // 黒
           "9ED9":["96D9","CCDB","E9BB99"], // 黙
           "9EDB":["91E1","C2E3","E9BB9B"], // 黛
           "9F0E":["9343","C5A4","E9BC8E"], // 鼎
           "9F13":["8CDB","B8DD","E9BC93"], // 鼓
           "9F20":["916C","C1CD","E9BCA0"], // 鼠
           "9F3B":["9540","C9A1","E9BCBB"], // 鼻
           "9F62":["97EE","CEF0","E9BDA2"], // 齢
           "9F8D":["97B4","CEB6","E9BE8D"], // 龍
           "FF01":["8149","A1AA","EFBC81"], // ！
           "FF03":["8194","A1F4","EFBC83"], // ＃
           "FF04":["8190","A1F0","EFBC84"], // ＄
           "FF05":["8193","A1F3","EFBC85"], // ％
           "FF06":["8195","A1F5","EFBC86"], // ＆
           "FF08":["8169","A1CA","EFBC88"], // （
           "FF09":["816A","A1CB","EFBC89"], // ）
           "FF0A":["8196","A1F6","EFBC8A"], // ＊
           "FF0B":["817B","A1DC","EFBC8B"], // ＋
           "FF0C":["8143","A1A4","EFBC8C"], // ，
           "FF0E":["8144","A1A5","EFBC8E"], // ．
           "FF0F":["815E","A1BF","EFBC8F"], // ／
           "FF10":["824F","A3B0","EFBC90"], // ０
           "FF11":["8250","A3B1","EFBC91"], // １
           "FF12":["8251","A3B2","EFBC92"], // ２
           "FF13":["8252","A3B3","EFBC93"], // ３
           "FF14":["8253","A3B4","EFBC94"], // ４
           "FF15":["8254","A3B5","EFBC95"], // ５
           "FF16":["8255","A3B6","EFBC96"], // ６
           "FF17":["8256","A3B7","EFBC97"], // ７
           "FF18":["8257","A3B8","EFBC98"], // ８
           "FF19":["8258","A3B9","EFBC99"], // ９
           "FF1A":["8146","A1A7","EFBC9A"], // ：
           "FF1B":["8147","A1A8","EFBC9B"], // ；
           "FF1C":["8183","A1E3","EFBC9C"], // ＜
           "FF1D":["8181","A1E1","EFBC9D"], // ＝
           "FF1E":["8184","A1E4","EFBC9E"], // ＞
           "FF1F":["8148","A1A9","EFBC9F"], // ？
           "FF20":["8197","A1F7","EFBCA0"], // ＠
           "FF21":["8260","A3C1","EFBCA1"], // Ａ
           "FF22":["8261","A3C2","EFBCA2"], // Ｂ
           "FF23":["8262","A3C3","EFBCA3"], // Ｃ
           "FF24":["8263","A3C4","EFBCA4"], // Ｄ
           "FF25":["8264","A3C5","EFBCA5"], // Ｅ
           "FF26":["8265","A3C6","EFBCA6"], // Ｆ
           "FF27":["8266","A3C7","EFBCA7"], // Ｇ
           "FF28":["8267","A3C8","EFBCA8"], // Ｈ
           "FF29":["8268","A3C9","EFBCA9"], // Ｉ
           "FF2A":["8269","A3CA","EFBCAA"], // Ｊ
           "FF2B":["826A","A3CB","EFBCAB"], // Ｋ
           "FF2C":["826B","A3CC","EFBCAC"], // Ｌ
           "FF2D":["826C","A3CD","EFBCAD"], // Ｍ
           "FF2E":["826D","A3CE","EFBCAE"], // Ｎ
           "FF2F":["826E","A3CF","EFBCAF"], // Ｏ
           "FF30":["826F","A3D0","EFBCB0"], // Ｐ
           "FF31":["8270","A3D1","EFBCB1"], // Ｑ
           "FF32":["8271","A3D2","EFBCB2"], // Ｒ
           "FF33":["8272","A3D3","EFBCB3"], // Ｓ
           "FF34":["8273","A3D4","EFBCB4"], // Ｔ
           "FF35":["8274","A3D5","EFBCB5"], // Ｕ
           "FF36":["8275","A3D6","EFBCB6"], // Ｖ
           "FF37":["8276","A3D7","EFBCB7"], // Ｗ
           "FF38":["8277","A3D8","EFBCB8"], // Ｘ
           "FF39":["8278","A3D9","EFBCB9"], // Ｙ
           "FF3A":["8279","A3DA","EFBCBA"], // Ｚ
           "FF3B":["816D","A1CE","EFBCBB"], // ［
           "FF3D":["816E","A1CF","EFBCBD"], // ］
           "FF3E":["814F","A1B0","EFBCBE"], // ＾
           "FF3F":["8151","A1B2","EFBCBF"], // ＿
           "FF40":["814D","A1AE","EFBD80"], // ｀
           "FF41":["8281","A3E1","EFBD81"], // ａ
           "FF42":["8282","A3E2","EFBD82"], // ｂ
           "FF43":["8283","A3E3","EFBD83"], // ｃ
           "FF44":["8284","A3E4","EFBD84"], // ｄ
           "FF45":["8285","A3E5","EFBD85"], // ｅ
           "FF46":["8286","A3E6","EFBD86"], // ｆ
           "FF47":["8287","A3E7","EFBD87"], // ｇ
           "FF48":["8288","A3E8","EFBD88"], // ｈ
           "FF49":["8289","A3E9","EFBD89"], // ｉ
           "FF4A":["828A","A3EA","EFBD8A"], // ｊ
           "FF4B":["828B","A3EB","EFBD8B"], // ｋ
           "FF4C":["828C","A3EC","EFBD8C"], // ｌ
           "FF4D":["828D","A3ED","EFBD8D"], // ｍ
           "FF4E":["828E","A3EE","EFBD8E"], // ｎ
           "FF4F":["828F","A3EF","EFBD8F"], // ｏ
           "FF50":["8290","A3F0","EFBD90"], // ｐ
           "FF51":["8291","A3F1","EFBD91"], // ｑ
           "FF52":["8292","A3F2","EFBD92"], // ｒ
           "FF53":["8293","A3F3","EFBD93"], // ｓ
           "FF54":["8294","A3F4","EFBD94"], // ｔ
           "FF55":["8295","A3F5","EFBD95"], // ｕ
           "FF56":["8296","A3F6","EFBD96"], // ｖ
           "FF57":["8297","A3F7","EFBD97"], // ｗ
           "FF58":["8298","A3F8","EFBD98"], // ｘ
           "FF59":["8299","A3F9","EFBD99"], // ｙ
           "FF5A":["829A","A3FA","EFBD9A"], // ｚ
           "FF5B":["816F","A1D0","EFBD9B"], // ｛
           "FF5C":["8162","A1C3","EFBD9C"], // ｜
           "FF5D":["8170","A1D1","EFBD9D"], // ｝
           "FFE3":["8150","A1B1","EFBFA3"], // ￣
           "FFE5":["818F","A1EF","EFBFA5"]  // ￥
    }
  }
}
