﻿package org.alivepdf.japanese.pdf.linux {
  /**
  * JIS第二水準漢字・文字コード変換テーブル [Unicodeベース(UTF-16BE)]. <br/>
  * 参考 http://ash.jp/code/ <br/>
  */
  public final class CharSetTable_Kanji02 {                //JIS 第二水準
    public static var charSet_MultiBytes:Object = {   // Utf-16 : [ Shift-Jis , Euc-JP , Utf-8 ]
           "4E10":["98A0","D0A2","E4B890"], // 丐
           "4E15":["98A1","D0A3","E4B895"], // 丕
           "4E17":["99C0","D2C2","E4B897"], // 丗
           "4E2A":["98A2","D0A4","E4B8AA"], // 个
           "4E31":["98A3","D0A5","E4B8B1"], // 丱
           "4E36":["98A4","D0A6","E4B8B6"], // 丶
           "4E3C":["98A5","D0A7","E4B8BC"], // 丼
           "4E3F":["98A6","D0A8","E4B8BF"], // 丿
           "4E42":["98A7","D0A9","E4B982"], // 乂
           "4E55":["E568","E9C9","E4B995"], // 乕
           "4E56":["98A8","D0AA","E4B996"], // 乖
           "4E58":["98A9","D0AB","E4B998"], // 乘
           "4E62":["9BA4","D6A6","E4B9A2"], // 乢
           "4E82":["98AA","D0AC","E4BA82"], // 亂
           "4E85":["98AB","D0AD","E4BA85"], // 亅
           "4E8A":["98AD","D0AF","E4BA8A"], // 亊
           "4E8E":["98B0","D0B2","E4BA8E"], // 于
           "4E9E":["98B1","D0B3","E4BA9E"], // 亞
           "4E9F":["98B2","D0B4","E4BA9F"], // 亟
           "4EA0":["98B3","D0B5","E4BAA0"], // 亠
           "4EA2":["98B4","D0B6","E4BAA2"], // 亢
           "4EB0":["98B5","D0B7","E4BAB0"], // 亰
           "4EB3":["98B6","D0B8","E4BAB3"], // 亳
           "4EB6":["98B7","D0B9","E4BAB6"], // 亶
           "4EC2":["98BC","D0BE","E4BB82"], // 仂
           "4EC4":["98BA","D0BC","E4BB84"], // 仄
           "4EC6":["98BB","D0BD","E4BB86"], // 仆
           "4ECD":["98B9","D0BB","E4BB8D"], // 仍
           "4ECE":["98B8","D0BA","E4BB8E"], // 从
           "4ED7":["98BD","D0BF","E4BB97"], // 仗
           "4EDE":["98BE","D0C0","E4BB9E"], // 仞
           "4EDF":["98C0","D0C2","E4BB9F"], // 仟
           "4EED":["98BF","D0C1","E4BBAD"], // 仭
           "4EF7":["98C1","D0C3","E4BBB7"], // 价
           "4F09":["98C2","D0C4","E4BC89"], // 伉
           "4F1C":["98E5","D0E7","E4BC9C"], // 伜
           "4F30":["98C4","D0C6","E4BCB0"], // 估
           "4F47":["98C8","D0CA","E4BD87"], // 佇
           "4F57":["98C7","D0C9","E4BD97"], // 佗
           "4F5A":["98C3","D0C5","E4BD9A"], // 佚
           "4F5B":["98C5","D0C7","E4BD9B"], // 佛
           "4F5D":["98C6","D0C8","E4BD9D"], // 佝
           "4F5E":["9B43","D5A4","E4BD9E"], // 佞
           "4F69":["98CE","D0D0","E4BDA9"], // 佩
           "4F6F":["98D1","D0D3","E4BDAF"], // 佯
           "4F70":["98CF","D0D1","E4BDB0"], // 佰
           "4F76":["98C9","D0CB","E4BDB6"], // 佶
           "4F7B":["98CD","D0CF","E4BDBB"], // 佻
           "4F86":["98D2","D0D4","E4BE86"], // 來
           "4F88":["98CA","D0CC","E4BE88"], // 侈
           "4F8F":["98CB","D0CD","E4BE8F"], // 侏
           "4F91":["98D0","D0D2","E4BE91"], // 侑
           "4F96":["98D3","D0D5","E4BE96"], // 侖
           "4F98":["98CC","D0CE","E4BE98"], // 侘
           "4FAB":["9B44","D5A5","E4BEAB"], // 侫
           "4FCE":["98D7","D0D9","E4BF8E"], // 俎
           "4FD0":["98DC","D0DE","E4BF90"], // 俐
           "4FD1":["98DA","D0DC","E4BF91"], // 俑
           "4FD4":["98D5","D0D7","E4BF94"], // 俔
           "4FD8":["98D8","D0DA","E4BF98"], // 俘
           "4FDA":["98DB","D0DD","E4BF9A"], // 俚
           "4FDB":["98D9","D0DB","E4BF9B"], // 俛
           "4FDF":["98D6","D0D8","E4BF9F"], // 俟
           "4FE4":["98DD","D0DF","E4BFA4"], // 俤
           "4FE5":["98DE","D0E0","E4BFA5"], // 俥
           "4FEF":["98EB","D0ED","E4BFAF"], // 俯
           "4FF6":["98E6","D0E8","E4BFB6"], // 俶
           "4FFE":["98EA","D0EC","E4BFBE"], // 俾
           "5005":["98E4","D0E6","E58085"], // 倅
           "5006":["98ED","D0EF","E58086"], // 倆
           "500F":["E0C5","E0C7","E5808F"], // 倏
           "5011":["98EC","D0EE","E58091"], // 們
           "5014":["98E1","D0E3","E58094"], // 倔
           "501A":["98DF","D0E1","E5809A"], // 倚
           "5021":["98E7","D0E9","E580A1"], // 倡
           "5025":["98E3","D0E5","E580A5"], // 倥
           "5028":["98E0","D0E2","E580A8"], // 倨
           "5029":["98E8","D0EA","E580A9"], // 倩
           "502A":["98E2","D0E4","E580AA"], // 倪
           "502C":["98E9","D0EB","E580AC"], // 倬
           "5043":["98EE","D0F0","E58183"], // 偃
           "5047":["98EF","D0F1","E58187"], // 假
           "5048":["98F3","D0F5","E58188"], // 偈
           "5050":["98F2","D0F4","E58190"], // 偐
           "5055":["98F1","D0F3","E58195"], // 偕
           "5056":["98F5","D0F7","E58196"], // 偖
           "505A":["98F4","D0F6","E5819A"], // 做
           "506C":["98F6","D0F8","E581AC"], // 偬
           "5078":["98F7","D0F9","E581B8"], // 偸
           "5080":["98F8","D0FA","E58280"], // 傀
           "5085":["98FA","D0FC","E58285"], // 傅
           "509A":["98F9","D0FB","E5829A"], // 傚
           "50B2":["98FC","D0FE","E582B2"], // 傲
           "50B3":["9942","D1A3","E582B3"], // 傳
           "50B4":["98FB","D0FD","E582B4"], // 傴
           "50C2":["9943","D1A4","E58382"], // 僂
           "50C9":["9940","D1A1","E58389"], // 僉
           "50CA":["9941","D1A2","E5838A"], // 僊
           "50D6":["9944","D1A5","E58396"], // 僖
           "50DE":["9945","D1A6","E5839E"], // 僞
           "50E3":["9948","D1A9","E583A3"], // 僣
           "50E5":["9946","D1A7","E583A5"], // 僥
           "50ED":["9947","D1A8","E583AD"], // 僭
           "50EE":["9949","D1AA","E583AE"], // 僮
           "50F5":["994B","D1AC","E583B5"], // 僵
           "50F9":["994A","D1AB","E583B9"], // 價
           "5101":["994D","D1AE","E58481"], // 儁
           "5102":["994E","D1AF","E58482"], // 儂
           "5109":["994C","D1AD","E58489"], // 儉
           "5114":["9951","D1B2","E58494"], // 儔
           "5115":["9950","D1B1","E58495"], // 儕
           "5116":["994F","D1B0","E58496"], // 儖
           "5118":["98D4","D0D6","E58498"], // 儘
           "511A":["9952","D1B3","E5849A"], // 儚
           "5121":["9953","D1B4","E584A1"], // 儡
           "5137":["9955","D1B6","E584B7"], // 儷
           "513A":["9954","D1B5","E584BA"], // 儺
           "513B":["9957","D1B8","E584BB"], // 儻
           "513C":["9956","D1B7","E584BC"], // 儼
           "513F":["9958","D1B9","E584BF"], // 儿
           "5140":["9959","D1BA","E58580"], // 兀
           "514C":["995B","D1BC","E5858C"], // 兌
           "5152":["995A","D1BB","E58592"], // 兒
           "5154":["995C","D1BD","E58594"], // 兔
           "5162":["995D","D1BE","E585A2"], // 兢
           "5169":["995F","D1C0","E585A9"], // 兩
           "516A":["9960","D1C1","E585AA"], // 兪
           "516E":["9961","D1C2","E585AE"], // 兮
           "5180":["9962","D1C3","E58680"], // 冀
           "5182":["9963","D1C4","E58682"], // 冂
           "5189":["9966","D1C7","E58689"], // 冉
           "518C":["9965","D1C6","E5868C"], // 册
           "518F":["9967","D1C8","E5868F"], // 冏
           "5190":["E3EC","E6EE","E58690"], // 冐
           "5191":["9968","D1C9","E58691"], // 冑
           "5193":["9969","D1CA","E58693"], // 冓
           "5195":["996A","D1CB","E58695"], // 冕
           "5196":["996B","D1CC","E58696"], // 冖
           "51A2":["996E","D1CF","E586A2"], // 冢
           "51A4":["996C","D1CD","E586A4"], // 冤
           "51A6":["996D","D1CE","E586A6"], // 冦
           "51A9":["996F","D1D0","E586A9"], // 冩
           "51AA":["9970","D1D1","E586AA"], // 冪
           "51AB":["9971","D1D2","E586AB"], // 冫
           "51B0":["9975","D1D6","E586B0"], // 冰
           "51B1":["9973","D1D4","E586B1"], // 冱
           "51B2":["9974","D1D5","E586B2"], // 冲
           "51B3":["9972","D1D3","E586B3"], // 决
           "51B5":["9976","D1D7","E586B5"], // 况
           "51BD":["9977","D1D8","E586BD"], // 冽
           "51C5":["9978","D1D9","E58785"], // 凅
           "51C9":["9979","D1DA","E58789"], // 凉
           "51D6":["99C3","D2C5","E58796"], // 凖
           "51DB":["997A","D1DB","E5879B"], // 凛
           "51DC":["EAA3","F4A5","E5879C"], // 凜
           "51E0":["997B","D1DC","E587A0"], // 几
           "51E9":["997D","D1DE","E587A9"], // 凩
           "51ED":["997E","D1DF","E587AD"], // 凭
           "51F0":["9980","D1E0","E587B0"], // 凰
           "51F5":["9981","D1E1","E587B5"], // 凵
           "51FE":["9982","D1E2","E587BE"], // 凾
           "5204":["9983","D1E3","E58884"], // 刄
           "520B":["9984","D1E4","E5888B"], // 刋
           "520E":["9986","D1E6","E5888E"], // 刎
           "5214":["9985","D1E5","E58894"], // 刔
           "5227":["9987","D1E7","E588A7"], // 刧
           "522A":["9988","D1E8","E588AA"], // 刪
           "522E":["9989","D1E9","E588AE"], // 刮
           "5233":["998A","D1EA","E588B3"], // 刳
           "5239":["998B","D1EB","E588B9"], // 刹
           "5244":["998D","D1ED","E58984"], // 剄
           "524B":["998E","D1EE","E5898B"], // 剋
           "524C":["998F","D1EF","E5898C"], // 剌
           "524F":["998C","D1EC","E5898F"], // 剏
           "5254":["9991","D1F1","E58994"], // 剔
           "525E":["9990","D1F0","E5899E"], // 剞
           "5269":["9994","D1F4","E589A9"], // 剩
           "526A":["9992","D1F2","E589AA"], // 剪
           "5271":["999B","D1FB","E589B1"], // 剱
           "5273":["9995","D1F5","E589B3"], // 剳
           "5274":["9993","D1F3","E589B4"], // 剴
           "527D":["9997","D1F7","E589BD"], // 剽
           "527F":["9996","D1F6","E589BF"], // 剿
           "5288":["999C","D1FC","E58A88"], // 劈
           "528D":["9998","D1F8","E58A8D"], // 劍
           "5291":["999D","D1FD","E58A91"], // 劑
           "5292":["999A","D1FA","E58A92"], // 劒
           "5294":["9999","D1F9","E58A94"], // 劔
           "52AC":["99A0","D2A2","E58AAC"], // 劬
           "52AD":["99A1","D2A3","E58AAD"], // 劭
           "52B5":["99A3","D2A5","E58AB5"], // 劵
           "52BC":["99A2","D2A4","E58ABC"], // 劼
           "52C1":["99A4","D2A6","E58B81"], // 勁
           "52CD":["99A5","D2A7","E58B8D"], // 勍
           "52D2":["E8D3","F0D5","E58B92"], // 勒
           "52D7":["99A6","D2A8","E58B97"], // 勗
           "52DE":["99A7","D2A9","E58B9E"], // 勞
           "52E0":["99AB","D2AD","E58BA0"], // 勠
           "52E3":["99A8","D2AA","E58BA3"], // 勣
           "52E6":["99A9","D2AB","E58BA6"], // 勦
           "52F3":["99AC","D2AE","E58BB3"], // 勳
           "52F5":["99AD","D2AF","E58BB5"], // 勵
           "52F8":["99AE","D2B0","E58BB8"], // 勸
           "52F9":["99AF","D2B1","E58BB9"], // 勹
           "5306":["99B0","D2B2","E58C86"], // 匆
           "5308":["99B1","D2B3","E58C88"], // 匈
           "530D":["99B3","D2B5","E58C8D"], // 匍
           "530F":["99B5","D2B7","E58C8F"], // 匏
           "5310":["99B4","D2B6","E58C90"], // 匐
           "5315":["99B6","D2B8","E58C95"], // 匕
           "531A":["99B7","D2B9","E58C9A"], // 匚
           "5323":["99B8","D2BA","E58CA3"], // 匣
           "532F":["99B9","D2BB","E58CAF"], // 匯
           "5331":["99BA","D2BC","E58CB1"], // 匱
           "5333":["99BB","D2BD","E58CB3"], // 匳
           "5338":["99BC","D2BE","E58CB8"], // 匸
           "5340":["99BD","D2BF","E58D80"], // 區
           "5345":["99BF","D2C1","E58D85"], // 卅
           "5346":["99BE","D2C0","E58D86"], // 卆
           "5349":["99C1","D2C3","E58D89"], // 卉
           "534D":["99C2","D2C4","E58D8D"], // 卍
           "535E":["99C4","D2C6","E58D9E"], // 卞
           "5369":["99C5","D2C7","E58DA9"], // 卩
           "536E":["99C6","D2C8","E58DAE"], // 卮
           "5377":["99C9","D2CB","E58DB7"], // 卷
           "537B":["99C8","D2CA","E58DBB"], // 卻
           "5382":["99CA","D2CC","E58E82"], // 厂
           "5396":["99CB","D2CD","E58E96"], // 厖
           "53A0":["99CC","D2CE","E58EA0"], // 厠
           "53A5":["99CE","D2D0","E58EA5"], // 厥
           "53A6":["99CD","D2CF","E58EA6"], // 厦
           "53AE":["99CF","D2D1","E58EAE"], // 厮
           "53B0":["99D0","D2D2","E58EB0"], // 厰
           "53B6":["99D1","D2D3","E58EB6"], // 厶
           "53C3":["99D2","D2D4","E58F83"], // 參
           "53DF":["99D5","D2D7","E58F9F"], // 叟
           "53E8":["99D9","D2DB","E58FA8"], // 叨
           "53ED":["99DA","D2DC","E58FAD"], // 叭
           "53EE":["99D8","D2DA","E58FAE"], // 叮
           "53FA":["99DB","D2DD","E58FBA"], // 叺
           "5401":["99DC","D2DE","E59081"], // 吁
           "541D":["99E5","D2E7","E5909D"], // 吝
           "5429":["99E4","D2E6","E590A9"], // 吩
           "542C":["99DF","D2E1","E590AC"], // 听
           "542D":["99E0","D2E2","E590AD"], // 吭
           "542E":["99E2","D2E4","E590AE"], // 吮
           "5436":["99E3","D2E5","E590B6"], // 吶
           "543C":["99E1","D2E3","E590BC"], // 吼
           "543D":["99DD","D2DF","E590BD"], // 吽
           "5440":["99DE","D2E0","E59180"], // 呀
           "544E":["99E6","D2E8","E5918E"], // 呎
           "545F":["99EA","D2EC","E5919F"], // 呟
           "5470":["99ED","D2EF","E591B0"], // 呰
           "5471":["99EB","D2ED","E591B1"], // 呱
           "5475":["99E8","D2EA","E591B5"], // 呵
           "5476":["99F1","D2F3","E591B6"], // 呶
           "5477":["99EC","D2EE","E591B7"], // 呷
           "547B":["99EF","D2F1","E591BB"], // 呻
           "5480":["99F0","D2F2","E59280"], // 咀
           "5484":["99F2","D2F4","E59284"], // 咄
           "5486":["99F4","D2F6","E59286"], // 咆
           "548E":["99E9","D2EB","E5928E"], // 咎
           "548F":["99E7","D2E9","E5928F"], // 咏
           "5490":["99F3","D2F5","E59290"], // 咐
           "5492":["99EE","D2F0","E59292"], // 咒
           "54A2":["99F6","D2F8","E592A2"], // 咢
           "54A4":["9A42","D3A3","E592A4"], // 咤
           "54A5":["99F8","D2FA","E592A5"], // 咥
           "54A8":["99FC","D2FE","E592A8"], // 咨
           "54AB":["9A40","D3A1","E592AB"], // 咫
           "54AC":["99F9","D2FB","E592AC"], // 咬
           "54AF":["9A5D","D3BE","E592AF"], // 咯
           "54B8":["99F7","D2F9","E592B8"], // 咸
           "54BC":["9A44","D3A5","E592BC"], // 咼
           "54BE":["9A43","D3A4","E592BE"], // 咾
           "54C2":["9A41","D3A2","E59382"], // 哂
           "54C4":["99FA","D2FC","E59384"], // 哄
           "54C7":["99F5","D2F7","E59387"], // 哇
           "54C8":["99FB","D2FD","E59388"], // 哈
           "54D8":["9A45","D3A6","E59398"], // 哘
           "54E2":["9A4E","D3AF","E593A2"], // 哢
           "54E5":["9A46","D3A7","E593A5"], // 哥
           "54E6":["9A47","D3A8","E593A6"], // 哦
           "54ED":["9A4C","D3AD","E593AD"], // 哭
           "54EE":["9A4B","D3AC","E593AE"], // 哮
           "54FA":["9A4D","D3AE","E593BA"], // 哺
           "54FD":["9A4A","D3AB","E593BD"], // 哽
           "550F":["9A48","D3A9","E5948F"], // 唏
           "5514":["9A49","D3AA","E59494"], // 唔
           "552E":["9A53","D3B4","E594AE"], // 售
           "5533":["9A59","D3BA","E594B3"], // 唳
           "5538":["9A58","D3B9","E594B8"], // 唸
           "5539":["9A4F","D3B0","E594B9"], // 唹
           "5540":["9A50","D3B1","E59580"], // 啀
           "5545":["9A55","D3B6","E59585"], // 啅
           "554C":["9A52","D3B3","E5958C"], // 啌
           "5556":["9A56","D3B7","E59596"], // 啖
           "5557":["9A57","D3B8","E59597"], // 啗
           "555C":["9A54","D3B5","E5959C"], // 啜
           "555D":["9A5A","D3BB","E5959D"], // 啝
           "5563":["9A51","D3B2","E595A3"], // 啣
           "557B":["9A60","D3C1","E595BB"], // 啻
           "557C":["9A65","D3C6","E595BC"], // 啼
           "557E":["9A61","D3C2","E595BE"], // 啾
           "5580":["9A5C","D3BD","E59680"], // 喀
           "5583":["9A66","D3C7","E59683"], // 喃
           "5587":["9A68","D3C9","E59687"], // 喇
           "558A":["9A5E","D3BF","E5968A"], // 喊
           "5598":["9A62","D3C3","E59698"], // 喘
           "5599":["9A5B","D3BC","E59699"], // 喙
           "559E":["9A63","D3C4","E5969E"], // 喞
           "559F":["9A5F","D3C0","E5969F"], // 喟
           "55A8":["9A69","D3CA","E596A8"], // 喨
           "55A9":["9A67","D3C8","E596A9"], // 喩
           "55AE":["9A64","D3C5","E596AE"], // 單
           "55C4":["9A6D","D3CE","E59784"], // 嗄
           "55C5":["9A6B","D3CC","E59785"], // 嗅
           "55C7":["9AA5","D4A7","E59787"], // 嗇
           "55D4":["9A70","D3D1","E59794"], // 嗔
           "55DA":["9A6A","D3CB","E5979A"], // 嗚
           "55DC":["9A6E","D3CF","E5979C"], // 嗜
           "55DF":["9A6C","D3CD","E5979F"], // 嗟
           "55E4":["9A6F","D3D0","E597A4"], // 嗤
           "55F7":["9A72","D3D3","E597B7"], // 嗷
           "55F9":["9A77","D3D8","E597B9"], // 嗹
           "55FD":["9A75","D3D6","E597BD"], // 嗽
           "55FE":["9A74","D3D5","E597BE"], // 嗾
           "5614":["9A71","D3D2","E59894"], // 嘔
           "5616":["9A73","D3D4","E59896"], // 嘖
           "561B":["9A76","D3D7","E5989B"], // 嘛
           "562F":["9A82","D3E2","E598AF"], // 嘯
           "5632":["9A7D","D3DE","E598B2"], // 嘲
           "5634":["9A7B","D3DC","E598B4"], // 嘴
           "5636":["9A7C","D3DD","E598B6"], // 嘶
           "5638":["9A7E","D3DF","E598B8"], // 嘸
           "564E":["9A78","D3D9","E5998E"], // 噎
           "5650":["9A79","D3DA","E59990"], // 噐
           "5664":["9A81","D3E1","E599A4"], // 噤
           "566A":["9A84","D3E4","E599AA"], // 噪
           "566B":["9A80","D3E0","E599AB"], // 噫
           "566C":["9A83","D3E3","E599AC"], // 噬
           "5680":["9A86","D3E6","E59A80"], // 嚀
           "5686":["9A85","D3E5","E59A86"], // 嚆
           "568A":["9A87","D3E7","E59A8A"], // 嚊
           "568F":["9A8A","D3EA","E59A8F"], // 嚏
           "5694":["9A89","D3E9","E59A94"], // 嚔
           "56A0":["9A88","D3E8","E59AA0"], // 嚠
           "56A5":["9A8B","D3EB","E59AA5"], // 嚥
           "56AE":["9A8C","D3EC","E59AAE"], // 嚮
           "56B4":["9A8E","D3EE","E59AB4"], // 嚴
           "56B6":["9A8D","D3ED","E59AB6"], // 嚶
           "56BC":["9A90","D3F0","E59ABC"], // 嚼
           "56C0":["9A93","D3F3","E59B80"], // 囀
           "56C1":["9A91","D3F1","E59B81"], // 囁
           "56C2":["9A8F","D3EF","E59B82"], // 囂
           "56C3":["9A92","D3F2","E59B83"], // 囃
           "56C8":["9A94","D3F4","E59B88"], // 囈
           "56CE":["9A95","D3F5","E59B8E"], // 囎
           "56D1":["9A96","D3F6","E59B91"], // 囑
           "56D3":["9A97","D3F7","E59B93"], // 囓
           "56D7":["9A98","D3F8","E59B97"], // 囗
           "56D8":["9964","D1C5","E59B98"], // 囘
           "56EE":["9A99","D3F9","E59BAE"], // 囮
           "56F9":["9A9A","D3FA","E59BB9"], // 囹
           "56FF":["9A9C","D3FC","E59BBF"], // 囿
           "5700":["9A9B","D3FB","E59C80"], // 圀
           "5704":["9A9D","D3FD","E59C84"], // 圄
           "5708":["9A9F","D4A1","E59C88"], // 圈
           "5709":["9A9E","D3FE","E59C89"], // 圉
           "570B":["9AA0","D4A2","E59C8B"], // 國
           "570D":["9AA1","D4A3","E59C8D"], // 圍
           "5713":["9AA2","D4A4","E59C93"], // 圓
           "5716":["9AA4","D4A6","E59C96"], // 圖
           "5718":["9AA3","D4A5","E59C98"], // 團
           "571C":["9AA6","D4A8","E59C9C"], // 圜
           "5726":["9AA7","D4A9","E59CA6"], // 圦
           "5737":["9AA8","D4AA","E59CB7"], // 圷
           "5738":["9AA9","D4AB","E59CB8"], // 圸
           "573B":["9AAB","D4AD","E59CBB"], // 圻
           "5740":["9AAC","D4AE","E59D80"], // 址
           "574E":["9AAA","D4AC","E59D8E"], // 坎
           "574F":["9AAD","D4AF","E59D8F"], // 坏
           "5761":["9AB1","D4B3","E59DA1"], // 坡
           "5769":["9AAE","D4B0","E59DA9"], // 坩
           "577F":["9AB2","D4B4","E59DBF"], // 坿
           "5788":["9AB0","D4B2","E59E88"], // 垈
           "5789":["9AB3","D4B5","E59E89"], // 垉
           "5793":["9AB4","D4B6","E59E93"], // 垓
           "57A0":["9AB5","D4B7","E59EA0"], // 垠
           "57A4":["9AB7","D4B9","E59EA4"], // 垤
           "57AA":["9AB8","D4BA","E59EAA"], // 垪
           "57B0":["9AB9","D4BB","E59EB0"], // 垰
           "57B3":["9AB6","D4B8","E59EB3"], // 垳
           "57C0":["9AAF","D4B1","E59F80"], // 埀
           "57C3":["9ABA","D4BC","E59F83"], // 埃
           "57C6":["9ABB","D4BD","E59F86"], // 埆
           "57D2":["9ABD","D4BF","E59F92"], // 埒
           "57D3":["9ABE","D4C0","E59F93"], // 埓
           "57D4":["9ABC","D4BE","E59F94"], // 埔
           "57D6":["9AC0","D4C2","E59F96"], // 埖
           "57E3":["9AC1","D4C3","E59FA3"], // 埣
           "580A":["9ABF","D4C1","E5A08A"], // 堊
           "580B":["9AC2","D4C4","E5A08B"], // 堋
           "5819":["9AC3","D4C5","E5A099"], // 堙
           "581D":["9AC4","D4C6","E5A09D"], // 堝
           "5821":["9AC6","D4C8","E5A0A1"], // 堡
           "582F":["EA9F","F4A1","E5A0AF"], // 堯
           "583D":["9ACC","D4CE","E5A0BD"], // 堽
           "584B":["9AC8","D4CA","E5A18B"], // 塋
           "5852":["9ACB","D4CD","E5A192"], // 塒
           "5862":["9AC7","D4C9","E5A1A2"], // 塢
           "5870":["9AC9","D4CB","E5A1B0"], // 塰
           "5872":["9AC5","D4C7","E5A1B2"], // 塲
           "5879":["9ACD","D4CF","E5A1B9"], // 塹
           "5885":["9ACE","D4D0","E5A285"], // 墅
           "589F":["9AD0","D4D2","E5A29F"], // 墟
           "58AB":["9AD1","D4D3","E5A2AB"], // 墫
           "58AE":["9AD6","D4D8","E5A2AE"], // 墮
           "58B8":["9AD5","D4D7","E5A2B8"], // 墸
           "58B9":["9ACF","D4D1","E5A2B9"], // 墹
           "58BA":["9AD2","D4D4","E5A2BA"], // 墺
           "58BB":["9AD4","D4D6","E5A2BB"], // 墻
           "58C5":["9AD7","D4D9","E5A385"], // 壅
           "58D1":["9AD9","D4DB","E5A391"], // 壑
           "58D3":["9AD8","D4DA","E5A393"], // 壓
           "58D7":["9ADA","D4DC","E5A397"], // 壗
           "58D8":["9ADC","D4DE","E5A398"], // 壘
           "58D9":["9ADB","D4DD","E5A399"], // 壙
           "58DC":["9ADE","D4E0","E5A39C"], // 壜
           "58DE":["9AD3","D4D5","E5A39E"], // 壞
           "58DF":["9AE0","D4E2","E5A39F"], // 壟
           "58E4":["9ADF","D4E1","E5A3A4"], // 壤
           "58E5":["9ADD","D4DF","E5A3A5"], // 壥
           "58EF":["9AE1","D4E3","E5A3AF"], // 壯
           "58F9":["9AE3","D4E5","E5A3B9"], // 壹
           "58FA":["9AE2","D4E4","E5A3BA"], // 壺
           "58FB":["9AE4","D4E6","E5A3BB"], // 壻
           "58FC":["9AE5","D4E7","E5A3BC"], // 壼
           "58FD":["9AE6","D4E8","E5A3BD"], // 壽
           "5902":["9AE7","D4E9","E5A482"], // 夂
           "590A":["9AE8","D4EA","E5A48A"], // 夊
           "5910":["9AE9","D4EB","E5A490"], // 夐
           "5918":["99C7","D2C9","E5A498"], // 夘
           "591B":["9AEA","D4EC","E5A49B"], // 夛
           "5925":["9AEC","D4EE","E5A4A5"], // 夥
           "592C":["9AED","D4EF","E5A4AC"], // 夬
           "592D":["9AEE","D4F0","E5A4AD"], // 夭
           "5932":["9AEF","D4F1","E5A4B2"], // 夲
           "5938":["9AF0","D4F2","E5A4B8"], // 夸
           "593E":["9AF1","D4F3","E5A4BE"], // 夾
           "594E":["9AF5","D4F7","E5A58E"], // 奎
           "5950":["9AF4","D4F6","E5A590"], // 奐
           "5955":["9AF3","D4F5","E5A595"], // 奕
           "5958":["9AF7","D4F9","E5A598"], // 奘
           "595A":["9AF6","D4F8","E5A59A"], // 奚
           "5960":["9AF9","D4FB","E5A5A0"], // 奠
           "5962":["9AF8","D4FA","E5A5A2"], // 奢
           "5967":["9AFA","D4FC","E5A5A7"], // 奧
           "5969":["9AFC","D4FE","E5A5A9"], // 奩
           "596C":["9AFB","D4FD","E5A5AC"], // 奬
           "5978":["9B40","D5A1","E5A5B8"], // 奸
           "5981":["9B41","D5A2","E5A681"], // 妁
           "598D":["9B4A","D5AB","E5A68D"], // 妍
           "599B":["9BAA","D6AC","E5A69B"], // 妛
           "599D":["9B42","D5A3","E5A69D"], // 妝
           "59A3":["9B45","D5A6","E5A6A3"], // 妣
           "59B2":["9B46","D5A7","E5A6B2"], // 妲
           "59C6":["9B47","D5A8","E5A786"], // 姆
           "59D9":["9B4B","D5AC","E5A799"], // 姙
           "59DA":["9B4C","D5AD","E5A79A"], // 姚
           "59DC":["9B49","D5AA","E5A79C"], // 姜
           "59E8":["9B48","D5A9","E5A7A8"], // 姨
           "5A09":["9B51","D5B2","E5A889"], // 娉
           "5A11":["9B4F","D5B0","E5A891"], // 娑
           "5A1A":["9B52","D5B3","E5A89A"], // 娚
           "5A1C":["9B50","D5B1","E5A89C"], // 娜
           "5A1F":["9B4E","D5AF","E5A89F"], // 娟
           "5A25":["9B4D","D5AE","E5A8A5"], // 娥
           "5A35":["9B56","D5B7","E5A8B5"], // 娵
           "5A36":["9B57","D5B8","E5A8B6"], // 娶
           "5A40":["9B53","D5B4","E5A980"], // 婀
           "5A49":["9B55","D5B6","E5A989"], // 婉
           "5A62":["9B58","D5B9","E5A9A2"], // 婢
           "5A6A":["9B59","D5BA","E5A9AA"], // 婪
           "5A6C":["9B54","D5B5","E5A9AC"], // 婬
           "5A9A":["9B5A","D5BB","E5AA9A"], // 媚
           "5ABC":["9B5B","D5BC","E5AABC"], // 媼
           "5ABD":["9B5F","D5C0","E5AABD"], // 媽
           "5ABE":["9B5C","D5BD","E5AABE"], // 媾
           "5AC2":["9B5E","D5BF","E5AB82"], // 嫂
           "5ACB":["9B5D","D5BE","E5AB8B"], // 嫋
           "5AD0":["9B6B","D5CC","E5AB90"], // 嫐
           "5AD6":["9B64","D5C5","E5AB96"], // 嫖
           "5AD7":["9B61","D5C2","E5AB97"], // 嫗
           "5AE3":["9B60","D5C1","E5ABA3"], // 嫣
           "5AE6":["9B62","D5C3","E5ABA6"], // 嫦
           "5AE9":["9B63","D5C4","E5ABA9"], // 嫩
           "5AFA":["9B65","D5C6","E5ABBA"], // 嫺
           "5AFB":["9B66","D5C7","E5ABBB"], // 嫻
           "5B0B":["9B68","D5C9","E5AC8B"], // 嬋
           "5B0C":["9B67","D5C8","E5AC8C"], // 嬌
           "5B16":["9B69","D5CA","E5AC96"], // 嬖
           "5B2A":["9B6C","D5CD","E5ACAA"], // 嬪
           "5B32":["9B6A","D5CB","E5ACB2"], // 嬲
           "5B36":["9B6D","D5CE","E5ACB6"], // 嬶
           "5B3E":["9B6E","D5CF","E5ACBE"], // 嬾
           "5B40":["9B71","D5D2","E5AD80"], // 孀
           "5B43":["9B6F","D5D0","E5AD83"], // 孃
           "5B45":["9B70","D5D1","E5AD85"], // 孅
           "5B51":["9B72","D5D3","E5AD91"], // 孑
           "5B55":["9B73","D5D4","E5AD95"], // 孕
           "5B5A":["9B74","D5D5","E5AD9A"], // 孚
           "5B5B":["9B75","D5D6","E5AD9B"], // 孛
           "5B65":["9B76","D5D7","E5ADA5"], // 孥
           "5B69":["9B77","D5D8","E5ADA9"], // 孩
           "5B70":["9B78","D5D9","E5ADB0"], // 孰
           "5B71":["9BA1","D6A3","E5ADB1"], // 孱
           "5B73":["9B79","D5DA","E5ADB3"], // 孳
           "5B75":["9B7A","D5DB","E5ADB5"], // 孵
           "5B78":["9B7B","D5DC","E5ADB8"], // 學
           "5B7A":["9B7D","D5DE","E5ADBA"], // 孺
           "5B80":["9B7E","D5DF","E5AE80"], // 宀
           "5B83":["9B80","D5E0","E5AE83"], // 它
           "5BA6":["9B81","D5E1","E5AEA6"], // 宦
           "5BB8":["9B82","D5E2","E5AEB8"], // 宸
           "5BC3":["9B83","D5E3","E5AF83"], // 寃
           "5BC7":["9B84","D5E4","E5AF87"], // 寇
           "5BC9":["9B85","D5E5","E5AF89"], // 寉
           "5BD0":["9B87","D5E7","E5AF90"], // 寐
           "5BD4":["9B86","D5E6","E5AF94"], // 寔
           "5BDE":["9B8B","D5EB","E5AF9E"], // 寞
           "5BE2":["9B8A","D5EA","E5AFA2"], // 寢
           "5BE4":["9B88","D5E8","E5AFA4"], // 寤
           "5BE5":["9B8C","D5EC","E5AFA5"], // 寥
           "5BE6":["9B89","D5E9","E5AFA6"], // 實
           "5BE8":["9ECB","DCCD","E5AFA8"], // 寨
           "5BEB":["9B8D","D5ED","E5AFAB"], // 寫
           "5BF0":["9B8E","D5EE","E5AFB0"], // 寰
           "5BF3":["9B90","D5F0","E5AFB3"], // 寳
           "5BF6":["9B8F","D5EF","E5AFB6"], // 寶
           "5C05":["9B91","D5F1","E5B085"], // 尅
           "5C07":["9B92","D5F2","E5B087"], // 將
           "5C08":["9B93","D5F3","E5B088"], // 專
           "5C0D":["9B94","D5F4","E5B08D"], // 對
           "5C13":["9B95","D5F5","E5B093"], // 尓
           "5C20":["9B96","D5F6","E5B0A0"], // 尠
           "5C22":["9B97","D5F7","E5B0A2"], // 尢
           "5C28":["9B98","D5F8","E5B0A8"], // 尨
           "5C38":["9B99","D5F9","E5B0B8"], // 尸
           "5C39":["9B9A","D5FA","E5B0B9"], // 尹
           "5C41":["9B9B","D5FB","E5B181"], // 屁
           "5C46":["9B9C","D5FC","E5B186"], // 屆
           "5C4E":["9B9D","D5FD","E5B18E"], // 屎
           "5C4F":["9BA0","D6A2","E5B18F"], // 屏
           "5C50":["9B9F","D6A1","E5B190"], // 屐
           "5C53":["9B9E","D5FE","E5B193"], // 屓
           "5C6C":["9BA2","D6A4","E5B1AC"], // 屬
           "5C6E":["9BA3","D6A5","E5B1AE"], // 屮
           "5C76":["9BA5","D6A7","E5B1B6"], // 屶
           "5C79":["9BA6","D6A8","E5B1B9"], // 屹
           "5C8C":["9BA7","D6A9","E5B28C"], // 岌
           "5C91":["9BA8","D6AA","E5B291"], // 岑
           "5C94":["9BA9","D6AB","E5B294"], // 岔
           "5CAB":["9BAB","D6AD","E5B2AB"], // 岫
           "5CB6":["9BAD","D6AF","E5B2B6"], // 岶
           "5CB7":["9BAF","D6B1","E5B2B7"], // 岷
           "5CBB":["9BAC","D6AE","E5B2BB"], // 岻
           "5CBC":["9BAE","D6B0","E5B2BC"], // 岼
           "5CBE":["9BB1","D6B3","E5B2BE"], // 岾
           "5CC5":["9BB0","D6B2","E5B385"], // 峅
           "5CC7":["9BB2","D6B4","E5B387"], // 峇
           "5CD9":["9BB3","D6B5","E5B399"], // 峙
           "5CE9":["9BB4","D6B6","E5B3A9"], // 峩
           "5CEA":["9BB9","D6BB","E5B3AA"], // 峪
           "5CED":["9BB7","D6B9","E5B3AD"], // 峭
           "5CFA":["9BB6","D6B8","E5B3BA"], // 峺
           "5CFD":["9BB5","D6B7","E5B3BD"], // 峽
           "5D0B":["9BBA","D6BC","E5B48B"], // 崋
           "5D11":["9BC0","D6C2","E5B491"], // 崑
           "5D14":["9BC1","D6C3","E5B494"], // 崔
           "5D15":["9BBB","D6BD","E5B495"], // 崕
           "5D17":["9BBC","D6BE","E5B497"], // 崗
           "5D18":["9BC5","D6C7","E5B498"], // 崘
           "5D19":["9BC4","D6C6","E5B499"], // 崙
           "5D1A":["9BC3","D6C5","E5B49A"], // 崚
           "5D1B":["9BBF","D6C1","E5B49B"], // 崛
           "5D1F":["9BBE","D6C0","E5B49F"], // 崟
           "5D22":["9BC2","D6C4","E5B4A2"], // 崢
           "5D4B":["9BC9","D6CB","E5B58B"], // 嵋
           "5D4C":["9BC6","D6C8","E5B58C"], // 嵌
           "5D4E":["9BC8","D6CA","E5B58E"], // 嵎
           "5D52":["9BC7","D6C9","E5B592"], // 嵒
           "5D5C":["9BBD","D6BF","E5B59C"], // 嵜
           "5D6C":["9BCA","D6CC","E5B5AC"], // 嵬
           "5D73":["9BCB","D6CD","E5B5B3"], // 嵳
           "5D76":["9BCC","D6CE","E5B5B6"], // 嵶
           "5D82":["9BCF","D6D1","E5B682"], // 嶂
           "5D84":["9BCE","D6D0","E5B684"], // 嶄
           "5D87":["9BCD","D6CF","E5B687"], // 嶇
           "5D8C":["9BB8","D6BA","E5B68C"], // 嶌
           "5D90":["9BD5","D6D7","E5B690"], // 嶐
           "5D9D":["9BD1","D6D3","E5B69D"], // 嶝
           "5DA2":["9BD0","D6D2","E5B6A2"], // 嶢
           "5DAC":["9BD2","D6D4","E5B6AC"], // 嶬
           "5DAE":["9BD3","D6D5","E5B6AE"], // 嶮
           "5DB7":["9BD6","D6D8","E5B6B7"], // 嶷
           "5DBC":["9BD7","D6D9","E5B6BC"], // 嶼
           "5DBD":["9BD4","D6D6","E5B6BD"], // 嶽
           "5DC9":["9BD8","D6DA","E5B789"], // 巉
           "5DCD":["9BD9","D6DB","E5B78D"], // 巍
           "5DD2":["9BDB","D6DD","E5B792"], // 巒
           "5DD3":["9BDA","D6DC","E5B793"], // 巓
           "5DD6":["9BDC","D6DE","E5B796"], // 巖
           "5DDB":["9BDD","D6DF","E5B79B"], // 巛
           "5DEB":["9BDE","D6E0","E5B7AB"], // 巫
           "5DF2":["9BDF","D6E1","E5B7B2"], // 已
           "5DF5":["9BE0","D6E2","E5B7B5"], // 巵
           "5E0B":["9BE1","D6E3","E5B88B"], // 帋
           "5E11":["9BE4","D6E6","E5B891"], // 帑
           "5E19":["9BE3","D6E5","E5B899"], // 帙
           "5E1A":["9BE2","D6E4","E5B89A"], // 帚
           "5E1B":["9BE5","D6E7","E5B89B"], // 帛
           "5E36":["9BE6","D6E8","E5B8B6"], // 帶
           "5E37":["9BE7","D6E9","E5B8B7"], // 帷
           "5E40":["9BEA","D6EC","E5B980"], // 幀
           "5E43":["9BE9","D6EB","E5B983"], // 幃
           "5E44":["9BE8","D6EA","E5B984"], // 幄
           "5E47":["9BF1","D6F3","E5B987"], // 幇
           "5E4E":["9BEB","D6ED","E5B98E"], // 幎
           "5E54":["9BED","D6EF","E5B994"], // 幔
           "5E57":["9BEC","D6EE","E5B997"], // 幗
           "5E5F":["9BEE","D6F0","E5B99F"], // 幟
           "5E62":["9BEF","D6F1","E5B9A2"], // 幢
           "5E64":["9BF0","D6F2","E5B9A4"], // 幤
           "5E75":["9BF2","D6F4","E5B9B5"], // 幵
           "5E76":["9BF3","D6F5","E5B9B6"], // 并
           "5E7A":["9BF4","D6F6","E5B9BA"], // 幺
           "5E7F":["9BF6","D6F8","E5B9BF"], // 广
           "5EA0":["9BF7","D6F9","E5BAA0"], // 庠
           "5EC1":["9BF8","D6FA","E5BB81"], // 廁
           "5EC2":["9BF9","D6FB","E5BB82"], // 廂
           "5EC8":["9BFA","D6FC","E5BB88"], // 廈
           "5ECF":["9BFC","D6FE","E5BB8F"], // 廏
           "5ED0":["9BFB","D6FD","E5BB90"], // 廐
           "5ED6":["9C40","D7A1","E5BB96"], // 廖
           "5EDA":["9C43","D7A4","E5BB9A"], // 廚
           "5EDB":["9C44","D7A5","E5BB9B"], // 廛
           "5EDD":["9C42","D7A3","E5BB9D"], // 廝
           "5EE1":["9C46","D7A7","E5BBA1"], // 廡
           "5EE2":["9C45","D7A6","E5BBA2"], // 廢
           "5EE3":["9C41","D7A2","E5BBA3"], // 廣
           "5EE8":["9C47","D7A8","E5BBA8"], // 廨
           "5EE9":["9C48","D7A9","E5BBA9"], // 廩
           "5EEC":["9C49","D7AA","E5BBAC"], // 廬
           "5EF0":["9C4C","D7AD","E5BBB0"], // 廰
           "5EF1":["9C4A","D7AB","E5BBB1"], // 廱
           "5EF3":["9C4B","D7AC","E5BBB3"], // 廳
           "5EF4":["9C4D","D7AE","E5BBB4"], // 廴
           "5EF8":["9C4E","D7AF","E5BBB8"], // 廸
           "5EFE":["9C4F","D7B0","E5BBBE"], // 廾
           "5F03":["9C50","D7B1","E5BC83"], // 弃
           "5F09":["9C51","D7B2","E5BC89"], // 弉
           "5F0B":["9C54","D7B5","E5BC8B"], // 弋
           "5F0C":["989F","D0A1","E5BC8C"], // 弌
           "5F0D":["98AF","D0B1","E5BC8D"], // 弍
           "5F11":["9C55","D7B6","E5BC91"], // 弑
           "5F16":["9C56","D7B7","E5BC96"], // 弖
           "5F29":["9C57","D7B8","E5BCA9"], // 弩
           "5F2D":["9C58","D7B9","E5BCAD"], // 弭
           "5F2F":["9C5E","D7BF","E5BCAF"], // 弯
           "5F38":["9C59","D7BA","E5BCB8"], // 弸
           "5F41":["9C5A","D7BB","E5BD81"], // 彁
           "5F48":["9C5B","D7BC","E5BD88"], // 彈
           "5F4C":["9C5C","D7BD","E5BD8C"], // 彌
           "5F4E":["9C5D","D7BE","E5BD8E"], // 彎
           "5F51":["9C5F","D7C0","E5BD91"], // 彑
           "5F56":["9C60","D7C1","E5BD96"], // 彖
           "5F57":["9C61","D7C2","E5BD97"], // 彗
           "5F59":["9C62","D7C3","E5BD99"], // 彙
           "5F5C":["9C53","D7B4","E5BD9C"], // 彜
           "5F5D":["9C52","D7B3","E5BD9D"], // 彝
           "5F61":["9C63","D7C4","E5BDA1"], // 彡
           "5F6D":["9C64","D7C5","E5BDAD"], // 彭
           "5F73":["9C65","D7C6","E5BDB3"], // 彳
           "5F77":["9C66","D7C7","E5BDB7"], // 彷
           "5F7F":["9C69","D7CA","E5BDBF"], // 彿
           "5F82":["9C68","D7C9","E5BE82"], // 徂
           "5F83":["9C67","D7C8","E5BE83"], // 徃
           "5F87":["9C6D","D7CE","E5BE87"], // 徇
           "5F88":["9C6B","D7CC","E5BE88"], // 很
           "5F8A":["9C6A","D7CB","E5BE8A"], // 徊
           "5F91":["9C6C","D7CD","E5BE91"], // 徑
           "5F98":["9C70","D7D1","E5BE98"], // 徘
           "5F99":["9C6F","D7D0","E5BE99"], // 徙
           "5F9E":["9C6E","D7CF","E5BE9E"], // 從
           "5FA0":["9C71","D7D2","E5BEA0"], // 徠
           "5FA8":["9C72","D7D3","E5BEA8"], // 徨
           "5FAD":["9C73","D7D4","E5BEAD"], // 徭
           "5FBC":["9C74","D7D5","E5BEBC"], // 徼
           "5FD6":["9C75","D7D6","E5BF96"], // 忖
           "5FDD":["9C7A","D7DB","E5BF9D"], // 忝
           "5FE4":["9C77","D7D8","E5BFA4"], // 忤
           "5FF0":["9CAB","D8AD","E5BFB0"], // 忰
           "5FF1":["9C79","D7DA","E5BFB1"], // 忱
           "5FF8":["9C78","D7D9","E5BFB8"], // 忸
           "5FFB":["9C76","D7D7","E5BFBB"], // 忻
           "5FFF":["9C7C","D7DD","E5BFBF"], // 忿
           "600E":["9C83","D7E3","E6808E"], // 怎
           "600F":["9C89","D7E9","E6808F"], // 怏
           "6010":["9C81","D7E1","E68090"], // 怐
           "6015":["9C86","D7E6","E68095"], // 怕
           "6019":["9C80","D7E0","E68099"], // 怙
           "601B":["9C85","D7E5","E6809B"], // 怛
           "6021":["9C7D","D7DE","E680A1"], // 怡
           "6026":["9C88","D7E8","E680A6"], // 怦
           "6029":["9C82","D7E2","E680A9"], // 怩
           "602B":["9C87","D7E7","E680AB"], // 怫
           "6031":["9C84","D7E4","E680B1"], // 怱
           "603A":["9C8A","D7EA","E680BA"], // 怺
           "6041":["9C8C","D7EC","E68181"], // 恁
           "6042":["9C96","D7F6","E68182"], // 恂
           "6043":["9C94","D7F4","E68183"], // 恃
           "6046":["9C91","D7F1","E68186"], // 恆
           "604A":["9C90","D7F0","E6818A"], // 恊
           "604D":["9C92","D7F2","E6818D"], // 恍
           "6059":["9C99","D7F9","E68199"], // 恙
           "605A":["9C8B","D7EB","E6819A"], // 恚
           "605F":["9C8F","D7EF","E6819F"], // 恟
           "6060":["9C7E","D7DF","E681A0"], // 恠
           "6063":["9C93","D7F3","E681A3"], // 恣
           "6064":["9C95","D7F5","E681A4"], // 恤
           "606A":["9C8D","D7ED","E681AA"], // 恪
           "606B":["9C98","D7F8","E681AB"], // 恫
           "606C":["9C97","D7F7","E681AC"], // 恬
           "6077":["9C8E","D7EE","E681B7"], // 恷
           "6081":["9C9A","D7FA","E68281"], // 悁
           "6083":["9C9D","D7FD","E68283"], // 悃
           "6084":["9C9F","D8A1","E68284"], // 悄
           "608B":["9CA5","D8A7","E6828B"], // 悋
           "608D":["9C9B","D7FB","E6828D"], // 悍
           "6092":["9CA3","D8A5","E68292"], // 悒
           "6096":["9CA1","D8A3","E68296"], // 悖
           "6097":["9CA2","D8A4","E68297"], // 悗
           "609A":["9C9E","D7FE","E6829A"], // 悚
           "609B":["9CA0","D8A2","E6829B"], // 悛
           "60A7":["9CA4","D8A6","E682A7"], // 悧
           "60B3":["9C7B","D7DC","E682B3"], // 悳
           "60B4":["9CAA","D8AC","E682B4"], // 悴
           "60B5":["9CAE","D8B0","E682B5"], // 悵
           "60B8":["9CA7","D8A9","E682B8"], // 悸
           "60BD":["9CAC","D8AE","E682BD"], // 悽
           "60C6":["9CAD","D8AF","E68386"], // 惆
           "60D3":["9CA9","D8AB","E68393"], // 惓
           "60D8":["9CAF","D8B1","E68398"], // 惘
           "60E0":["9CA8","D8AA","E683A0"], // 惠
           "60E1":["9CA6","D8A8","E683A1"], // 惡
           "60E7":["9C9C","D7FC","E683A7"], // 惧
           "60F1":["9CBB","D8BD","E683B1"], // 惱
           "60F4":["9CB6","D8B8","E683B4"], // 惴
           "60F6":["9CB3","D8B5","E683B6"], // 惶
           "60F7":["9CB4","D8B6","E683B7"], // 惷
           "60FA":["9CB7","D8B9","E683BA"], // 惺
           "60FB":["9CBA","D8BC","E683BB"], // 惻
           "6100":["9CB5","D8B7","E68480"], // 愀
           "6103":["9CB8","D8BA","E68483"], // 愃
           "6106":["9CB2","D8B4","E68486"], // 愆
           "610D":["9CBC","D8BE","E6848D"], // 愍
           "610E":["9CBD","D8BF","E6848E"], // 愎
           "6115":["9CB1","D8B3","E68495"], // 愕
           "6121":["9CB9","D8BB","E684A1"], // 愡
           "6127":["9CC1","D8C3","E684A7"], // 愧
           "6128":["9CC0","D8C2","E684A8"], // 愨
           "612C":["9CC5","D8C7","E684AC"], // 愬
           "6134":["9CC6","D8C8","E684B4"], // 愴
           "613C":["9CC4","D8C6","E684BC"], // 愼
           "613D":["9CC7","D8C9","E684BD"], // 愽
           "613E":["9CBF","D8C1","E684BE"], // 愾
           "613F":["9CC3","D8C5","E684BF"], // 愿
           "6142":["9CC8","D8CA","E68582"], // 慂
           "6144":["9CC9","D8CB","E68584"], // 慄
           "6147":["9CBE","D8C0","E68587"], // 慇
           "614A":["9CC2","D8C4","E6858A"], // 慊
           "614D":["9CB0","D8B2","E6858D"], // 慍
           "6153":["9CD6","D8D8","E68593"], // 慓
           "6158":["9CCC","D8CE","E68598"], // 慘
           "6159":["9CCD","D8CF","E68599"], // 慙
           "615A":["9CCE","D8D0","E6859A"], // 慚
           "615D":["9CD5","D8D7","E6859D"], // 慝
           "615F":["9CD4","D8D6","E6859F"], // 慟
           "6165":["9CD2","D8D4","E685A5"], // 慥
           "616B":["9CCF","D8D1","E685AB"], // 慫
           "616F":["9CD1","D8D3","E685AF"], // 慯
           "6171":["9CD3","D8D5","E685B1"], // 慱
           "6173":["9CCA","D8CC","E685B3"], // 慳
           "6174":["9CD0","D8D2","E685B4"], // 慴
           "6175":["9CD7","D8D9","E685B5"], // 慵
           "6177":["9CCB","D8CD","E685B7"], // 慷
           "6187":["9CDA","D8DC","E68687"], // 憇
           "618A":["9CDE","D8E0","E6868A"], // 憊
           "6191":["9CDF","D8E1","E68691"], // 憑
           "6194":["9CDC","D8DE","E68694"], // 憔
           "6196":["9CD9","D8DB","E68696"], // 憖
           "6199":["9CD8","D8DA","E68699"], // 憙
           "619A":["9CDD","D8DF","E6869A"], // 憚
           "61AB":["9CE0","D8E2","E686AB"], // 憫
           "61AC":["9CDB","D8DD","E686AC"], // 憬
           "61AE":["9CE1","D8E3","E686AE"], // 憮
           "61BA":["9CE9","D8EB","E686BA"], // 憺
           "61C3":["9CE7","D8E9","E68783"], // 懃
           "61C6":["9CE8","D8EA","E68786"], // 懆
           "61C8":["9CE6","D8E8","E68788"], // 懈
           "61C9":["9CE4","D8E6","E68789"], // 應
           "61CA":["9CE3","D8E5","E6878A"], // 懊
           "61CB":["9CEA","D8EC","E6878B"], // 懋
           "61CC":["9CE2","D8E4","E6878C"], // 懌
           "61CD":["9CEC","D8EE","E6878D"], // 懍
           "61E3":["9CEE","D8F0","E687A3"], // 懣
           "61E6":["9CED","D8EF","E687A6"], // 懦
           "61F4":["9CF1","D8F3","E687B4"], // 懴
           "61F6":["9CEF","D8F1","E687B6"], // 懶
           "61F7":["9CE5","D8E7","E687B7"], // 懷
           "61FA":["9CF0","D8F2","E687BA"], // 懺
           "61FC":["9CF4","D8F6","E687BC"], // 懼
           "61FD":["9CF3","D8F5","E687BD"], // 懽
           "61FE":["9CF5","D8F7","E687BE"], // 懾
           "61FF":["9CF2","D8F4","E687BF"], // 懿
           "6200":["9CF6","D8F8","E68880"], // 戀
           "6208":["9CF7","D8F9","E68888"], // 戈
           "6209":["9CF8","D8FA","E68889"], // 戉
           "620C":["9CFA","D8FC","E6888C"], // 戌
           "620D":["9CF9","D8FB","E6888D"], // 戍
           "6214":["9CFB","D8FD","E68894"], // 戔
           "621B":["9CFC","D8FE","E6889B"], // 戛
           "621D":["E6C1","ECC3","E6889D"], // 戝
           "621E":["9D40","D9A1","E6889E"], // 戞
           "6221":["9D41","D9A2","E688A1"], // 戡
           "622A":["9D42","D9A3","E688AA"], // 截
           "622E":["9D43","D9A4","E688AE"], // 戮
           "6230":["9D44","D9A5","E688B0"], // 戰
           "6232":["9D45","D9A6","E688B2"], // 戲
           "6233":["9D46","D9A7","E688B3"], // 戳
           "6241":["9D47","D9A8","E68981"], // 扁
           "6248":["E7BB","EEBD","E68988"], // 扈
           "624E":["9D48","D9A9","E6898E"], // 扎
           "625B":["9D4B","D9AC","E6899B"], // 扛
           "625E":["9D49","D9AA","E6899E"], // 扞
           "6260":["9D4C","D9AD","E689A0"], // 扠
           "6263":["9D4A","D9AB","E689A3"], // 扣
           "6268":["9D4D","D9AE","E689A8"], // 扨
           "627C":["9D4E","D9AF","E689BC"], // 扼
           "627E":["9D51","D9B2","E689BE"], // 找
           "6282":["9D4F","D9B0","E68A82"], // 抂
           "6283":["9D56","D9B7","E68A83"], // 抃
           "6289":["9D50","D9B1","E68A89"], // 抉
           "6292":["9D52","D9B3","E68A92"], // 抒
           "6293":["9D53","D9B4","E68A93"], // 抓
           "6294":["9D57","D9B8","E68A94"], // 抔
           "6296":["9D54","D9B5","E68A96"], // 抖
           "629B":["9D65","D9C6","E68A9B"], // 抛
           "62AC":["9DAB","DAAD","E68AAC"], // 抬
           "62BB":["9D5A","D9BB","E68ABB"], // 抻
           "62C2":["9D63","D9C4","E68B82"], // 拂
           "62C6":["9D5D","D9BE","E68B86"], // 拆
           "62C7":["9D64","D9C5","E68B87"], // 拇
           "62C8":["9D5F","D9C0","E68B88"], // 拈
           "62C9":["9D66","D9C7","E68B89"], // 拉
           "62CA":["9D62","D9C3","E68B8A"], // 拊
           "62CC":["9D61","D9C2","E68B8C"], // 拌
           "62CF":["9D5B","D9BC","E68B8F"], // 拏
           "62D1":["9D59","D9BA","E68B91"], // 拑
           "62D4":["9D55","D9B6","E68B94"], // 拔
           "62D7":["9D58","D9B9","E68B97"], // 拗
           "62DC":["9D60","D9C1","E68B9C"], // 拜
           "62EE":["9D68","D9C9","E68BAE"], // 拮
           "62EF":["9D6D","D9CE","E68BAF"], // 拯
           "62F1":["9D69","D9CA","E68BB1"], // 拱
           "62F5":["9D6E","D9CF","E68BB5"], // 拵
           "62FF":["9D5C","D9BD","E68BBF"], // 拿
           "6302":["9D6B","D9CC","E68C82"], // 挂
           "6308":["9D6C","D9CD","E68C88"], // 挈
           "630C":["9D67","D9C8","E68C8C"], // 挌
           "6327":["9D6A","D9CB","E68CA7"], // 挧
           "633E":["9D70","D9D1","E68CBE"], // 挾
           "634D":["9D71","D9D2","E68D8D"], // 捍
           "634F":["9D73","D9D4","E68D8F"], // 捏
           "6350":["9D6F","D9D0","E68D90"], // 捐
           "6369":["9D80","D9E0","E68DA9"], // 捩
           "636B":["9D7E","D9DF","E68DAB"], // 捫
           "6376":["9D78","D9D9","E68DB6"], // 捶
           "6380":["9D76","D9D7","E68E80"], // 掀
           "6389":["9D7B","D9DC","E68E89"], // 掉
           "638E":["9D75","D9D6","E68E8E"], // 掎
           "638F":["9D7A","D9DB","E68E8F"], // 掏
           "6396":["9D74","D9D5","E68E96"], // 掖
           "639F":["9D7C","D9DD","E68E9F"], // 掟
           "63A3":["9D79","D9DA","E68EA3"], // 掣
           "63AB":["9D77","D9D8","E68EAB"], // 掫
           "63B5":["9D7D","D9DE","E68EB5"], // 掵
           "63BE":["9D81","D9E1","E68EBE"], // 掾
           "63C0":["9D83","D9E3","E68F80"], // 揀
           "63C4":["9D89","D9E9","E68F84"], // 揄
           "63C6":["9D84","D9E4","E68F86"], // 揆
           "63C9":["9D86","D9E6","E68F89"], // 揉
           "63D2":["9D87","D9E7","E68F92"], // 插
           "63E3":["9D85","D9E5","E68FA3"], // 揣
           "63E9":["9D82","D9E2","E68FA9"], // 揩
           "63F6":["9D88","D9E8","E68FB6"], // 揶
           "6406":["9D8C","D9EC","E69086"], // 搆
           "640F":["9D93","D9F3","E6908F"], // 搏
           "6413":["9D8D","D9ED","E69093"], // 搓
           "6416":["9D8A","D9EA","E69096"], // 搖
           "6417":["9D91","D9F1","E69097"], // 搗
           "641C":["9D72","D9D3","E6909C"], // 搜
           "6426":["9D8E","D9EE","E690A6"], // 搦
           "6428":["9D92","D9F2","E690A8"], // 搨
           "6434":["9D8B","D9EB","E690B4"], // 搴
           "6436":["9D8F","D9EF","E690B6"], // 搶
           "644E":["9D97","D9F7","E6918E"], // 摎
           "6467":["9D94","D9F4","E691A7"], // 摧
           "646F":["9D95","D9F5","E691AF"], // 摯
           "6476":["9D96","D9F6","E691B6"], // 摶
           "6488":["9D9D","D9FD","E69288"], // 撈
           "6493":["9D9A","D9FA","E69293"], // 撓
           "6495":["9D99","D9F9","E69295"], // 撕
           "64A5":["9D9B","D9FB","E692A5"], // 撥
           "64A9":["9D9C","D9FC","E692A9"], // 撩
           "64BB":["9DA3","DAA5","E692BB"], // 撻
           "64BC":["9D9E","D9FE","E692BC"], // 撼
           "64C2":["9DA5","DAA7","E69382"], // 擂
           "64C5":["9DA1","DAA3","E69385"], // 擅
           "64C7":["9DA2","DAA4","E69387"], // 擇
           "64D2":["9DA0","DAA2","E69392"], // 擒
           "64D4":["9D5E","D9BF","E69394"], // 擔
           "64D8":["9DA4","DAA6","E69398"], // 擘
           "64DA":["9D9F","DAA1","E6939A"], // 據
           "64E0":["9DA9","DAAB","E693A0"], // 擠
           "64E1":["9DAA","DAAC","E693A1"], // 擡
           "64E3":["9DAC","DAAE","E693A3"], // 擣
           "64E7":["9DA7","DAA9","E693A7"], // 擧
           "64EF":["9DAD","DAAF","E693AF"], // 擯
           "64F1":["9DA6","DAA8","E693B1"], // 擱
           "64F2":["9DB1","DAB3","E693B2"], // 擲
           "64F4":["9DB0","DAB2","E693B4"], // 擴
           "64F6":["9DAF","DAB1","E693B6"], // 擶
           "64FA":["9DB2","DAB4","E693BA"], // 擺
           "64FD":["9DB4","DAB6","E693BD"], // 擽
           "6500":["9DB3","DAB5","E69480"], // 攀
           "6505":["9DB7","DAB9","E69485"], // 攅
           "6518":["9DB5","DAB7","E69498"], // 攘
           "651C":["9DB6","DAB8","E6949C"], // 攜
           "651D":["9D90","D9F0","E6949D"], // 攝
           "6523":["9DB9","DABB","E694A3"], // 攣
           "6524":["9DB8","DABA","E694A4"], // 攤
           "652A":["9D98","D9F8","E694AA"], // 攪
           "652B":["9DBA","DABC","E694AB"], // 攫
           "652C":["9DAE","DAB0","E694AC"], // 攬
           "6534":["9DBB","DABD","E694B4"], // 攴
           "6535":["9DBC","DABE","E694B5"], // 攵
           "6536":["9DBE","DAC0","E694B6"], // 收
           "6537":["9DBD","DABF","E694B7"], // 攷
           "6538":["9DBF","DAC1","E694B8"], // 攸
           "6548":["9DC1","DAC3","E69588"], // 效
           "654D":["9DC4","DAC6","E6958D"], // 敍
           "6555":["9DC3","DAC5","E69595"], // 敕
           "6556":["9DC2","DAC4","E69596"], // 敖
           "6558":["9DC5","DAC7","E69598"], // 敘
           "655D":["9DC7","DAC9","E6959D"], // 敝
           "655E":["9DC6","DAC8","E6959E"], // 敞
           "6572":["9DC8","DACA","E695B2"], // 敲
           "6578":["9DC9","DACB","E695B8"], // 數
           "6582":["9DCA","DACC","E69682"], // 斂
           "6583":["9DCB","DACD","E69683"], // 斃
           "6588":["9B7C","D5DD","E69688"], // 斈
           "659B":["9DCD","DACF","E6969B"], // 斛
           "659F":["9DCE","DAD0","E6969F"], // 斟
           "65AB":["9DCF","DAD1","E696AB"], // 斫
           "65B7":["9DD0","DAD2","E696B7"], // 斷
           "65C1":["9DD3","DAD5","E69781"], // 旁
           "65C3":["9DD1","DAD3","E69783"], // 旃
           "65C4":["9DD4","DAD6","E69784"], // 旄
           "65C6":["9DD2","DAD4","E69786"], // 旆
           "65CC":["9DD5","DAD7","E6978C"], // 旌
           "65D2":["9DD6","DAD8","E69792"], // 旒
           "65D9":["9DD8","DADA","E69799"], // 旙
           "65DB":["9DD7","DAD9","E6979B"], // 旛
           "65E0":["9DD9","DADB","E697A0"], // 无
           "65E1":["9DDA","DADC","E697A1"], // 旡
           "65F1":["9DDB","DADD","E697B1"], // 旱
           "65FB":["9DDF","DAE1","E697BB"], // 旻
           "6603":["9DDE","DAE0","E69883"], // 昃
           "660A":["9DDD","DADF","E6988A"], // 昊
           "661C":["9DE4","DAE6","E6989C"], // 昜
           "6634":["9DE3","DAE5","E698B4"], // 昴
           "6635":["9DE1","DAE3","E698B5"], // 昵
           "6636":["9DE2","DAE4","E698B6"], // 昶
           "663F":["9E45","DBA6","E698BF"], // 昿
           "6641":["9DE8","DAEA","E69981"], // 晁
           "6644":["9DE6","DAE8","E69984"], // 晄
           "6649":["9DE7","DAE9","E69989"], // 晉
           "664F":["9DE5","DAE7","E6998F"], // 晏
           "665D":["9DEA","DAEC","E6999D"], // 晝
           "665E":["9DE9","DAEB","E6999E"], // 晞
           "665F":["9DEE","DAF0","E6999F"], // 晟
           "6662":["9DEF","DAF1","E699A2"], // 晢
           "6664":["9DEB","DAED","E699A4"], // 晤
           "6667":["9DEC","DAEE","E699A7"], // 晧
           "6668":["9DED","DAEF","E699A8"], // 晨
           "6670":["9DF0","DAF2","E699B0"], // 晰
           "6683":["9DF1","DAF3","E69A83"], // 暃
           "6684":["9DF5","DAF7","E69A84"], // 暄
           "6688":["9DF2","DAF4","E69A88"], // 暈
           "6689":["9DF4","DAF6","E69A89"], // 暉
           "668E":["9DF3","DAF5","E69A8E"], // 暎
           "6698":["9DF6","DAF8","E69A98"], // 暘
           "669D":["9DF7","DAF9","E69A9D"], // 暝
           "66B8":["9E41","DBA2","E69AB8"], // 暸
           "66B9":["9DF9","DAFB","E69AB9"], // 暹
           "66BC":["9DFC","DAFE","E69ABC"], // 暼
           "66BE":["9DFB","DAFD","E69ABE"], // 暾
           "66C1":["9DF8","DAFA","E69B81"], // 曁
           "66C4":["9E40","DBA1","E69B84"], // 曄
           "66C9":["9DFA","DAFC","E69B89"], // 曉
           "66D6":["9E42","DBA3","E69B96"], // 曖
           "66DA":["9E43","DBA4","E69B9A"], // 曚
           "66E0":["9E44","DBA5","E69BA0"], // 曠
           "66E6":["9E46","DBA7","E69BA6"], // 曦
           "66E9":["9E47","DBA8","E69BA9"], // 曩
           "66F0":["9E48","DBA9","E69BB0"], // 曰
           "66F5":["9E49","DBAA","E69BB5"], // 曵
           "66F7":["9E4A","DBAB","E69BB7"], // 曷
           "66FC":["99D6","D2D8","E69BBC"], // 曼
           "6703":["98F0","D0F2","E69C83"], // 會
           "670F":["9E4B","DBAC","E69C8F"], // 朏
           "6716":["9E4C","DBAD","E69C96"], // 朖
           "671E":["9E4D","DBAE","E69C9E"], // 朞
           "6726":["9E4E","DBAF","E69CA6"], // 朦
           "6727":["9E4F","DBB0","E69CA7"], // 朧
           "672E":["9E51","DBB2","E69CAE"], // 朮
           "6736":["9E53","DBB4","E69CB6"], // 朶
           "6737":["9E56","DBB7","E69CB7"], // 朷
           "6738":["9E55","DBB6","E69CB8"], // 朸
           "673F":["9E52","DBB3","E69CBF"], // 朿
           "6741":["9E54","DBB5","E69D81"], // 杁
           "6746":["9E57","DBB8","E69D86"], // 杆
           "6759":["9E5A","DBBB","E69D99"], // 杙
           "675E":["9E58","DBB9","E69D9E"], // 杞
           "6760":["9E59","DBBA","E69DA0"], // 杠
           "6763":["9E5B","DBBC","E69DA3"], // 杣
           "6764":["9E5C","DBBD","E69DA4"], // 杤
           "676A":["9E61","DBC2","E69DAA"], // 杪
           "6770":["9E5E","DBBF","E69DB0"], // 杰
           "6772":["9DDC","DADE","E69DB2"], // 杲
           "6773":["9DE0","DAE2","E69DB3"], // 杳
           "677C":["9E60","DBC1","E69DBC"], // 杼
           "6785":["9E66","DBC7","E69E85"], // 枅
           "6789":["9E5D","DBBE","E69E89"], // 枉
           "678B":["9E63","DBC4","E69E8B"], // 枋
           "678C":["9E62","DBC3","E69E8C"], // 枌
           "67A1":["9E65","DBC6","E69EA1"], // 枡
           "67A6":["9E64","DBC5","E69EA6"], // 枦
           "67A9":["9E5F","DBC0","E69EA9"], // 枩
           "67B3":["9E6B","DBCC","E69EB3"], // 枳
           "67B4":["9E69","DBCA","E69EB4"], // 枴
           "67B7":["9E67","DBC8","E69EB7"], // 枷
           "67B8":["9E6D","DBCE","E69EB8"], // 枸
           "67B9":["9E73","DBD4","E69EB9"], // 枹
           "67C6":["9E75","DBD6","E69F86"], // 柆
           "67CE":["9E74","DBD5","E69F8E"], // 柎
           "67DD":["9E70","DBD1","E69F9D"], // 柝
           "67DE":["9E6F","DBD0","E69F9E"], // 柞
           "67E2":["9E71","DBD2","E69FA2"], // 柢
           "67E4":["9E6E","DBCF","E69FA4"], // 柤
           "67E7":["9E76","DBD7","E69FA7"], // 柧
           "67E9":["9E6C","DBCD","E69FA9"], // 柩
           "67EC":["9E6A","DBCB","E69FAC"], // 柬
           "67EE":["9E72","DBD3","E69FAE"], // 柮
           "67EF":["9E68","DBC9","E69FAF"], // 柯
           "681E":["9E78","DBD9","E6A09E"], // 栞
           "6829":["9E7A","DBDB","E6A0A9"], // 栩
           "682B":["9E81","DBE1","E6A0AB"], // 栫
           "6832":["9E7D","DBDE","E6A0B2"], // 栲
           "6840":["9E7B","DBDC","E6A180"], // 桀
           "6846":["9E79","DBDA","E6A186"], // 框
           "684D":["9E7C","DBDD","E6A18D"], // 桍
           "684E":["9E7E","DBDF","E6A18E"], // 桎
           "6859":["9E82","DBE2","E6A199"], // 桙
           "6863":["9E83","DBE3","E6A1A3"], // 档
           "6874":["9E8F","DBEF","E6A1B4"], // 桴
           "6877":["9E84","DBE4","E6A1B7"], // 桷
           "687E":["9E95","DBF5","E6A1BE"], // 桾
           "687F":["9E85","DBE5","E6A1BF"], // 桿
           "6883":["9E8C","DBEC","E6A283"], // 梃
           "688D":["9E94","DBF4","E6A28D"], // 梍
           "688F":["9E87","DBE7","E6A28F"], // 梏
           "6894":["9E89","DBE9","E6A294"], // 梔
           "689B":["9E8B","DBEB","E6A29B"], // 梛
           "689D":["9E8A","DBEA","E6A29D"], // 條
           "689F":["9E86","DBE6","E6A29F"], // 梟
           "68A0":["9E91","DBF1","E6A2A0"], // 梠
           "68A6":["9AEB","D4ED","E6A2A6"], // 梦
           "68AD":["9E88","DBE8","E6A2AD"], // 梭
           "68B3":["9E80","DBE0","E6A2B3"], // 梳
           "68B5":["9E90","DBF0","E6A2B5"], // 梵
           "68B9":["9E8E","DBEE","E6A2B9"], // 梹
           "68BA":["9E92","DBF2","E6A2BA"], // 梺
           "68C6":["9EB0","DCB2","E6A386"], // 棆
           "68CA":["9E97","DBF7","E6A38A"], // 棊
           "68CD":["9E9E","DBFE","E6A38D"], // 棍
           "68D4":["9E9F","DCA1","E6A394"], // 棔
           "68D5":["9EA1","DCA3","E6A395"], // 棕
           "68D7":["9EA5","DCA7","E6A397"], // 棗
           "68D8":["9E99","DBF9","E6A398"], // 棘
           "68E0":["9EA9","DCAB","E6A3A0"], // 棠
           "68E1":["9E9C","DBFC","E6A3A1"], // 棡
           "68E3":["9EA6","DCA8","E6A3A3"], // 棣
           "68E7":["9EA0","DCA2","E6A3A7"], // 棧
           "68EF":["9EAA","DCAC","E6A3AF"], // 棯
           "68F9":["9EA8","DCAA","E6A3B9"], // 棹
           "6901":["9E96","DBF6","E6A481"], // 椁
           "6904":["9EA4","DCA6","E6A484"], // 椄
           "6908":["9E98","DBF8","E6A488"], // 椈
           "690C":["9E9D","DBFD","E6A48C"], // 椌
           "690F":["9E93","DBF3","E6A48F"], // 椏
           "6912":["9EA3","DCA5","E6A492"], // 椒
           "691A":["9EAD","DCAF","E6A49A"], // 椚
           "6921":["9EAF","DCB1","E6A4A1"], // 椡
           "6922":["9E9A","DBFA","E6A4A2"], // 椢
           "6923":["9EAE","DCB0","E6A4A3"], // 椣
           "6925":["9EA7","DCA9","E6A4A5"], // 椥
           "6926":["9E9B","DBFB","E6A4A6"], // 椦
           "6928":["9EAB","DCAD","E6A4A8"], // 椨
           "692A":["9EAC","DCAE","E6A4AA"], // 椪
           "6930":["9EBD","DCBF","E6A4B0"], // 椰
           "6936":["9EA2","DCA4","E6A4B6"], // 椶
           "6939":["9EB9","DCBB","E6A4B9"], // 椹
           "693D":["9EBB","DCBD","E6A4BD"], // 椽
           "6954":["9EB6","DCB8","E6A594"], // 楔
           "6959":["9EBC","DCBE","E6A599"], // 楙
           "695C":["9EB3","DCB5","E6A59C"], // 楜
           "695D":["9EC0","DCC2","E6A59D"], // 楝
           "695E":["9EBF","DCC1","E6A59E"], // 楞
           "6961":["9EBE","DCC0","E6A5A1"], // 楡
           "696A":["9EC2","DCC4","E6A5AA"], // 楪
           "696B":["9EB5","DCB7","E6A5AB"], // 楫
           "696E":["9EB8","DCBA","E6A5AE"], // 楮
           "6974":["9EBA","DCBC","E6A5B4"], // 楴
           "6977":["9EB2","DCB4","E6A5B7"], // 楷
           "6978":["9EB4","DCB6","E6A5B8"], // 楸
           "6979":["9EB1","DCB3","E6A5B9"], // 楹
           "697E":["9EB7","DCB9","E6A5BE"], // 楾
           "6981":["9EC1","DCC3","E6A681"], // 榁
           "6991":["9ED2","DCD4","E6A691"], // 榑
           "6995":["9ED5","DCD7","E6A695"], // 榕
           "699C":["9ED4","DCD6","E6A69C"], // 榜
           "69A0":["9ED3","DCD5","E6A6A0"], // 榠
           "69A7":["9ED0","DCD2","E6A6A7"], // 榧
           "69AE":["9EC4","DCC6","E6A6AE"], // 榮
           "69B1":["9EE1","DCE3","E6A6B1"], // 榱
           "69B2":["9EC3","DCC5","E6A6B2"], // 榲
           "69B4":["9ED6","DCD8","E6A6B4"], // 榴
           "69BB":["9ECE","DCD0","E6A6BB"], // 榻
           "69BE":["9EC9","DCCB","E6A6BE"], // 榾
           "69BF":["9EC6","DCC8","E6A6BF"], // 榿
           "69C1":["9EC7","DCC9","E6A781"], // 槁
           "69C3":["9ECF","DCD1","E6A783"], // 槃
           "69C7":["EAA0","F4A2","E6A787"], // 槇
           "69CA":["9ECC","DCCE","E6A78A"], // 槊
           "69CE":["9ECA","DCCC","E6A78E"], // 槎
           "69D0":["9EC5","DCC7","E6A790"], // 槐
           "69D3":["9EC8","DCCA","E6A793"], // 槓
           "69DD":["9ECD","DCCF","E6A79D"], // 槝
           "69DE":["9ED7","DCD9","E6A79E"], // 槞
           "69E7":["9EDF","DCE1","E6A7A7"], // 槧
           "69E8":["9ED8","DCDA","E6A7A8"], // 槨
           "69EB":["9EE5","DCE7","E6A7AB"], // 槫
           "69ED":["9EE3","DCE5","E6A7AD"], // 槭
           "69F2":["9EDE","DCE0","E6A7B2"], // 槲
           "69F9":["9EDD","DCDF","E6A7B9"], // 槹
           "69FF":["9EDB","DCDD","E6A7BF"], // 槿
           "6A02":["9ED9","DCDB","E6A882"], // 樂
           "6A05":["9EE0","DCE2","E6A885"], // 樅
           "6A0A":["9EE6","DCE8","E6A88A"], // 樊
           "6A0C":["9EEC","DCEE","E6A88C"], // 樌
           "6A12":["9EE7","DCE9","E6A892"], // 樒
           "6A13":["9EEA","DCEC","E6A893"], // 樓
           "6A14":["9EE4","DCE6","E6A894"], // 樔
           "6A1B":["9EDA","DCDC","E6A89B"], // 樛
           "6A1E":["9EE2","DCE4","E6A89E"], // 樞
           "6A22":["9EF6","DCF8","E6A8A2"], // 樢
           "6A23":["9EE9","DCEB","E6A8A3"], // 樣
           "6A2E":["9ED1","DCD3","E6A8AE"], // 樮
           "6A36":["9EEE","DCF0","E6A8B6"], // 樶
           "6A38":["9EF5","DCF7","E6A8B8"], // 樸
           "6A44":["9EEB","DCED","E6A984"], // 橄
           "6A47":["9EF0","DCF2","E6A987"], // 橇
           "6A48":["9EF4","DCF6","E6A988"], // 橈
           "6A59":["9EF2","DCF4","E6A999"], // 橙
           "6A62":["9EF1","DCF3","E6A9A2"], // 橢
           "6A66":["9EF3","DCF5","E6A9A6"], // 橦
           "6A72":["9EED","DCEF","E6A9B2"], // 橲
           "6A78":["9EEF","DCF1","E6A9B8"], // 橸
           "6A84":["9EFA","DCFC","E6AA84"], // 檄
           "6A8D":["9EF8","DCFA","E6AA8D"], // 檍
           "6A90":["9EF7","DCF9","E6AA90"], // 檐
           "6A97":["9F40","DDA1","E6AA97"], // 檗
           "6A9C":["9E77","DBD8","E6AA9C"], // 檜
           "6AA0":["9EF9","DCFB","E6AAA0"], // 檠
           "6AA2":["9EFB","DCFD","E6AAA2"], // 檢
           "6AA3":["9EFC","DCFE","E6AAA3"], // 檣
           "6AAA":["9F4B","DDAC","E6AAAA"], // 檪
           "6AAC":["9F47","DDA8","E6AAAC"], // 檬
           "6AAE":["9E8D","DBED","E6AAAE"], // 檮
           "6AB3":["9F46","DDA7","E6AAB3"], // 檳
           "6AB8":["9F45","DDA6","E6AAB8"], // 檸
           "6ABB":["9F42","DDA3","E6AABB"], // 檻
           "6AC1":["9EE8","DCEA","E6AB81"], // 櫁
           "6AC2":["9F44","DDA5","E6AB82"], // 櫂
           "6AC3":["9F43","DDA4","E6AB83"], // 櫃
           "6AD1":["9F49","DDAA","E6AB91"], // 櫑
           "6ADA":["9F4C","DDAD","E6AB9A"], // 櫚
           "6ADE":["9F48","DDA9","E6AB9E"], // 櫞
           "6ADF":["9F4A","DDAB","E6AB9F"], // 櫟
           "6AEA":["9F4D","DDAE","E6ABAA"], // 櫪
           "6AFA":["9F51","DDB2","E6ABBA"], // 櫺
           "6AFB":["9F4E","DDAF","E6ABBB"], // 櫻
           "6B05":["9F4F","DDB0","E6AC85"], // 欅
           "6B0A":["9EDC","DCDE","E6AC8A"], // 權
           "6B12":["9F52","DDB3","E6AC92"], // 欒
           "6B16":["9F53","DDB4","E6AC96"], // 欖
           "6B1F":["9F55","DDB6","E6AC9F"], // 欟
           "6B37":["9F57","DDB8","E6ACB7"], // 欷
           "6B38":["9F56","DDB7","E6ACB8"], // 欸
           "6B39":["9F59","DDBA","E6ACB9"], // 欹
           "6B43":["9F5C","DDBD","E6AD83"], // 歃
           "6B47":["9F5B","DDBC","E6AD87"], // 歇
           "6B49":["9F5D","DDBE","E6AD89"], // 歉
           "6B50":["9F5E","DDBF","E6AD90"], // 歐
           "6B54":["9F60","DDC1","E6AD94"], // 歔
           "6B59":["9F5F","DDC0","E6AD99"], // 歙
           "6B5B":["9F61","DDC2","E6AD9B"], // 歛
           "6B5F":["9F62","DDC3","E6AD9F"], // 歟
           "6B61":["9F63","DDC4","E6ADA1"], // 歡
           "6B78":["9F64","DDC5","E6ADB8"], // 歸
           "6B79":["9F65","DDC6","E6ADB9"], // 歹
           "6B7F":["9F66","DDC7","E6ADBF"], // 歿
           "6B80":["9F67","DDC8","E6AE80"], // 殀
           "6B83":["9F69","DDCA","E6AE83"], // 殃
           "6B84":["9F68","DDC9","E6AE84"], // 殄
           "6B8D":["9F6A","DDCB","E6AE8D"], // 殍
           "6B95":["9F6C","DDCD","E6AE95"], // 殕
           "6B98":["9F6B","DDCC","E6AE98"], // 殘
           "6B9E":["9F6D","DDCE","E6AE9E"], // 殞
           "6BA4":["9F6E","DDCF","E6AEA4"], // 殤
           "6BAA":["9F6F","DDD0","E6AEAA"], // 殪
           "6BAB":["9F70","DDD1","E6AEAB"], // 殫
           "6BAF":["9F71","DDD2","E6AEAF"], // 殯
           "6BB1":["9F73","DDD4","E6AEB1"], // 殱
           "6BB2":["9F72","DDD3","E6AEB2"], // 殲
           "6BB3":["9F74","DDD5","E6AEB3"], // 殳
           "6BB7":["9F75","DDD6","E6AEB7"], // 殷
           "6BBC":["9F76","DDD7","E6AEBC"], // 殼
           "6BC0":["9ACA","D4CC","E6AF80"], // 毀
           "6BC6":["9F77","DDD8","E6AF86"], // 毆
           "6BCB":["9F78","DDD9","E6AF8B"], // 毋
           "6BD3":["9F79","DDDA","E6AF93"], // 毓
           "6BDF":["9F7A","DDDB","E6AF9F"], // 毟
           "6BEB":["9F7C","DDDD","E6AFAB"], // 毫
           "6BEC":["9F7B","DDDC","E6AFAC"], // 毬
           "6BEF":["9F7E","DDDF","E6AFAF"], // 毯
           "6BF3":["9F7D","DDDE","E6AFB3"], // 毳
           "6C08":["9F81","DDE1","E6B088"], // 氈
           "6C13":["9F82","DDE2","E6B093"], // 氓
           "6C14":["9F83","DDE3","E6B094"], // 气
           "6C1B":["9F84","DDE4","E6B09B"], // 氛
           "6C23":["9F86","DDE6","E6B0A3"], // 氣
           "6C24":["9F85","DDE5","E6B0A4"], // 氤
           "6C55":["9F88","DDE8","E6B195"], // 汕
           "6C5E":["9F87","DDE7","E6B19E"], // 汞
           "6C62":["9F89","DDE9","E6B1A2"], // 汢
           "6C68":["9F91","DDF1","E6B1A8"], // 汨
           "6C6A":["9F8A","DDEA","E6B1AA"], // 汪
           "6C73":["9F92","DDF2","E6B1B3"], // 汳
           "6C7E":["9F90","DDF0","E6B1BE"], // 汾
           "6C81":["9F8E","DDEE","E6B281"], // 沁
           "6C82":["9F8B","DDEB","E6B282"], // 沂
           "6C8D":["9F8C","DDEC","E6B28D"], // 沍
           "6C90":["9F94","DDF4","E6B290"], // 沐
           "6C92":["9F93","DDF3","E6B292"], // 沒
           "6C9A":["9F8D","DDED","E6B29A"], // 沚
           "6C9B":["9F8F","DDEF","E6B29B"], // 沛
           "6CAE":["9F9C","DDFC","E6B2AE"], // 沮
           "6CB1":["9F9D","DDFD","E6B2B1"], // 沱
           "6CBA":["9F9F","DEA1","E6B2BA"], // 沺
           "6CBD":["9F98","DDF8","E6B2BD"], // 沽
           "6CBE":["9F9E","DDFE","E6B2BE"], // 沾
           "6CC4":["9F95","DDF5","E6B384"], // 泄
           "6CC5":["9F9A","DDFA","E6B385"], // 泅
           "6CD3":["9F97","DDF7","E6B393"], // 泓
           "6CD7":["9F99","DDF9","E6B397"], // 泗
           "6CD9":["9FA2","DEA4","E6B399"], // 泙
           "6CDB":["9FA0","DEA2","E6B39B"], // 泛
           "6CDD":["9F9B","DDFB","E6B39D"], // 泝
           "6CEA":["9FA3","DEA5","E6B3AA"], // 泪
           "6CEF":["9FA1","DEA3","E6B3AF"], // 泯
           "6CF1":["9F96","DDF6","E6B3B1"], // 泱
           "6D0C":["9FAE","DEB0","E6B48C"], // 洌
           "6D12":["9FAD","DEAF","E6B492"], // 洒
           "6D19":["9FAA","DEAC","E6B499"], // 洙
           "6D1F":["9FA4","DEA6","E6B49F"], // 洟
           "6D2B":["9FA7","DEA9","E6B4AB"], // 洫
           "6D33":["9FAC","DEAE","E6B4B3"], // 洳
           "6D35":["9FAB","DEAD","E6B4B5"], // 洵
           "6D36":["9FA6","DEA8","E6B4B6"], // 洶
           "6D38":["9FA9","DEAB","E6B4B8"], // 洸
           "6D3D":["9FA8","DEAA","E6B4BD"], // 洽
           "6D59":["9FB4","DEB6","E6B599"], // 浙
           "6D5A":["9FB2","DEB4","E6B59A"], // 浚
           "6D63":["9FAF","DEB1","E6B5A3"], // 浣
           "6D64":["9FB1","DEB3","E6B5A4"], // 浤
           "6D79":["9FB3","DEB5","E6B5B9"], // 浹
           "6D85":["9FB8","DEBA","E6B685"], // 涅
           "6D8E":["9FB5","DEB7","E6B68E"], // 涎
           "6D93":["9FB0","DEB2","E6B693"], // 涓
           "6D95":["9FB6","DEB8","E6B695"], // 涕
           "6DB5":["9FBC","DEBE","E6B6B5"], // 涵
           "6DB8":["9FBF","DEC1","E6B6B8"], // 涸
           "6DC5":["9FC6","DEC8","E6B785"], // 淅
           "6DC6":["9FC0","DEC2","E6B786"], // 淆
           "6DC7":["9FBD","DEBF","E6B787"], // 淇
           "6DCC":["9FC3","DEC5","E6B78C"], // 淌
           "6DD2":["9FC5","DEC7","E6B792"], // 淒
           "6DD5":["9FCA","DECC","E6B795"], // 淕
           "6DD9":["9FC8","DECA","E6B799"], // 淙
           "6DDE":["9FC2","DEC4","E6B79E"], // 淞
           "6DE4":["9FC9","DECB","E6B7A4"], // 淤
           "6DE6":["9FBE","DEC0","E6B7A6"], // 淦
           "6DE8":["9FC4","DEC6","E6B7A8"], // 淨
           "6DEA":["9FCB","DECD","E6B7AA"], // 淪
           "6DEC":["9FC1","DEC3","E6B7AC"], // 淬
           "6DEE":["9FCC","DECE","E6B7AE"], // 淮
           "6DF9":["9FB9","DEBB","E6B7B9"], // 淹
           "6DFA":["9FC7","DEC9","E6B7BA"], // 淺
           "6E0A":["9FBB","DEBD","E6B88A"], // 渊
           "6E15":["9FBA","DEBC","E6B895"], // 渕
           "6E19":["9FD0","DED2","E6B899"], // 渙
           "6E1D":["9FDF","DEE1","E6B89D"], // 渝
           "6E1F":["9FD9","DEDB","E6B89F"], // 渟
           "6E23":["9FD4","DED6","E6B8A3"], // 渣
           "6E24":["9FDD","DEDF","E6B8A4"], // 渤
           "6E2B":["9FD6","DED8","E6B8AB"], // 渫
           "6E2D":["9FCD","DECF","E6B8AD"], // 渭
           "6E2E":["9FCF","DED1","E6B8AE"], // 渮
           "6E38":["9FE0","DEE2","E6B8B8"], // 游
           "6E3A":["9FDB","DEDD","E6B8BA"], // 渺
           "6E3E":["9FD3","DED5","E6B8BE"], // 渾
           "6E43":["9FDA","DEDC","E6B983"], // 湃
           "6E4D":["9FD8","DEDA","E6B98D"], // 湍
           "6E4E":["9FDC","DEDE","E6B98E"], // 湎
           "6E5F":["9FD2","DED4","E6B99F"], // 湟
           "6E6B":["9FD5","DED7","E6B9AB"], // 湫
           "6E6E":["9FCE","DED0","E6B9AE"], // 湮
           "6E72":["9FD1","DED3","E6B9B2"], // 湲
           "6E76":["9FD7","DED9","E6B9B6"], // 湶
           "6E82":["9FE1","DEE3","E6BA82"], // 溂
           "6E8F":["9FED","DEEF","E6BA8F"], // 溏
           "6E98":["9FE3","DEE5","E6BA98"], // 溘
           "6E9F":["9FF0","DEF2","E6BA9F"], // 溟
           "6EA5":["9FEE","DEF0","E6BAA5"], // 溥
           "6EAA":["9FE2","DEE4","E6BAAA"], // 溪
           "6EAF":["9FE8","DEEA","E6BAAF"], // 溯
           "6EB2":["9FEA","DEEC","E6BAB2"], // 溲
           "6EB7":["9FE5","DEE7","E6BAB7"], // 溷
           "6EBD":["9FE7","DEE9","E6BABD"], // 溽
           "6EC2":["9FEF","DEF1","E6BB82"], // 滂
           "6EC4":["9FE9","DEEB","E6BB84"], // 滄
           "6EC9":["9FE4","DEE6","E6BB89"], // 滉
           "6ECC":["9FFC","DEFE","E6BB8C"], // 滌
           "6ED3":["9FE6","DEE8","E6BB93"], // 滓
           "6ED4":["9FEB","DEED","E6BB94"], // 滔
           "6ED5":["9FEC","DEEE","E6BB95"], // 滕
           "6EEC":["9FF4","DEF6","E6BBAC"], // 滬
           "6EEF":["9FFA","DEFC","E6BBAF"], // 滯
           "6EF2":["9FF8","DEFA","E6BBB2"], // 滲
           "6EF7":["E042","DFA3","E6BBB7"], // 滷
           "6EF8":["9FF5","DEF7","E6BBB8"], // 滸
           "6EFE":["9FF6","DEF8","E6BBBE"], // 滾
           "6EFF":["9FDE","DEE0","E6BBBF"], // 滿
           "6F11":["9FF2","DEF4","E6BC91"], // 漑
           "6F13":["E041","DFA2","E6BC93"], // 漓
           "6F31":["9FF9","DEFB","E6BCB1"], // 漱
           "6F32":["9FFB","DEFD","E6BCB2"], // 漲
           "6F3E":["E040","DFA1","E6BCBE"], // 漾
           "6F3F":["9FF7","DEF9","E6BCBF"], // 漿
           "6F41":["9FF1","DEF3","E6BD81"], // 潁
           "6F58":["E04E","DFAF","E6BD98"], // 潘
           "6F5B":["E049","DFAA","E6BD9B"], // 潛
           "6F66":["E052","DFB3","E6BDA6"], // 潦
           "6F6D":["E04B","DFAC","E6BDAD"], // 潭
           "6F6F":["E048","DFA9","E6BDAF"], // 潯
           "6F74":["E06B","DFCC","E6BDB4"], // 潴
           "6F78":["E045","DFA6","E6BDB8"], // 潸
           "6F7A":["E044","DFA5","E6BDBA"], // 潺
           "6F7C":["E04D","DFAE","E6BDBC"], // 潼
           "6F80":["E047","DFA8","E6BE80"], // 澀
           "6F81":["E046","DFA7","E6BE81"], // 澁
           "6F82":["E04C","DFAD","E6BE82"], // 澂
           "6F86":["E043","DFA4","E6BE86"], // 澆
           "6F8E":["E04F","DFB0","E6BE8E"], // 澎
           "6F91":["E050","DFB1","E6BE91"], // 澑
           "6FA1":["E055","DFB6","E6BEA1"], // 澡
           "6FA3":["E054","DFB5","E6BEA3"], // 澣
           "6FA4":["E056","DFB7","E6BEA4"], // 澤
           "6FAA":["E059","DFBA","E6BEAA"], // 澪
           "6FB3":["E053","DFB4","E6BEB3"], // 澳
           "6FB9":["E057","DFB8","E6BEB9"], // 澹
           "6FC2":["E051","DFB2","E6BF82"], // 濂
           "6FC6":["E058","DFB9","E6BF86"], // 濆
           "6FD4":["E05D","DFBE","E6BF94"], // 濔
           "6FD5":["E05B","DFBC","E6BF95"], // 濕
           "6FD8":["E05E","DFBF","E6BF98"], // 濘
           "6FDB":["E061","DFC2","E6BF9B"], // 濛
           "6FDF":["E05A","DFBB","E6BF9F"], // 濟
           "6FE4":["9FB7","DEB9","E6BFA4"], // 濤
           "6FEC":["E05C","DFBD","E6BFAC"], // 濬
           "6FEE":["E060","DFC1","E6BFAE"], // 濮
           "6FF1":["E05F","DFC0","E6BFB1"], // 濱
           "6FF3":["E04A","DFAB","E6BFB3"], // 濳
           "6FF6":["E889","EFE9","E6BFB6"], // 濶
           "6FFA":["E064","DFC5","E6BFBA"], // 濺
           "6FFE":["E068","DFC9","E6BFBE"], // 濾
           "7001":["E066","DFC7","E78081"], // 瀁
           "7009":["E062","DFC3","E78089"], // 瀉
           "700B":["E063","DFC4","E7808B"], // 瀋
           "700F":["E067","DFC8","E7808F"], // 瀏
           "7011":["E065","DFC6","E78091"], // 瀑
           "7018":["E06D","DFCE","E78098"], // 瀘
           "701A":["E06A","DFCB","E7809A"], // 瀚
           "701B":["E069","DFCA","E7809B"], // 瀛
           "701D":["E06C","DFCD","E7809D"], // 瀝
           "701F":["E06E","DFCF","E7809F"], // 瀟
           "7030":["E06F","DFD0","E780B0"], // 瀰
           "7032":["E071","DFD2","E780B2"], // 瀲
           "703E":["E070","DFD1","E780BE"], // 瀾
           "704C":["9FF3","DEF5","E7818C"], // 灌
           "7051":["E072","DFD3","E78191"], // 灑
           "7063":["E073","DFD4","E781A3"], // 灣
           "7092":["E075","DFD6","E78292"], // 炒
           "7099":["E074","DFD5","E78299"], // 炙
           "70AC":["E078","DFD9","E782AC"], // 炬
           "70AE":["E07B","DFDC","E782AE"], // 炮
           "70AF":["E076","DFD7","E782AF"], // 炯
           "70B3":["E07A","DFDB","E782B3"], // 炳
           "70B8":["E079","DFDA","E782B8"], // 炸
           "70CB":["E07D","DFDE","E7838B"], // 烋
           "70D9":["E080","DFE0","E78399"], // 烙
           "70DD":["E07E","DFDF","E7839D"], // 烝
           "70DF":["E07C","DFDD","E7839F"], // 烟
           "70F1":["E077","DFD8","E783B1"], // 烱
           "70FD":["E082","DFE2","E783BD"], // 烽
           "7109":["E081","DFE1","E78489"], // 焉
           "7119":["E084","DFE4","E78499"], // 焙
           "711C":["E083","DFE3","E7849C"], // 焜
           "714C":["E08A","DFEA","E7858C"], // 煌
           "7155":["E086","DFE6","E78595"], // 煕
           "7156":["E08B","DFEB","E78596"], // 煖
           "7162":["E089","DFE9","E785A2"], // 煢
           "7165":["E085","DFE5","E785A5"], // 煥
           "7166":["E088","DFE8","E785A6"], // 煦
           "716C":["E08C","DFEC","E785AC"], // 煬
           "7184":["E08F","DFEF","E78684"], // 熄
           "7188":["E087","DFE7","E78688"], // 熈
           "718F":["E08D","DFED","E7868F"], // 熏
           "7195":["E090","DFF0","E78695"], // 熕
           "7199":["EAA4","F4A6","E78699"], // 熙
           "71A8":["E091","DFF1","E786A8"], // 熨
           "71AC":["E092","DFF2","E786AC"], // 熬
           "71B9":["E094","DFF4","E786B9"], // 熹
           "71BE":["E095","DFF5","E786BE"], // 熾
           "71C9":["E097","DFF7","E78789"], // 燉
           "71CE":["E099","DFF9","E7878E"], // 燎
           "71D2":["E096","DFF6","E78792"], // 燒
           "71D4":["E098","DFF8","E78794"], // 燔
           "71D7":["E093","DFF3","E78797"], // 燗
           "71DF":["9A7A","D3DB","E7879F"], // 營
           "71E0":["E09A","DFFA","E787A0"], // 燠
           "71E7":["E09C","DFFC","E787A7"], // 燧
           "71EC":["E09B","DFFB","E787AC"], // 燬
           "71EE":["99D7","D2D9","E787AE"], // 燮
           "71F5":["E09D","DFFD","E787B5"], // 燵
           "71F9":["E09F","E0A1","E787B9"], // 燹
           "71FB":["E08E","DFEE","E787BB"], // 燻
           "71FC":["E09E","DFFE","E787BC"], // 燼
           "71FF":["E0A0","E0A2","E787BF"], // 燿
           "720D":["E0A1","E0A3","E7888D"], // 爍
           "7210":["E0A2","E0A4","E78890"], // 爐
           "721B":["E0A3","E0A5","E7889B"], // 爛
           "7228":["E0A4","E0A6","E788A8"], // 爨
           "722C":["E0A6","E0A8","E788AC"], // 爬
           "722D":["E0A5","E0A7","E788AD"], // 爭
           "7230":["E0A7","E0A9","E788B0"], // 爰
           "7232":["E0A8","E0AA","E788B2"], // 爲
           "723B":["E0A9","E0AB","E788BB"], // 爻
           "723C":["E0AA","E0AC","E788BC"], // 爼
           "723F":["E0AB","E0AD","E788BF"], // 爿
           "7240":["E0AC","E0AE","E78980"], // 牀
           "7246":["E0AD","E0AF","E78986"], // 牆
           "724B":["E0AE","E0B0","E7898B"], // 牋
           "7258":["E0AF","E0B1","E78998"], // 牘
           "7274":["E0B0","E0B2","E789B4"], // 牴
           "727E":["E0B1","E0B3","E789BE"], // 牾
           "7281":["E0B3","E0B5","E78A81"], // 犁
           "7282":["E0B2","E0B4","E78A82"], // 犂
           "7287":["E0B4","E0B6","E78A87"], // 犇
           "7292":["E0B5","E0B7","E78A92"], // 犒
           "7296":["E0B6","E0B8","E78A96"], // 犖
           "72A2":["E0B7","E0B9","E78AA2"], // 犢
           "72A7":["E0B8","E0BA","E78AA7"], // 犧
           "72B2":["E0BA","E0BC","E78AB2"], // 犲
           "72B9":["E0B9","E0BB","E78AB9"], // 犹
           "72C3":["E0BB","E0BD","E78B83"], // 狃
           "72C4":["E0BD","E0BF","E78B84"], // 狄
           "72C6":["E0BC","E0BE","E78B86"], // 狆
           "72CE":["E0BE","E0C0","E78B8E"], // 狎
           "72D2":["E0BF","E0C1","E78B92"], // 狒
           "72E0":["E0C1","E0C3","E78BA0"], // 狠
           "72E1":["E0C2","E0C4","E78BA1"], // 狡
           "72E2":["E0C0","E0C2","E78BA2"], // 狢
           "72F7":["E0C4","E0C6","E78BB7"], // 狷
           "72F9":["E0C3","E0C5","E78BB9"], // 狹
           "730A":["E0C7","E0C9","E78C8A"], // 猊
           "7316":["E0C9","E0CB","E78C96"], // 猖
           "7317":["E0C6","E0C8","E78C97"], // 猗
           "731C":["E0C8","E0CA","E78C9C"], // 猜
           "731D":["E0CA","E0CC","E78C9D"], // 猝
           "7325":["E0CE","E0D0","E78CA5"], // 猥
           "7329":["E0CD","E0CF","E78CA9"], // 猩
           "732F":["E0CC","E0CE","E78CAF"], // 猯
           "7334":["E0CB","E0CD","E78CB4"], // 猴
           "733E":["E0CF","E0D1","E78CBE"], // 猾
           "734E":["E0D0","E0D2","E78D8E"], // 獎
           "734F":["E0D1","E0D3","E78D8F"], // 獏
           "7357":["E0D3","E0D5","E78D97"], // 獗
           "7368":["E0D5","E0D7","E78DA8"], // 獨
           "736A":["E0D4","E0D6","E78DAA"], // 獪
           "7370":["E0D6","E0D8","E78DB0"], // 獰
           "7375":["E0D8","E0DA","E78DB5"], // 獵
           "7378":["E0D7","E0D9","E78DB8"], // 獸
           "737A":["E0DA","E0DC","E78DBA"], // 獺
           "737B":["E0D9","E0DB","E78DBB"], // 獻
           "73B3":["E0DC","E0DE","E78EB3"], // 玳
           "73BB":["E0DE","E0E0","E78EBB"], // 玻
           "73C0":["E0DF","E0E1","E78F80"], // 珀
           "73C8":["E0DB","E0DD","E78F88"], // 珈
           "73CE":["E0DD","E0DF","E78F8E"], // 珎
           "73DE":["E0E2","E0E4","E78F9E"], // 珞
           "73E5":["E0E0","E0E2","E78FA5"], // 珥
           "73EE":["E0E1","E0E3","E78FAE"], // 珮
           "73F1":["E0FC","E0FE","E78FB1"], // 珱
           "73F8":["E0E7","E0E9","E78FB8"], // 珸
           "7405":["E0E4","E0E6","E79085"], // 琅
           "7425":["E0E6","E0E8","E790A5"], // 琥
           "7432":["E0E8","E0EA","E790B2"], // 琲
           "743A":["E0E9","E0EB","E790BA"], // 琺
           "743F":["E0EB","E0ED","E790BF"], // 琿
           "7441":["E0EE","E0F0","E79181"], // 瑁
           "7455":["E0EA","E0EC","E79195"], // 瑕
           "7459":["E0ED","E0EF","E79199"], // 瑙
           "745C":["E0EF","E0F1","E7919C"], // 瑜
           "745F":["E0EC","E0EE","E7919F"], // 瑟
           "7463":["E0F2","E0F4","E791A3"], // 瑣
           "7464":["EAA2","F4A4","E791A4"], // 瑤
           "7469":["E0F0","E0F2","E791A9"], // 瑩
           "746A":["E0F3","E0F5","E791AA"], // 瑪
           "746F":["E0E5","E0E7","E791AF"], // 瑯
           "7470":["E0F1","E0F3","E791B0"], // 瑰
           "7476":["E0F4","E0F6","E791B6"], // 瑶
           "747E":["E0F5","E0F7","E791BE"], // 瑾
           "748B":["E0F6","E0F8","E7928B"], // 璋
           "749E":["E0F7","E0F9","E7929E"], // 璞
           "74A2":["E0E3","E0E5","E792A2"], // 璢
           "74A7":["E0F8","E0FA","E792A7"], // 璧
           "74CA":["E0F9","E0FB","E7938A"], // 瓊
           "74CF":["E0FA","E0FC","E7938F"], // 瓏
           "74D4":["E0FB","E0FD","E79394"], // 瓔
           "74E0":["E140","E1A1","E793A0"], // 瓠
           "74E3":["E141","E1A2","E793A3"], // 瓣
           "74E7":["E142","E1A3","E793A7"], // 瓧
           "74E9":["E143","E1A4","E793A9"], // 瓩
           "74EE":["E144","E1A5","E793AE"], // 瓮
           "74F0":["E146","E1A7","E793B0"], // 瓰
           "74F1":["E147","E1A8","E793B1"], // 瓱
           "74F2":["E145","E1A6","E793B2"], // 瓲
           "74F7":["E149","E1AA","E793B7"], // 瓷
           "74F8":["E148","E1A9","E793B8"], // 瓸
           "7503":["E14B","E1AC","E79483"], // 甃
           "7504":["E14A","E1AB","E79484"], // 甄
           "7505":["E14C","E1AD","E79485"], // 甅
           "750C":["E14D","E1AE","E7948C"], // 甌
           "750D":["E14F","E1B0","E7948D"], // 甍
           "750E":["E14E","E1AF","E7948E"], // 甎
           "7513":["E151","E1B2","E79493"], // 甓
           "7515":["E150","E1B1","E79495"], // 甕
           "751E":["E152","E1B3","E7949E"], // 甞
           "7526":["E153","E1B4","E794A6"], // 甦
           "752C":["E154","E1B5","E794AC"], // 甬
           "7538":["99B2","D2B4","E794B8"], // 甸
           "753C":["E155","E1B6","E794BC"], // 甼
           "7544":["E156","E1B7","E79584"], // 畄
           "7546":["E15B","E1BC","E79586"], // 畆
           "7549":["E159","E1BA","E79589"], // 畉
           "754A":["E158","E1B9","E7958A"], // 畊
           "754B":["9DC0","DAC2","E7958B"], // 畋
           "754D":["E157","E1B8","E7958D"], // 畍
           "755A":["E15C","E1BD","E7959A"], // 畚
           "755B":["E15A","E1BB","E7959B"], // 畛
           "7564":["E15E","E1BF","E795A4"], // 畤
           "7567":["E15F","E1C0","E795A7"], // 畧
           "7569":["E15D","E1BE","E795A9"], // 畩
           "756B":["E160","E1C1","E795AB"], // 畫
           "756D":["E161","E1C2","E795AD"], // 畭
           "7574":["E166","E1C7","E795B4"], // 畴
           "7576":["E163","E1C4","E795B6"], // 當
           "7578":["E162","E1C3","E795B8"], // 畸
           "7582":["E169","E1CA","E79682"], // 疂
           "7586":["E164","E1C5","E79686"], // 疆
           "7587":["E165","E1C6","E79687"], // 疇
           "7589":["E168","E1C9","E79689"], // 疉
           "758A":["E167","E1C8","E7968A"], // 疊
           "7594":["E16A","E1CB","E79694"], // 疔
           "759A":["E16B","E1CC","E7969A"], // 疚
           "759D":["E16C","E1CD","E7969D"], // 疝
           "75A3":["E16E","E1CF","E796A3"], // 疣
           "75A5":["E16D","E1CE","E796A5"], // 疥
           "75B1":["E176","E1D7","E796B1"], // 疱
           "75B3":["E170","E1D1","E796B3"], // 疳
           "75B5":["E172","E1D3","E796B5"], // 疵
           "75B8":["E174","E1D5","E796B8"], // 疸
           "75BC":["E175","E1D6","E796BC"], // 疼
           "75BD":["E173","E1D4","E796BD"], // 疽
           "75C2":["E16F","E1D0","E79782"], // 痂
           "75C3":["E171","E1D2","E79783"], // 痃
           "75CA":["E178","E1D9","E7978A"], // 痊
           "75CD":["E177","E1D8","E7978D"], // 痍
           "75D2":["E179","E1DA","E79792"], // 痒
           "75D9":["E17A","E1DB","E79799"], // 痙
           "75DE":["E17C","E1DD","E7979E"], // 痞
           "75E3":["E17B","E1DC","E797A3"], // 痣
           "75F0":["E182","E1E2","E797B0"], // 痰
           "75F2":["E184","E1E4","E797B2"], // 痲
           "75F3":["E185","E1E5","E797B3"], // 痳
           "75FA":["E183","E1E3","E797BA"], // 痺
           "75FC":["E180","E1E0","E797BC"], // 痼
           "75FE":["E17D","E1DE","E797BE"], // 痾
           "75FF":["E17E","E1DF","E797BF"], // 痿
           "7601":["E181","E1E1","E79881"], // 瘁
           "7609":["E188","E1E8","E79889"], // 瘉
           "760B":["E186","E1E6","E7988B"], // 瘋
           "760D":["E187","E1E7","E7988D"], // 瘍
           "761F":["E189","E1E9","E7989F"], // 瘟
           "7620":["E18B","E1EB","E798A0"], // 瘠
           "7621":["E18C","E1EC","E798A1"], // 瘡
           "7622":["E18D","E1ED","E798A2"], // 瘢
           "7624":["E18E","E1EE","E798A4"], // 瘤
           "7627":["E18A","E1EA","E798A7"], // 瘧
           "7630":["E190","E1F0","E798B0"], // 瘰
           "7634":["E18F","E1EF","E798B4"], // 瘴
           "763B":["E191","E1F1","E798BB"], // 瘻
           "7646":["E194","E1F4","E79986"], // 癆
           "7647":["E192","E1F2","E79987"], // 癇
           "7648":["E193","E1F3","E79988"], // 癈
           "7658":["E196","E1F6","E79998"], // 癘
           "765C":["E195","E1F5","E7999C"], // 癜
           "7661":["E197","E1F7","E799A1"], // 癡
           "7662":["E198","E1F8","E799A2"], // 癢
           "7667":["E19C","E1FC","E799A7"], // 癧
           "7668":["E199","E1F9","E799A8"], // 癨
           "7669":["E19A","E1FA","E799A9"], // 癩
           "766A":["E19B","E1FB","E799AA"], // 癪
           "766C":["E19D","E1FD","E799AC"], // 癬
           "7670":["E19E","E1FE","E799B0"], // 癰
           "7672":["E19F","E2A1","E799B2"], // 癲
           "7676":["E1A0","E2A2","E799B6"], // 癶
           "7678":["E1A1","E2A3","E799B8"], // 癸
           "767C":["E1A2","E2A4","E799BC"], // 發
           "7680":["E1A3","E2A5","E79A80"], // 皀
           "7683":["E1A4","E2A6","E79A83"], // 皃
           "7688":["E1A5","E2A7","E79A88"], // 皈
           "768B":["E1A6","E2A8","E79A8B"], // 皋
           "768E":["E1A7","E2A9","E79A8E"], // 皎
           "7693":["E1A9","E2AB","E79A93"], // 皓
           "7696":["E1A8","E2AA","E79A96"], // 皖
           "7699":["E1AA","E2AC","E79A99"], // 皙
           "769A":["E1AB","E2AD","E79A9A"], // 皚
           "76B0":["E1AC","E2AE","E79AB0"], // 皰
           "76B4":["E1AD","E2AF","E79AB4"], // 皴
           "76B7":["EA89","F3E9","E79AB7"], // 皷
           "76B8":["E1AE","E2B0","E79AB8"], // 皸
           "76B9":["E1AF","E2B1","E79AB9"], // 皹
           "76BA":["E1B0","E2B2","E79ABA"], // 皺
           "76C2":["E1B1","E2B3","E79B82"], // 盂
           "76CD":["E1B2","E2B4","E79B8D"], // 盍
           "76D2":["E1B4","E2B6","E79B92"], // 盒
           "76D6":["E1B3","E2B5","E79B96"], // 盖
           "76DC":["9F58","DDB9","E79B9C"], // 盜
           "76DE":["E1B5","E2B7","E79B9E"], // 盞
           "76E1":["E1B6","E2B8","E79BA1"], // 盡
           "76E5":["E1B7","E2B9","E79BA5"], // 盥
           "76E7":["E1B8","E2BA","E79BA7"], // 盧
           "76EA":["E1B9","E2BB","E79BAA"], // 盪
           "76FB":["E1BB","E2BD","E79BBB"], // 盻
           "7704":["E1BE","E2C0","E79C84"], // 眄
           "7707":["E1BD","E2BF","E79C87"], // 眇
           "7708":["E1BC","E2BE","E79C88"], // 眈
           "771B":["E1C4","E2C6","E79C9B"], // 眛
           "771E":["E1C1","E2C3","E79C9E"], // 眞
           "7724":["E1C0","E2C2","E79CA4"], // 眤
           "7725":["E1C2","E2C4","E79CA5"], // 眥
           "7726":["E1C3","E2C5","E79CA6"], // 眦
           "7729":["E1BF","E2C1","E79CA9"], // 眩
           "7737":["E1C5","E2C7","E79CB7"], // 眷
           "7738":["E1C6","E2C8","E79CB8"], // 眸
           "7747":["E1C7","E2C9","E79D87"], // 睇
           "775A":["E1C8","E2CA","E79D9A"], // 睚
           "775B":["E1CB","E2CD","E79D9B"], // 睛
           "7765":["E1CC","E2CE","E79DA5"], // 睥
           "7768":["E1C9","E2CB","E79DA8"], // 睨
           "776B":["E1CA","E2CC","E79DAB"], // 睫
           "7779":["E1CF","E2D1","E79DB9"], // 睹
           "777E":["E1CE","E2D0","E79DBE"], // 睾
           "777F":["E1CD","E2CF","E79DBF"], // 睿
           "778B":["E1D1","E2D3","E79E8B"], // 瞋
           "778E":["E1D0","E2D2","E79E8E"], // 瞎
           "7791":["E1D2","E2D4","E79E91"], // 瞑
           "779E":["E1D4","E2D6","E79E9E"], // 瞞
           "77A0":["E1D3","E2D5","E79EA0"], // 瞠
           "77B0":["E1D5","E2D7","E79EB0"], // 瞰
           "77B6":["E1D6","E2D8","E79EB6"], // 瞶
           "77B9":["E1D7","E2D9","E79EB9"], // 瞹
           "77BB":["E1DB","E2DD","E79EBB"], // 瞻
           "77BC":["E1D9","E2DB","E79EBC"], // 瞼
           "77BD":["E1DA","E2DC","E79EBD"], // 瞽
           "77BF":["E1D8","E2DA","E79EBF"], // 瞿
           "77C7":["E1DC","E2DE","E79F87"], // 矇
           "77CD":["E1DD","E2DF","E79F8D"], // 矍
           "77D7":["E1DE","E2E0","E79F97"], // 矗
           "77DA":["E1DF","E2E1","E79F9A"], // 矚
           "77DC":["E1E0","E2E2","E79F9C"], // 矜
           "77E3":["E1E1","E2E3","E79FA3"], // 矣
           "77EE":["E1E2","E2E4","E79FAE"], // 矮
           "77FC":["E1E3","E2E5","E79FBC"], // 矼
           "780C":["E1E4","E2E6","E7A08C"], // 砌
           "7812":["E1E5","E2E7","E7A092"], // 砒
           "7820":["E1E7","E2E9","E7A0A0"], // 砠
           "7845":["E1E9","E2EB","E7A185"], // 硅
           "7874":["E1EB","E2ED","E7A1B4"], // 硴
           "787C":["E1ED","E2EF","E7A1BC"], // 硼
           "7886":["E1EC","E2EE","E7A286"], // 碆
           "788C":["E1EF","E2F1","E7A28C"], // 碌
           "788E":["E1EA","E2EC","E7A28E"], // 碎
           "789A":["E1EE","E2F0","E7A29A"], // 碚
           "78A3":["E1F0","E2F2","E7A2A3"], // 碣
           "78AA":["E1F2","E2F4","E7A2AA"], // 碪
           "78AF":["E1F3","E2F5","E7A2AF"], // 碯
           "78B5":["E1F1","E2F3","E7A2B5"], // 碵
           "78BC":["E1F9","E2FB","E7A2BC"], // 碼
           "78BE":["E1F8","E2FA","E7A2BE"], // 碾
           "78C5":["E1FA","E2FC","E7A385"], // 磅
           "78C6":["E1F5","E2F7","E7A386"], // 磆
           "78CA":["E1FB","E2FD","E7A38A"], // 磊
           "78CB":["E1F6","E2F8","E7A38B"], // 磋
           "78D1":["E1F4","E2F6","E7A391"], // 磑
           "78D4":["E1F7","E2F9","E7A394"], // 磔
           "78DA":["E241","E3A2","E7A39A"], // 磚
           "78E7":["E240","E3A1","E7A3A7"], // 磧
           "78EC":["E1FC","E2FE","E7A3AC"], // 磬
           "78F4":["E243","E3A4","E7A3B4"], // 磴
           "78FD":["E242","E3A3","E7A3BD"], // 磽
           "7907":["E244","E3A5","E7A487"], // 礇
           "7911":["E246","E3A7","E7A491"], // 礑
           "7912":["E245","E3A6","E7A492"], // 礒
           "7919":["E247","E3A8","E7A499"], // 礙
           "7926":["E1E6","E2E8","E7A4A6"], // 礦
           "792A":["E1E8","E2EA","E7A4AA"], // 礪
           "792B":["E249","E3AA","E7A4AB"], // 礫
           "792C":["E248","E3A9","E7A4AC"], // 礬
           "7940":["E24A","E3AB","E7A580"], // 祀
           "7953":["E250","E3B1","E7A593"], // 祓
           "7955":["E24F","E3B0","E7A595"], // 祕
           "7957":["E24C","E3AD","E7A597"], // 祗
           "795A":["E24E","E3AF","E7A59A"], // 祚
           "795F":["E24D","E3AE","E7A59F"], // 祟
           "7960":["E24B","E3AC","E7A5A0"], // 祠
           "797A":["E251","E3B2","E7A5BA"], // 祺
           "797F":["E252","E3B3","E7A5BF"], // 祿
           "7980":["E268","E3C9","E7A680"], // 禀
           "798A":["E253","E3B4","E7A68A"], // 禊
           "799D":["E254","E3B5","E7A69D"], // 禝
           "79A7":["E255","E3B6","E7A6A7"], // 禧
           "79AA":["E257","E3B8","E7A6AA"], // 禪
           "79AE":["E258","E3B9","E7A6AE"], // 禮
           "79B3":["E259","E3BA","E7A6B3"], // 禳
           "79B9":["E25A","E3BB","E7A6B9"], // 禹
           "79BA":["E25B","E3BC","E7A6BA"], // 禺
           "79C9":["E25C","E3BD","E7A789"], // 秉
           "79D5":["E25D","E3BE","E7A795"], // 秕
           "79E1":["E260","E3C1","E7A7A1"], // 秡
           "79E3":["E261","E3C2","E7A7A3"], // 秣
           "79E7":["E25E","E3BF","E7A7A7"], // 秧
           "79EC":["E25F","E3C0","E7A7AC"], // 秬
           "7A08":["E262","E3C3","E7A888"], // 稈
           "7A0D":["E263","E3C4","E7A88D"], // 稍
           "7A18":["E264","E3C5","E7A898"], // 稘
           "7A19":["E265","E3C6","E7A899"], // 稙
           "7A1F":["E267","E3C8","E7A89F"], // 稟
           "7A20":["E266","E3C7","E7A8A0"], // 稠
           "7A31":["E269","E3CA","E7A8B1"], // 稱
           "7A37":["E26C","E3CD","E7A8B7"], // 稷
           "7A3B":["E26A","E3CB","E7A8BB"], // 稻
           "7A3E":["E26B","E3CC","E7A8BE"], // 稾
           "7A43":["E26D","E3CE","E7A983"], // 穃
           "7A49":["E26F","E3D0","E7A989"], // 穉
           "7A57":["E26E","E3CF","E7A997"], // 穗
           "7A61":["E270","E3D1","E7A9A1"], // 穡
           "7A62":["E271","E3D2","E7A9A2"], // 穢
           "7A69":["E272","E3D3","E7A9A9"], // 穩
           "7A70":["E274","E3D5","E7A9B0"], // 穰
           "7A79":["E275","E3D6","E7A9B9"], // 穹
           "7A7D":["E276","E3D7","E7A9BD"], // 穽
           "7A88":["E277","E3D8","E7AA88"], // 窈
           "7A95":["E279","E3DA","E7AA95"], // 窕
           "7A96":["E27B","E3DC","E7AA96"], // 窖
           "7A97":["E278","E3D9","E7AA97"], // 窗
           "7A98":["E27A","E3DB","E7AA98"], // 窘
           "7AA9":["E27C","E3DD","E7AAA9"], // 窩
           "7AB0":["E27E","E3DF","E7AAB0"], // 窰
           "7AB6":["E280","E3E0","E7AAB6"], // 窶
           "7ABF":["E283","E3E3","E7AABF"], // 窿
           "7AC4":["E282","E3E2","E7AB84"], // 竄
           "7AC5":["E281","E3E1","E7AB85"], // 竅
           "7AC7":["E285","E3E5","E7AB87"], // 竇
           "7AC8":["E27D","E3DE","E7AB88"], // 竈
           "7ACA":["E286","E3E6","E7AB8A"], // 竊
           "7ACD":["E287","E3E7","E7AB8D"], // 竍
           "7ACF":["E288","E3E8","E7AB8F"], // 竏
           "7AD2":["9AF2","D4F4","E7AB92"], // 竒
           "7AD3":["E28A","E3EA","E7AB93"], // 竓
           "7AD5":["E289","E3E9","E7AB95"], // 竕
           "7AD9":["E28B","E3EB","E7AB99"], // 站
           "7ADA":["E28C","E3EC","E7AB9A"], // 竚
           "7ADD":["E28D","E3ED","E7AB9D"], // 竝
           "7ADF":["E8ED","F0EF","E7AB9F"], // 竟
           "7AE1":["E28E","E3EE","E7ABA1"], // 竡
           "7AE2":["E28F","E3EF","E7ABA2"], // 竢
           "7AE6":["E290","E3F0","E7ABA6"], // 竦
           "7AED":["E291","E3F1","E7ABAD"], // 竭
           "7AF0":["E292","E3F2","E7ABB0"], // 竰
           "7AF8":["995E","D1BF","E7ABB8"], // 竸
           "7B02":["E293","E3F3","E7AC82"], // 笂
           "7B04":["E2A0","E4A2","E7AC84"], // 笄
           "7B06":["E296","E3F6","E7AC86"], // 笆
           "7B0A":["E295","E3F5","E7AC8A"], // 笊
           "7B0B":["E2A2","E4A4","E7AC8B"], // 笋
           "7B0F":["E294","E3F4","E7AC8F"], // 笏
           "7B18":["E298","E3F8","E7AC98"], // 笘
           "7B19":["E299","E3F9","E7AC99"], // 笙
           "7B1E":["E29A","E3FA","E7AC9E"], // 笞
           "7B28":["E29C","E3FC","E7ACA8"], // 笨
           "7B33":["E297","E3F7","E7ACB3"], // 笳
           "7B35":["E29B","E3FB","E7ACB5"], // 笵
           "7B36":["E29D","E3FD","E7ACB6"], // 笶
           "7B45":["E2A4","E4A6","E7AD85"], // 筅
           "7B4C":["E2A3","E4A5","E7AD8C"], // 筌
           "7B4D":["E2A1","E4A3","E7AD8D"], // 筍
           "7B50":["E29E","E3FE","E7AD90"], // 筐
           "7B5D":["E2B6","E4B8","E7AD9D"], // 筝
           "7B65":["E2A6","E4A8","E7ADA5"], // 筥
           "7B67":["E2A8","E4AA","E7ADA7"], // 筧
           "7B6C":["E2AB","E4AD","E7ADAC"], // 筬
           "7B6E":["E2AC","E4AE","E7ADAE"], // 筮
           "7B70":["E2A9","E4AB","E7ADB0"], // 筰
           "7B71":["E2AA","E4AC","E7ADB1"], // 筱
           "7B74":["E2A7","E4A9","E7ADB4"], // 筴
           "7B75":["E2A5","E4A7","E7ADB5"], // 筵
           "7B7A":["E29F","E4A1","E7ADBA"], // 筺
           "7B8B":["E2B3","E4B5","E7AE8B"], // 箋
           "7B8D":["E2B0","E4B2","E7AE8D"], // 箍
           "7B8F":["E2B5","E4B7","E7AE8F"], // 箏
           "7B92":["E2B4","E4B6","E7AE92"], // 箒
           "7B98":["E2AE","E4B0","E7AE98"], // 箘
           "7B99":["E2B7","E4B9","E7AE99"], // 箙
           "7B9A":["E2B2","E4B4","E7AE9A"], // 箚
           "7B9C":["E2B1","E4B3","E7AE9C"], // 箜
           "7B9D":["E2AD","E4AF","E7AE9D"], // 箝
           "7B9F":["E2AF","E4B1","E7AE9F"], // 箟
           "7BB4":["E2BC","E4BE","E7AEB4"], // 箴
           "7BC1":["E2B9","E4BB","E7AF81"], // 篁
           "7BC6":["E2BD","E4BF","E7AF86"], // 篆
           "7BCB":["E2B8","E4BA","E7AF8B"], // 篋
           "7BCC":["E2BA","E4BC","E7AF8C"], // 篌
           "7BCF":["E2BB","E4BD","E7AF8F"], // 篏
           "7BDD":["E2BE","E4C0","E7AF9D"], // 篝
           "7BE5":["E2C3","E4C5","E7AFA5"], // 篥
           "7BE6":["E2C2","E4C4","E7AFA6"], // 篦
           "7BE9":["E2BF","E4C1","E7AFA9"], // 篩
           "7BF3":["E2C8","E4CA","E7AFB3"], // 篳
           "7BF6":["E2CC","E4CE","E7AFB6"], // 篶
           "7BF7":["E2C9","E4CB","E7AFB7"], // 篷
           "7C00":["E2C5","E4C7","E7B080"], // 簀
           "7C07":["E2C6","E4C8","E7B087"], // 簇
           "7C0D":["E2CB","E4CD","E7B08D"], // 簍
           "7C11":["E2C0","E4C2","E7B091"], // 簑
           "7C12":["99D3","D2D5","E7B092"], // 簒
           "7C13":["E2C7","E4C9","E7B093"], // 簓
           "7C14":["E2C1","E4C3","E7B094"], // 簔
           "7C17":["E2CA","E4CC","E7B097"], // 簗
           "7C1F":["E2D0","E4D2","E7B09F"], // 簟
           "7C23":["E2CD","E4CF","E7B0A3"], // 簣
           "7C27":["E2CE","E4D0","E7B0A7"], // 簧
           "7C2A":["E2CF","E4D1","E7B0AA"], // 簪
           "7C2B":["E2D2","E4D4","E7B0AB"], // 簫
           "7C37":["E2D1","E4D3","E7B0B7"], // 簷
           "7C3D":["E2D3","E4D5","E7B0BD"], // 簽
           "7C40":["E2D8","E4DA","E7B180"], // 籀
           "7C43":["E2D5","E4D7","E7B183"], // 籃
           "7C4C":["E2D4","E4D6","E7B18C"], // 籌
           "7C4F":["E2D7","E4D9","E7B18F"], // 籏
           "7C50":["E2D9","E4DB","E7B190"], // 籐
           "7C54":["E2D6","E4D8","E7B194"], // 籔
           "7C56":["E2DD","E4DF","E7B196"], // 籖
           "7C58":["E2DA","E4DC","E7B198"], // 籘
           "7C5F":["E2DB","E4DD","E7B19F"], // 籟
           "7C60":["E2C4","E4C6","E7B1A0"], // 籠
           "7C64":["E2DC","E4DE","E7B1A4"], // 籤
           "7C65":["E2DE","E4E0","E7B1A5"], // 籥
           "7C6C":["E2DF","E4E1","E7B1AC"], // 籬
           "7C75":["E2E0","E4E2","E7B1B5"], // 籵
           "7C83":["E2E1","E4E3","E7B283"], // 粃
           "7C90":["E2E2","E4E4","E7B290"], // 粐
           "7CA1":["E2E7","E4E9","E7B2A1"], // 粡
           "7CA2":["E2E5","E4E7","E7B2A2"], // 粢
           "7CA4":["E2E3","E4E5","E7B2A4"], // 粤
           "7CA8":["E2E8","E4EA","E7B2A8"], // 粨
           "7CAB":["E2E6","E4E8","E7B2AB"], // 粫
           "7CAD":["E2E4","E4E6","E7B2AD"], // 粭
           "7CAE":["E2EC","E4EE","E7B2AE"], // 粮
           "7CB1":["E2EB","E4ED","E7B2B1"], // 粱
           "7CB2":["E2EA","E4EC","E7B2B2"], // 粲
           "7CB3":["E2E9","E4EB","E7B2B3"], // 粳
           "7CB9":["E2ED","E4EF","E7B2B9"], // 粹
           "7CBD":["E2EE","E4F0","E7B2BD"], // 粽
           "7CC0":["E2EF","E4F1","E7B380"], // 糀
           "7CC2":["E2F1","E4F3","E7B382"], // 糂
           "7CC5":["E2F0","E4F2","E7B385"], // 糅
           "7CD2":["E2F3","E4F5","E7B392"], // 糒
           "7CD8":["E2F2","E4F4","E7B398"], // 糘
           "7CDC":["E2F4","E4F6","E7B39C"], // 糜
           "7CE2":["E2F5","E4F7","E7B3A2"], // 糢
           "7CEF":["E2F7","E4F9","E7B3AF"], // 糯
           "7CF2":["E2F8","E4FA","E7B3B2"], // 糲
           "7CF4":["E2F9","E4FB","E7B3B4"], // 糴
           "7CF6":["E2FA","E4FC","E7B3B6"], // 糶
           "7CFA":["E2FB","E4FD","E7B3BA"], // 糺
           "7D02":["E340","E5A1","E7B482"], // 紂
           "7D06":["E2FC","E4FE","E7B486"], // 紆
           "7D0A":["E343","E5A4","E7B48A"], // 紊
           "7D15":["E342","E5A3","E7B495"], // 紕
           "7D1C":["E341","E5A2","E7B49C"], // 紜
           "7D2E":["E346","E5A7","E7B4AE"], // 紮
           "7D32":["E347","E5A8","E7B4B2"], // 紲
           "7D35":["E349","E5AA","E7B4B5"], // 紵
           "7D3F":["E348","E5A9","E7B4BF"], // 紿
           "7D45":["E344","E5A5","E7B585"], // 絅
           "7D46":["E34A","E5AB","E7B586"], // 絆
           "7D4B":["E345","E5A6","E7B58B"], // 絋
           "7D4E":["E34D","E5AE","E7B58E"], // 絎
           "7D4F":["E351","E5B2","E7B58F"], // 絏
           "7D56":["E34C","E5AD","E7B596"], // 絖
           "7D5B":["E355","E5B6","E7B59B"], // 絛
           "7D63":["E352","E5B3","E7B5A3"], // 絣
           "7D68":["E34F","E5B0","E7B5A8"], // 絨
           "7D6E":["E350","E5B1","E7B5AE"], // 絮
           "7D72":["E34E","E5AF","E7B5B2"], // 絲
           "7D73":["E34B","E5AC","E7B5B3"], // 絳
           "7D7D":["E357","E5B8","E7B5BD"], // 絽
           "7D89":["E354","E5B5","E7B689"], // 綉
           "7D8F":["E356","E5B7","E7B68F"], // 綏
           "7D93":["E353","E5B4","E7B693"], // 經
           "7D9B":["E358","E5B9","E7B69B"], // 綛
           "7D9F":["E365","E5C6","E7B69F"], // 綟
           "7DA2":["E361","E5C2","E7B6A2"], // 綢
           "7DA3":["E35B","E5BC","E7B6A3"], // 綣
           "7DAB":["E35F","E5C0","E7B6AB"], // 綫
           "7DAE":["E35A","E5BB","E7B6AE"], // 綮
           "7DAF":["E362","E5C3","E7B6AF"], // 綯
           "7DB0":["E366","E5C7","E7B6B0"], // 綰
           "7DB5":["E35C","E5BD","E7B6B5"], // 綵
           "7DB8":["E364","E5C5","E7B6B8"], // 綸
           "7DBA":["E359","E5BA","E7B6BA"], // 綺
           "7DBD":["E35E","E5BF","E7B6BD"], // 綽
           "7DC7":["E35D","E5BE","E7B787"], // 緇
           "7DD5":["E38E","E5EE","E7B795"], // 緕
           "7DD8":["E367","E5C8","E7B798"], // 緘
           "7DDC":["E363","E5C4","E7B79C"], // 緜
           "7DDD":["E368","E5C9","E7B79D"], // 緝
           "7DDE":["E36A","E5CB","E7B79E"], // 緞
           "7DE1":["E36D","E5CE","E7B7A1"], // 緡
           "7DE4":["E369","E5CA","E7B7A4"], // 緤
           "7DF2":["E36C","E5CD","E7B7B2"], // 緲
           "7DFB":["E36B","E5CC","E7B7BB"], // 緻
           "7E05":["E36E","E5CF","E7B885"], // 縅
           "7E09":["E375","E5D6","E7B889"], // 縉
           "7E0A":["E36F","E5D0","E7B88A"], // 縊
           "7E0B":["E376","E5D7","E7B88B"], // 縋
           "7E12":["E372","E5D3","E7B892"], // 縒
           "7E1F":["E374","E5D5","E7B89F"], // 縟
           "7E21":["E371","E5D2","E7B8A1"], // 縡
           "7E22":["E377","E5D8","E7B8A2"], // 縢
           "7E23":["E370","E5D1","E7B8A3"], // 縣
           "7E31":["E373","E5D4","E7B8B1"], // 縱
           "7E32":["E380","E5E0","E7B8B2"], // 縲
           "7E35":["E37B","E5DC","E7B8B5"], // 縵
           "7E37":["E37E","E5DF","E7B8B7"], // 縷
           "7E39":["E37C","E5DD","E7B8B9"], // 縹
           "7E3A":["E381","E5E1","E7B8BA"], // 縺
           "7E3B":["E37A","E5DB","E7B8BB"], // 縻
           "7E3D":["E360","E5C1","E7B8BD"], // 總
           "7E43":["E37D","E5DE","E7B983"], // 繃
           "7E46":["E378","E5D9","E7B986"], // 繆
           "7E56":["E384","E5E4","E7B996"], // 繖
           "7E59":["E386","E5E6","E7B999"], // 繙
           "7E5A":["E387","E5E7","E7B99A"], // 繚
           "7E5D":["E383","E5E3","E7B99D"], // 繝
           "7E5E":["E385","E5E5","E7B99E"], // 繞
           "7E66":["E379","E5DA","E7B9A6"], // 繦
           "7E67":["E382","E5E2","E7B9A7"], // 繧
           "7E69":["E38A","E5EA","E7B9A9"], // 繩
           "7E6A":["E389","E5E9","E7B9AA"], // 繪
           "7E79":["E388","E5E8","E7B9B9"], // 繹
           "7E7B":["E38C","E5EC","E7B9BB"], // 繻
           "7E7C":["E38B","E5EB","E7B9BC"], // 繼
           "7E7D":["E38F","E5EF","E7B9BD"], // 繽
           "7E7F":["E391","E5F1","E7B9BF"], // 繿
           "7E83":["E38D","E5ED","E7BA83"], // 纃
           "7E88":["E392","E5F2","E7BA88"], // 纈
           "7E89":["E393","E5F3","E7BA89"], // 纉
           "7E8C":["E394","E5F4","E7BA8C"], // 續
           "7E8E":["E39A","E5FA","E7BA8E"], // 纎
           "7E90":["E396","E5F6","E7BA90"], // 纐
           "7E92":["E395","E5F5","E7BA92"], // 纒
           "7E93":["E397","E5F7","E7BA93"], // 纓
           "7E94":["E398","E5F8","E7BA94"], // 纔
           "7E96":["E399","E5F9","E7BA96"], // 纖
           "7E9B":["E39B","E5FB","E7BA9B"], // 纛
           "7E9C":["E39C","E5FC","E7BA9C"], // 纜
           "7F38":["E39D","E5FD","E7BCB8"], // 缸
           "7F3A":["E39E","E5FE","E7BCBA"], // 缺
           "7F45":["E39F","E6A1","E7BD85"], // 罅
           "7F4C":["E3A0","E6A2","E7BD8C"], // 罌
           "7F4D":["E3A1","E6A3","E7BD8D"], // 罍
           "7F4E":["E3A2","E6A4","E7BD8E"], // 罎
           "7F50":["E3A3","E6A5","E7BD90"], // 罐
           "7F51":["E3A4","E6A6","E7BD91"], // 网
           "7F54":["E3A6","E6A8","E7BD94"], // 罔
           "7F55":["E3A5","E6A7","E7BD95"], // 罕
           "7F58":["E3A7","E6A9","E7BD98"], // 罘
           "7F5F":["E3A8","E6AA","E7BD9F"], // 罟
           "7F60":["E3A9","E6AB","E7BDA0"], // 罠
           "7F67":["E3AC","E6AE","E7BDA7"], // 罧
           "7F68":["E3AA","E6AC","E7BDA8"], // 罨
           "7F69":["E3AB","E6AD","E7BDA9"], // 罩
           "7F78":["E3AD","E6AF","E7BDB8"], // 罸
           "7F79":["9CEB","D8ED","E7BDB9"], // 罹
           "7F82":["E3AE","E6B0","E7BE82"], // 羂
           "7F83":["E3B0","E6B2","E7BE83"], // 羃
           "7F86":["E3AF","E6B1","E7BE86"], // 羆
           "7F87":["E3B2","E6B4","E7BE87"], // 羇
           "7F88":["E3B1","E6B3","E7BE88"], // 羈
           "7F8C":["E3B3","E6B5","E7BE8C"], // 羌
           "7F94":["E3B4","E6B6","E7BE94"], // 羔
           "7F9A":["E3B7","E6B9","E7BE9A"], // 羚
           "7F9D":["E3B6","E6B8","E7BE9D"], // 羝
           "7F9E":["E3B5","E6B7","E7BE9E"], // 羞
           "7FA3":["E3B8","E6BA","E7BEA3"], // 羣
           "7FAE":["E3BC","E6BE","E7BEAE"], // 羮
           "7FAF":["E3B9","E6BB","E7BEAF"], // 羯
           "7FB2":["E3BA","E6BC","E7BEB2"], // 羲
           "7FB6":["E3BD","E6BF","E7BEB6"], // 羶
           "7FB8":["E3BE","E6C0","E7BEB8"], // 羸
           "7FB9":["E3BB","E6BD","E7BEB9"], // 羹
           "7FC5":["E3C0","E6C2","E7BF85"], // 翅
           "7FC6":["E3C1","E6C3","E7BF86"], // 翆
           "7FCA":["E3C2","E6C4","E7BF8A"], // 翊
           "7FD4":["E3C4","E6C6","E7BF94"], // 翔
           "7FD5":["E3C3","E6C5","E7BF95"], // 翕
           "7FE1":["E3C5","E6C7","E7BFA1"], // 翡
           "7FE6":["E3C6","E6C8","E7BFA6"], // 翦
           "7FE9":["E3C7","E6C9","E7BFA9"], // 翩
           "7FF3":["E3C8","E6CA","E7BFB3"], // 翳
           "7FF9":["E3C9","E6CB","E7BFB9"], // 翹
           "8004":["E3CC","E6CE","E88084"], // 耄
           "8006":["E3CB","E6CD","E88086"], // 耆
           "800B":["E3CD","E6CF","E8808B"], // 耋
           "8012":["E3CE","E6D0","E88092"], // 耒
           "8018":["E3CF","E6D1","E88098"], // 耘
           "8019":["E3D0","E6D2","E88099"], // 耙
           "801C":["E3D1","E6D3","E8809C"], // 耜
           "8021":["E3D2","E6D4","E880A1"], // 耡
           "8028":["E3D3","E6D5","E880A8"], // 耨
           "803B":["E3D5","E6D7","E880BB"], // 耻
           "803F":["E3D4","E6D6","E880BF"], // 耿
           "8046":["E3D7","E6D9","E88186"], // 聆
           "804A":["E3D6","E6D8","E8818A"], // 聊
           "8052":["E3D8","E6DA","E88192"], // 聒
           "8058":["E3D9","E6DB","E88198"], // 聘
           "805A":["E3DA","E6DC","E8819A"], // 聚
           "805F":["E3DB","E6DD","E8819F"], // 聟
           "8062":["E3DC","E6DE","E881A2"], // 聢
           "8068":["E3DD","E6DF","E881A8"], // 聨
           "8070":["E3E0","E6E2","E881B0"], // 聰
           "8072":["E3DF","E6E1","E881B2"], // 聲
           "8073":["E3DE","E6E0","E881B3"], // 聳
           "8076":["E3E1","E6E3","E881B6"], // 聶
           "8079":["E3E2","E6E4","E881B9"], // 聹
           "807D":["E3E3","E6E5","E881BD"], // 聽
           "807F":["E3E4","E6E6","E881BF"], // 聿
           "8084":["E3E5","E6E7","E88284"], // 肄
           "8085":["E3E7","E6E9","E88285"], // 肅
           "8086":["E3E6","E6E8","E88286"], // 肆
           "8093":["E3E9","E6EB","E88293"], // 肓
           "809A":["E3EA","E6EC","E8829A"], // 肚
           "809B":["E3E8","E6EA","E8829B"], // 肛
           "80AC":["E3ED","E6EF","E882AC"], // 肬
           "80AD":["E3EB","E6ED","E882AD"], // 肭
           "80C4":["E3F2","E6F4","E88384"], // 胄
           "80D6":["E3F4","E6F6","E88396"], // 胖
           "80D9":["E3F0","E6F2","E88399"], // 胙
           "80DA":["E3F3","E6F5","E8839A"], // 胚
           "80DB":["E3EE","E6F0","E8839B"], // 胛
           "80DD":["E3F1","E6F3","E8839D"], // 胝
           "80E5":["E3EF","E6F1","E883A5"], // 胥
           "80EF":["E3F6","E6F8","E883AF"], // 胯
           "80F1":["E3F7","E6F9","E883B1"], // 胱
           "80FC":["E445","E7A6","E883BC"], // 胼
           "8109":["E3F5","E6F7","E88489"], // 脉
           "811B":["E3F8","E6FA","E8849B"], // 脛
           "8123":["E3FA","E6FC","E884A3"], // 脣
           "8129":["E3F9","E6FB","E884A9"], // 脩
           "812F":["E3FB","E6FD","E884AF"], // 脯
           "813E":["E442","E7A3","E884BE"], // 脾
           "8146":["E441","E7A2","E88586"], // 腆
           "814B":["E3FC","E6FE","E8858B"], // 腋
           "8151":["E444","E7A5","E88591"], // 腑
           "8153":["E443","E7A4","E88593"], // 腓
           "815F":["E454","E7B5","E8859F"], // 腟
           "8165":["E448","E7A9","E885A5"], // 腥
           "8166":["E449","E7AA","E885A6"], // 腦
           "816E":["E447","E7A8","E885AE"], // 腮
           "8171":["E446","E7A7","E885B1"], // 腱
           "8174":["E44A","E7AB","E885B4"], // 腴
           "8180":["E44E","E7AF","E88680"], // 膀
           "8182":["E44F","E7B0","E88682"], // 膂
           "8183":["E44B","E7AC","E88683"], // 膃
           "8188":["E44C","E7AD","E88688"], // 膈
           "818A":["E44D","E7AE","E8868A"], // 膊
           "8193":["E455","E7B6","E88693"], // 膓
           "8195":["E451","E7B2","E88695"], // 膕
           "81A0":["E450","E7B1","E886A0"], // 膠
           "81A3":["E453","E7B4","E886A3"], // 膣
           "81A4":["E452","E7B3","E886A4"], // 膤
           "81A9":["E456","E7B7","E886A9"], // 膩
           "81B0":["E457","E7B8","E886B0"], // 膰
           "81B5":["E458","E7B9","E886B5"], // 膵
           "81B8":["E45A","E7BB","E886B8"], // 膸
           "81BA":["E45E","E7BF","E886BA"], // 膺
           "81BD":["E45B","E7BC","E886BD"], // 膽
           "81BE":["E459","E7BA","E886BE"], // 膾
           "81C0":["E45C","E7BD","E88780"], // 臀
           "81C2":["E45D","E7BE","E88782"], // 臂
           "81C8":["E464","E7C5","E88788"], // 臈
           "81C9":["E45F","E7C0","E88789"], // 臉
           "81CD":["E460","E7C1","E8878D"], // 臍
           "81D1":["E461","E7C2","E88791"], // 臑
           "81D8":["E463","E7C4","E88798"], // 臘
           "81D9":["E462","E7C3","E88799"], // 臙
           "81DA":["E465","E7C6","E8879A"], // 臚
           "81DF":["E466","E7C7","E8879F"], // 臟
           "81E0":["E467","E7C8","E887A0"], // 臠
           "81E7":["E468","E7C9","E887A7"], // 臧
           "81FA":["E469","E7CA","E887BA"], // 臺
           "81FB":["E46A","E7CB","E887BB"], // 臻
           "81FE":["E46B","E7CC","E887BE"], // 臾
           "8201":["E46C","E7CD","E88881"], // 舁
           "8202":["E46D","E7CE","E88882"], // 舂
           "8205":["E46E","E7CF","E88885"], // 舅
           "8207":["E46F","E7D0","E88887"], // 與
           "8209":["9DA8","DAAA","E88889"], // 舉
           "820A":["E470","E7D1","E8888A"], // 舊
           "820D":["E471","E7D2","E8888D"], // 舍
           "8210":["E472","E7D3","E88890"], // 舐
           "8212":["98AE","D0B0","E88892"], // 舒
           "8216":["E473","E7D4","E88896"], // 舖
           "8229":["E474","E7D5","E888A9"], // 舩
           "822B":["E475","E7D6","E888AB"], // 舫
           "822E":["E484","E7E4","E888AE"], // 舮
           "8233":["E477","E7D8","E888B3"], // 舳
           "8238":["E476","E7D7","E888B8"], // 舸
           "8240":["E478","E7D9","E88980"], // 艀
           "8258":["E47A","E7DB","E88998"], // 艘
           "8259":["E479","E7DA","E88999"], // 艙
           "825A":["E47C","E7DD","E8899A"], // 艚
           "825D":["E47B","E7DC","E8899D"], // 艝
           "825F":["E47D","E7DE","E8899F"], // 艟
           "8262":["E480","E7E0","E889A2"], // 艢
           "8264":["E47E","E7DF","E889A4"], // 艤
           "8268":["E481","E7E1","E889A8"], // 艨
           "826A":["E482","E7E2","E889AA"], // 艪
           "826B":["E483","E7E3","E889AB"], // 艫
           "8271":["E485","E7E5","E889B1"], // 艱
           "8277":["E486","E7E6","E889B7"], // 艷
           "8278":["E487","E7E7","E889B8"], // 艸
           "827E":["E488","E7E8","E889BE"], // 艾
           "828D":["E489","E7E9","E88A8D"], // 芍
           "8292":["E48A","E7EA","E88A92"], // 芒
           "829F":["E48C","E7EC","E88A9F"], // 芟
           "82AB":["E48B","E7EB","E88AAB"], // 芫
           "82AC":["E48E","E7EE","E88AAC"], // 芬
           "82BB":["E48D","E7ED","E88ABB"], // 芻
           "82D2":["E492","E7F2","E88B92"], // 苒
           "82D9":["E49E","E7FE","E88B99"], // 苙
           "82DC":["E49C","E7FC","E88B9C"], // 苜
           "82DE":["E49A","E7FA","E88B9E"], // 苞
           "82DF":["E491","E7F1","E88B9F"], // 苟
           "82E1":["E48F","E7EF","E88BA1"], // 苡
           "82E3":["E490","E7F0","E88BA3"], // 苣
           "82F3":["E494","E7F4","E88BB3"], // 苳
           "82F4":["E493","E7F3","E88BB4"], // 苴
           "82F9":["E499","E7F9","E88BB9"], // 苹
           "82FA":["E495","E7F5","E88BBA"], // 苺
           "82FB":["E498","E7F8","E88BBB"], // 苻
           "8303":["E497","E7F7","E88C83"], // 范
           "8306":["E49B","E7FB","E88C86"], // 茆
           "8309":["E49D","E7FD","E88C89"], // 茉
           "8316":["E4A1","E8A3","E88C96"], // 茖
           "8317":["E4AA","E8AC","E88C97"], // 茗
           "8318":["E4AB","E8AD","E88C98"], // 茘
           "8323":["E4B2","E8B4","E88CA3"], // 茣
           "832B":["E4A9","E8AB","E88CAB"], // 茫
           "832F":["E4A8","E8AA","E88CAF"], // 茯
           "8331":["E4A3","E8A5","E88CB1"], // 茱
           "8332":["E4A2","E8A4","E88CB2"], // 茲
           "8334":["E4A0","E8A2","E88CB4"], // 茴
           "8335":["E49F","E8A1","E88CB5"], // 茵
           "8339":["E4A5","E8A7","E88CB9"], // 茹
           "8340":["E4A4","E8A6","E88D80"], // 荀
           "8345":["E4A7","E8A9","E88D85"], // 荅
           "8350":["E4A6","E8A8","E88D90"], // 荐
           "8373":["E4B8","E8BA","E88DB3"], // 荳
           "8375":["E4B9","E8BB","E88DB5"], // 荵
           "837C":["E4B6","E8B8","E88DBC"], // 荼
           "8385":["E4AC","E8AE","E88E85"], // 莅
           "8387":["E4B4","E8B6","E88E87"], // 莇
           "8389":["E4BB","E8BD","E88E89"], // 莉
           "838A":["E4B5","E8B7","E88E8A"], // 莊
           "838E":["E4B3","E8B5","E88E8E"], // 莎
           "8393":["E496","E7F6","E88E93"], // 莓
           "8396":["E4B1","E8B3","E88E96"], // 莖
           "839A":["E4AD","E8AF","E88E9A"], // 莚
           "839F":["E4AF","E8B1","E88E9F"], // 莟
           "83A0":["E4BA","E8BC","E88EA0"], // 莠
           "83A2":["E4B0","E8B2","E88EA2"], // 莢
           "83A8":["E4BC","E8BE","E88EA8"], // 莨
           "83AA":["E4AE","E8B0","E88EAA"], // 莪
           "83B5":["E4B7","E8B9","E88EB5"], // 莵
           "83BD":["E4CD","E8CF","E88EBD"], // 莽
           "83C1":["E4C5","E8C7","E88F81"], // 菁
           "83CE":["E4C0","E8C2","E88F8E"], // 菎
           "83D8":["E4C3","E8C5","E88F98"], // 菘
           "83E0":["E4C8","E8CA","E88FA0"], // 菠
           "83EB":["E4BF","E8C1","E88FAB"], // 菫
           "83F2":["E4C9","E8CB","E88FB2"], // 菲
           "83F4":["E4BD","E8BF","E88FB4"], // 菴
           "83F7":["E4C6","E8C8","E88FB7"], // 菷
           "83FB":["E4D0","E8D2","E88FBB"], // 菻
           "83FD":["E4C1","E8C3","E88FBD"], // 菽
           "8403":["E4C2","E8C4","E89083"], // 萃
           "8407":["E4C7","E8C9","E89087"], // 萇
           "840B":["E4C4","E8C6","E8908B"], // 萋
           "840D":["E4CA","E8CC","E8908D"], // 萍
           "8413":["E4BE","E8C0","E89093"], // 萓
           "8420":["E4CC","E8CE","E890A0"], // 萠
           "8422":["E4CB","E8CD","E890A2"], // 萢
           "842A":["E4D2","E8D4","E890AA"], // 萪
           "842C":["E4DD","E8DF","E890AC"], // 萬
           "8435":["E4E0","E8E2","E890B5"], // 萵
           "8438":["E4CE","E8D0","E890B8"], // 萸
           "843C":["E4D3","E8D5","E890BC"], // 萼
           "8446":["E4DC","E8DE","E89186"], // 葆
           "8462":["E4E2","E8E4","E891A2"], // 葢
           "8469":["E4DB","E8DD","E891A9"], // 葩
           "846B":["E4D7","E8D9","E891AB"], // 葫
           "846D":["E4D1","E8D3","E891AD"], // 葭
           "846E":["E4D9","E8DB","E891AE"], // 葮
           "846F":["E4DE","E8E0","E891AF"], // 葯
           "8477":["E4D6","E8D8","E891B7"], // 葷
           "8479":["E4DF","E8E1","E891B9"], // 葹
           "8482":["E4DA","E8DC","E89282"], // 蒂
           "8484":["E4D5","E8D7","E89284"], // 蒄
           "849F":["E4E5","E8E7","E8929F"], // 蒟
           "84A1":["E4EE","E8F0","E892A1"], // 蒡
           "84AD":["E4D8","E8DA","E892AD"], // 蒭
           "84B9":["E4E3","E8E5","E892B9"], // 蒹
           "84BB":["E4E8","E8EA","E892BB"], // 蒻
           "84BF":["E4E4","E8E6","E892BF"], // 蒿
           "84C1":["E4EB","E8ED","E89381"], // 蓁
           "84C6":["E4EC","E8EE","E89386"], // 蓆
           "84CA":["E4E1","E8E3","E8938A"], // 蓊
           "84CD":["E4E7","E8E9","E8938D"], // 蓍
           "84D0":["E4EA","E8EC","E89390"], // 蓐
           "84D6":["E4ED","E8EF","E89396"], // 蓖
           "84D9":["E4E6","E8E8","E89399"], // 蓙
           "84DA":["E4E9","E8EB","E8939A"], // 蓚
           "84F4":["E4F1","E8F3","E893B4"], // 蓴
           "84FC":["E4F8","E8FA","E893BC"], // 蓼
           "84FF":["E4F0","E8F2","E893BF"], // 蓿
           "8506":["E4CF","E8D1","E89486"], // 蔆
           "8514":["E4F7","E8F9","E89494"], // 蔔
           "8515":["E4F6","E8F8","E89495"], // 蔕
           "8517":["E4F2","E8F4","E89497"], // 蔗
           "8518":["E4F3","E8F5","E89498"], // 蔘
           "851F":["E4F5","E8F7","E8949F"], // 蔟
           "8521":["E4EF","E8F1","E894A1"], // 蔡
           "852C":["E4F4","E8F6","E894AC"], // 蔬
           "8540":["E4F9","E8FB","E89580"], // 蕀
           "8541":["E540","E9A1","E89581"], // 蕁
           "8548":["E4FC","E8FE","E89588"], // 蕈
           "854B":["E542","E9A3","E8958B"], // 蕋
           "8555":["E543","E9A4","E89595"], // 蕕
           "8558":["E4FB","E8FD","E89598"], // 蕘
           "855A":["E4D4","E8D6","E8959A"], // 蕚
           "8563":["E4FA","E8FC","E895A3"], // 蕣
           "856D":["E54A","E9AB","E895AD"], // 蕭
           "8577":["E550","E9B1","E895B7"], // 蕷
           "857E":["E551","E9B2","E895BE"], // 蕾
           "8580":["E544","E9A5","E89680"], // 薀
           "8587":["E54E","E9AF","E89687"], // 薇
           "8588":["E546","E9A7","E89688"], // 薈
           "858A":["E548","E9A9","E8968A"], // 薊
           "8590":["E552","E9B3","E89690"], // 薐
           "8591":["E547","E9A8","E89691"], // 薑
           "8594":["E54B","E9AC","E89694"], // 薔
           "859B":["E54C","E9AD","E8969B"], // 薛
           "859C":["E54F","E9B0","E8969C"], // 薜
           "85A4":["E545","E9A6","E896A4"], // 薤
           "85A8":["E549","E9AA","E896A8"], // 薨
           "85B9":["E556","E9B7","E896B9"], // 薹
           "85BA":["E554","E9B5","E896BA"], // 薺
           "85C9":["E553","E9B4","E89789"], // 藉
           "85CF":["E555","E9B6","E8978F"], // 藏
           "85D0":["E557","E9B8","E89790"], // 藐
           "85D5":["E558","E9B9","E89795"], // 藕
           "85DC":["E55B","E9BC","E8979C"], // 藜
           "85DD":["E559","E9BA","E8979D"], // 藝
           "85E5":["E55A","E9BB","E897A5"], // 藥
           "85EA":["E54D","E9AE","E897AA"], // 藪
           "85F9":["E55C","E9BD","E897B9"], // 藹
           "85FA":["E561","E9C2","E897BA"], // 藺
           "85FE":["E560","E9C1","E897BE"], // 藾
           "8602":["E541","E9A2","E89882"], // 蘂
           "8606":["E562","E9C3","E89886"], // 蘆
           "860A":["E55D","E9BE","E8988A"], // 蘊
           "860B":["E55F","E9C0","E8988B"], // 蘋
           "8613":["E55E","E9BF","E89893"], // 蘓
           "8616":["9F50","DDB1","E89896"], // 蘖
           "8617":["9F41","DDA2","E89897"], // 蘗
           "861A":["E564","E9C5","E8989A"], // 蘚
           "8622":["E563","E9C4","E898A2"], // 蘢
           "862F":["E1BA","E2BC","E898AF"], // 蘯
           "8630":["E565","E9C6","E898B0"], // 蘰
           "863F":["E566","E9C7","E898BF"], // 蘿
           "864D":["E567","E9C8","E8998D"], // 虍
           "8654":["E569","E9CA","E89994"], // 虔
           "8655":["997C","D1DD","E89995"], // 處
           "865F":["E56A","E9CB","E8999F"], // 號
           "8667":["E56B","E9CC","E899A7"], // 虧
           "8671":["E56C","E9CD","E899B1"], // 虱
           "868B":["E571","E9D2","E89A8B"], // 蚋
           "868C":["E572","E9D3","E89A8C"], // 蚌
           "8693":["E56D","E9CE","E89A93"], // 蚓
           "86A3":["E56E","E9CF","E89AA3"], // 蚣
           "86A9":["E56F","E9D0","E89AA9"], // 蚩
           "86AA":["E570","E9D1","E89AAA"], // 蚪
           "86AB":["E57A","E9DB","E89AAB"], // 蚫
           "86AF":["E574","E9D5","E89AAF"], // 蚯
           "86B0":["E577","E9D8","E89AB0"], // 蚰
           "86B6":["E573","E9D4","E89AB6"], // 蚶
           "86C4":["E575","E9D6","E89B84"], // 蛄
           "86C6":["E576","E9D7","E89B86"], // 蛆
           "86C9":["E578","E9D9","E89B89"], // 蛉
           "86D4":["E57B","E9DC","E89B94"], // 蛔
           "86DB":["E581","E9E1","E89B9B"], // 蛛
           "86DE":["E57C","E9DD","E89B9E"], // 蛞
           "86DF":["E580","E9E0","E89B9F"], // 蛟
           "86E9":["E57D","E9DE","E89BA9"], // 蛩
           "86EC":["E57E","E9DF","E89BAC"], // 蛬
           "86EF":["E582","E9E2","E89BAF"], // 蛯
           "86F9":["E58C","E9EC","E89BB9"], // 蛹
           "86FB":["E588","E9E8","E89BBB"], // 蛻
           "8700":["E586","E9E6","E89C80"], // 蜀
           "8703":["E587","E9E7","E89C83"], // 蜃
           "8706":["E584","E9E4","E89C86"], // 蜆
           "8708":["E585","E9E5","E89C88"], // 蜈
           "8709":["E58A","E9EA","E89C89"], // 蜉
           "870A":["E58D","E9ED","E89C8A"], // 蜊
           "870D":["E58B","E9EB","E89C8D"], // 蜍
           "8711":["E589","E9E9","E89C91"], // 蜑
           "8712":["E583","E9E3","E89C92"], // 蜒
           "871A":["E594","E9F4","E89C9A"], // 蜚
           "8725":["E592","E9F2","E89CA5"], // 蜥
           "8729":["E593","E9F3","E89CA9"], // 蜩
           "8734":["E58E","E9EE","E89CB4"], // 蜴
           "8737":["E590","E9F0","E89CB7"], // 蜷
           "873B":["E591","E9F1","E89CBB"], // 蜻
           "873F":["E58F","E9EF","E89CBF"], // 蜿
           "874C":["E598","E9F8","E89D8C"], // 蝌
           "874E":["E599","E9F9","E89D8E"], // 蝎
           "8753":["E59F","EAA1","E89D93"], // 蝓
           "8757":["E59B","E9FB","E89D97"], // 蝗
           "8759":["E59E","E9FE","E89D99"], // 蝙
           "875F":["E596","E9F6","E89D9F"], // 蝟
           "8760":["E595","E9F5","E89DA0"], // 蝠
           "8763":["E5A0","EAA2","E89DA3"], // 蝣
           "8768":["E59C","E9FC","E89DA8"], // 蝨
           "876A":["E5A1","EAA3","E89DAA"], // 蝪
           "876E":["E59D","E9FD","E89DAE"], // 蝮
           "8774":["E59A","E9FA","E89DB4"], // 蝴
           "8778":["E597","E9F7","E89DB8"], // 蝸
           "8782":["E5A5","EAA7","E89E82"], // 螂
           "879F":["E5A4","EAA6","E89E9F"], // 螟
           "87A2":["E5A3","EAA5","E89EA2"], // 螢
           "87AB":["E5AC","EAAE","E89EAB"], // 螫
           "87AF":["E5A6","EAA8","E89EAF"], // 螯
           "87B3":["E5AE","EAB0","E89EB3"], // 螳
           "87BB":["E5B1","EAB3","E89EBB"], // 螻
           "87BD":["E5A8","EAAA","E89EBD"], // 螽
           "87C0":["E5A9","EAAB","E89F80"], // 蟀
           "87C4":["E5AD","EAAF","E89F84"], // 蟄
           "87C6":["E5B0","EAB2","E89F86"], // 蟆
           "87C7":["E5AF","EAB1","E89F87"], // 蟇
           "87CB":["E5A7","EAA9","E89F8B"], // 蟋
           "87D0":["E5AA","EAAC","E89F90"], // 蟐
           "87D2":["E5BB","EABD","E89F92"], // 蟒
           "87E0":["E5B4","EAB6","E89FA0"], // 蟠
           "87EF":["E5B2","EAB4","E89FAF"], // 蟯
           "87F2":["E5B3","EAB5","E89FB2"], // 蟲
           "87F6":["E5B8","EABA","E89FB6"], // 蟶
           "87F7":["E5B9","EABB","E89FB7"], // 蟷
           "87FE":["E5B7","EAB9","E89FBE"], // 蟾
           "8805":["E5A2","EAA4","E8A085"], // 蠅
           "880D":["E5B6","EAB8","E8A08D"], // 蠍
           "880E":["E5BA","EABC","E8A08E"], // 蠎
           "880F":["E5B5","EAB7","E8A08F"], // 蠏
           "8811":["E5BC","EABE","E8A091"], // 蠑
           "8815":["E5BE","EAC0","E8A095"], // 蠕
           "8816":["E5BD","EABF","E8A096"], // 蠖
           "8821":["E5C0","EAC2","E8A0A1"], // 蠡
           "8822":["E5BF","EAC1","E8A0A2"], // 蠢
           "8823":["E579","E9DA","E8A0A3"], // 蠣
           "8827":["E5C4","EAC6","E8A0A7"], // 蠧
           "8831":["E5C1","EAC3","E8A0B1"], // 蠱
           "8836":["E5C2","EAC4","E8A0B6"], // 蠶
           "8839":["E5C3","EAC5","E8A0B9"], // 蠹
           "883B":["E5C5","EAC7","E8A0BB"], // 蠻
           "8842":["E5C7","EAC9","E8A182"], // 衂
           "8844":["E5C6","EAC8","E8A184"], // 衄
           "884D":["9FA5","DEA7","E8A18D"], // 衍
           "8852":["E5C8","EACA","E8A192"], // 衒
           "8859":["E5C9","EACB","E8A199"], // 衙
           "885E":["E5CA","EACC","E8A19E"], // 衞
           "8862":["E5CB","EACD","E8A1A2"], // 衢
           "886B":["E5CC","EACE","E8A1AB"], // 衫
           "8872":["E5D3","EAD5","E8A1B2"], // 衲
           "8875":["E5D0","EAD2","E8A1B5"], // 衵
           "887D":["E5D1","EAD3","E8A1BD"], // 衽
           "887E":["E5CE","EAD0","E8A1BE"], // 衾
           "8881":["E5CD","EACF","E8A281"], // 袁
           "8882":["E5D4","EAD6","E8A282"], // 袂
           "888D":["E5DA","EADC","E8A28D"], // 袍
           "8892":["E5D6","EAD8","E8A292"], // 袒
           "8897":["E5D5","EAD7","E8A297"], // 袗
           "8899":["E5D8","EADA","E8A299"], // 袙
           "889E":["E5CF","EAD1","E8A29E"], // 袞
           "88A2":["E5D9","EADB","E8A2A2"], // 袢
           "88A4":["E5DB","EADD","E8A2A4"], // 袤
           "88AE":["E5D7","EAD9","E8A2AE"], // 袮
           "88B0":["E5DC","EADE","E8A2B0"], // 袰
           "88B1":["E5DE","EAE0","E8A2B1"], // 袱
           "88B5":["E5D2","EAD4","E8A2B5"], // 袵
           "88BF":["E5DD","EADF","E8A2BF"], // 袿
           "88C3":["E5DF","EAE1","E8A383"], // 裃
           "88C4":["E5E0","EAE2","E8A384"], // 裄
           "88D4":["E5E1","EAE3","E8A394"], // 裔
           "88D8":["E5E2","EAE4","E8A398"], // 裘
           "88D9":["E5E3","EAE5","E8A399"], // 裙
           "88DD":["E5E4","EAE6","E8A39D"], // 裝
           "88E8":["E5E9","EAEB","E8A3A8"], // 裨
           "88F2":["E5EA","EAEC","E8A3B2"], // 裲
           "88F4":["E5E8","EAEA","E8A3B4"], // 裴
           "88F9":["E5E5","EAE7","E8A3B9"], // 裹
           "88FC":["E5E7","EAE9","E8A3BC"], // 裼
           "8902":["E5E6","EAE8","E8A482"], // 褂
           "8904":["E5EB","EAED","E8A484"], // 褄
           "890A":["E5ED","EAEF","E8A48A"], // 褊
           "890C":["E5EC","EAEE","E8A48C"], // 褌
           "8913":["E5EE","EAF0","E8A493"], // 褓
           "891D":["E5FA","EAFC","E8A49D"], // 褝
           "891E":["E5F0","EAF2","E8A49E"], // 褞
           "8925":["E5F1","EAF3","E8A4A5"], // 褥
           "892A":["E5F2","EAF4","E8A4AA"], // 褪
           "892B":["E5F3","EAF5","E8A4AB"], // 褫
           "8936":["E5F7","EAF9","E8A4B6"], // 褶
           "8938":["E5F8","EAFA","E8A4B8"], // 褸
           "893B":["E5F6","EAF8","E8A4BB"], // 褻
           "8941":["E5F4","EAF6","E8A581"], // 襁
           "8943":["E5EF","EAF1","E8A583"], // 襃
           "8944":["E5F5","EAF7","E8A584"], // 襄
           "894C":["E5F9","EAFB","E8A58C"], // 襌
           "894D":["E8B5","F0B7","E8A58D"], // 襍
           "895E":["E5FC","EAFE","E8A59E"], // 襞
           "8960":["E5FB","EAFD","E8A5A0"], // 襠
           "8964":["E641","EBA2","E8A5A4"], // 襤
           "8966":["E640","EBA1","E8A5A6"], // 襦
           "896A":["E643","EBA4","E8A5AA"], // 襪
           "896D":["E642","EBA3","E8A5AD"], // 襭
           "896F":["E644","EBA5","E8A5AF"], // 襯
           "8974":["E645","EBA6","E8A5B4"], // 襴
           "8977":["E646","EBA7","E8A5B7"], // 襷
           "897E":["E647","EBA8","E8A5BE"], // 襾
           "8983":["E648","EBA9","E8A683"], // 覃
           "8988":["E649","EBAA","E8A688"], // 覈
           "898A":["E64A","EBAB","E8A68A"], // 覊
           "8993":["E64B","EBAC","E8A693"], // 覓
           "8998":["E64C","EBAD","E8A698"], // 覘
           "89A1":["E64D","EBAE","E8A6A1"], // 覡
           "89A6":["E64F","EBB0","E8A6A6"], // 覦
           "89A9":["E64E","EBAF","E8A6A9"], // 覩
           "89AC":["E650","EBB1","E8A6AC"], // 覬
           "89AF":["E651","EBB2","E8A6AF"], // 覯
           "89B2":["E652","EBB3","E8A6B2"], // 覲
           "89BA":["E653","EBB4","E8A6BA"], // 覺
           "89BD":["E654","EBB5","E8A6BD"], // 覽
           "89BF":["E655","EBB6","E8A6BF"], // 覿
           "89C0":["E656","EBB7","E8A780"], // 觀
           "89DA":["E657","EBB8","E8A79A"], // 觚
           "89DC":["E658","EBB9","E8A79C"], // 觜
           "89DD":["E659","EBBA","E8A79D"], // 觝
           "89E7":["E65A","EBBB","E8A7A7"], // 觧
           "89F4":["E65B","EBBC","E8A7B4"], // 觴
           "89F8":["E65C","EBBD","E8A7B8"], // 觸
           "8A03":["E65D","EBBE","E8A883"], // 訃
           "8A0C":["E660","EBC1","E8A88C"], // 訌
           "8A10":["E65F","EBC0","E8A890"], // 訐
           "8A16":["E65E","EBBF","E8A896"], // 訖
           "8A1B":["E661","EBC2","E8A89B"], // 訛
           "8A1D":["E662","EBC3","E8A89D"], // 訝
           "8A25":["E663","EBC4","E8A8A5"], // 訥
           "8A36":["E664","EBC5","E8A8B6"], // 訶
           "8A41":["E665","EBC6","E8A981"], // 詁
           "8A46":["E668","EBC9","E8A986"], // 詆
           "8A48":["E669","EBCA","E8A988"], // 詈
           "8A52":["E667","EBC8","E8A992"], // 詒
           "8A5B":["E666","EBC7","E8A99B"], // 詛
           "8A62":["E66D","EBCE","E8A9A2"], // 詢
           "8A6C":["E66C","EBCD","E8A9AC"], // 詬
           "8A6D":["E66B","EBCC","E8A9AD"], // 詭
           "8A7C":["E66A","EBCB","E8A9BC"], // 詼
           "8A82":["E66F","EBD0","E8AA82"], // 誂
           "8A84":["E670","EBD1","E8AA84"], // 誄
           "8A85":["E66E","EBCF","E8AA85"], // 誅
           "8A91":["E673","EBD4","E8AA91"], // 誑
           "8A9A":["E676","EBD7","E8AA9A"], // 誚
           "8AA1":["E672","EBD3","E8AAA1"], // 誡
           "8AA3":["E677","EBD8","E8AAA3"], // 誣
           "8AA5":["E674","EBD5","E8AAA5"], // 誥
           "8AA6":["E675","EBD6","E8AAA6"], // 誦
           "8AA8":["E671","EBD2","E8AAA8"], // 誨
           "8AC2":["E67A","EBDB","E8AB82"], // 諂
           "8AC4":["E678","EBD9","E8AB84"], // 諄
           "8ACD":["E679","EBDA","E8AB8D"], // 諍
           "8ADA":["E67B","EBDC","E8AB9A"], // 諚
           "8ADB":["E687","EBE7","E8AB9B"], // 諛
           "8ADE":["E686","EBE6","E8AB9E"], // 諞
           "8AE0":["E683","EBE3","E8ABA0"], // 諠
           "8AE1":["E68B","EBEB","E8ABA1"], // 諡
           "8AE2":["E684","EBE4","E8ABA2"], // 諢
           "8AE4":["E680","EBE0","E8ABA4"], // 諤
           "8AE7":["E67E","EBDF","E8ABA7"], // 諧
           "8AEB":["E67C","EBDD","E8ABAB"], // 諫
           "8AF1":["E681","EBE1","E8ABB1"], // 諱
           "8AF3":["E67D","EBDE","E8ABB3"], // 諳
           "8AF7":["E685","EBE5","E8ABB7"], // 諷
           "8B07":["E689","EBE9","E8AC87"], // 謇
           "8B0C":["E688","EBE8","E8AC8C"], // 謌
           "8B10":["E68D","EBED","E8AC90"], // 謐
           "8B14":["E682","EBE2","E8AC94"], // 謔
           "8B16":["E68C","EBEC","E8AC96"], // 謖
           "8B17":["E68E","EBEE","E8AC97"], // 謗
           "8B1A":["E68A","EBEA","E8AC9A"], // 謚
           "8B20":["E68F","EBEF","E8ACA0"], // 謠
           "8B26":["E692","EBF2","E8ACA6"], // 謦
           "8B28":["E695","EBF5","E8ACA8"], // 謨
           "8B2B":["E693","EBF3","E8ACAB"], // 謫
           "8B33":["E690","EBF0","E8ACB3"], // 謳
           "8B3E":["E694","EBF4","E8ACBE"], // 謾
           "8B41":["E696","EBF6","E8AD81"], // 譁
           "8B49":["E69A","EBFA","E8AD89"], // 證
           "8B4C":["E697","EBF7","E8AD8C"], // 譌
           "8B4E":["E699","EBF9","E8AD8E"], // 譎
           "8B4F":["E698","EBF8","E8AD8F"], // 譏
           "8B56":["E69B","EBFB","E8AD96"], // 譖
           "8B5A":["E69D","EBFD","E8AD9A"], // 譚
           "8B5B":["E69C","EBFC","E8AD9B"], // 譛
           "8B5F":["E69F","ECA1","E8AD9F"], // 譟
           "8B6B":["E69E","EBFE","E8ADAB"], // 譫
           "8B6C":["E6A0","ECA2","E8ADAC"], // 譬
           "8B6F":["E6A1","ECA3","E8ADAF"], // 譯
           "8B71":["E3BF","E6C1","E8ADB1"], // 譱
           "8B74":["E6A2","ECA4","E8ADB4"], // 譴
           "8B7D":["E6A3","ECA5","E8ADBD"], // 譽
           "8B80":["E6A4","ECA6","E8AE80"], // 讀
           "8B8A":["9DCC","DACE","E8AE8A"], // 變
           "8B8C":["E6A5","ECA7","E8AE8C"], // 讌
           "8B8E":["E6A6","ECA8","E8AE8E"], // 讎
           "8B92":["E6A7","ECA9","E8AE92"], // 讒
           "8B93":["E6A8","ECAA","E8AE93"], // 讓
           "8B96":["E6A9","ECAB","E8AE96"], // 讖
           "8B99":["E6AA","ECAC","E8AE99"], // 讙
           "8B9A":["E6AB","ECAD","E8AE9A"], // 讚
           "8C3A":["E6AC","ECAE","E8B0BA"], // 谺
           "8C3F":["E6AE","ECB0","E8B0BF"], // 谿
           "8C41":["E6AD","ECAF","E8B181"], // 豁
           "8C48":["E6AF","ECB1","E8B188"], // 豈
           "8C4C":["E6B0","ECB2","E8B18C"], // 豌
           "8C4E":["E6B1","ECB3","E8B18E"], // 豎
           "8C50":["E6B2","ECB4","E8B190"], // 豐
           "8C55":["E6B3","ECB5","E8B195"], // 豕
           "8C62":["E6B4","ECB6","E8B1A2"], // 豢
           "8C6B":["98AC","D0AE","E8B1AB"], // 豫
           "8C6C":["E6B5","ECB7","E8B1AC"], // 豬
           "8C78":["E6B6","ECB8","E8B1B8"], // 豸
           "8C7A":["E6B7","ECB9","E8B1BA"], // 豺
           "8C7C":["E6BF","ECC1","E8B1BC"], // 豼
           "8C82":["E6B8","ECBA","E8B282"], // 貂
           "8C85":["E6BA","ECBC","E8B285"], // 貅
           "8C89":["E6B9","ECBB","E8B289"], // 貉
           "8C8A":["E6BB","ECBD","E8B28A"], // 貊
           "8C8D":["E6BC","ECBE","E8B28D"], // 貍
           "8C8E":["E6BD","ECBF","E8B28E"], // 貎
           "8C94":["E6BE","ECC0","E8B294"], // 貔
           "8C98":["E6C0","ECC2","E8B298"], // 貘
           "8CAA":["E6C3","ECC5","E8B2AA"], // 貪
           "8CAD":["E6C2","ECC4","E8B2AD"], // 貭
           "8CAE":["E6C7","ECC9","E8B2AE"], // 貮
           "8CB2":["E6C5","ECC7","E8B2B2"], // 貲
           "8CB3":["E6C6","ECC8","E8B2B3"], // 貳
           "8CB6":["E6C8","ECCA","E8B2B6"], // 貶
           "8CBD":["E6C4","ECC6","E8B2BD"], // 貽
           "8CC1":["E6CA","ECCC","E8B381"], // 賁
           "8CC8":["E6C9","ECCB","E8B388"], // 賈
           "8CCD":["E6DA","ECDC","E8B38D"], // 賍
           "8CDA":["E6CD","ECCF","E8B39A"], // 賚
           "8CE3":["E6CC","ECCE","E8B3A3"], // 賣
           "8CE4":["E6CB","ECCD","E8B3A4"], // 賤
           "8CFA":["E6CF","ECD1","E8B3BA"], // 賺
           "8CFB":["E6D0","ECD2","E8B3BB"], // 賻
           "8CFD":["E6CE","ECD0","E8B3BD"], // 賽
           "8D04":["E6D1","ECD3","E8B484"], // 贄
           "8D05":["E6D2","ECD4","E8B485"], // 贅
           "8D07":["E6D4","ECD6","E8B487"], // 贇
           "8D0A":["E6D3","ECD5","E8B48A"], // 贊
           "8D0D":["E6D6","ECD8","E8B48D"], // 贍
           "8D0F":["E6D5","ECD7","E8B48F"], // 贏
           "8D10":["E6D7","ECD9","E8B490"], // 贐
           "8D13":["E6D9","ECDB","E8B493"], // 贓
           "8D14":["E6DB","ECDD","E8B494"], // 贔
           "8D16":["E6DC","ECDE","E8B496"], // 贖
           "8D67":["E6DD","ECDF","E8B5A7"], // 赧
           "8D6D":["E6DE","ECE0","E8B5AD"], // 赭
           "8D71":["E6DF","ECE1","E8B5B1"], // 赱
           "8D73":["E6E0","ECE2","E8B5B3"], // 赳
           "8D81":["E6E1","ECE3","E8B681"], // 趁
           "8D99":["E6E2","ECE4","E8B699"], // 趙
           "8DBA":["E6E5","ECE7","E8B6BA"], // 趺
           "8DBE":["E6E4","ECE6","E8B6BE"], // 趾
           "8DC2":["E6E3","ECE5","E8B782"], // 跂
           "8DCB":["E6EB","ECED","E8B78B"], // 跋
           "8DCC":["E6E9","ECEB","E8B78C"], // 跌
           "8DCF":["E6E6","ECE8","E8B78F"], // 跏
           "8DD6":["E6E8","ECEA","E8B796"], // 跖
           "8DDA":["E6E7","ECE9","E8B79A"], // 跚
           "8DDB":["E6EA","ECEC","E8B79B"], // 跛
           "8DDF":["E6EE","ECF0","E8B79F"], // 跟
           "8DE3":["E6EF","ECF1","E8B7A3"], // 跣
           "8DEA":["E6EC","ECEE","E8B7AA"], // 跪
           "8DEB":["E6ED","ECEF","E8B7AB"], // 跫
           "8DFC":["E6F0","ECF2","E8B7BC"], // 跼
           "8DFF":["E6F3","ECF5","E8B7BF"], // 跿
           "8E08":["E6F1","ECF3","E8B888"], // 踈
           "8E09":["E6F2","ECF4","E8B889"], // 踉
           "8E10":["E6F6","ECF8","E8B890"], // 踐
           "8E1D":["E6F4","ECF6","E8B89D"], // 踝
           "8E1E":["E6F5","ECF7","E8B89E"], // 踞
           "8E1F":["E6F7","ECF9","E8B89F"], // 踟
           "8E2A":["E748","EDA9","E8B8AA"], // 踪
           "8E30":["E6FA","ECFC","E8B8B0"], // 踰
           "8E34":["E6FB","ECFD","E8B8B4"], // 踴
           "8E35":["E6F9","ECFB","E8B8B5"], // 踵
           "8E42":["E6F8","ECFA","E8B982"], // 蹂
           "8E47":["E740","EDA1","E8B987"], // 蹇
           "8E48":["E744","EDA5","E8B988"], // 蹈
           "8E49":["E741","EDA2","E8B989"], // 蹉
           "8E4A":["E6FC","ECFE","E8B98A"], // 蹊
           "8E4C":["E742","EDA3","E8B98C"], // 蹌
           "8E50":["E743","EDA4","E8B990"], // 蹐
           "8E55":["E74A","EDAB","E8B995"], // 蹕
           "8E59":["E745","EDA6","E8B999"], // 蹙
           "8E60":["E747","EDA8","E8B9A0"], // 蹠
           "8E63":["E749","EDAA","E8B9A3"], // 蹣
           "8E64":["E746","EDA7","E8B9A4"], // 蹤
           "8E72":["E74C","EDAD","E8B9B2"], // 蹲
           "8E76":["E74B","EDAC","E8B9B6"], // 蹶
           "8E7C":["E74D","EDAE","E8B9BC"], // 蹼
           "8E81":["E74E","EDAF","E8BA81"], // 躁
           "8E84":["E751","EDB2","E8BA84"], // 躄
           "8E85":["E750","EDB1","E8BA85"], // 躅
           "8E87":["E74F","EDB0","E8BA87"], // 躇
           "8E8A":["E753","EDB4","E8BA8A"], // 躊
           "8E8B":["E752","EDB3","E8BA8B"], // 躋
           "8E91":["E755","EDB6","E8BA91"], // 躑
           "8E93":["E754","EDB5","E8BA93"], // 躓
           "8E94":["E756","EDB7","E8BA94"], // 躔
           "8E99":["E757","EDB8","E8BA99"], // 躙
           "8EA1":["E759","EDBA","E8BAA1"], // 躡
           "8EAA":["E758","EDB9","E8BAAA"], // 躪
           "8EAC":["E75A","EDBB","E8BAAC"], // 躬
           "8EB0":["E75B","EDBC","E8BAB0"], // 躰
           "8EB1":["E75D","EDBE","E8BAB1"], // 躱
           "8EBE":["E75E","EDBF","E8BABE"], // 躾
           "8EC5":["E75F","EDC0","E8BB85"], // 軅
           "8EC6":["E75C","EDBD","E8BB86"], // 軆
           "8EC8":["E760","EDC1","E8BB88"], // 軈
           "8ECB":["E761","EDC2","E8BB8B"], // 軋
           "8EDB":["E762","EDC3","E8BB9B"], // 軛
           "8EE3":["E763","EDC4","E8BBA3"], // 軣
           "8EEB":["E766","EDC7","E8BBAB"], // 軫
           "8EFB":["E765","EDC6","E8BBBB"], // 軻
           "8EFC":["E764","EDC5","E8BBBC"], // 軼
           "8EFE":["E767","EDC8","E8BBBE"], // 軾
           "8F05":["E769","EDCA","E8BC85"], // 輅
           "8F0A":["E768","EDC9","E8BC8A"], // 輊
           "8F0C":["E771","EDD2","E8BC8C"], // 輌
           "8F12":["E76B","EDCC","E8BC92"], // 輒
           "8F13":["E76D","EDCE","E8BC93"], // 輓
           "8F15":["E76A","EDCB","E8BC95"], // 輕
           "8F19":["E76C","EDCD","E8BC99"], // 輙
           "8F1B":["E770","EDD1","E8BC9B"], // 輛
           "8F1C":["E76E","EDCF","E8BC9C"], // 輜
           "8F1F":["E76F","EDD0","E8BC9F"], // 輟
           "8F26":["E772","EDD3","E8BCA6"], // 輦
           "8F33":["E773","EDD4","E8BCB3"], // 輳
           "8F39":["E775","EDD6","E8BCB9"], // 輹
           "8F3B":["E774","EDD5","E8BCBB"], // 輻
           "8F3E":["E778","EDD9","E8BCBE"], // 輾
           "8F42":["E777","EDD8","E8BD82"], // 轂
           "8F45":["E776","EDD7","E8BD85"], // 轅
           "8F46":["E77B","EDDC","E8BD86"], // 轆
           "8F49":["E77A","EDDB","E8BD89"], // 轉
           "8F4C":["E779","EDDA","E8BD8C"], // 轌
           "8F4E":["E77C","EDDD","E8BD8E"], // 轎
           "8F57":["E77D","EDDE","E8BD97"], // 轗
           "8F5C":["E77E","EDDF","E8BD9C"], // 轜
           "8F62":["E780","EDE0","E8BDA2"], // 轢
           "8F63":["E781","EDE1","E8BDA3"], // 轣
           "8F64":["E782","EDE2","E8BDA4"], // 轤
           "8F9C":["E783","EDE3","E8BE9C"], // 辜
           "8F9F":["E784","EDE4","E8BE9F"], // 辟
           "8FA3":["E785","EDE5","E8BEA3"], // 辣
           "8FA7":["999F","D2A1","E8BEA7"], // 辧
           "8FA8":["999E","D1FE","E8BEA8"], // 辨
           "8FAD":["E786","EDE6","E8BEAD"], // 辭
           "8FAE":["E390","E5F0","E8BEAE"], // 辮
           "8FAF":["E787","EDE7","E8BEAF"], // 辯
           "8FB7":["E788","EDE8","E8BEB7"], // 辷
           "8FDA":["E789","EDE9","E8BF9A"], // 迚
           "8FE2":["E78B","EDEB","E8BFA2"], // 迢
           "8FE5":["E78A","EDEA","E8BFA5"], // 迥
           "8FEA":["E78C","EDEC","E8BFAA"], // 迪
           "8FEF":["E78D","EDED","E8BFAF"], // 迯
           "8FF4":["E78F","EDEF","E8BFB4"], // 迴
           "8FF8":["E79E","EDFE","E8BFB8"], // 迸
           "8FF9":["E791","EDF1","E8BFB9"], // 迹
           "8FFA":["E792","EDF2","E8BFBA"], // 迺
           "9005":["E790","EDF0","E98085"], // 逅
           "900B":["E799","EDF9","E9808B"], // 逋
           "900D":["E796","EDF6","E9808D"], // 逍
           "900E":["E7A3","EEA5","E9808E"], // 逎
           "9011":["E793","EDF3","E98091"], // 逑
           "9015":["E794","EDF4","E98095"], // 逕
           "9016":["E798","EDF8","E98096"], // 逖
           "901E":["E797","EDF7","E9809E"], // 逞
           "9021":["E795","EDF5","E980A1"], // 逡
           "9027":["E79A","EDFA","E980A7"], // 逧
           "9035":["E79C","EDFC","E980B5"], // 逵
           "9036":["E79B","EDFB","E980B6"], // 逶
           "9039":["E79D","EDFD","E980B9"], // 逹
           "903E":["E7A5","EEA7","E980BE"], // 逾
           "9049":["E7A4","EEA6","E98189"], // 遉
           "904F":["E79F","EEA1","E9818F"], // 遏
           "9050":["E7A0","EEA2","E98190"], // 遐
           "9051":["E7A1","EEA3","E98191"], // 遑
           "9052":["E7A2","EEA4","E98192"], // 遒
           "9056":["E7A6","EEA8","E98196"], // 遖
           "9058":["E7A7","EEA9","E98198"], // 遘
           "9059":["EAA1","F4A3","E98199"], // 遙
           "905E":["E7A8","EEAA","E9819E"], // 遞
           "9068":["E7A9","EEAB","E981A8"], // 遨
           "906F":["E7AA","EEAC","E981AF"], // 遯
           "9072":["E7AD","EEAF","E981B2"], // 遲
           "9076":["E7AB","EEAD","E981B6"], // 遶
           "907D":["E7AF","EEB1","E981BD"], // 遽
           "9080":["E7B1","EEB3","E98280"], // 邀
           "9081":["E7B0","EEB2","E98281"], // 邁
           "9082":["E7AE","EEB0","E98282"], // 邂
           "9083":["E284","E3E4","E98283"], // 邃
           "9087":["E78E","EDEE","E98287"], // 邇
           "9089":["E7B3","EEB5","E98289"], // 邉
           "908A":["E7B2","EEB4","E9828A"], // 邊
           "908F":["E7B4","EEB6","E9828F"], // 邏
           "90A8":["E7B5","EEB7","E982A8"], // 邨
           "90AF":["E7B6","EEB8","E982AF"], // 邯
           "90B1":["E7B7","EEB9","E982B1"], // 邱
           "90B5":["E7B8","EEBA","E982B5"], // 邵
           "90DB":["E7BC","EEBE","E9839B"], // 郛
           "90E2":["E7B9","EEBB","E983A2"], // 郢
           "90E4":["E7BA","EEBC","E983A4"], // 郤
           "9102":["E7BD","EEBF","E98482"], // 鄂
           "9112":["E7BE","EEC0","E98492"], // 鄒
           "9119":["E7BF","EEC1","E98499"], // 鄙
           "9130":["E7C1","EEC3","E984B0"], // 鄰
           "9132":["E7C0","EEC2","E984B2"], // 鄲
           "914A":["E7C2","EEC4","E9858A"], // 酊
           "9156":["E7C3","EEC5","E98596"], // 酖
           "9158":["E7C4","EEC6","E98598"], // 酘
           "9163":["E7C5","EEC7","E985A3"], // 酣
           "9165":["E7C6","EEC8","E985A5"], // 酥
           "9169":["E7C7","EEC9","E985A9"], // 酩
           "9172":["E7C9","EECB","E985B2"], // 酲
           "9173":["E7C8","EECA","E985B3"], // 酳
           "9182":["E7CC","EECE","E98682"], // 醂
           "9189":["E7CB","EECD","E98689"], // 醉
           "918B":["E7CA","EECC","E9868B"], // 醋
           "91A2":["E7CD","EECF","E986A2"], // 醢
           "91AA":["E7D0","EED2","E986AA"], // 醪
           "91AB":["E7CE","EED0","E986AB"], // 醫
           "91AF":["E7CF","EED1","E986AF"], // 醯
           "91B4":["E7D2","EED4","E986B4"], // 醴
           "91B5":["E7D1","EED3","E986B5"], // 醵
           "91BA":["E7D3","EED5","E986BA"], // 醺
           "91C0":["E7D4","EED6","E98780"], // 釀
           "91C1":["E7D5","EED7","E98781"], // 釁
           "91C9":["E7D6","EED8","E98789"], // 釉
           "91CB":["E7D7","EED9","E9878B"], // 釋
           "91D0":["E7D8","EEDA","E98790"], // 釐
           "91D6":["E7D9","EEDB","E98796"], // 釖
           "91DB":["E7DC","EEDE","E9879B"], // 釛
           "91DF":["E7DA","EEDC","E9879F"], // 釟
           "91E1":["E7DB","EEDD","E987A1"], // 釡
           "91F5":["E7DE","EEE0","E987B5"], // 釵
           "91F6":["E7DF","EEE1","E987B6"], // 釶
           "91FC":["E7DD","EEDF","E987BC"], // 釼
           "91FF":["E7E1","EEE3","E987BF"], // 釿
           "9211":["E7E5","EEE7","E98891"], // 鈑
           "9214":["E7E2","EEE4","E98894"], // 鈔
           "9215":["E7E4","EEE6","E98895"], // 鈕
           "921E":["E7E0","EEE2","E9889E"], // 鈞
           "9229":["E86E","EFCF","E988A9"], // 鈩
           "922C":["E7E3","EEE5","E988AC"], // 鈬
           "923F":["E7ED","EEEF","E988BF"], // 鈿
           "9245":["E7E8","EEEA","E98985"], // 鉅
           "9248":["E7EB","EEED","E98988"], // 鉈
           "9249":["E7E9","EEEB","E98989"], // 鉉
           "924B":["E7EE","EEF0","E9898B"], // 鉋
           "9250":["E7EF","EEF1","E98990"], // 鉐
           "9257":["E7E7","EEE9","E98997"], // 鉗
           "925A":["E7F4","EEF6","E9899A"], // 鉚
           "925E":["E7E6","EEE8","E9899E"], // 鉞
           "9264":["E7EA","EEEC","E989A4"], // 鉤
           "9293":["E7F2","EEF4","E98A93"], // 銓
           "9295":["E7EC","EEEE","E98A95"], // 銕
           "9296":["E7F1","EEF3","E98A96"], // 銖
           "929B":["E7F3","EEF5","E98A9B"], // 銛
           "929C":["E7F0","EEF2","E98A9C"], // 銜
           "92B7":["E7F7","EEF9","E98AB7"], // 銷
           "92B9":["E7F6","EEF8","E98AB9"], // 銹
           "92CF":["E7F5","EEF7","E98B8F"], // 鋏
           "92E9":["E7F8","EEFA","E98BA9"], // 鋩
           "92FA":["E7FA","EEFC","E98BBA"], // 鋺
           "930F":["E7F9","EEFB","E98C8F"], // 錏
           "9319":["E840","EFA1","E98C99"], // 錙
           "931A":["E842","EFA3","E98C9A"], // 錚
           "9322":["E841","EFA2","E98CA2"], // 錢
           "9323":["E843","EFA4","E98CA3"], // 錣
           "932E":["E7FC","EEFE","E98CAE"], // 錮
           "9335":["E845","EFA6","E98CB5"], // 錵
           "933A":["E844","EFA5","E98CBA"], // 錺
           "933B":["E846","EFA7","E98CBB"], // 錻
           "9344":["E7FB","EEFD","E98D84"], // 鍄
           "9356":["E84B","EFAC","E98D96"], // 鍖
           "935C":["E847","EFA8","E98D9C"], // 鍜
           "9360":["E848","EFA9","E98DA0"], // 鍠
           "936E":["E84A","EFAB","E98DAE"], // 鍮
           "937C":["E849","EFAA","E98DBC"], // 鍼
           "9394":["E84F","EFB0","E98E94"], // 鎔
           "93AC":["E84D","EFAE","E98EAC"], // 鎬
           "93AD":["E84E","EFAF","E98EAD"], // 鎭
           "93B0":["E84C","EFAD","E98EB0"], // 鎰
           "93B9":["E850","EFB1","E98EB9"], // 鎹
           "93C3":["E856","EFB7","E98F83"], // 鏃
           "93C8":["E859","EFBA","E98F88"], // 鏈
           "93D0":["E858","EFB9","E98F90"], // 鏐
           "93D6":["E851","EFB2","E98F96"], // 鏖
           "93D7":["E852","EFB3","E98F97"], // 鏗
           "93D8":["E855","EFB6","E98F98"], // 鏘
           "93DD":["E857","EFB8","E98F9D"], // 鏝
           "93E4":["E85A","EFBB","E98FA4"], // 鏤
           "93E5":["E854","EFB5","E98FA5"], // 鏥
           "93E8":["E853","EFB4","E98FA8"], // 鏨
           "9403":["E85E","EFBF","E99083"], // 鐃
           "9407":["E85F","EFC0","E99087"], // 鐇
           "9410":["E860","EFC1","E99090"], // 鐐
           "9413":["E85D","EFBE","E99093"], // 鐓
           "9414":["E85C","EFBD","E99094"], // 鐔
           "941A":["E85B","EFBC","E9909A"], // 鐚
           "9421":["E864","EFC5","E990A1"], // 鐡
           "942B":["E862","EFC3","E990AB"], // 鐫
           "9435":["E863","EFC4","E990B5"], // 鐵
           "9436":["E861","EFC2","E990B6"], // 鐶
           "943A":["E865","EFC6","E990BA"], // 鐺
           "9441":["E866","EFC7","E99181"], // 鑁
           "9444":["E868","EFC9","E99184"], // 鑄
           "9452":["E867","EFC8","E99192"], // 鑒
           "945A":["E873","EFD4","E9919A"], // 鑚
           "945B":["E869","EFCA","E9919B"], // 鑛
           "945E":["E86C","EFCD","E9919E"], // 鑞
           "9460":["E86A","EFCB","E991A0"], // 鑠
           "9462":["E86B","EFCC","E991A2"], // 鑢
           "946A":["E86D","EFCE","E991AA"], // 鑪
           "9470":["E86F","EFD0","E991B0"], // 鑰
           "9475":["E870","EFD1","E991B5"], // 鑵
           "9477":["E871","EFD2","E991B7"], // 鑷
           "947C":["E874","EFD5","E991BC"], // 鑼
           "947D":["E872","EFD3","E991BD"], // 鑽
           "947E":["E875","EFD6","E991BE"], // 鑾
           "947F":["E877","EFD8","E991BF"], // 鑿
           "9481":["E876","EFD7","E99281"], // 钁
           "9582":["E878","EFD9","E99682"], // 閂
           "9587":["E879","EFDA","E99687"], // 閇
           "958A":["E87A","EFDB","E9968A"], // 閊
           "9594":["E87B","EFDC","E99694"], // 閔
           "9596":["E87C","EFDD","E99696"], // 閖
           "9598":["E87D","EFDE","E99698"], // 閘
           "9599":["E87E","EFDF","E99699"], // 閙
           "95A0":["E880","EFE0","E996A0"], // 閠
           "95A7":["E882","EFE2","E996A7"], // 閧
           "95A8":["E881","EFE1","E996A8"], // 閨
           "95AD":["E883","EFE3","E996AD"], // 閭
           "95B9":["E886","EFE6","E996B9"], // 閹
           "95BB":["E885","EFE5","E996BB"], // 閻
           "95BC":["E884","EFE4","E996BC"], // 閼
           "95BE":["E887","EFE7","E996BE"], // 閾
           "95C3":["E88A","EFEA","E99783"], // 闃
           "95CA":["E888","EFE8","E9978A"], // 闊
           "95CC":["E88C","EFEC","E9978C"], // 闌
           "95CD":["E88B","EFEB","E9978D"], // 闍
           "95D4":["E88E","EFEE","E99794"], // 闔
           "95D5":["E88D","EFED","E99795"], // 闕
           "95D6":["E88F","EFEF","E99796"], // 闖
           "95DC":["E890","EFF0","E9979C"], // 關
           "95E1":["E891","EFF1","E997A1"], // 闡
           "95E2":["E893","EFF3","E997A2"], // 闢
           "95E5":["E892","EFF2","E997A5"], // 闥
           "9621":["E894","EFF4","E998A1"], // 阡
           "9628":["E895","EFF5","E998A8"], // 阨
           "962E":["E896","EFF6","E998AE"], // 阮
           "962F":["E897","EFF7","E998AF"], // 阯
           "9642":["E898","EFF8","E99982"], // 陂
           "964B":["E89B","EFFB","E9998B"], // 陋
           "964C":["E899","EFF9","E9998C"], // 陌
           "964F":["E89A","EFFA","E9998F"], // 陏
           "965C":["E89D","EFFD","E9999C"], // 陜
           "965D":["E89F","F0A1","E9999D"], // 陝
           "965E":["E89E","EFFE","E9999E"], // 陞
           "965F":["E8A0","F0A2","E9999F"], // 陟
           "9666":["E8A1","F0A3","E999A6"], // 陦
           "966C":["E8A3","F0A5","E999AC"], // 陬
           "9672":["E8A2","F0A4","E999B2"], // 陲
           "9677":["E89C","EFFC","E999B7"], // 陷
           "968B":["E440","E7A1","E99A8B"], // 隋
           "968D":["E8A4","F0A6","E99A8D"], // 隍
           "9695":["E8A6","F0A8","E99A95"], // 隕
           "9697":["E8A7","F0A9","E99A97"], // 隗
           "9698":["E8A5","F0A7","E99A98"], // 隘
           "96A7":["E8A9","F0AB","E99AA7"], // 隧
           "96A8":["E7AC","EEAE","E99AA8"], // 隨
           "96AA":["E8A8","F0AA","E99AAA"], // 險
           "96B0":["E8AC","F0AE","E99AB0"], // 隰
           "96B1":["E8AA","F0AC","E99AB1"], // 隱
           "96B2":["E8AB","F0AD","E99AB2"], // 隲
           "96B4":["E8AD","F0AF","E99AB4"], // 隴
           "96B6":["E8AE","F0B0","E99AB6"], // 隶
           "96B8":["E8AF","F0B1","E99AB8"], // 隸
           "96B9":["E8B0","F0B2","E99AB9"], // 隹
           "96C9":["E8B3","F0B5","E99B89"], // 雉
           "96CB":["E8B2","F0B4","E99B8B"], // 雋
           "96CD":["E8B4","F0B6","E99B8D"], // 雍
           "96CE":["E8B1","F0B3","E99B8E"], // 雎
           "96D5":["E8B8","F0BA","E99B95"], // 雕
           "96D6":["E5AB","EAAD","E99B96"], // 雖
           "96D9":["99D4","D2D6","E99B99"], // 雙
           "96DC":["E8B6","F0B8","E99B9C"], // 雜
           "96F9":["E8B9","F0BB","E99BB9"], // 雹
           "9704":["E8BA","F0BC","E99C84"], // 霄
           "9706":["E8BB","F0BD","E99C86"], // 霆
           "9708":["E8BC","F0BE","E99C88"], // 霈
           "970D":["E8B7","F0B9","E99C8D"], // 霍
           "970E":["E8BE","F0C0","E99C8E"], // 霎
           "970F":["E8C0","F0C2","E99C8F"], // 霏
           "9711":["E8BF","F0C1","E99C91"], // 霑
           "9713":["E8BD","F0BF","E99C93"], // 霓
           "9716":["E8C1","F0C3","E99C96"], // 霖
           "9719":["E8C2","F0C4","E99C99"], // 霙
           "9724":["E8C3","F0C5","E99CA4"], // 霤
           "972A":["E8C4","F0C6","E99CAA"], // 霪
           "9730":["E8C5","F0C7","E99CB0"], // 霰
           "9738":["9E50","DBB1","E99CB8"], // 霸
           "9739":["E8C6","F0C8","E99CB9"], // 霹
           "973D":["E8C7","F0C9","E99CBD"], // 霽
           "973E":["E8C8","F0CA","E99CBE"], // 霾
           "9742":["E8CC","F0CE","E99D82"], // 靂
           "9744":["E8C9","F0CB","E99D84"], // 靄
           "9746":["E8CA","F0CC","E99D86"], // 靆
           "9748":["E8CB","F0CD","E99D88"], // 靈
           "9749":["E8CD","F0CF","E99D89"], // 靉
           "975C":["E8CE","F0D0","E99D9C"], // 靜
           "9760":["E8CF","F0D1","E99DA0"], // 靠
           "9761":["EA72","F3D3","E99DA1"], // 靡
           "9764":["E8D0","F0D2","E99DA4"], // 靤
           "9766":["E8D1","F0D3","E99DA6"], // 靦
           "9768":["E8D2","F0D4","E99DA8"], // 靨
           "976B":["E8D4","F0D6","E99DAB"], // 靫
           "9771":["E8D5","F0D7","E99DB1"], // 靱
           "9779":["E8D6","F0D8","E99DB9"], // 靹
           "977A":["E8DA","F0DC","E99DBA"], // 靺
           "977C":["E8D8","F0DA","E99DBC"], // 靼
           "9781":["E8D9","F0DB","E99E81"], // 鞁
           "9785":["E8D7","F0D9","E99E85"], // 鞅
           "9786":["E8DB","F0DD","E99E86"], // 鞆
           "978B":["E8DC","F0DE","E99E8B"], // 鞋
           "978F":["E8DD","F0DF","E99E8F"], // 鞏
           "9790":["E8DE","F0E0","E99E90"], // 鞐
           "979C":["E8DF","F0E1","E99E9C"], // 鞜
           "97A3":["E8E2","F0E4","E99EA3"], // 鞣
           "97A6":["E8E1","F0E3","E99EA6"], // 鞦
           "97A8":["E8E0","F0E2","E99EA8"], // 鞨
           "97AB":["E691","EBF1","E99EAB"], // 鞫
           "97B3":["E8E3","F0E5","E99EB3"], // 鞳
           "97B4":["E8E4","F0E6","E99EB4"], // 鞴
           "97C3":["E8E5","F0E7","E99F83"], // 韃
           "97C6":["E8E6","F0E8","E99F86"], // 韆
           "97C8":["E8E7","F0E9","E99F88"], // 韈
           "97CB":["E8E8","F0EA","E99F8B"], // 韋
           "97DC":["E8E9","F0EB","E99F9C"], // 韜
           "97ED":["E8EA","F0EC","E99FAD"], // 韭
           "97F2":["E8EC","F0EE","E99FB2"], // 韲
           "97F5":["E8EF","F0F1","E99FB5"], // 韵
           "97F6":["E8EE","F0F0","E99FB6"], // 韶
           "980C":["E8F1","F0F3","E9A08C"], // 頌
           "980F":["E8F0","F0F2","E9A08F"], // 頏
           "9821":["E8F4","F0F6","E9A0A1"], // 頡
           "9824":["E8F3","F0F5","E9A0A4"], // 頤
           "9837":["E8F5","F0F7","E9A0B7"], // 頷
           "9838":["E8F2","F0F4","E9A0B8"], // 頸
           "983D":["E8F6","F0F8","E9A0BD"], // 頽
           "9846":["E8F7","F0F9","E9A186"], // 顆
           "984B":["E8F9","F0FB","E9A18B"], // 顋
           "984F":["E8F8","F0FA","E9A18F"], // 顏
           "986B":["E8FA","F0FC","E9A1AB"], // 顫
           "986F":["E8FB","F0FD","E9A1AF"], // 顯
           "9870":["E8FC","F0FE","E9A1B0"], // 顰
           "9871":["E940","F1A1","E9A1B1"], // 顱
           "9873":["E942","F1A3","E9A1B3"], // 顳
           "9874":["E941","F1A2","E9A1B4"], // 顴
           "98AA":["E943","F1A4","E9A2AA"], // 颪
           "98AF":["E944","F1A5","E9A2AF"], // 颯
           "98B1":["E945","F1A6","E9A2B1"], // 颱
           "98B6":["E946","F1A7","E9A2B6"], // 颶
           "98C3":["E948","F1A9","E9A383"], // 飃
           "98C4":["E947","F1A8","E9A384"], // 飄
           "98C6":["E949","F1AA","E9A386"], // 飆
           "98DC":["E3CA","E6CC","E9A39C"], // 飜
           "98E9":["E94A","F1AB","E9A3A9"], // 飩
           "98EB":["E94B","F1AC","E9A3AB"], // 飫
           "98ED":["99AA","D2AC","E9A3AD"], // 飭
           "98EE":["9F5A","DDBB","E9A3AE"], // 飮
           "9903":["E94C","F1AD","E9A483"], // 餃
           "9909":["E94D","F1AE","E9A489"], // 餉
           "9912":["E94E","F1AF","E9A492"], // 餒
           "9914":["E94F","F1B0","E9A494"], // 餔
           "9918":["E950","F1B1","E9A498"], // 餘
           "991D":["E952","F1B3","E9A49D"], // 餝
           "991E":["E953","F1B4","E9A49E"], // 餞
           "9920":["E955","F1B6","E9A4A0"], // 餠
           "9921":["E951","F1B2","E9A4A1"], // 餡
           "9924":["E954","F1B5","E9A4A4"], // 餤
           "992C":["E956","F1B7","E9A4AC"], // 餬
           "992E":["E957","F1B8","E9A4AE"], // 餮
           "993D":["E958","F1B9","E9A4BD"], // 餽
           "993E":["E959","F1BA","E9A4BE"], // 餾
           "9942":["E95A","F1BB","E9A582"], // 饂
           "9945":["E95C","F1BD","E9A585"], // 饅
           "9949":["E95B","F1BC","E9A589"], // 饉
           "994B":["E95E","F1BF","E9A58B"], // 饋
           "994C":["E961","F1C2","E9A58C"], // 饌
           "9950":["E95D","F1BE","E9A590"], // 饐
           "9951":["E95F","F1C0","E9A591"], // 饑
           "9952":["E960","F1C1","E9A592"], // 饒
           "9955":["E962","F1C3","E9A595"], // 饕
           "9997":["E963","F1C4","E9A697"], // 馗
           "9998":["E964","F1C5","E9A698"], // 馘
           "99A5":["E965","F1C6","E9A6A5"], // 馥
           "99AD":["E966","F1C7","E9A6AD"], // 馭
           "99AE":["E967","F1C8","E9A6AE"], // 馮
           "99BC":["E968","F1C9","E9A6BC"], // 馼
           "99D1":["E96D","F1CE","E9A791"], // 駑
           "99D8":["E96C","F1CD","E9A798"], // 駘
           "99DB":["E96A","F1CB","E9A79B"], // 駛
           "99DD":["E96B","F1CC","E9A79D"], // 駝
           "99DF":["E969","F1CA","E9A79F"], // 駟
           "99E2":["E977","F1D8","E9A7A2"], // 駢
           "99ED":["E96E","F1CF","E9A7AD"], // 駭
           "99EE":["E96F","F1D0","E9A7AE"], // 駮
           "99F1":["E970","F1D1","E9A7B1"], // 駱
           "99F2":["E971","F1D2","E9A7B2"], // 駲
           "99F8":["E973","F1D4","E9A7B8"], // 駸
           "99FB":["E972","F1D3","E9A7BB"], // 駻
           "9A01":["E974","F1D5","E9A881"], // 騁
           "9A05":["E976","F1D7","E9A885"], // 騅
           "9A0F":["E975","F1D6","E9A88F"], // 騏
           "9A19":["E978","F1D9","E9A899"], // 騙
           "9A2B":["E979","F1DA","E9A8AB"], // 騫
           "9A37":["E97A","F1DB","E9A8B7"], // 騷
           "9A3E":["E980","F1E0","E9A8BE"], // 騾
           "9A40":["E97D","F1DE","E9A980"], // 驀
           "9A42":["E97C","F1DD","E9A982"], // 驂
           "9A43":["E97E","F1DF","E9A983"], // 驃
           "9A45":["E97B","F1DC","E9A985"], // 驅
           "9A4D":["E982","F1E2","E9A98D"], // 驍
           "9A55":["E981","F1E1","E9A995"], // 驕
           "9A57":["E984","F1E4","E9A997"], // 驗
           "9A5B":["E983","F1E3","E9A99B"], // 驛
           "9A5F":["E985","F1E5","E9A99F"], // 驟
           "9A62":["E986","F1E6","E9A9A2"], // 驢
           "9A64":["E988","F1E8","E9A9A4"], // 驤
           "9A65":["E987","F1E7","E9A9A5"], // 驥
           "9A69":["E989","F1E9","E9A9A9"], // 驩
           "9A6A":["E98B","F1EB","E9A9AA"], // 驪
           "9A6B":["E98A","F1EA","E9A9AB"], // 驫
           "9AAD":["E98C","F1EC","E9AAAD"], // 骭
           "9AB0":["E98D","F1ED","E9AAB0"], // 骰
           "9ABC":["E98E","F1EE","E9AABC"], // 骼
           "9AC0":["E98F","F1EF","E9AB80"], // 髀
           "9ACF":["E990","F1F0","E9AB8F"], // 髏
           "9AD1":["E991","F1F1","E9AB91"], // 髑
           "9AD3":["E992","F1F2","E9AB93"], // 髓
           "9AD4":["E993","F1F3","E9AB94"], // 體
           "9ADE":["E994","F1F4","E9AB9E"], // 髞
           "9ADF":["E995","F1F5","E9AB9F"], // 髟
           "9AE2":["E996","F1F6","E9ABA2"], // 髢
           "9AE3":["E997","F1F7","E9ABA3"], // 髣
           "9AE6":["E998","F1F8","E9ABA6"], // 髦
           "9AEB":["E99A","F1FA","E9ABAB"], // 髫
           "9AEE":["E99B","F1FB","E9ABAE"], // 髮
           "9AEF":["E999","F1F9","E9ABAF"], // 髯
           "9AF1":["E99D","F1FD","E9ABB1"], // 髱
           "9AF4":["E99C","F1FC","E9ABB4"], // 髴
           "9AF7":["E99E","F1FE","E9ABB7"], // 髷
           "9AFB":["E99F","F2A1","E9ABBB"], // 髻
           "9B06":["E9A0","F2A2","E9AC86"], // 鬆
           "9B18":["E9A1","F2A3","E9AC98"], // 鬘
           "9B1A":["E9A2","F2A4","E9AC9A"], // 鬚
           "9B1F":["E9A3","F2A5","E9AC9F"], // 鬟
           "9B22":["E9A4","F2A6","E9ACA2"], // 鬢
           "9B23":["E9A5","F2A7","E9ACA3"], // 鬣
           "9B25":["E9A6","F2A8","E9ACA5"], // 鬥
           "9B27":["E9A7","F2A9","E9ACA7"], // 鬧
           "9B28":["E9A8","F2AA","E9ACA8"], // 鬨
           "9B29":["E9A9","F2AB","E9ACA9"], // 鬩
           "9B2A":["E9AA","F2AC","E9ACAA"], // 鬪
           "9B2E":["E9AB","F2AD","E9ACAE"], // 鬮
           "9B2F":["E9AC","F2AE","E9ACAF"], // 鬯
           "9B31":["9F54","DDB5","E9ACB1"], // 鬱
           "9B32":["E9AD","F2AF","E9ACB2"], // 鬲
           "9B3B":["E2F6","E4F8","E9ACBB"], // 鬻
           "9B43":["E9AF","F2B1","E9AD83"], // 魃
           "9B44":["E9AE","F2B0","E9AD84"], // 魄
           "9B4D":["E9B1","F2B3","E9AD8D"], // 魍
           "9B4E":["E9B2","F2B4","E9AD8E"], // 魎
           "9B4F":["E9B0","F2B2","E9AD8F"], // 魏
           "9B51":["E9B3","F2B5","E9AD91"], // 魑
           "9B58":["E9B4","F2B6","E9AD98"], // 魘
           "9B74":["E9B5","F2B7","E9ADB4"], // 魴
           "9B83":["E9B7","F2B9","E9AE83"], // 鮃
           "9B91":["E9B8","F2BA","E9AE91"], // 鮑
           "9B93":["E9B6","F2B8","E9AE93"], // 鮓
           "9B96":["E9B9","F2BB","E9AE96"], // 鮖
           "9B97":["E9BA","F2BC","E9AE97"], // 鮗
           "9B9F":["E9BB","F2BD","E9AE9F"], // 鮟
           "9BA0":["E9BC","F2BE","E9AEA0"], // 鮠
           "9BA8":["E9BD","F2BF","E9AEA8"], // 鮨
           "9BB4":["E9BE","F2C0","E9AEB4"], // 鮴
           "9BB9":["E9C1","F2C3","E9AEB9"], // 鮹
           "9BC0":["E9BF","F2C1","E9AF80"], // 鯀
           "9BC6":["E9C2","F2C4","E9AF86"], // 鯆
           "9BCA":["E9C0","F2C2","E9AF8A"], // 鯊
           "9BCF":["E9C3","F2C5","E9AF8F"], // 鯏
           "9BD1":["E9C4","F2C6","E9AF91"], // 鯑
           "9BD2":["E9C5","F2C7","E9AF92"], // 鯒
           "9BD4":["E9C9","F2CB","E9AF94"], // 鯔
           "9BE1":["E9CA","F2CC","E9AFA1"], // 鯡
           "9BE2":["E9C7","F2C9","E9AFA2"], // 鯢
           "9BE3":["E9C6","F2C8","E9AFA3"], // 鯣
           "9BE4":["E9C8","F2CA","E9AFA4"], // 鯤
           "9BF0":["E9CE","F2D0","E9AFB0"], // 鯰
           "9BF1":["E9CD","F2CF","E9AFB1"], // 鯱
           "9BF2":["E9CC","F2CE","E9AFB2"], // 鯲
           "9C04":["E9D8","F2DA","E9B084"], // 鰄
           "9C06":["E9D4","F2D6","E9B086"], // 鰆
           "9C08":["E9D5","F2D7","E9B088"], // 鰈
           "9C09":["E9D1","F2D3","E9B089"], // 鰉
           "9C0A":["E9D7","F2D9","E9B08A"], // 鰊
           "9C0C":["E9D3","F2D5","E9B08C"], // 鰌
           "9C12":["E9D6","F2D8","E9B092"], // 鰒
           "9C13":["E9D2","F2D4","E9B093"], // 鰓
           "9C14":["E9D0","F2D2","E9B094"], // 鰔
           "9C15":["E9CF","F2D1","E9B095"], // 鰕
           "9C1B":["E9DA","F2DC","E9B09B"], // 鰛
           "9C21":["E9DD","F2DF","E9B0A1"], // 鰡
           "9C24":["E9DC","F2DE","E9B0A4"], // 鰤
           "9C25":["E9DB","F2DD","E9B0A5"], // 鰥
           "9C2E":["E9D9","F2DB","E9B0AE"], // 鰮
           "9C30":["E9DE","F2E0","E9B0B0"], // 鰰
           "9C32":["E9E0","F2E2","E9B0B2"], // 鰲
           "9C3A":["E9CB","F2CD","E9B0BA"], // 鰺
           "9C3E":["E9E2","F2E4","E9B0BE"], // 鰾
           "9C46":["E9E1","F2E3","E9B186"], // 鱆
           "9C47":["E9DF","F2E1","E9B187"], // 鱇
           "9C5A":["E9E3","F2E5","E9B19A"], // 鱚
           "9C60":["E9E4","F2E6","E9B1A0"], // 鱠
           "9C67":["E9E5","F2E7","E9B1A7"], // 鱧
           "9C76":["E9E6","F2E8","E9B1B6"], // 鱶
           "9C78":["E9E7","F2E9","E9B1B8"], // 鱸
           "9CE7":["E9E8","F2EA","E9B3A7"], // 鳧
           "9CEB":["E9ED","F2EF","E9B3AB"], // 鳫
           "9CEC":["E9E9","F2EB","E9B3AC"], // 鳬
           "9CF0":["E9EA","F2EC","E9B3B0"], // 鳰
           "9D03":["E9EE","F2F0","E9B483"], // 鴃
           "9D06":["E9EF","F2F1","E9B486"], // 鴆
           "9D08":["E9EC","F2EE","E9B488"], // 鴈
           "9D09":["E9EB","F2ED","E9B489"], // 鴉
           "9D12":["E9F7","F2F9","E9B492"], // 鴒
           "9D15":["E9F6","F2F8","E9B495"], // 鴕
           "9D1F":["E9F4","F2F6","E9B49F"], // 鴟
           "9D23":["E9F3","F2F5","E9B4A3"], // 鴣
           "9D26":["E9F1","F2F3","E9B4A6"], // 鴦
           "9D2A":["E9F0","F2F2","E9B4AA"], // 鴪
           "9D3E":["E9FA","F2FC","E9B4BE"], // 鴾
           "9D3F":["E9F9","F2FB","E9B4BF"], // 鴿
           "9D41":["E9F8","F2FA","E9B581"], // 鵁
           "9D44":["E9F5","F2F7","E9B584"], // 鵄
           "9D46":["E9FB","F2FD","E9B586"], // 鵆
           "9D48":["E9FC","F2FE","E9B588"], // 鵈
           "9D50":["EA44","F3A5","E9B590"], // 鵐
           "9D51":["EA43","F3A4","E9B591"], // 鵑
           "9D59":["EA45","F3A6","E9B599"], // 鵙
           "9D5D":["EA40","F3A1","E9B59D"], // 鵝
           "9D5E":["EA41","F3A2","E9B59E"], // 鵞
           "9D64":["EA42","F3A3","E9B5A4"], // 鵤
           "9D6F":["EA4A","F3AB","E9B5AF"], // 鵯
           "9D72":["EA46","F3A7","E9B5B2"], // 鵲
           "9D7A":["EA4B","F3AC","E9B5BA"], // 鵺
           "9D87":["EA48","F3A9","E9B687"], // 鶇
           "9D89":["EA47","F3A8","E9B689"], // 鶉
           "9D9A":["EA4C","F3AD","E9B69A"], // 鶚
           "9DA4":["EA4D","F3AE","E9B6A4"], // 鶤
           "9DA9":["EA4E","F3AF","E9B6A9"], // 鶩
           "9DAB":["EA49","F3AA","E9B6AB"], // 鶫
           "9DAF":["E9F2","F2F4","E9B6AF"], // 鶯
           "9DB2":["EA4F","F3B0","E9B6B2"], // 鶲
           "9DB8":["EA53","F3B4","E9B6B8"], // 鶸
           "9DBA":["EA54","F3B5","E9B6BA"], // 鶺
           "9DBB":["EA52","F3B3","E9B6BB"], // 鶻
           "9DC1":["EA51","F3B2","E9B781"], // 鷁
           "9DC2":["EA57","F3B8","E9B782"], // 鷂
           "9DC4":["EA50","F3B1","E9B784"], // 鷄
           "9DC6":["EA55","F3B6","E9B786"], // 鷆
           "9DCF":["EA56","F3B7","E9B78F"], // 鷏
           "9DD3":["EA59","F3BA","E9B793"], // 鷓
           "9DD9":["EA58","F3B9","E9B799"], // 鷙
           "9DE6":["EA5B","F3BC","E9B7A6"], // 鷦
           "9DED":["EA5C","F3BD","E9B7AD"], // 鷭
           "9DEF":["EA5D","F3BE","E9B7AF"], // 鷯
           "9DF8":["EA5A","F3BB","E9B7B8"], // 鷸
           "9DFD":["EA5E","F3BF","E9B7BD"], // 鷽
           "9E1A":["EA5F","F3C0","E9B89A"], // 鸚
           "9E1B":["EA60","F3C1","E9B89B"], // 鸛
           "9E1E":["EA61","F3C2","E9B89E"], // 鸞
           "9E75":["EA62","F3C3","E9B9B5"], // 鹵
           "9E79":["EA63","F3C4","E9B9B9"], // 鹹
           "9E7D":["EA64","F3C5","E9B9BD"], // 鹽
           "9E81":["EA65","F3C6","E9BA81"], // 麁
           "9E88":["EA66","F3C7","E9BA88"], // 麈
           "9E8B":["EA67","F3C8","E9BA8B"], // 麋
           "9E8C":["EA68","F3C9","E9BA8C"], // 麌
           "9E91":["EA6B","F3CC","E9BA91"], // 麑
           "9E92":["EA69","F3CA","E9BA92"], // 麒
           "9E95":["EA6A","F3CB","E9BA95"], // 麕
           "9E9D":["EA6C","F3CD","E9BA9D"], // 麝
           "9EA5":["EA6D","F3CE","E9BAA5"], // 麥
           "9EA9":["EA6E","F3CF","E9BAA9"], // 麩
           "9EAA":["EA70","F3D1","E9BAAA"], // 麪
           "9EAD":["EA71","F3D2","E9BAAD"], // 麭
           "9EB8":["EA6F","F3D0","E9BAB8"], // 麸
           "9EBC":["9BF5","D6F7","E9BABC"], // 麼
           "9EBE":["9F80","DDE0","E9BABE"], // 麾
           "9ECC":["EA73","F3D4","E9BB8C"], // 黌
           "9ECE":["EA74","F3D5","E9BB8E"], // 黎
           "9ECF":["EA75","F3D6","E9BB8F"], // 黏
           "9ED0":["EA76","F3D7","E9BB90"], // 黐
           "9ED4":["EA77","F3D8","E9BB94"], // 黔
           "9ED8":["E0D2","E0D4","E9BB98"], // 默
           "9EDC":["EA78","F3D9","E9BB9C"], // 黜
           "9EDD":["EA7A","F3DB","E9BB9D"], // 黝
           "9EDE":["EA79","F3DA","E9BB9E"], // 點
           "9EE0":["EA7B","F3DC","E9BBA0"], // 黠
           "9EE5":["EA7C","F3DD","E9BBA5"], // 黥
           "9EE8":["EA7D","F3DE","E9BBA8"], // 黨
           "9EEF":["EA7E","F3DF","E9BBAF"], // 黯
           "9EF4":["EA80","F3E0","E9BBB4"], // 黴
           "9EF6":["EA81","F3E1","E9BBB6"], // 黶
           "9EF7":["EA82","F3E2","E9BBB7"], // 黷
           "9EF9":["EA83","F3E3","E9BBB9"], // 黹
           "9EFB":["EA84","F3E4","E9BBBB"], // 黻
           "9EFC":["EA85","F3E5","E9BBBC"], // 黼
           "9EFD":["EA86","F3E6","E9BBBD"], // 黽
           "9F07":["EA87","F3E7","E9BC87"], // 鼇
           "9F08":["EA88","F3E8","E9BC88"], // 鼈
           "9F15":["EA8A","F3EA","E9BC95"], // 鼕
           "9F21":["EA8B","F3EB","E9BCA1"], // 鼡
           "9F2C":["EA8C","F3EC","E9BCAC"], // 鼬
           "9F3E":["EA8D","F3ED","E9BCBE"], // 鼾
           "9F4A":["EA8E","F3EE","E9BD8A"], // 齊
           "9F4B":["E256","E3B7","E9BD8B"], // 齋
           "9F4E":["E6D8","ECDA","E9BD8E"], // 齎
           "9F4F":["E8EB","F0ED","E9BD8F"], // 齏
           "9F52":["EA8F","F3EF","E9BD92"], // 齒
           "9F54":["EA90","F3F0","E9BD94"], // 齔
           "9F5F":["EA92","F3F2","E9BD9F"], // 齟
           "9F60":["EA93","F3F3","E9BDA0"], // 齠
           "9F61":["EA94","F3F4","E9BDA1"], // 齡
           "9F63":["EA91","F3F1","E9BDA3"], // 齣
           "9F66":["EA95","F3F5","E9BDA6"], // 齦
           "9F67":["EA96","F3F6","E9BDA7"], // 齧
           "9F6A":["EA98","F3F8","E9BDAA"], // 齪
           "9F6C":["EA97","F3F7","E9BDAC"], // 齬
           "9F72":["EA9A","F3FA","E9BDB2"], // 齲
           "9F76":["EA9B","F3FB","E9BDB6"], // 齶
           "9F77":["EA99","F3F9","E9BDB7"], // 齷
           "9F95":["EA9C","F3FC","E9BE95"], // 龕
           "9F9C":["EA9D","F3FD","E9BE9C"], // 龜
           "9F9D":["E273","E3D4","E9BE9D"], // 龝
           "9FA0":["EA9E","F3FE","E9BEA0"]  // 龠
    }
  }
}
